#!/bin/sh
# We check first that $TESTRTDIR is set?
if [ -z "$TESTRTDIR" ]
then
        echo "TESTRTDIR not defined:"
		echo "Run the .sh script file to set the environment variables."
        echo "In a sh or bash shell (the period ... is part of the command):"
        echo ". <install_dir>/TestRealTime.7.0.5.0/testrtinit.sh"
else
  # and that the release to patch is a 7.0.5.0 release?
  ls ${TESTRTDIR}/../TestRealTime.7.0.5.0/lib  
  if [  $? -ne 0 ]
  then
  	# it is not a 7.0.5.0 release
  	
  	echo "*********************************************************************"
	echo "*           W A R N I N G ! ! !                                     *"
	echo "* It is not a 7.0.5.0 release to patch:                               *"
	ls ${TESTRTDIR}/../
	echo "* Patch process is aborted                                          *"
	echo "*********************************************************************"
  	
  else
	# It is a 7.0.5.0 release
        cp rtrt.common.7.0.5.1.tar rtrt.zlinux.7.0.5.1.tar.Z  $TESTRTDIR
	cd $TESTRTDIR
	
	# save targets 7050 directory 
	echo "=> mv targets targets_7050"
	mv targets targets_7050
	# Untar of each required files.
	# for every platforms
	

	if [ -e "${TESTRTDIR}/lib" ]
	then
	echo "*********************************************************************"
	echo "*    Installation for Common part...                                *"
	echo "*********************************************************************"
	tar xvf rtrt.common.7.0.5.1.tar
	rm rtrt.common.7.0.5.1.tar
	fi
			
	# If LINUX is installed only
	if [ -e "${TESTRTDIR}/bin/s390x" ]
	then
		echo "*********************************************************************"
		echo "*    Installation for ZLINUX part...                                *"
		echo "*********************************************************************"
		tar zxvf rtrt.zlinux.7.0.5.1.tar.Z 
		rm rtrt.zlinux.7.0.5.1.tar.Z
	fi
	
	./bin/s390x/linux_redhat/PostInstall.sh
	
	echo "*********************************************************************"
	echo "* => "${TESTRTDIR}/targets 
	echo "* have been moved in before installation of the new release "
	echo "* => " ${TESTRTDIR}/targets_7050
	echo "*    Installation Done                                              *"
	echo "*********************************************************************"	
	
  fi # It is a 7.0.5.0 release

fi # TESTRTDIR is correctly set



