#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                  -*-  Batch TDP Library compilation -*-                      #
#                                                                              #
#                                                                              #
#  Script used by attolcc (batch compilation launcher)                         #
#                                                                              #
#                                                                              #
################################################################################
#$Id: BatchCCDefaults.pl,v 1.27 2007/07/02 20:52:07 rfrance Exp $
################################################################################

################################################################################
#
# Using this settings outside of attolcc:
# After a copy of this file, just select and uncomment the following variables
#
################################################################################

# Language choice:
# $INIFILE="tp.ini"; # C language
# $INIFILE="tpcpp.ini"; # C++ language (if any)

# Select the components you want to use:
# $ATUMODE=1; # Unit Testing
# $ATSMODE=1; # System Testing
# $ATOMODE=1; # Object Testing
# $ATKMODE=1; # Contract Check
# $ATCMODE=1; # Coverage
# $ATTMODE=1; # Trace
# $ATPMODE=1; # Memory Profiling
# $ATQMODE=1; # Performance Profiling

################################################################################
#
# These defaults settings are used by the attolcc launcher in order to compile
# the Target Deployment Port Library.
#
# To Override these defaults settings, copy this file in a directory,
# modify whatever you need and then the ATL_OVER_SET environment variable to
# your modified copy of the file.
#
################################################################################


# Compiler flags:
$CPPFLAGS.="";
$CFLAGS.="";

# General default settings:
$ATL_MULTI_THREADS=0;
$ATL_MULTI_PROCESS=0;
$ATL_THREADS_MAX=64;
$ATL_BUFFER_SIZE=16384;
$ATL_RUNTIME_FORMAT="OBJ";
$ATL_CHECK_STACK=0;

# System Testing flags:
$ATS_RT_BUFFER=0;
$ATS_BUFFER_SIZE=8192;
$ATS_TAGTBUF_SIZE=4096;
$ATS_DYN_FOLLOW=0;

#Component testing For C
$ATU_BREAK_ON_TEST_FAILED=0;
$CONTONWARN=1;

# Object Testing flags:
$ATO_STOP_ON_ERROR=0;
$ATO_DUMP_SUCCESS=0;
$ATO_MAX_INSTANCES=64;
$ATO_PRINT_BUFFER_SIZE=1024;
$ATK_STOP_ON_ERROR=0;
$ATK_DUMP_SUCCESS=0;
$ATK_REPORT_REFLEXIVE_STATES=1;

# Coverage default settings:
$ATC_INFORMATION=0 unless ($ATC_INFORMATION);
$ATC_DUMP_DRIVER=0;

# Trace default settings:
$ATT_ON_THE_FLY=0;
$ATT_ITEM_BUFFER=0;
$ATT_ITEM_BUFFER_SIZE=100;
$ATT_PARTIAL_DUMP=0;
$ATT_SIGNAL_ACTION=0;
$ATT_RECORD_MAX_STACK=1;
$ATT_TIMESTAMP=0;
$ATT_THREAD_INFO=1;

# Memory Profiling default settings:
$ATP_CALL_STACK_SIZE=6;
$ATP_REPORTS_FIU=1;
$ATP_REPORTS_SIG=1;
$ATP_REPORTS_MIU=0;
$ATP_REPORTS_FFM_FMWL=1;
$ATP_MAX_FREEQ_LENGTH=100;
$ATP_MAX_FREEQ_SIZE=1048576;
$ATP_MAX_FREEQ_BLOCK_SIZE=1048576;
$ATP_REPORTS_ABWL=1;
$ATP_RED_ZONE_SIZE=16;
$ATP_KEEP_CONTENT=0;
$ATP_NO_TRACK_ALLOCS_BEFORE_INIT=0;

# Performance Profiling default settings:
$ATQ_DUMP_DRIVER=0;

1;

