
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################


use File::Basename;
use File::Copy;

die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $SCRIPTDIR . "Translate.pl";

my $INTDIR=".";
my $pathSeparator;
my $gcc_dir;
my $gcc_version;

sub quit
{
	print &PerlTranslate("ConfigureGcc.pl", "\nConfiguration is not complete.\n");
	print &PerlTranslate("ConfigureGcc.pl", "You can relaunch this configuration script later by using the command:\n");
	print "$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl ConfigureGcc.pl\nor\nConfigureGcc.sh\n"; # NO TRANSLATION
	print &PerlTranslate("ConfigureGcc.pl", "Confirm quit ? ( y | n )\n");
	$reply=<STDIN>;
	chomp($reply);
	if(($reply eq &PerlTranslate("ConfigureGcc.pl", "y"))||($reply eq &PerlTranslate("ConfigureGcc.pl", "yes")))
	{
		print &PerlTranslate("ConfigureGcc.pl", "Quitting\n");
		exit(1);
	}
}

sub showLog #($)
{
	my $log=shift;

	open(IN,"<$log");
	while(<IN>) { print ; }
	close(IN);
}

sub MCheckGcc
{
	my $Status;
	my $gcccmd;
	my $tmp="$INTDIR/tmp_gcc_v";
	my $confirm;

	$confirm=0;
	while($confirm==0)
	{
		$Status=1;
		while($Status!=0)
		{
			$gcccmd="gcc" if($gcc_dir eq "");
			$gcccmd="$gcc_dir/gcc" if($gcc_dir ne "");
			print &PerlTranslate("ConfigureGcc.pl", "Trying to execute %1\n", "%1 is the command to be executed", "$gcccmd -v");
                        $back_lang = $ENV{'LANG'};
                        $ENV{'LANG'} = "C";
			$Status=system("$gcccmd -v > $tmp 2>&1");
                        $ENV{'LANG'} = $back_lang;
			$Status>>=8 if($^O=~/Win32/);
			if($Status!=0)
			{
				print &PerlTranslate("ConfigureGcc.pl", "The return status was %1\n", "%1 is the status", $Status);
				print &PerlTranslate("ConfigureGcc.pl", "The command %1 does not work properly: Here is the log file:\n", "%1 is the command", $gcccmd);
				showLog($tmp);
				print &PerlTranslate("ConfigureGcc.pl", "\nEnter the complete name of the directory containing gcc or q to quit\n");
				$gcc_dir=<STDIN>;
				chomp($gcc_dir);
				if($gcc_dir eq &PerlTranslate("ConfigureGcc.pl", "q"))
				{
					quit();
					$gcc_dir="";
				}
			}
		}
		#
		# Show the log
		#
		print &PerlTranslate("ConfigureGcc.pl", "Obtained following result:\n");
		showLog($tmp);
		print &PerlTranslate("ConfigureGcc.pl", "\nIs this correct ? ( y | n )\n");
		$reply=<STDIN>;
		chomp($reply);
		$confirm=1 if(($reply eq &PerlTranslate("ConfigureGcc.pl", "y"))||($reply eq &PerlTranslate("ConfigureGcc.pl", "yes")));
		if(($reply ne &PerlTranslate("ConfigureGcc.pl", "y"))&&($reply ne &PerlTranslate("ConfigureGcc.pl", "yes")))
		{
			print &PerlTranslate("ConfigureGcc.pl", "\nEnter the complete name of the directory containing gcc or q to quit\n");
			$gcc_dir=<STDIN>;
			chomp($gcc_dir);
			if($gcc_dir eq &PerlTranslate("ConfigureGcc.pl", "q"))
			{
				quit();
				$gcc_dir="";
			}
		}
		else
		{
			my $found=0;
			open(GCC,"<$tmp");
			while(<GCC>)
			{
				if (/^(.*) version (?:egcs-)?((\d+\.)+\d+).*$/)
				{
					$gcc_version = $2;
					$found = 1;
					break;
				}
			}
			close(GCC);
			if($found==0)
			{
				print &PerlTranslate("ConfigureGcc.pl", "Can not parse to find out the gnu version - Try again\n");
				print &PerlTranslate("ConfigureGcc.pl", "\nEnter the complete name of the directory containing gcc or q to quit\n");
				$gcc_dir=<STDIN>;
				chomp($gcc_dir);
				if($gcc_dir eq &PerlTranslate("ConfigureGcc.pl", "q"))
				{
					quit();
					$gcc_dir="";
				}
			}
		}
	}
	print &PerlTranslate("ConfigureGcc.pl", "Trying to C compile\n");
	$ENV{'PATH'}=$gcc_dir.$pathSeparator.$ENV{'PATH'} if($gcc_dir ne "");
	open(OU,">$INTDIR/empty.c"); print OU "int main() { return(0); }\n"; close(OU);
	$Status=system("gcc -v $INTDIR/empty.c > $tmp 2>&1");
	if($Status != 0)
	{
		print &PerlTranslate("ConfigureGcc.pl", "The return status was %1\n", "%1 is the status", $Status);
		print &PerlTranslate("ConfigureGcc.pl", "%1 produced the following results\n", "%1 is the command that has been launched", "gcc -v $INTDIR/empty.c");
		showLog($tmp);
		print &PerlTranslate("ConfigureGcc.pl", "\nConfiguration is not complete.\n");
		print &PerlTranslate("ConfigureGcc.pl", "Please solve the problem with the gnu compiler. Contact your system administrator if necessary.\n");
		print &PerlTranslate("ConfigureGcc.pl", "You can relaunch this configuration script later by using the command:\n");
		print "$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl ConfigureGcc.pl\nor\nConfigureGcc.sh\n"; # NO TRANSLATION
		exit(1);

	}
	print &PerlTranslate("ConfigureGcc.pl", "Success\n");
	copy("$INTDIR/empty.c","$INTDIR/empty.cc");
	print &PerlTranslate("ConfigureGcc.pl", "Trying to C++ compile\n");
	$Status=system("g++ -v $INTDIR/empty.c > $tmp 2>&1");
	if($Status != 0)
	{
		print &PerlTranslate("ConfigureGcc.pl", "The return status was %1\n", "%1 is the status", $Status);
		print &PerlTranslate("ConfigureGcc.pl", "%1 produced the following results\n", "%1 is the command that has been launched", "g++ -v $INTDIR/empty.c");
		showLog($tmp);
		print &PerlTranslate("ConfigureGcc.pl", "\nConfiguration is not complete.\n");
		print &PerlTranslate("ConfigureGcc.pl", "Please solve the problem with the gnu compiler. Contact your system administrator if necessary.\n");
		print &PerlTranslate("ConfigureGcc.pl", "You can relaunch this configuration script later by using the command:\n");
		print "$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl ConfigureGcc.pl\nor\nConfigureGcc.sh\n"; # NO TRANSLATION
		exit(1);
	}
	print &PerlTranslate("ConfigureGcc.pl", "Success\n");
	unlink("$INTDIR/empty.c");
	unlink("$INTDIR/empty.cc");
	unlink("$INTDIR/a.out");
	unlink($tmp);
	return($found);
}

sub patchXdp #($$)
{
	my $f=shift;
	my $path=shift;
	my $pathmet;
	
	print &PerlTranslate("ConfigureGcc.pl", "Patching %1 with PATH set to %2\n", "%1 is the file to be patched and %2 is the value for the PATH environment variable", $f, $path);
	$pathmet=0;
	open(IN,"<$f");
	open(OU,">tmp.txt");
	while(<IN>)
	{
		if(/<TDP/) #remove the Gnu version
		{
			s/(Name=\"[^\"]*Gnu) [^\"]*\"/$1\"/;
		}
		elsif(/<KEY>ENV_PATH<\/KEY>/)
		{
			$pathmet=1 if($path ne "");
			print OU;
			next;
		}
		if($pathmet==1)
		{
			s/<VALUE>.*<\/VALUE>/<VALUE>$path:\$ENV{'PATH'}<\/VALUE>/;
			$pathmet=0;
		}
		print OU;
	}
	close(IN);
	close(OU);
	rename("tmp.txt",$f);
}

sub main
{
	my $xdpFile; #xdp to generate
	my $perl;
	my $xmlDir="$ENV{'TESTRTDIR'}/targets/xml";
	my $orgxdp;

	die &PerlTranslate("ConfigureGcc.pl", "Environment variable TESTRTDIR not properly set. Cannot find targets directory. Exiting.\n") if(! -d "$ENV{'TESTRTDIR'}/targets");
	$pathSeparator=":";
	$pathSeparator=";" if($^O=~/Win32/);

	if($^O =~ /linux/i)
	{
	    $xdpFile="clinuxgnu.xdp";
	    if(-d "$ENV{'TESTRTDIR'}/bin/s390x")
	    {
		$host="linux_redhat";
		$perl="$ENV{'TESTRTDIR'}/bin/s390x/$host/TestRTperl";
		$orgxdp="czlinuxgnu.xdp";
	    }
	    else
	    {	#intel redhat & suse
		my $host;

		print &PerlTranslate("ConfigureGcc.pl", "\nLinux configuration for C / C++\n");
		$host="linux_redhat";
		$host="linux_suse" if(-d "/etc/SuSEconfig" );
		$perl="$ENV{'TESTRTDIR'}/bin/intel/$host/TestRTperl";
	
		my $s=MCheckGcc();
		# Gcc exists and is located
		my ($major_version,$minor_version,$release_number)=split(/\./,$gcc_version);
		print &PerlTranslate("ConfigureGcc.pl", "Status of CheckGcc %1: major=%2 minor=%3 location=%4\n", "%1 is the status, %2 is the Gnu compiler major part of the version, %3 is its minor part of the version and %4 is its location", $s, $major_version, $minor_version, $gcc_dir);
		$orgxdp="clinuxgnu2_95.xdp" if(($major_version eq "2")&&($minor_version eq "95"));
		$orgxdp="clinuxgnu2_96.xdp" if(($major_version eq "2")&&($minor_version eq "96"));
                $orgxdp="clinuxgnu3_2.xdp" if(($major_version eq "3")&&(($minor_version eq "2")||($minor_version eq "3")||($minor_version eq "4")));
                $orgxdp="clinuxgnu3_2.xdp" if($major_version eq "4");
		die &PerlTranslate("ConfigureGcc.pl", "No TDP match the version of gcc: %1 - Available versions are 2.95.x, 2.96.x, 3.2, 3.3, 3.4 and 4.x\n", "%1 is the Gnu compiler version", $gcc_version) if($orgxdp eq "");
	    }
	}
	else
	{
		my $s=MCheckGcc();
		# Gcc exists and is located
		my ($major_version,$minor_version,$release_number)=split(/\./,$gcc_version);
		print &PerlTranslate("ConfigureGcc.pl", "Status of CheckGcc %1: major=%2 minor=%3 location=%4\n", "%1 is the status, %2 is the Gnu compiler major part of the version, %3 is its minor part of the version and %4 is its location", $s, $major_version, $minor_version, $gcc_dir);
		if($^O =~ /solaris/i)
		{
			print &PerlTranslate("ConfigureGcc.pl", "\nSolaris Gnu configuration for C / C++\n");
			$perl="$ENV{'TESTRTDIR'}/bin/sun4/sunOS5/TestRTperl";
			$xdpFile="csolgnu.xdp";
			$orgxdp="csolgnu2_95.xdp" if(($major_version eq "2")&&($minor_version eq "95"));
			$orgxdp="csolgnu2_96.xdp" if(($major_version eq "2")&&($minor_version eq "96"));
			$orgxdp="csolgnu3_2.xdp" if(($major_version eq "3")&&(($minor_version eq "2")||($minor_version eq "3")||($minor_version eq "4")));
			$orgxdp="csolgnu3_2.xdp" if($major_version eq "4");
		}
		if($^O =~ /hpux/i)
		{
			print &PerlTranslate("ConfigureGcc.pl", "\nHP-UX Gnu configuration for C / C++\n");
			$perl="$ENV{'TESTRTDIR'}/bin/hp700/hpux/TestRTperl";
			$xdpFile="chpgnu.xdp";
			$orgxdp="chpgnu2_95.xdp" if(($major_version eq "2")&&($minor_version eq "95"));
			$orgxdp="chpgnu2_96.xdp" if(($major_version eq "2")&&($minor_version eq "96"));
			$orgxdp="chpgnu3_2.xdp" if(($major_version eq "3")&&(($minor_version eq "2")||($minor_version eq "3")||($minor_version eq "4")));
			$orgxdp="chpgnu3_2.xdp" if($major_version eq "4");
		}
		if($^O =~ /aix/i)
		{
			print &PerlTranslate("ConfigureGcc.pl", "\nAIX Gnu configuration for C / C++\n");
			$perl="$ENV{'TESTRTDIR'}/bin/rs6000/aix/TestRTperl";
			$xdpFile="caixgnu.xdp";
			$orgxdp="caixgnu2_95.xdp" if(($major_version eq "2")&&($minor_version eq "95"));
			$orgxdp="caixgnu2_96.xdp" if(($major_version eq "2")&&($minor_version eq "96"));
			$orgxdp="caixgnu3_2.xdp" if(($major_version eq "3")&&(($minor_version eq "2")||($minor_version eq "3")||($minor_version eq "4")));
			$orgxdp="caixgnu3_2.xdp" if($major_version eq "4");
		}
	}
	die &PerlTranslate("ConfigureGcc.pl", "No TDP match the version of gcc: %1\n", "%1 is the Gnu compiler version", $gcc_version) if(($orgxdp eq "") || !(-f "$xmlDir/$orgxdp"));
	copy("$xmlDir/$orgxdp","$xmlDir/$xdpFile");
	patchXdp("$xmlDir/$xdpFile",$gcc_dir);
	system("$perl -I$ENV{'TESTRTDIR'}/lib/perl $ENV{'TESTRTDIR'}/lib/scripts/tdpgen.pl $xmlDir/$xdpFile  $ENV{'TESTRTDIR'}/targets");
}

$|=1;
main();

1;
