
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################


use File::Basename;
use File::Copy;

die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
my $boot="rt.jar";

if ($BINDIR eq "") {
	$BINDIR = "$ENV{'TESTRTDIR'}/bin/";
	my $RTRT_OS;
	$RTRT_OS = "rs6000/aix" if ($^O =~ /aix/i);
	$RTRT_OS = "hp700/hpux" if ($^O =~ /hpux/i);
	$RTRT_OS = "sun4/sunOS5" if ($^O =~ /solaris/i);
	$RTRT_OS = "intel/win32" if ($^O =~ /win32/i);
	if ($^O =~ /linux/i) {
		if ( -d "/etc/SuSEconfig" ) {
			$RTRT_OS = "intel/linux_suse";
		}
		else {
	            if(-d "$ENV{'TESTRTDIR'}/bin/s390x")
        	    {
			$RTRT_OS = "s390x/linux_redhat";
            	    }
		    else
		    {
			$RTRT_OS = "intel/linux_redhat";
		    }
		}
	}
	$BINDIR .= $RTRT_OS;
}

$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $SCRIPTDIR . "Translate.pl";

my $INTDIR=".";
my $pathSeparator;
my $gcc_dir;
my $wtk_dir;
my $edition;
my $assert;
my $configwtk=0;
my $J2ME_VERSION;

sub quit
{
	print &PerlTranslate("ConfigureJavac.pl", "\nConfiguration is not complete.\n");
	print &PerlTranslate("ConfigureJavac.pl", "You can relaunch this configuration script later by using the command:\n");
	print "$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl ConfigureJavac.pl\nor\nConfigureJavac.sh\n"; # NO TRANSLATION
	print &PerlTranslate("ConfigureJavac.pl", "Confirm quit ? ( y | n )\n");
	$reply=<STDIN>;
	chomp($reply);
	die &PerlTranslate("ConfigureJavac.pl", "Quitting\n") if(($reply eq &PerlTranslate("ConfigureJavac.pl", "y"))||($reply eq &PerlTranslate("ConfigureJavac.pl", "yes")));
}

sub showLog #($)
{
	my $log=shift;

	open(IN,"<$log");
	while(<IN>) { print ; }
	close(IN);
}

sub MCheckGcc
{
	my $Status;
	my $gcccmd;
	my $tmp="$INTDIR/tmp_gcc_v";
	my $confirm;

	open(OU,">$INTDIR/Test.java"); print OU "class Test {}\n"; close(OU);
	$confirm=0;
	$configwtk=0;
	while($confirm==0)
	{
		$Status=1;
		while($Status!=0)
		{
			$gcccmd="javac" if($gcc_dir eq "");
			$gcccmd="$gcc_dir/javac" if($gcc_dir ne "");
			print &PerlTranslate("ConfigureJavac.pl", "Trying to execute %1\n", "%1 is the command that is to be launched", "$gcccmd Test.java");
			$Status=system("$gcccmd Test.java > $tmp 2>&1");
			$Status>>=8 if($^O=~/Win32/);
			if($Status!=0)
			{
				print &PerlTranslate("ConfigureJavac.pl", "The return status was %1\n", "%1 is the status returned by the command", $Status);
				print &PerlTranslate("ConfigureJavac.pl", "The command %1 does not work properly: Here is the log file:\n", "%1 is the command that has been launched", $gcccmd);
				showLog($tmp);
				print &PerlTranslate("ConfigureJavac.pl", "\nEnter the complete name of the directory containing javac or q to quit\n");
				$gcc_dir=<STDIN>;
				chomp($gcc_dir);
				if($gcc_dir eq &PerlTranslate("ConfigureJavac.pl", "q"))
				{
					quit();
					$gcc_dir="";
				}
			}
		}
		if($gcc_dir eq "")
		{
			foreach(split(/$pathSeparator/,$ENV{'PATH'}))
			{
				$gcc_dir=$_;
				$file=$gcc_dir."/javac";
				last if(-x $file);
			}
			if(! -x $file)
			{
				print &PerlTranslate("ConfigureJavac.pl", "javac was found, in the path, but could not be found when parsing the path !!\n");
				die &PerlTranslate("ConfigureJavac.pl", "This normally should not happen !!\n");
			}
		}
		print &PerlTranslate("ConfigureJavac.pl", "Found javac command in %1\n", "%1 is the directory where javac has been found", $gcc_dir);
		print &PerlTranslate("ConfigureJavac.pl", "\nIs this correct ? ( y | n )\n");
		$reply=<STDIN>;
		chomp($reply);
		$confirm=1 if(($reply eq &PerlTranslate("ConfigureJavac.pl", "y"))||($reply eq &PerlTranslate("ConfigureJavac.pl", "yes")));
		if(($reply ne &PerlTranslate("ConfigureJavac.pl", "y"))&&($reply ne &PerlTranslate("ConfigureJavac.pl", "yes")))
		{
			print &PerlTranslate("ConfigureJavac.pl", "\nEnter the complete name of the directory containing javac or q to quit\n");
			$gcc_dir=<STDIN>;
			chomp($gcc_dir);
			if($gcc_dir eq &PerlTranslate("ConfigureJavac.pl", "q"))
			{
				quit();
				$gcc_dir="";
			}
		}
		else
		{
			$assert=3;
			while(($assert!=0)&&($assert!=1))
			{
				print &PerlTranslate("ConfigureJavac.pl", "Which version of the JDK is it ? (1.3.1 | 1.4.x)\n");
				$reply=<STDIN>;
				chomp($reply);
				$assert=0 if($reply eq &PerlTranslate("ConfigureJavac.pl", "1.3.1"));
				$assert=1 if($reply eq &PerlTranslate("ConfigureJavac.pl", "1.4.x"));
			}
			$reply="";

			while(($reply ne &PerlTranslate("ConfigureJavac.pl", "y"))&&($reply ne &PerlTranslate("ConfigureJavac.pl", "yes"))&&($reply ne &PerlTranslate("ConfigureJavac.pl", "n"))&&($reply ne &PerlTranslate("ConfigureJavac.pl", "no")))
			{
				print &PerlTranslate("ConfigureJavac.pl", "Do you want also to configure the J2ME Wireless ToolKit? ( y | n )\n");
				$reply=<STDIN>;
				chomp($reply);
			}
		
	
                        if(($reply eq &PerlTranslate("ConfigureJavac.pl", "y"))||($reply eq &PerlTranslate("ConfigureJavac.pl", "yes"))) {
				while(($J2ME_VERSION ne &PerlTranslate("ConfigureJavac.pl", "1.0.3"))&&($J2ME_VERSION ne &PerlTranslate("ConfigureJavac.pl", "2.x"))) {
                	        	print &PerlTranslate("ConfigureJavac.pl", "Which version of the J2ME is it ? (1.0.3 | 2.x )\n");
        	                	$J2ME_VERSION=<STDIN>;
    	                		chomp($J2ME_VERSION);
                        	}
			}

			if(($reply eq &PerlTranslate("ConfigureJavac.pl", "y"))||($reply eq &PerlTranslate("ConfigureJavac.pl", "yes")))
			{
				$configwtk=1;
				$c2=0;
				while($c2==0)
				{
					#
					# Search for preverify
					#
					$ENV{'PATH'}=$gcc_dir.$pathSeparator.$ENV{'PATH'};
					$Status=system("javac -target 1.1 Test.java > $tmp 2>&1") if ($J2ME_VERSION eq "1.0.3");
					$Status=system("javac -target Test.java > $tmp 2>&1") if ($J2ME_VERSION eq "2.x");
					$Status=1;
					while($Status!=0)
					{
						if($wtk_dir eq "")
						{
							foreach(split(/$pathSeparator/,$ENV{'PATH'}))
							{
								$wtk_dir=$_;
								$file=$wtk_dir."/preverify";
								last if(-x $file);
							}
							$wtk_dir="" if(! -x $file);
						}
						if($wtk_dir ne "")
						{
							$ENV{'PATH'}=$wtk_dir.$pathSeparator.$ENV{'PATH'};
							$gcccmd="preverify -classpath ".dirname($wtk_dir)."/lib/midpapi.zip" if ($J2ME_VERSION eq "1.0.3");
							$gcccmd="preverify -classpath ".dirname($wtk_dir)."/lib/midpapi20.jar:".dirname($wtk_dir)."/lib/cldcapi10.jar" if ($J2ME_VERSION eq "2.x");
							print &PerlTranslate("ConfigureJavac.pl", "Trying to execute %1\n", "%1 is the command that is to be launched", "$gcccmd Test");
							$Status=system("$gcccmd Test > $tmp 2>&1");
						}
						else
						{
							$Status=0xFFFF;
						}
						$Status>>=8 if($^O=~/Win32/);
						if($Status!=0)
						{
							if($Status!=0xFFFF)
							{
								print &PerlTranslate("ConfigureJavac.pl", "The return status was %1\n", "%1 is the status returned by the command", $Status);
								print &PerlTranslate("ConfigureJavac.pl", "The command %1 does not work properly: Here is the log file:\n", "%1 is the command that has been launched", $gcccmd);
								showLog($tmp);
							}
							print &PerlTranslate("ConfigureJavac.pl", "\nEnter the complete name of the directory containing preverify or q to quit\n");
							$wtk_dir=<STDIN>;
							chomp($wtk_dir);
							if($wtk_dir eq &PerlTranslate("ConfigureJavac.pl", "q"))
							{
								quit();
								$wtk_dir="";
							}
						}
						else
						{
							print &PerlTranslate("ConfigureJavac.pl", "Found the Wireless Toolkit in %1\n", "%1 is the directory where the Wireless Toolkit has been found", $wtk_dir);
							$reply="";
							while(($reply ne &PerlTranslate("ConfigureJavac.pl", "y"))&&($reply ne &PerlTranslate("ConfigureJavac.pl", "yes"))&&($reply ne &PerlTranslate("ConfigureJavac.pl", "n"))&&($reply ne &PerlTranslate("ConfigureJavac.pl", "no")))
							{
								print &PerlTranslate("ConfigureJavac.pl", "Is this correct ( y | n )\n");
								$reply=<STDIN>;
								chomp($reply);
								$c2=1 if(($reply eq &PerlTranslate("ConfigureJavac.pl", "y"))||($reply eq &PerlTranslate("ConfigureJavac.pl", "yes")));
								if(($reply eq &PerlTranslate("ConfigureJavac.pl", "n"))||($reply eq &PerlTranslate("ConfigureJavac.pl", "no")))
								{
									print &PerlTranslate("ConfigureJavac.pl", "\nEnter the complete name of the directory containing javac or q to quit\n");
									$wtk_dir=<STDIN>;
									chomp($wtk_dir);
									if($wtk_dir eq "q")
									{
										quit();
										$wtk_dir="";

									}
								}
							}
						}
					}
				}
			}
		}
	}
	print &PerlTranslate("ConfigureJavac.pl", "Success\n");
	unlink("$INTDIR/Test.java");
	unlink("$INTDIR/Test.class");
	unlink("$INTDIR/output/Test.class");
	unlink("$INTDIR/output");
	system("/bin/rm -rf output");
	unlink($tmp);
}

sub patchXdp #($$$$)
{
	my $f=shift;
	my $path=shift;
	my $bootclasspath=shift;
	my $assert=shift;
	my $pathmet;
	my $bootclasspathmet;
	
	print &PerlTranslate("ConfigureJavac.pl", "Patching %1 with PATH set to %2\n", "%1 is the xdp file to be patched and %2 is the value convenient for the environment variable PATH", $f, $path);
	$pathmet=0;
	$bootclasspathmet=0;
	open(IN,"<$f");
	open(OU,">tmp.txt");
	while(<IN>)
	{
		if(/<KEY>ENV_PATH<\/KEY>/)
		{
			$pathmet=1;
			print OU;
			next;
		}
		if(/<KEY>DEFAULT_BOOTCLASSPATH<\/KEY>/)
		{
			$bootclasspathmet=1;
			print OU;
			next;
		}
		if($pathmet==1)
		{
			s/<VALUE>.*<\/VALUE>/<VALUE>$path:\$ENV{'PATH'}<\/VALUE>/;
			$pathmet=0;
		}
		if($bootclasspathmet==1)
		{
			s/<VALUE>.*<\/VALUE>/<VALUE>$bootclasspath<\/VALUE>/;
			$bootclasspathmet=0;
		}
		s/<BINARY_MACRO.*Name=\"AssertAvailable\".*>/<BINARY_MACRO Doc=\"ASSERTAVAILABLE\" Name=\"AssertAvailable\" Value=\"$assert\" Label=\"Java Assert Available\" >/;
		print OU;
	}
	close(IN);
	close(OU);
	rename("tmp.txt",$f);
}

sub main
{
	print &PerlTranslate("ConfigureJavac.pl", "Configuration for Java\n");
	print &PerlTranslate("ConfigureJavac.pl", "With this configuration process, you have the ability to support the following development environments:\n");
	print &PerlTranslate("ConfigureJavac.pl", "\tJDK 1.3.1\n\tJDK 1.4.x\n");
	
	die &PerlTranslate("ConfigureJavac.pl", "Environment variable TESTRTDIR not properly set. Cannot find 'targets' directory. Exiting.\n") if(! -d "$ENV{'TESTRTDIR'}/targets");
	$pathSeparator=":";
	$pathSeparator=";" if($^O=~/Win32/);
	my $s=MCheckGcc();

	my $xdpFile="";
	$xdpFile="$ENV{'TESTRTDIR'}/targets/xml/jdk1.4.0.xdp" if($assert==1);
	$xdpFile="$ENV{'TESTRTDIR'}/targets/xml/jdk1.3.1.xdp" if($assert==0);

	$boot    = "core.jar" if(($^O =~ /aix/i) && ($assert==1));
	my $bootclasspath=dirname($gcc_dir)."/jre/lib/".$boot;
	patchXdp($xdpFile,$gcc_dir,$bootclasspath,$assert);
	system("$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl $ENV{'TESTRTDIR'}/lib/scripts/tdpgen.pl $xdpFile $ENV{'TESTRTDIR'}/targets");

	if($configwtk==1)
	{
		my $bootclasspath;
		$xdpFile="$ENV{'TESTRTDIR'}/targets/xml/j2mewtk1.03.xdp"  if ($J2ME_VERSION eq "1.0.3");
		$xdpFile="$ENV{'TESTRTDIR'}/targets/xml/j2mewtk2.x.xdp"  if ($J2ME_VERSION eq "2.x");
		my $pathtopatch=$wtk_dir.$pathSeparator.$gcc_dir;
		$bootclasspath=dirname($wtk_dir)."/lib/midpapi.zip,".dirname($gcc_dir)."/jre/lib/rt.jar" if ($J2ME_VERSION eq "1.0.3");
		$bootclasspath=dirname($wtk_dir)."/lib/midpapi20.jar,".dirname($wtk_dir)."/lib/cldcapi10.jar,".dirname($gcc_dir)."/jre/lib/rt.jar" if ($J2ME_VERSION eq "2.x");
		patchXdp($xdpFile,$pathtopatch,$bootclasspath,$assert);
		system("$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl $ENV{'TESTRTDIR'}/lib/scripts/tdpgen.pl $xdpFile $ENV{'TESTRTDIR'}/targets");
	}
}

$|=1;
main();

1;
