
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################


use File::Basename;
use File::Copy;

die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $SCRIPTDIR . "Translate.pl";

my $INTDIR=".";
my $pathSeparator;
my $gcc_dir;
my $wtk_dir;
my $edition;
my $assert;
my $configwtk=0;
my $Rose_RT_REG_File ="TestRT-RoseRT.reg" ;
my $Reg_File;
my $RTRT_RRT_DIR = "/RoseRT/sun5/";
$RTRT_RRT_DIR = "/RoseRT/linux/" if ($^O =~ /linux/i);
my $RoseRT_Home=$ENV{ROSERT_HOME};
$RoseRT_Home="/projets/build/RoseRT/release/RoseRT.7.0.0.0" if($RoseRT_Home eq '');
sub quit
{
	print &PerlTranslate("ConfigureRoseRT.pl", "\nConfiguration is not complete.\n");
	print &PerlTranslate("ConfigureRoseRT.pl", "You can relaunch this configuration script later by using the command:\n");
	print "$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl ConfigureRoseRT.pl\nor\nConfigureRoseRT.sh\n"; # NO TRANSLATION
	print &PerlTranslate("ConfigureRoseRT.pl", "Confirm quit ? ( y | n )\n");
	$reply=<STDIN>;
	chomp($reply);
	die &PerlTranslate("ConfigureRoseRT.pl", "Quitting\n") if(($reply eq &PerlTranslate("ConfigureRoseRT.pl", "y"))||($reply eq &PerlTranslate("ConfigureRoseRT.pl", "yes")));
}

sub MCheckRoseRT
{
	my $Status;
	my $gcccmd;
	my $confirm;

	$confirm=0;
	while($confirm==0)
	{


			print &PerlTranslate("ConfigureRoseRT.pl", "\nIf you want to configure the RoseRT plugin and you have RoseRT installed,");
			print &PerlTranslate("ConfigureRoseRT.pl", "\nenter the complete name of the directory containing RoseRT, or q to quit");
			print &PerlTranslate("ConfigureRoseRT.pl", "\nExamples:");
			print &PerlTranslate("ConfigureRoseRT.pl", "\n$RoseRT_Home\n?\n");
			$gcc_dir=<STDIN>;
			chomp($gcc_dir) ;
			$RoseRT_Home=$gcc_dir if($gcc_dir ne '');
			my $RoseRT_reg=$RoseRT_Home . "/bin/registry" ;
			
			if($gcc_dir eq &PerlTranslate("ConfigureRoseRT.pl", "q"))
			{
				quit();
				$gcc_dir="";
			}
			if ( -x $RoseRT_reg )
			{ # Rose RT Found
			    $confirm=1 ;
			    print &PerlTranslate("ConfigureRoseRT.pl", "\nRose RT registry found in : " . $RoseRT_reg . "\n");
			    $Reg_File = $ENV{'TESTRTDIR'} . $RTRT_RRT_DIR . $Rose_RT_REG_File ;
			    if ($gcc_dir =~ /2002\.05/)
			    {# Version = 2002.05.xx => Old version => 6.4
				 # patchRoseRT("6.5","6.4",$Reg_File);
					print &PerlTranslate("ConfigureRoseRT.pl", "Patching 6.5 to 6.4 in " . $Rose_RT_REG_File  . "\n");
					open(IN,"<$Reg_File");
					open(OU,">$RoseRT_reg/$Rose_RT_REG_File") || die print &PerlTranslate("ConfigureRoseRT.pl","Unable to write $RoseRT_reg/$Rose_RT_REG_File");
					while(<IN>)
					{
						s/6.5/6.4/;
						print OU;
					}
					close(IN);
					close(OU);
			    }
			    else
			    {# Version = 2003.06.xx => New RoseRT release => 6.5 
			    	copy($Reg_File,"$RoseRT_reg/$Rose_RT_REG_File");
			    }
			    print &PerlTranslate("ConfigureRoseRT.pl", "\ncopy " . $Reg_File . "\nto: $RoseRT_reg/$Rose_RT_REG_File with success\n") if(-s "$RoseRT_reg/$Rose_RT_REG_File");

			}
			else
			{
			    print &PerlTranslate("ConfigureRoseRT.pl", "\nRose RT registry Not found in : " . $RoseRT_reg . "\n");
			}
	} # End of While
} # End of MCheckRoseRT 

sub main
{
	print &PerlTranslate("ConfigureRoseRT.pl", "Configuration for RoseRT\n");
	print &PerlTranslate("ConfigureRoseRT.pl", "With this configuration process, you have the ability to support the following Rose RealTime:\n");
	print &PerlTranslate("ConfigureRoseRT.pl", "\tRoseRT 2003.06.xx\n\tRoseRT 7.0.0.0\n");
	
	die &PerlTranslate("ConfigureRoseRT.pl", "Environment variable TESTRTDIR not properly set. Cannot find apropriate '$RTRT_RRT_DIR' directory. Exiting.\n") if(! -d "$ENV{'TESTRTDIR'}$RTRT_RRT_DIR");
	my $s=MCheckRoseRT();


} # End of Main

$|=1;
main();

1;
