#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                          -*-  Source Browsing -*-                            #
#                                                                              #
#                                                                              #
#                                                                              #
#  Perl-Script         tags.pl                                                 #
#  Version             v3.4                                                    #
#                                                                              #
#  $Revision: 1.22 $                                                           #
#  $Date: 2007/07/23 18:41:58 $                                                #
#                                                                              #
#  Launch tags tool to determinate control structures into program files       #
#                                                                              #
#  Usage:                                                                      #
#       TestRTperl tags.pl <file list>                                               #
#                                                                              #
#  Problems:                                                                   #
#	Source Compilation: Spec=ads; Bdy=adb                                  #
#	RecompileAdaRuntimeLibraries: Verification NAME/LNAME only             #
#                                                                              #
# Required global variables:                                                   #
#   $BINDIR		 : binary directory required for the PerlTranslate     #
################################################################################
use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

# Configuration file
require $ARGV[0];

# Miscellaneous functions
require $SCRIPTDIR . "Fcts.pl";


################################################################################
# Here is the beginning
################################################################################
#&EnterInScript;


###########################################################################
# This routine analyze the command line of script
sub CommandLineAnalyze
{
  return (1);
}

###########################################################################
# Print the USAGE
sub AttolCommandUsage
{
   die &PerlTranslate("Import.pl", "Use command like that : TestRTperl Import.pl <environment file> <file> \nExiting\n");
}

###########################################################################
# Decide what to do

# analyze command line to get phases
CommandLineAnalyze() || AttolCommandUsage();

#ClearLogFile($LOGFILENAME);

print &PerlTranslate("Import.pl", "Importing Test RealTime v2001a Unit Testing project files ...\n");

$ENV{'ATTOLHOME'}=$ATTOLHOME;

#
# Command line: atm2stu <rtw_filename> ( <prj_filename> | <cmp_filename> | <ses_filename> ) * 
#      $1           --> Studio "workspace" file,
#      $2 $3 $4 ... --> Attoltm "project", "session" or "campaign" files
#
my $my_command = $BINDIR . $PATH_SEPARATOR . "atm2stu -o \"$PROJECT_FILEPATH\" ";
foreach $import_file (@IMPORTFILES)
{
  $my_command .= " \"$import_file\"";
}
my $my_status = SystemP($my_command);

if ($my_status != 0 )
{
  print &PerlTranslate("Import.pl", "Importation failed.\n");
  exit(-1);
}

#open ( LOG, ">>$LOGFILENAME" ) or die ("Cannot open log file: $!\n");
#print  LOG "WSP $WORKSPACEFILE\n";
#close( LOG );

print &PerlTranslate("Import.pl", "Generation of project done.\n");
exit(0);

#
###############################################################################







