#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#               -*-  Start Tag SystemTestingScript Node -*-                    #
#                                                                              #
#                                                                              #
#  Script for System Test Script Node.                                         #
#                                                                              #
#                                                                              #
# Required global variables:                                                   #
#                                                                              #
################################################################################
#$Id: PreproTagSystemTest.pl,v 1.23 2007/07/23 18:41:58 rfrance Exp $
################################################################################


# useful for stdout/stderr direct viewing inside 'console' of studio window
# (better: we have stdout/stderr lines in right order and not stder before stdout
use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

# This script depends on the followings (both studio'n Target Package)
#print $ARGV[0];
#$c = 'cat ' . $ARGV[0];
#system($c);
require $ARGV[0] ; #environment and global variables.
require $SCRIPTDIR . "Fcts.pl";

#----------------------------------------------------------------------------

################################################################################
# Here is the beginning
################################################################################
EnterInScript();

ClearLogFile( $LOGFILENAME );

# Let's associate right binary to any supported language
$AtsPrepro{'C'} = "atspreproC";
$AtsPrepro{'CPP'} = "atspreproCPP";
$AtsPrepro{'C++'} = "atspreproCPP";

# Let's go for the environment
# temporary: -> to be replaced by ATS_DIR
$ENV{'ATS_DIR'} = "$BINDIR";

#----------------------------------------------------------------------------
## Start generation
print &PerlTranslate("PreproTagSystemTest.pl", "Analyzing Test Script: %1 ...\n", "%1 is the Test Script being analyzed", $FILENAME);

my $Command = "$BINDIR" . "$PATH_SEPARATOR" . $AtsPrepro{$TDP_LANGUAGE};
#my $Command = "$BINDIR" . "$PATH_SEPARATOR" . $AtsPrepro{$ATS_PREPRO_EXE};

my $ATS_TEST_SCRIPT = "$FILENAME";
if ( $ATS_TEST_SCRIPT )
{
   $Command .= " \"$ATS_TEST_SCRIPT\"";
}

if(@ATS_INTERFACE_FILES ) {
	$Command .= " \"".join("\",\"",@ATS_INTERFACE_FILES )."\"";
}else{
	$Command .= " X";
	print &PerlTranslate("PreproTagSystemTest.pl", "ERROR: no interface file selected\n");	
}

$Command .= " X";

if(@COMPLETE_INCLUDE_DIR_LIST ) {
	$Command .= " -INCL=\"".join("\",\"",@COMPLETE_INCLUDE_DIR_LIST )."\"";
}

if ( $ATS_DEFINE )
{
   $Command .= " -DEFINE=\"$ATS_DEFINE\"";
}

if ($TDP_LANGUAGE eq "C")
{
  $Command .= " -STD_DEFINE=\"$TARGETDIR/ana/atus_c.def\" ";
}
if ($TDP_LANGUAGE eq "CPP")
{
  $Command .= " -STD_DEFINE=\"$TARGETDIR/ana/atus_cpp.def\" ";
}

$Command .= " -SPVGEN";

#print "$Command\n" if $ENV{'ATTOLSTUDIO_VERBOSE'}; # NO TRANSLATION
$status = SystemP($Command);

if(($status!=0) && ($status!=3)) {
	if($ENV{'ATTOLSTUDIO_VERBOSE'}){
		if(open(IN,$ATS_TEST_SCRIPT)) {
			print &PerlTranslate("PreproTagSystemTest.pl", "Script using:\n");
			while(<IN>){
				print if(/^\s*(MESSAGE|INCLUDE)\s/);
			}
			close IN;
		} else {print &PerlTranslate("PreproTagSystemTest.pl", "cannot open %1.\n","%1 is the Test Script being analyzed", $ATS_TEST_SCRIPT);}
	}
	print &PerlTranslate("PreproTagSystemTest.pl", "Generation failed. status=$status\n"); 
	exit($status); 
}

#if($status!=0) { print &PerlTranslate("PreproTagSystemTest.pl", "Generation failed.\n"); exit(1); }

#print &PerlTranslate("PreproTagSystemTest.pl", "Done.\n");

0;
# That's all Folks.
################################################################################
