
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Cop.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                          -*-  Probe preprocessing -*-                        #
#                                                                              #
#                                                                              #
#                                                                              #
#  Perl-Script         tags.pl                                                 #
#  Version             v3.4                                                    #
#                                                                              #
#  $Revision: 1.33 $                                                           #
#  $Date: 2007/07/23 18:41:58 $                                                #
#                                                                              #
#  launch probe analyzor to generate files before source compilations          #
#                                                                              #
#  Usage:                                                                      #
#       TestRTperl Probe.pl <environment file>                                 #
#                                                                              #
#  Problems:                                                                   #
#                                                                              #
################################################################################

use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

# Configuration file
require $ARGV[0];

# Miscellaneous functions
require $SCRIPTDIR . "Fcts.pl";

# Attol tools functions
require $SCRIPTDIR . "Tools.pl";

# Target-dependant functions
die &PerlTranslate("Probe.pl", "Unknown TDP... check configuration\n") unless (-d $TARGETDIR);
require $TARGETDIR . "/cmd/atl_cc.pl";

################################################################################
# Here is the beginning
################################################################################
CheckIntDir();
EnterInScript();
ClearLogFile($LOGFILENAME);
PutProbeSetting();

###########################################################################
# Decide what to do

print &PerlTranslate("Probe.pl", "Probing files...\n");

# test probe application node settings  
if ($ATS_PROBE_CUSTOM)
{
    my $status=1;
    my $language ="c";
    my $interfaces="";
    my $PreproInclude=join(",",@COMPLETE_INCLUDE_DIR_LIST);
    my $src_files="";
    my %mode=('default',0,'fifo',1,'file',2,'user',3,'ignore',4);
    my $stringmode;
    


    while(@ATS_INTERFACE_FILES)
    {
	my $tmp_interface=pop(@ATS_INTERFACE_FILES);
	$interfaces .= "\"$tmp_interface\" ";  
    }
    

    if ($ATS_PROBE_CUSTOM_TYPE==$mode{default})
    {
	$stringmode="DEFAULT";
    }
    elsif (($ATS_PROBE_CUSTOM_TYPE==$mode{fifo}) || ($ATS_PROBE_CUSTOM_TYPE==$mode{file}) || ($ATS_PROBE_CUSTOM_TYPE==$mode{user}))
    {
	$stringmode="CUSTOM";
    }
    else
    {
	exit(0);
    }


    $PreproInclude="-INCL=$PreproInclude";
    
    while(@SOURCES)
    {
	my $tmp_src = pop(@SOURCES);
	my ($dirpath,$basename,$extension) = SplitFileName($tmp_src);
	my $lang = LanguageOf ($extension, "Unknown");
	if (($lang eq "C") ||  ($lang eq "CPP"))
	{
	    $src_files .= "\"$tmp_src\" ";
	    if ($lang eq "CPP")
	    {
		$language = "cpp";
	    }
	}
	else
	{
	    print &PerlTranslate("Probe.pl", "PROBE Warning: Cannot probe files with extension %1.\n", "%1 is the extension of files", $extension);
	}
    }

    my $outdir= "$INTDIR";

    my $perlcommand =  "$BINDIR" . "$PATH_SEPARATOR" . "TestRTperl -I\"".$ATTOLHOME.$PATH_SEPARATOR."lib".$PATH_SEPARATOR."perl"."\"";

    $ENV{TARGET_DIR}=$TARGETDIR;
    if (@COMPLETE_INCLUDE_DIR_LIST)
    {
	$status=SystemP("$perlcommand $SCRIPTDIR" . "parsecode.pl -preopts=\"$PreproInclude\" -outdir=\"$outdir\" -mode=$stringmode $src_files $interfaces");
    }
    else
    {
	$status=SystemP("$perlcommand $SCRIPTDIR" . "parsecode.pl -outdir=\"$outdir\" -mode=$stringmode $src_files $interfaces");
    }
    
#    print &PerlTranslate("Probe.pl", "Done.\n");
    
#Compilation of the generated file atlprobe.(c||cpp)
#--------------------------------------------------------------------------
    if ($status!=0)
    { 
	exit(1); 
    }
   my $atlprobeFile =$INTDIR . $PATH_SEPARATOR . "atlprobe.$language";
   if(( $language eq "cpp") && !(-r $atlprobeFile)){
   	$language = "c";
   	$atlprobeFile =$INTDIR . $PATH_SEPARATOR . "atlprobe.$language";
   }
## Compilation
    $status = MakeCompilationOptionsFile ();
    if ($status != 0) { return $status; }

        
    # to use TP.h
    my @all_includes = @COMPLETE_INCLUDE_DIR_LIST;
    push @all_includes, $TARGETDIR.$PATH_SEPARATOR."lib";
    push @all_includes, $INTDIR;   
    push @all_includes, $WORKSPACE_PATH; 
    my $custompath="nothing";
    if($ATS_PROBE_CUSTOM_TYPE==$mode{fifo}) 
    {
	$custompath=$ATTOLHOME.$PATH_SEPARATOR."lib".$PATH_SEPARATOR."probe" .$PATH_SEPARATOR."probecst".$PATH_SEPARATOR."fifo";
    }
    elsif ($ATS_PROBE_CUSTOM_TYPE==$mode{file})
    {
	$custompath=$ATTOLHOME.$PATH_SEPARATOR."lib".$PATH_SEPARATOR."probe" .$PATH_SEPARATOR."probecst".$PATH_SEPARATOR."file";
    }
    elsif ($ATS_PROBE_CUSTOM_TYPE==$mode{user})
    {
	$custompath=$PROBE_CUSTOM_DIR if($PROBE_CUSTOM_DIR ne "");
    }
    if ($custompath ne "nothing")
    {
	push (@all_includes,"$custompath");
	$status=atl_cc ($TDP_LANGUAGE,$custompath.$PATH_SEPARATOR."probecst.c",$INTDIR.$PATH_SEPARATOR."probecst.$OBJEXT", $CPPFLAGS.' '.$CFLAGS.' '.$PPFLAGS,\@GENERATION_CONDITION, \@all_includes);
    }
    
    $status=atl_cc ($TDP_LANGUAGE, $atlprobeFile, $INTDIR.$PATH_SEPARATOR."atlprobe.$OBJEXT", $CPPFLAGS.' '.$CFLAGS.' '.$PPFLAGS,\@GENERATION_CONDITION, \@all_includes);
    
    
 if($status!=0) { exit(1); }
    
    #--------------------------------------------------------------------------
    open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("Probe.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
    if ($ATS_CUSTOM_TYPE!=$mode{ignore})
    {
	print  LOG "SRC $INTDIR/atlprobe.$language\n";
	print  LOG "SRC $INTDIR/atlprobe.h\n";
	print  LOG "SRC $INTDIR/atldeclar.h\n";
	print  LOG "DUM $INTDIR/atlprobe.pts\n";
	print  LOG "DUM $INTDIR/atlprobe.lis\n";
	print  LOG "DUM $INTDIR/atlprobe.tdc\n";
        print  LOG "OBJ $INTDIR/atlprobe.$OBJEXT\n";
	
	print  LOG "OBJ $INTDIR/TP.$OBJEXT\n";
	
	if ($ATS_CUSTOM_TYPE!=$mode{default})
	{
	    print  LOG "OBJ $INTDIR/probecst.$OBJEXT\n";
	}
	close( LOG );
    }
    
}    
exit(0);
#
###############################################################################
