
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

#required by attolcclib.pl when -treatmt=RoseRTtrmt.pl option is on the command line as attolcc option
my $emptyTrName="_empty_transition";
my $DEF="_COVMODEL";
my %transition;
my %transitionCall;
my %transitionMother;
my %state;


$TreatmentOnSource=1;
sub TreatmentSource #($$)
{
my ($lang,$s)=@_;
   	my ($dir,$name,$ext) = SplitFileName($s);
   	my $d=$dir.'../cov/';
   	my $ov=0;
   	my $so=$d.$name.'.'.$ext;
	if(! -d $d) {
		$ov=1;
		$so=$dir.$name.'I.'.$ext;
	}   	
	if(SourceInsert($s,$so,$ov)) { #1 as param3 means overwrite original
	    my $opa=$DefineFlag.$DEF;
	    $PreproFlags .=$opa.$sp if (!($PreproFlags =~ /$opa/));
	    return $so unless $ov;
	}
return $s;
}


$TreatmentOnPreprocessed=0;
sub TreatmentPreprocessed #($$)
{
my ($lang,$p)=@_;
return $p;
}


$TreatmentOnInstrumented=0;
sub TreatmentInstrumented #($$)
{
my ($lang,$i)=@_;

return $i;
}

$TreatmentOnObject=0;
sub TreatmentObject #($$)
{
my ($lang,$o)=@_;

return $o;
}

###########################################################################
# pass 1:
# look for all // {{{RME transition ':TOP:S1:S3:Junction2:t1' (proc declaration)
# and all             // transition ':TOP:S1:S3:Junction2:t1' (real transition)
# some real transition may not call the proc because proc does not exist because no additional code come from the model.
# So this script look for transition which have no proc
# then look for void <Class>::rtsBehavior( ... ) to get all state number (case x:) and name identified by // {{{RME state ':TOP'
sub readFile #($)
{
my $filename=shift; 
my $modifFound=0;
my $numState=0;
my $rtsBehavior=0;
my $transIndex=0;
my $line=0;
my $previousLine;
my $trName;
my $mother;
open IN, "<$filename"     or die &PerlTranslate("rrt.pl", "Cannot open file %1\n",   "%1 is the name of the file", $filename);
while(<IN>)
   {
   	$line++;
   	############## look for transitions ############
   	if(/\/\/ \{\{\{RME.* transition '(.+)' *$/) { 
   	    $transition{$1}=1;#proc exist
   	}
#	track the transition comment
#	// transition ':TOP:Initial:Initial'   	
#	the transition method exist in the current source
#
#	// classifier 'Logical View::Device' transition ':TOP:Initial:Initial'
#	the transition method is inherited from the device capsule. it is not in the current source
#	an intermediate proc is created to know if this capsule has executed this transition.
   	elsif(/\/\/.* transition '(.+)' *$/){
   	    $trName=$1;
   	    $transition{$trName}+=2;#proc should exist
   	    if(/Logical View::(.+)' transition/){ #'
   	    	$mother=$1;
   	    } else {
   	    	$mother="";
   	    }
   	}
   	elsif(/rtgTransitionEnd\(\)/){
#   		$previousLine=~s/^\s*//;
#   		$transitionCall{$trName}=$mother.$previousLine unless (($previousLine =~ /rtgTransitionBegin/) || ($trName eq ""));
   		$transitionMother{$trName}=$mother unless (($previousLine =~ /rtgTransitionBegin/) || ($trName eq ""));
   	}
   	############## look for states #################
   	elsif(/^}/){
   		$rtsBehavior=0; # end of the  proc
   		$numState=0;
   		$trName="";
   	}
   	elsif(/void .+\:\:rtsBehavior\(.*\)/){
   		$rtsBehavior=1;
   	}
   	elsif(/case ([0-9]+):/){
   		$numState=$1 if($rtsBehavior);
   	}
   	elsif(/\/\/ \{\{\{RME.* state '(.+)'/){
   	     if($numState) {
   		$state{$1}=$numState ;
   		$modifFound=1;
   		$numState=0;
   	     }
	}
	$previousLine=$_;
	chomp($previousLine);
   }
close IN;
## affect an index for all missing transition and 0 for existing one
foreach $tr ( keys %transition )
    {
        if($transition{$tr}&1){# this transition exist yet
            $transition{$tr}=0;
        }
        else
        {# this transition proc does not exist.Affect an index for the name of the proc
            $transIndex++;
            $transition{$tr}=$transIndex;
   	    $modifFound=1;
        }
    }
return $modifFound;
}

#generate the missing transitions
sub genMisTrans
{
    foreach $tr ( keys %transition )
    {
	if($transition{$tr}!=0){# this transition proc does not exist
	    print OUT "\n// {{{RME transition '$tr'\n";
	    print OUT "static void $emptyTrName$transition{$tr}()\n";
	    print OUT "{/*ATL_JUMP_NAME*";
	    if ($transitionMother{$tr}){
#		    print OUT "Call $transitionCall{$tr}\n";
		    print OUT "=\"$transitionMother{$tr},T$tr\";inherited from $transitionMother{$tr} capsule" if ($transitionMother{$tr});
	    }
	    print OUT "*/\n}\n";
	}
    }
    print OUT "\n/* RTRTLEVEL0 */\n";
}
# generate our Behavior 
sub genRTRTBehavior
{
    print OUT "static void _RTRTBehavior(int state)\n";
    print OUT "{\n\tswitch(state)\n\t{\n";
    foreach $st ( sort keys %state )
    {
	print OUT "\t\tcase $state{$st}:\n\t\t\t\/\/ {{{RME state '$st'\n\t\t\tbreak;\n";
	$i++;
    }
    print OUT "\t}\n}\n" ;
}

sub addedproc
{
    print OUT "#if defined($DEF) && !defined(VIRTUAL_CAPSULE)\n" ;
    genRTRTBehavior();
    genMisTrans() ; 
    print OUT "#define RTRTenterState(s)    enterState(s);_RTRTBehavior(s)\n";
    print OUT "#define RTRTrtgTransitionEnd(s) $emptyTrName##s();rtgTransitionEnd()\n";
    print OUT "#define RTRTSTATE(s)     _RTRTBehavior(s)\n";
    print OUT "#else  //$DEF\n";
    print OUT "#define RTRTenterState(s)    enterState(s)\n";
    print OUT "#define RTRTrtgTransitionEnd(s) rtgTransitionEnd()\n";
    print OUT "#define RTRTSTATE(s)\n";
    print OUT "#endif //$DEF\n\n";

}
###########################################################################
# pass 2:
# generate the new code before the first // {{{RME transition '...'
sub writeNewFile #($$)
{
my ($filename,$outfilename)=@_; 
my $line=0;
my $gentr=0;
my $trName="";
my $rtsBehavior=0;
my $chain=0;
open IN, "<$filename"     or die &PerlTranslate("rrt.pl", "Cannot open file %1\n",   "%1 is the name of the file", $filename);
open OUT, ">$outfilename" or die &PerlTranslate("rrt.pl", "Cannot create file %1\n", "%1 is the name of the file", $outfilename);
while(<IN>)
   {
   	$line++;
   	#### generate the added code before any use ###
   	if(/\/\/ \{\{\{RME.* transition '.+' *$/) { 
   	    if(!$gentr++){# executed only once
   	        addedproc() ; 
   	    }
   	}
   	elsif(/INLINE_CHAINS void .+::chain.*\(.*\)/){
   		$chain=1;
		if(!$gentr++){# executed only once
		    addedproc() ; 
		}
   	}
   	elsif(/void .+::rtsBehavior\(.*\)/){
   		$rtsBehavior=1;
		if(!$gentr++){# executed only once
		    addedproc() ; 
		}
   	}
   	elsif(/^}/){
   		$rtsBehavior=0; # end of the  proc
   		$chain=0;
   		$trName="";
   	}
   	elsif($chain){
#	// classifier 'Logical View::Device' transition ':TOP:Initial:Initial'   	
#	// transition ':TOP:Initial:Initial'   	
   	    if(/\/\/.* transition '(.+)' *$/){
   		$trName=$1;
   		if($transition{$trName}==0){
   		    $trName="";
   		}
   	    }
   	    elsif(/rtgTransitionEnd\(\);/){
   		if($trName ne ""){
#   		    print OUT "#ifdef $DEF\n $emptyTrName$transition{$trName}();\n#endif //$DEF\n";
   		    $_ =~ s/rtgTransitionEnd\(/RTRTrtgTransitionEnd($transition{$trName}/;
   		}
   		$trName="";
   	    }
   	    elsif(/enterState\((.+)\);/){
   		$_ =~ s/enterState/RTRTenterState/;
   		}
   	}
   	elsif($rtsBehavior) {
#	// {{{RME classifier 'Logical View::Device' state ':TOP'
#	// {{{RME state ':TOP'
   	    if(/\/\/ \{\{\{RME.* state '(.+)' *$/){
   	    	my $s=$1;
#   		print OUT "RTRTSTATE($state{$s});" if($state{$s});
   		$_ =~ s/^(.*)\/\//$1RTRTSTATE($state{$s});\/\// if($state{$s});
   		$_ =~ s/RME/ R M E/; #avoid recognition by the RoseRTCov tool
   	    }
   	}
   print OUT ;
   }
close IN;close OUT;
}

sub SourceInsert #($$$)
{
my ($filename,$outfilename,$ov)=@_; 
  my $m=readFile($filename);
  if($m) {
	writeNewFile($filename,$outfilename);
	if($ov){
	   unlink($filename);
	   rename($outfilename,$filename);
	   $outfilename=$filename;
	}
	print &PerlTranslate("roserttrmt.pl", "file %1 modified for coverage purposes\n",   "%1 is the name of the file", $outfilename);
  }
  return $m;
}

1;
