#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);


#use File::Copy;
#copy($ARGV[0],"envNodeATS.pl");

# Configuration file
require $ARGV[0] unless($main::TestRTCC);

# Miscellaneous functions
require $SCRIPTDIR . "Fcts.pl";

################################################################################

sub StartSystemTesting {

my $src="atltmp_inc.c";
my $ptuTmp = "atltmp_inc.ptu";
my $pts = $FILENAME;
my $dir=$GENERATENEWSCRIPT_APIPATH.'/';
my $basename=$GENERATENEWSCRIPT_APIBN;
my $template=$SCRIPTDIR ."../SystemTesting/template1";
my $msgfields;
my $instances=$GENERATENEWSCRIPT_WINSTANCE;
my $msgType=$GENERATENEWSCRIPT_TYPE; 
my $userApis;
$msgType="char *" if($msgType eq "");

open TMP,">$src" or die "cannot write the file $src\n";
foreach(@ATS_INTERFACE_FILES){
print TMP "#include \"$_\"\n";
}
print TMP "void attolsystemTesting($msgType msgfields_attol) \n{}\n";
close TMP;

$ENV{'ATW_NO_USR_INCLUDE'}="on";

$command = "$BINDIR" . "$PATH_SEPARATOR" . "attolstartC ";
$command.= " \"$src\" \"$ptuTmp\" -STD_DEFINE=$TARGETDIR/ana/atus_c.def";
$command.=" -incl=\"".join("\",\"",@COMPLETE_INCLUDE_DIR_LIST)."\"" if(@COMPLETE_INCLUDE_DIR_LIST);
$command.=" -define=\"".join("\",\"",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
#$command.=" -define=__cplusplus" if ( $TDP_LANGUAGE eq "CPP" );

my $status=SystemP($command);

unless($status){
	print &PerlTranslate("StartSystemTesting.pl", "Test Script generation %1...\n", "%1 is the name of the Test Script", $pts);
	open IN, $ptuTmp or die "No generation\n";
	my $on=0;
	while(<IN>){
		$on = 1 if(/^\s+(VAR|STRUCTURE)\s+msgfields_attol/);
		if($on) {
			$msgfields.=$_;
			if(/ev = init/){
				$on=0;
				LAST;
			}
		}
	}
	close IN;
#	print ">>$msgfields\n";
	$msgfields=~ s/,\s*ev = init.*$//;
#	print ">>$msgfields\n";
	$msgfields=~ s/^.*(VAR|STRUCTURE|ARRAY) msgfields_attol,\s*init =//;
#	print ">>$msgfields\n";
	$msgfields="write your description here" if($msgfields eq "");
#print "Generation of $pts\n";
	if($GENERATENEWSCRIPT_USERAPI){
		foreach(@GENERATENEWSCRIPT_TYPEAPI_LIST){
			my ($d,$b,$e)=SplitFileName($_);
			$e="hts" unless($e);
			$userApis.="INCLUDE \"$b.$e\"\n";
		}
	}

	open OU,">$pts" or die "No PTS generation\n";
	if(open IN,"$template.pts") {
		while(<IN>){
			s/__NAME__/$NAME/;
			s/__MSGTYPE__/$msgType/;
			if(/__BASENAME__/){
				if($GENERATENEWSCRIPT_USERAPI){
					$_=$userApis;
				}else{
					s/__BASENAME__/$basename/;
				}
			}
			s/__MSGFIELDS__/$msgfields/;
			s/others/OTHERS/g;
			s/--i // if($instances);
			s/--i /--/;
			print OU;
		}
		close IN;
	} else {  print &PerlTranslate("StartSystemTesting.pl", "Template not found, check your installation\n",""); }
	close OU;
    unless($GENERATENEWSCRIPT_USERAPI){
	
	if((-f "$dir$basename.hts") || ($basename eq "")){
		print &PerlTranslate("StartSystemTesting.pl", "HTS Script %1 already exist\n", "%1 is the name of the Test Script", "$dir$basename.hts");
	} else {
		print &PerlTranslate("StartSystemTesting.pl", "HTS Script generation %1...\n", "%1 is the name of the Test Script", "$dir$basename.hts");
		open OU,">$dir$basename.hts" or die "No HTS generation\n";
		if(open IN,"$template.hts") {
			while(<IN>){
				s/__MSGTYPE__/$msgType/;
				s/__BASENAME__/$basename/;
				print OU;
			}
			close IN;
		} else {  print &PerlTranslate("StartSystemTesting.pl", "Template not found, check your installation\n",""); }
		close OU;
	}
# API Generation
	if((-f "$dir$basename.c") || ($basename eq "")) {
		print &PerlTranslate("StartSystemTesting.pl", "API Sources %1 already exist\n", "%1 is the name of the Test Script", "$dir$basename.c");
	} else {
		print &PerlTranslate("StartSystemTesting.pl", "API Sources generation %1...\n", "%1 is the name of the Test Script", "$dir$basename.c");
		open OU,">$dir$basename.c" or die "No C API generation\n";
		if(open IN,"$template.c") {
			while(<IN>){
				if(/^\#include\s+__MSGTYPE__/){
					foreach(@ATS_INTERFACE_FILES){
					my ($d,$b,$e)=SplitFileName($_);
					print OU "#include \"$b.$e\"\n";
					}
					next;
				}
				s/__MSGTYPE__/$msgType/;
				s/__BASENAME__/$basename/;
				print OU;
			}
			close IN;
		} else {  print &PerlTranslate("StartSystemTesting.pl", "Template not found, check your installation\n",""); }
		close OU;
		copy("$template.h","$dir$basename.h");
	}
    }
}
unlink($src);
unlink($ptuTmp);
unlink("typedeftags");
print "exit status $status\n" if($status);
return($status);
}
################################################################################
# Here is the beginning
################################################################################
unless($main::TestRTCC){

	EnterInScript();

	exit (StartSystemTesting());
}

1;
