#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                      -*-  Java TDP Preparation -*-                           #
#                                                                              #
#                                                                              #
################################################################################
#$Id: TDPBatchJava.pl,v 1.21 2007/07/23 18:41:59 rfrance Exp $
################################################################################

# useful for stdout/stderr direct viewing inside 'console' of studio window
# (better: we have stdout/stderr lines in right order and not stderr before stdout
use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

my $BatchMode = 0;
my $InstallDir = "";
$INIFILE="tp.ini";



# This script is called by studio or by javic/ant or by javic/perl

if ($ENV{'TESTRTDIR'}) {
  $InstallDir = $ENV{'TESTRTDIR'};
} elsif ($ENV{'ATLTGT'}) {
  $InstallDir = "$ENV{'ATLTGT'}/../..";
}

if ($InstallDir) {
  $SCRIPTDIR = $InstallDir . "/lib/scripts/";
  $TARGETDIR = $ENV{'ATLTGT'};
  $INTDIR = "."; # default value: can be overriden by $ARGV[0] from user or studio
  require $SCRIPTDIR . "BatchJavaDefaults.pl"; # Default settings
  $BatchMode = 1;
}

# Caller-known settings
if ($ARGV[0]) {
  if ($BatchMode) {
    if ( $ARGV[0] eq "--destdir" ) {
      if ( $ARGV[1] ) {
        $INTDIR = $ARGV[1];
        ParseOtherSettings(2);
      } else {
        die &PerlTranslate("TDPBatchJava.pl", "Target Deployment Port Preparation - Error: please give an argument to the --destdir option\n");
      }
    } elsif ( ! IsASetting($ARGV[0]) ) {
      require $ARGV[0];
    } else {
      ParseOtherSettings(1);
    }
  } else {
    require $ARGV[0];
  }
}

# This script depends on the followings
require $SCRIPTDIR . "Fcts.pl";
require $SCRIPTDIR . "Tools.pl";
require $SCRIPTDIR . "Products.pl";

#----------------------------------------------------------------------------

# Let's start (inifile read, etc.)
CheckIntDir();
EnterInScript();

# Let's do it
PrepareJavaTargetPackage();

0;
# That's all Folks.
################################################################################
