#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
#$Id: TestRT_test.pl,v 1.34 2007/10/16 15:51:45 rfrance Exp $
##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*- eclipse and command line Testing -*-                     #
#                                                                              #
#                                                                              #
# Required global variables:
#   $NAME='PhoneNumber'; #used as node name
#   $XRDFILE='cvisual6\\PhoneNumber.xrd';
#   $TESTPROGRAM='.\\cvisual6\\PhoneNumber.exe';
#   $TESTPROGRAM_ABS='C:\\......\\cvisual6\\PhoneNumber.exe';
#   @OTCFILES = otc file names for C++
#   $OTDNAME = otd file name for C++
#   $UNITTESTING_TESTSCRIPTNAME = ptu file name for C
#   $ATU_INTERMEDIATE_FILE = generated source file name for  C
#   @INTEGRATEDFILENAMES
################################################################################

# To do output in chronological order when stderr and stdout are both used
use FileHandle;
use File::Spec;
STDOUT->autoflush(1);
STDERR->autoflush(1);

BEGIN {
## globals ############
$TestRTCC=1;
#######################
$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
$TARGETDIR=$ENV{ATLTGT};
$INTDIR=$TARGETDIR;$INTDIR=~s,.*[\\\/](\w+)[\\\/]?$,$1,;
$OUTDIR=$INTDIR;
$INIFILE='tp.ini';
$LOGFILENAME='TestRT.log';
$STAGE='cptler';
  $ATTMODE=0;
  $ATCMODE=0;
  $ATPMODE=0;
  $ATQMODE=0;
  $ATSMODE=0;
  $ATUMODE=0;
  $ATOMODE=0;
  $ATKMODE=0;
  $ATJMODE=0;
$CODE_INSERTION=1;
$ATO_PREPRO_MAX_ERRORS=30;
$PROJECT_NAME='temp';
$PROJECT_PATH='none';
$WORKSPACE_NAME='Local';
$CONFIGURATION=$INTDIR;

}
my $tmpdir=$ENV{'TEMP'};
if($^O=~/win32/i)
{
    unless($tmpdir){
	$tmpdir=$ENV{'TMP'};
    }
}else{
    $tmpdir=$ENV{'TMPDIR'};
    unless($tmpdir){
	$tmpdir='/tmp';
    }
}

my $envnode="$tmpdir/envTestRT_test.pl";

sub BugTPTP196809
{
   my $dir=shift;
   return unless($dir);
   unless(-f  "$dir/196809.txt"){
	copy($envnode,"$dir/196809.txt");
   }
}

if(@ARGV) {
	if ($ARGV[0] eq "-eclipse") {
		$envnode=$ARGV[1];
		die "unable to find $envnode\n" unless (-f $envnode);
		require $envnode ;
	}else{
		require $SCRIPTDIR . "BatchCCDefaults.pl";
		$envnode='';
	}
} else {
	die "unable to find $envnode\n" unless (-f $envnode);
	require $envnode ;
}
  # some options are not available in this mode
$ATT_ON_THE_FLY=0;

#set minimum required
$XTPFILE = "TestRTccfiles.xtp" unless($XTPFILE);

#require $SCRIPTDIR . "Fcts.pl";

require $SCRIPTDIR . "TestScript.pl";
require $SCRIPTDIR . "Source.pl";
require $SCRIPTDIR . "ObjecTest.pl";	
require $SCRIPTDIR . "UnitTesting.pl";
require $SCRIPTDIR . "Application.pl";
require $SCRIPTDIR . "StartObjecTest.pl";	
require $SCRIPTDIR . "StartUnitTesting.pl";
require $SCRIPTDIR . "UpdateUnitTestingScript.pl";
require $SCRIPTDIR . "metricC.pl";


# some settings are modified by the called scripts
my $savATTMODE;
my $savATCMODE;
my $savATPMODE;
my $savATQMODE;
my $savATSMODE;
my $savATUMODE;
my $savATOMODE;
my $savATKMODE;
my $savATJMODE;
my @savCOMPLETE_INCLUDE_DIR_LIST;

sub setSettings
{
  $ATTMODE=$savATTMODE;
  $ATCMODE=$savATCMODE;
  $ATPMODE=$savATPMODE;
  $ATQMODE=$savATQMODE;
  $ATSMODE=$savATSMODE;
  $ATUMODE=$savATUMODE;
  $ATOMODE=$savATOMODE;
  $ATKMODE=$savATKMODE;
  $ATJMODE=$savATJMODE;
  @COMPLETE_INCLUDE_DIR_LIST=@savCOMPLETE_INCLUDE_DIR_LIST;
  $CODE_INSERTION=1;

}

###########################################################################
# read the launcher options
sub read_options
{

   while(@ARGV)
   {
	$_=shift(@ARGV);
	#print "<$_>\n";
	my $lcarg=lc($_);
	if(/^--([a-zA-Z_0-9]+)(\+?)=(\"?)(.+)\3$/){ #settings option
		my $set=uc($1);
		my $append="$2" if($2);
		my $cotStr=$3 if($3);
		my $val=$4;
		eval "\$$set=\"$val\"";
	}
	elsif(/^--([a-zA-Z_0-9]+)$/){ #settings option
		my $set=uc($1);
		eval "\$$set=1";
	}
	elsif($lcarg eq "-verbose")		{$ENV{'ATTOLSTUDIO_VERBOSE'}=1;}
	elsif($lcarg eq "-v")			{$ENV{'ATTOLSTUDIO_VERBOSE'}=1;}
	elsif($lcarg eq "-one_level_metrics")	{$ATMMODE=1;$MET_ONE_LEVEL=1;}
	elsif($lcarg eq "-metrics_in_source")	{$ATMMODE=1;$MET_IN_SOURCE_DIR=1;}
	elsif(/^-restrict_dir_metrics=(.+)$/i)	{$ATMMODE=1;push(@MET_RESTRICT_DIR,split(/,/,$1));}
	elsif(/^-metric=(\"?)(.+)\1$/i)		{$ATMMODE=1;$metdir=$2;}
	elsif(/^-ada(\d\d)$/i)			{$INIFILE="ada$1.ini";}
	elsif(/^-codereview=(\"?)(.+)\1$/i)	{$MISRA_MODE=1;$MISRA_CONF=$2;}
	elsif(/^-codereview$/i)			{$MISRA_MODE=1;$MISRA_CONF="$ENV{'TESTRTDIR'}/plugins/Common/lib/confrule.xml";}
	elsif(/^-\#.*$/)		   	{$showCmd=1;$ATTOLCC_VERBOSE=1;}
	elsif(/^-I(.+)$/)			{push(@INCLUDE_DIR_LIST,split(/,/,$1));}
	elsif(/^-D(.+)$/)			{push(@GENERATION_CONDITION,$1);}
	elsif(/^-opt=(\"?)(.+)\1$|\@(\"?)(.+)\3$/i){ #" accept @optFile or -opt=optFile for options
		my $fileOpt=$2.$4;
		# read the options in the file and push into the existing @argv to be analysed as other
		open OPTIN,"<$fileOpt" || die &PerlTranslate("attolcc.pl", "Cannot open the file %1\n", "%1 is the file name", $fileOpt);
		while (<OPTIN>){
			chomp($_);
			#print("[$_]\n");
			my @optInFile=splitArgs($_);
			push(@ARGV,@optInFile);
		}
		close OPTIN;
	}
	elsif(/^-/) {
		{
		  $_=uc($_);
		  #debug("instr option:$_");
		  $ATKMODE=1 if (/^-AU/); #AUTO_OTI
		  $ATPMODE=1 if (/^-MEM/);
		  $ATQMODE=1 if (/^-PERF/);
		  $ATMMODE=1 if (/^-MET/);
		  $ATL_CLOCK_KIND=1 if(/^-PERF.*=P/);
		  $ATTMODE=1 if (/^-TR/);#TRACE
		  $ATC_INFORMATION=1 if(/^-COMPA/);#1compact 2count
		  $ATC_INFORMATION=2 if(/^-COUN/);#1compact 2count
		  $ATCMODE=1 if ((/^-PAS/) || (/^-PRO/) || (/^-BL/) || (/^-COND/));
		}
	}
  	elsif(-f $_) {
		   if(/\.otc$/) {push(@OTCFILES,$_);$ATKMODE=1;}
		elsif(/\.otd$/) {$OTDNAME=$_;$ATOMODE=1;$INIFILE='tpcpp.ini';my ($d,$b,$e)=SplitFileName($_);$NAME=$b;$TDFFILE=$OUTDIR."/$b.tdf";}
		elsif(/\.ptu$/) {$UNITTESTING_TESTSCRIPTNAME=$_;$ATUMODE=1;  my ($d,$b,$e)=SplitFileName($_);$NAME=$b;}
		else {
			push(@INTEGRATEDFILENAMES,$_);
			unless($NAME) {my ($d,$b,$e)=SplitFileName($_);$NAME=$b;}
		}
	}
	else {print PerlTranslate("TestRT_test.pl","unknown parameter: $_\n");}
   }
EnterInScript();
$TDP_LANGUAGE =uc($Ini{'LANGUAGE'});
$SRCEXT=$Ini{'SRCEXT'};
$OBJEXT=$Ini{'OBJEXT'};
$LIBEXT=$Ini{'LIBEXT'};
$DLLEXT=$Ini{'DLLEXT'};

$PROJECT_PATH=GetCurrentDir();
$XRDFILE=$OUTDIR.'/'.$NAME.'.xrd';
#$XRDFILE=$PROJECT_PATH.'/'.$OUTDIR.'/'.$NAME.'.xrd';
$WORKSPACE_PATH=$PROJECT_PATH;
$WORKING_DIR=$PROJECT_PATH;
$TESTPROGRAM=$OUTDIR.$PATH_SEPARATOR.$NAME;$TESTPROGRAM.='.'.$Ini{EXEEXT} if($Ini{EXEEXT});
$TESTPROGRAM_ABS=$PROJECT_PATH.$PATH_SEPARATOR.$TESTPROGRAM;
}

sub reports
{
  my $log=shift;
  my $xtp=shift;
  my $tsf;
  my @files;
	open LOG, "<$log";
	while(<LOG>)
	{
		chomp;
		if (/^(TIO|TPF|TQF|TDF|TSF|FDC|MET|CRC|XRD|RTX) (.+)$/){
		  my $f=$2;
		  my $c=$1;
		  my @l=grep(/^\Q$f\E$/, @files);
		  push (@files, $f) unless(scalar(@l) || (($c =~ /TIO|TPF|TQF|TDF/) && !$tsf));
		  if($c eq 'FDC') {$tsf=1;push(@FDCFILES,$f);}
		  if($c eq 'TSF') {$tsf=1;}
		}elsif (/^OTS (.+)$/){
		  push(@OTSFILES,$1);
		  push(@dummy,$1);
		}elsif (/^OBJ (.+)$/){
		  push(@OBJECTS,$1);
		}elsif (/^XOB (.+)$/){
		  push(@XOB,$1);
		  push(@dummy,$1);
		}elsif (/^(DUM|ALK) (.+)$/){
		  push(@dummy,$2);
		}# other lines are ignored
	}
	close(LOG);
	if($xtp) {
		my ($base,$n,$e)=SplitFileName($xtp);
		$base=~s/[\\\/]$//g;
		my $ch;
		my $pwd=GetCurrentDir();
		$ch=1 if($base && ($base ne $pwd));
		$base=$pwd unless($base);

		#print "writing XTP file $xtp, $pwd, $ch, $base\n";
		open XTP, ">$xtp";
		foreach $f (@files) {
		    if($f =~ /^(\w:)?[\\\/]/) {
			$f = File::Spec->abs2rel( $f, $base ) ;
		    } elsif($ch) {
			$f = File::Spec->rel2abs( $f , $pwd ) ;
			$f = File::Spec->abs2rel( $f, $base ) ;
		    }
		    print XTP "$f\n" ;
		}
		close XTP;
		unless($KEEP){
		  	unlink(@dummy); #remove only at the build end
		  	#print "remove ",join("\n       ",@dummy),"\n"; #remove only at the build end
		}
	}
}

sub buildOt
{
	my $otFile=shift;
	$FILENAME=$otFile;
	my ($fdir,$otname,$otext)=SplitFileName($FILENAME);

	$SRCFILE=$otname.'.'.$otext.'.cpp';
	$OTIFILE=$INTDIR.$PATH_SEPARATOR.$otname.'.'.$otext.'.oti';
	
	exit(1) if(TestScript());
}

$BINDIR=GetBinDir() unless($BINDIR);
$BINDIR =  ShortPathName($BINDIR);
$TARGETDIR=ShortPathName($TARGETDIR);

CheckIntDir();
CheckOutDir();
if((@ARGV) && ($ARGV[0] ne "-eclipse")){read_options() ;}
else {
	EnterInScript();
	BugTPTP196809($INTDIR);
	BugTPTP196809($OUTDIR);
}

# some settings are modified by the called scripts
$savATTMODE=$ATTMODE;
$savATCMODE=$ATCMODE;
$savATPMODE=$ATPMODE;
$savATQMODE=$ATQMODE;
$savATSMODE=$ATSMODE;
$savATUMODE=$ATUMODE;
$savATOMODE=$ATOMODE;
$savATKMODE=$ATKMODE;
$savATJMODE=$ATJMODE;

@savCOMPLETE_INCLUDE_DIR_LIST=();
foreach my $i (@COMPLETE_INCLUDE_DIR_LIST){
	$i=$WORKSPACE_PATH.$i if(($i =~ /^[\\\/]/) && (!(-d $i))) ;
	push(@savCOMPLETE_INCLUDE_DIR_LIST,$i);
}
@COMPLETE_INCLUDE_DIR_LIST=@savCOMPLETE_INCLUDE_DIR_LIST;
@OTIFILES=();

print "Current dir: ", GetCurrentDir() ,"\n" if($ENV{ATTOLSTUDIO_VERBOSE});
print "Include Paths:",join(',',@COMPLETE_INCLUDE_DIR_LIST),"\n" if($ENV{ATTOLSTUDIO_VERBOSE});

if ($STAGE =~ /s/ ) #start
{
	ClearLogFile($LOGFILENAME2);
	if($TDP_LANGUAGE eq 'CPP'){
		exit(1) if(StartObjecTest());
	}else{
		exit(1) if(StartUnitTesting());
	}
	print PerlTranslate("TestRT_test.pl",  "\nDone.\n");
	exit(0);
	
}elsif ($STAGE =~ /u/ ) #update
{
	if($TDP_LANGUAGE eq 'CPP'){
		print PerlTranslate("TestRT_test.pl", "TestRT-W-NOFEATURE This feature is not available for C++: no update possible\n");
	}else{
		exit(1) if(UpdateUnitTestingScript());
	}
	print PerlTranslate("TestRT_test.pl",  "\nDone.\n");
	exit(0);

}elsif ($STAGE =~ /m/ ) #metrics
{
	my $status=0;
	ClearLogFile($LOGFILENAME2);
	foreach $FILENAME (@FILENAMES){
		$status|=metricsC ($TDP_LANGUAGE, $FILENAME, $LOGFILENAME2, $METDIR);
	}
	print PerlTranslate("TestRT_test.pl",  "\nDone.\n");
	exit($status);
	
}else{ #build
	ClearLogFile($LOGFILENAME);
	my $x;
#	print "Source compilations\n";
	foreach $FILENAME (@DATAPOOLFILENAMES){

		exit(1) if(Source());
	}

#		print "OTC generation:\n";
	foreach (@OTCFILES){
		buildOt($_) ;
	}

	if($OTDNAME){
#		print "OTD generation:\n";
		buildOt($OTDNAME) ;
		
	}elsif($UNITTESTING_TESTSCRIPTNAME){
#		print "PTU generation:\n";
		$FILENAME=$UNITTESTING_TESTSCRIPTNAME;

		$ATU_INTERMEDIATE_FILE='T'.$NAME unless($ATU_INTERMEDIATE_FILE);
		TDPAdaGenerate ( $TDP_LANGUAGE ) if ($TDP_LANGUAGE=~/^ADA/ );
		exit(1) if(TestScript());
	}else{print PerlTranslate("TestRT_test.pl", "TestRT-W-NOTSTDRIV No Test driver selected\n");
	}

#	print "Source compilations\n";
	$x=0;
	foreach $FILENAME (@INTEGRATEDFILENAMES){
		setSettings();
		$CODE_INSERTION=0 if($INTEGRATEDFILENAMES_INSTR[$x] eq '0');#let 1 if not initialized
		exit(1) if(Source());
	}
	foreach $FILENAME (@ADDITONALFILES){
		$CODE_INSERTION=0;
		exit(1) if(Source());
	}
	setSettings();
#	print "link then exec then report genration\n";
	reports($LOGFILENAME,''); #load generated file names
	push( @OBJECTS, @LINKEDFILES);
	if($OTDNAME){
		exit(1) if(ObjectTest());
	}elsif($UNITTESTING_TESTSCRIPTNAME){
		exit(1) if(UnitTesting());
	}else {
		exit(1) if(Application());
	}

	#print "preparation to view reports\";
	reports($LOGFILENAME,$XTPFILE);
	#unlink($LOGFILENAME);
	print PerlTranslate("TestRT_test.pl",  "\nDone.\n");
	exit(0);
}
1;
