##!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
#TestRTcc.exe perl launcher is located in bin and execute the perl sript TestRTcc.pl located in the lib/scripts
#TestRTcc.pl open the envTestRTcc.pl located in %HOMEDRIVE% %HOMEPATH% on windows or $HOME on unix
#a special perl var $TestRTCC is set to 1 allowing to attolcclib to change the behavior.
#the TestRTcc require the generated file to set all vars
#then execute the $TARGETDIR/cmd/attolcc.pl
#So the attolcc.pl call the sub Attolcc located in the attolcclib.pl which can do different thing for TestRTcc command line also used in eclipse 
################################################################################
#$Id: TestRTcc.pl,v 1.24.2.4 2008/02/06 11:56:54 rfrance Exp $
################################################################################

# useful for stdout/stderr direct viewing inside 'console' of studio window
# (better: we have stdout/stderr lines in right order and not stderr before stdout
use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

## globals ############
$main::TestRTCC=1;
#######################
$main::SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
my $tmpdir;
my $nodeSettings="envTestRTcc.pl";
if($^O=~/win32/i)
{
    $tmpdir=$ENV{'HOMEDRIVE'}.$ENV{'HOMEPATH'};
    unless(($tmpdir) && (-f "$tmpdir/$nodeSettings")){
	$tmpdir=$ENV{'TEMP'} ;
	$tmpdir=$ENV{'TMP'} unless($tmpdir);
    }
}else{
    $tmpdir=$ENV{'HOME'};
    $tmpdir=$ENV{'TMPDIR'} unless($tmpdir);
    $tmpdir='/tmp' unless($tmpdir);
}

my $envnode="$tmpdir/$nodeSettings";
if(-f $envnode) {
	require $envnode;
	$CFLAGS=1 if($USE_CFLAGS_TP);
} else {
	print "$envnode not found. Launching command.\n";
	my $ret=system(@ARGV);
	exit($ret);
}

unless($RTRT_ACTIVATED){
# do not print anything when using original command
#	print "No instrumentation required. Launching command.\n" if($ENV{'ATTOLSTUDIO_VERBOSE'});
	my $ret=system(@ARGV);
	exit($ret);
}

if($TARGETDIR) {
	$ENV{'ATLTGT'} =$TARGETDIR;
} else {
	$main::TARGETDIR=$ENV{'ATLTGT'};
}
#print "use TDP $TARGETDIR\n";
die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
die "$main::TARGETDIR/cmd/attolcc.pl does not exist !!!\n" unless(-f $main::TARGETDIR . "/cmd/attolcc.pl");

# compute instrum option regarding environment file
require $main::SCRIPTDIR."Fcts.pl";
require $main::SCRIPTDIR."instrum.pl";
$instrumOpt = BuildCCppInstrOptions($TDP_LANGUAGE,"","","");

my $testRTlog=$LOGFILENAME; #attolcc use its own LOGFILENAME format. so memorize it
$LOGFILENAME=$INTDIR.'/'."atlfiles.log";
require $main::TARGETDIR . "/cmd/attolcc.pl";

#translate the log format
if(-f $LOGFILENAME){
	open IN, $LOGFILENAME or die "unable to open the log file $LOGFILENAME\n";
	open OU,">>$testRTlog" or die "unable to write the log file $testRTlog\n";
	while(<IN>){
		if(/^(TSF|FDC|CRC|MET)\s+(.*)$/) {print OU $2,"\n";}
	}
	close IN;
	close OU;
}
unlink($LOGFILENAME);
if($main::TestRTCC == 2){ #2 means link step detected
	#after the link (last build step) we finalize the build
	print "cleaning report file $testRTlog\n";
	$ATKMODE=1 if(@OTIFILES);
	my $tsf;
	$tsf=( $ATTMODE || $ATPMODE || $ATQMODE || $ATKMODE );
	my %seen = ();
	copy($testRTlog,$LOGFILENAME);
	
	open OU,">$testRTlog" or die "unable to write the log file $testRTlog\n";
	open LG, "$LOGFILENAME" or die &PerlTranslate("TestRTcc.pl", "cannot open result file.\n");
	while(<LG>){
	   chop;
	   $seen{$_}++ if((/\.(tsf|tpf|tqf|tdf)$/i) && !($tsf));
	   $seen{$_}++ if((/\.(fdc|tio)$/i) && !($ATCMODE));
	   $seen{$_}++ if((/\.crc$/i) && !($MISRA_MODE));
	   $seen{$_}++ if((/\.met$/i) && !($ATMMODE));
	   $seen{$_}++ unless($seen{$_} || (-f $_));
	   print OU "$_\n" unless $seen{$_}++;
	   print  "$_\n" unless $seen{$_}++;
	 }
	close LG;
	unlink($LOGFILENAME);
	if( $ATCMODE ) {print OU  "$ATC_TIO_NAME\n" unless $seen{$ATC_TIO_NAME};}
	if( $ATPMODE ) {print OU  "$ATP_TPF_NAME\n" unless $seen{$ATP_TPF_NAME};}
	if( $ATQMODE ) {print OU  "$ATQ_TQF_NAME\n" unless $seen{$ATQ_TQF_NAME};}
	if( $ATTMODE || $ATKMODE) {print OU  "$TDFFILE\n" unless $seen{$TDFFILE};}
	#manage remote spt file en attendant que le viewer start TestRTpost
   	my $name=$ATL_OUT_FILE;
	if( defined $Ini{REMOTE_SPT} ){
		$name=$Ini{REMOTE_SPT};
		if($name=~ m/[\\\/]$/){ #it is a directory not a file
			my ($d,$n,$e) = SplitFileName($ATL_OUT_FILE);
			$name.=$n.'.'.$e;
		}
	}
   	$name=~s/(.*\.)(\w{3})$/$1\*.$2/ if($ATL_MULTI_PROCESS);
	print OU "$name\n" unless $seen{$name};
	#############
	close OU;
	
	if(( $ATCMODE ) && !(-f $ATC_TIO_NAME)) {
		open TMP,">$ATC_TIO_NAME";
		close TMP;
	}
	if(($ATTMODE || $ATKMODE) && !(-f $TDFFILE)) {
		open TMP,">$TDFFILE";
		close TMP;
	}
	if(($ATPMODE) && !(-f $ATP_TPF_NAME)) {
		open TMP,">$ATP_TPF_NAME";
		close TMP;
	}
	if(($ATQMODE ) && !(-f $ATQ_TQF_NAME))  {
		open TMP,">$ATQ_TQF_NAME";
		close TMP;
	}
}
exit(0);

sub TestRTcc_MakeXOBList
{
	opendir(DIR,".") || die "Code Review: Cannot open directory .\n";
	while($d=readdir(DIR)) {
		push(@XOB,$d) if ($d=~/\.xob$/);
	}
	closedir(DIR);
}
1;
