##!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
#TestRTexec.exe perl application launcher is located in bin and execute the perl sript TestRTexec.pl located in the lib/scripts
#it allow to execute a targeted instrumented application on the target from the command line as does TestRT GUI
#it append all generated result file names to a $LOGFILENAME and sort out double
################################################################################
#$Id: TestRTexec.pl,v 1.26.2.2 2008/02/05 14:44:40 rfrance Exp $
################################################################################

# useful for stdout/stderr direct viewing inside 'console' of studio window
# (better: we have stdout/stderr lines in right order and not stderr before stdout
use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

## globals ############
$main::TestRTCC=1;
#######################
$main::SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
my $tmpdir;
if($^O=~/win32/i)
{
    $tmpdir=$ENV{'HOMEDRIVE'}.$ENV{'HOMEPATH'};
    $tmpdir=$ENV{'TEMP'} unless($tmpdir);
    $tmpdir=$ENV{'TMP'} unless($tmpdir);
}else{
    $tmpdir=$ENV{'HOME'};
    $tmpdir=$ENV{'TMPDIR'} unless($tmpdir);
    $tmpdir='/tmp' unless($tmpdir);
}

my $envnode="$tmpdir/envTestRTcc.pl";
if(-f $envnode) {
	require $envnode;
	
} else {
	print "Settings not found. Save TestRT settings. Launching executable.\n";
	my $ret=system(@ARGV);
	exit($ret);
}

unless($RTRT_ACTIVATED){

	print "TestRT is not enabled. Check properties. Launching executable.\n" if($ENV{'ATTOLSTUDIO_VERBOSE'});
	my $ret=system(@ARGV);
	exit($ret);
}

unless($TARGETDIR) {
	$main::TARGETDIR=$ENV{'ATLTGT'};
}
print "run with TDP $TARGETDIR\n";
die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
die "TDP not found.\n" unless(-f $TARGETDIR . "/cmd/atl_exec.pl");

require $SCRIPTDIR . "Fcts.pl";
require $SCRIPTDIR . "Tools.pl";
require $SCRIPTDIR . "Split.pl";
require $TARGETDIR . "/cmd/atl_exec.pl";

# exec
$TESTPROGRAM=shift(@ARGV);
$TESTPROGRAM=~s/(\w:)\\.*:/$1/; #Fix defect RATLC00869194 due to CDT3.0: Run configuration : the first time Application binary is empty and when selecting file => Errors
$ARGUMENTS=join(' ',@ARGV).$ARGUMENTS;
my $testRTlog=$LOGFILENAME; #attolcc use its own LOGFILENAME format. so memorize it
my $attSplitted=0;
$LOGFILENAME="TestRTexec.log";
@ARGV=($envnode);

EnterInScript();
# clean traces if required
if($RESET_RESULTS){
unlink($ATP_TPF_NAME);
unlink($ATQ_TQF_NAME);
unlink($ATC_TIO_NAME);
unlink($ATT_TDF_NAME);
unlink($TDFFILE);

}
    $TESTPROGRAM=~s/\"//g;
    print &PerlTranslate("TestRTexec.pl", "Executing %1 %2...\n", "%1 is the program to be executed and %2 contains the arguments given to it", $TESTPROGRAM, $ARGUMENTS);
    $status = AtlExec ($TESTPROGRAM, $ATL_OUT_FILE, $ARGUMENTS);
    $ATKMODE=1 if(@OTIFILES);

    if ( $ATCMODE || $ATTMODE || $ATPMODE || $ATQMODE || $ATKMODE )
    {
       # when socket uploader is used SplitTraces check created files and make the log 
       my $exeInstr=0;
          if($ATL_MULTI_PROCESS){
          	 my ($dir,$name,$ext) = SplitFileName($ATL_OUT_FILE);
          	 opendir(DIR,"$dir") || die &PerlTranslate("TestRTexec.pl", "Error: unable to open directory %1.\n","%1 directory name",$dir);
          	 while($f=readdir(DIR)) {
          	 	SplitTraces ($dir.'/'.$f) if($f=~ /$name\..*\.$ext/);
          	 }
          	 closedir(DIR);
          } else {
	  	SplitTraces ($ATL_OUT_FILE); # LOG are made inside SplitTraces
	  }
	  #---------------------------------------------------------------------
	  ## Coverage check ...
	  if ( $ATCMODE )
	  {
	      if ( ! $used[$tio] )
	      {
		  print &PerlTranslate("TestRTexec.pl", "No Coverage results found.\n");
		  $exeInstr++;
	      }
	      
	  } 	  

	  #---------------------------------------------------------------------
	  ## Manage TDF Traces ...
	  if ( $ATTMODE )
	  { # No attsplit nor attloop on the fly
	      if ( $used[$tdf] )
	      {
		      # print $TDFFILE, "size=",(-s $TDFFILE),"\n";
		      if((-s $TDFFILE) > ($ATT_SPLIT_SIZE*1000)) {
		          # get the TSF file in the $testRTlog to be used by the PostAttManage
		          # ......
		          
		          #then split the big file
			  PostAttManage ($TDFFILE);
			  $attSplitted=1;
		      }
	      }
	      else
	      {
		  print &PerlTranslate("TestRTexec.pl", "No Tracing results found.\n");
		  $exeInstr++;
	      }
	  } #ATTMODE==1
	  
	  #---------------------------------------------------------------------
	  ## Memory Profiling check ...
	  if ( $ATPMODE )
	  {
	      if ( ! $used[$tpf] )
	      {
		  print &PerlTranslate("TestRTexec.pl", "No Mempro results found.\n");
	      }
	  } #ATPMODE==1
	  
	  #---------------------------------------------------------------------------
	  ## Performance Profiling check ...
	  if ( $ATQMODE )
	  {
	      if ( ! $used[$tqf] )
	      {
		  print &PerlTranslate("TestRTexec.pl", "No Perfpro results found.\n");
		  $exeInstr++;
	      }
	  } #ATQMODE==1
	  
	  #---------------------------------------------------------------------------
	if($exeInstr == 3) {
          print "No results. Clean the project to instrument the application.\n";
          exit(0);
	}
    } #ATCMODE==1 || ATTMODE==1 || ATPMODE==1 || ATQMODE==1 || $ATKMODE==1

#generate the log file for eclipse
$ATKMODE=1 if(@OTIFILES);
my $tsf;
$tsf=( $ATTMODE || $ATPMODE || $ATQMODE || $ATKMODE );

if(open IN, $LOGFILENAME) {
	open OU, ">>$testRTlog" or die &PerlTranslate("TestRTexec.pl", "cannot write the log file.\n");
	while(<IN>){
		if((/^TDF\s+(.*)$/) && ($attSplitted))  {$attSplitted=0;} #forget the first one 
		elsif(/^(XRD|TDF|TQF|TPF|TIO)\s+(.*)$/) {print OU $2,"\n";} 
		elsif(/^DUM\s+(.*)$/) {unlink($1) unless($KEEP);}
	}
	close IN;
	close OU;
	#clean the logfile.
	my %seen = ();
	open IN, $testRTlog or die &PerlTranslate("TestRTexec.pl", "No log found.\n");
	open OU, ">$LOGFILENAME" or die &PerlTranslate("TestRTexec.pl", "cannot write the temp log file.\n");
	while(<IN>){
	   chop;
	   $seen{$_}++ if((/\.(tsf|tpf|tqf|tdf)$/i) && !($tsf));
	   $seen{$_}++ if((/\.(fdc|tio)$/i) && !($ATCMODE));
	   $seen{$_}++ if((/\.crc$/i) && !($MISRA_MODE));
	   $seen{$_}++ if((/\.met$/i) && !($ATMMODE));
	   $seen{$_}++ if(/\.spt$/i);
	   $seen{$_}++ unless($seen{$_} || (-f $_));
	   print OU "$_\n" unless $seen{$_}++;
	 }
	close IN;
	close OU;
	rename($LOGFILENAME,$testRTlog);
	#and suppress the studio log file
	unlink($LOGFILENAME);
} else {
	&PerlTranslate("TestRTexec.pl", "No result log found.\n");
}


0;

