#!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                      -*-  Source Instrumentation launcher -*-                #
#                                                                              #
#                                                                              #
################################################################################

#$Id: attolcclib.pl,v 1.123.2.4 2008/02/07 10:50:26 rfrance Exp $

push(@INC,$SCRIPTDIR);

################################################################################
# useful for stdout/stderr direct viewing inside 'console' of studio window
# (better: we have stdout/stderr lines in right order and not stder before stdout
use FileHandle ;
use File::Path;
STDOUT->autoflush(1);
STDERR->autoflush(1);

#require "Fcts.pl";
#require "Translate.pl";
require "Products.pl";
require "codeChecker.pl";
require "metricC.pl";
#require "version.pl";

$OSNAME = ($^O=~/win32/i) ? "win32" : "unix" unless ($OSNAME);

my $pwd = GetCurrentDir();
$INTDIR = "." if ($INTDIR eq '');
$BINDIR = GetBinDir() if ($BINDIR eq "");
$BINDIR = ShortPathName($BINDIR);

my $StdErrFile="Err.log"; #files used by SystemL func
my $StdOutFile="Out.log";

# Default settings
# Launcher flags (declared before require $envfile
$INIFILE="tp.ini" unless($INIFILE);
$TDP_LANGUAGE="C" unless($TDP_LANGUAGE);
my $lang;
#at first attolcc exec tdp have to be generated
my $generateTdp=1;
my $link=1;
$ADDFLAGS="";
@COMPLETE_INCLUDE_DIR_LIST=();
@GENERATION_CONDITION=();
@XOB=();
$MET_ONE_LEVEL=0;
$MET_IN_SOURCE_DIR=0;
my ($dir,$launcher,$extl)=SplitFileName($0);
$TreatmentOnSource=0;
$TreatmentOnPreprocessed=0;
$TreatmentOnInstrumented=0;
$TreatmentOnObject=0;

ReadProductName();

if($^O=~/win32/i) {
    $PATH_SEPARATOR = '\\';
    $CLASSPATH_SEPARATOR = ';';
  } else {
    $PATH_SEPARATOR = '/';
    $CLASSPATH_SEPARATOR = ':';
  }

my $activ=1;
my $firstExec=0;
my $iniHasChanged=0;
my  @otc=();
#--------------- begin of saved variable --------------
 $ATTOLCC_LOGNAME=$launcher."Log.log" unless($ATTOLCC_LOGNAME); # default log file name for error&trace&exec
 $ATTOLCC_LOGFILE=0 unless($ATTOLCC_LOGFILE);
 $ATTOLCC_NOLIST=0 unless($ATTOLCC_NOLIST);
 $ATTOLCC_VERBOSE=0 unless($ATTOLCC_VERBOSE);
 $KEEP=0 unless($KEEP);
 $NOSTOP=0 unless($NOSTOP);
 $IGNORE="" unless ($IGNORE);
 $INSTRUM="" unless ($INSTRUM);
 $LOGFILENAME="" unless ($LOGFILENAME);
 $instrumOpt="" unless($instrumOpt);
 $attolcc_tmpdir="";
 $launcherEnvOptions="";
 $force_tdp_cc=0;
 $showCmd=0;
 $no_tdp=0;
 $force_lang=0;
 $force_tdp_lang=0;
 $metdir="";
 @oti=();
#--------------- end of saved variable --------------

$sp=" ";
$cot="\"";
my $pc_cmdDiff=0; #1 means that some options are used for prepro and not used for compil
#my @Errors;
my @filesToRemove=();
my @srcFilesToInstrum=();

my $OutFile;
my $tsfdir;
my $fdcdir;

my @launcherOptions=();
my $launcherStrOptions="";
my $onCompiler=0;
my @IgnoreList=();
my @InstrumList=();
my $Pext=".i"; # preprocessed file ext
my $Iext="_aug"; # Instrumented file sufix
%settings=(); #memo for save

#between compilation some data are saved into env_attolcc.pl it is removed after the successful link 
$envfile="env_$launcher.pl";
###########################################################################
# read the launcher options
sub read_Launch_cmd #(@)
{
   my @argv=@_;
   #debug("analyse cmd");
   $ATKMODE=0;
   $ATPMODE=0;
   $ATQMODE=0;
   $ATL_CLOCK_KIND=0;
   $ATTMODE=0;
   $ATC_INFORMATION=0;
   $ATCMODE=0;
   $iniHasChanged=1;
   $ATTOLCC_LOGNAME=$launcher."Log.log"; # default log file name for error&trace&exec
   $force_tdp_cc=0;
   $ATTOLCC_VERBOSE=0;
   $showCmd=0;
   $KEEP=0;
   $NOSTOP=0;
   $ATTOLCC_LOGFILE=0;
   $IGNORE="";
   $link=1;
   $force_lang=0;
   $force_tdp_lang=0;
   $instrumOpt="";
   $MET_ONE_LEVEL=0;
   $MET_IN_SOURCE_DIR=0;
   $ATMMODE=0;
   @MET_RESTRICT_DIR=();
   $metdir='';
   $MISRA_MODE=0;
   while(@argv)
   {
	$_=shift(@argv);
	my $lcarg=lc($_);
	if(/^--([a-zA-Z_0-9]+)(\+?)=(\"?)(.+)\3$/){ #settings option
		my $set=uc($1);
		my $append="$2" if($2);
		my $cotStr=$3 if($3);
		my $val=$4;
		if($^O=~/win32/i){
			if($set =~/FILE/) {
			          $val =~ s/\\/\\\\/g;
#			          $val = TestRTUtil::LocaleStringReplace($val,"\\\\","\\\\"); # for japanese
			}
		} else {
		#pb for CFLAGS	if(($val =~/ /) && !($set =~/NAME|FILE/)) {$val = $cot.$val.$cot;}
		}
		#debug("settings:$set $append=($cotStr) $val");
		if(($append) && (($set eq 'CFLAGS') || ($set eq 'CPPFLAGS'))){
			if (!($ADDFLAGS=~ /$val/)) {
				$ADDFLAGS.=' '.$val;
				$settings{'ADDFLAGS'}=$ADDFLAGS;
			}
			next;
		}
		$settings{$set}=$val;
		eval "\$$set='$val'";
	}
	elsif(/^--([a-zA-Z_0-9]+)$/){ #settings option
		my $set=uc($1);
		$settings{$set}=1;
		eval "\$$set=1";
	}
	# launcher or instrum option
	elsif($lcarg eq "-nostop")	{$NOSTOP=1;}
	elsif($lcarg eq "-keep") 	{$KEEP=1;}
	elsif($lcarg eq "-force_tdp_cc"){$force_tdp_cc=1;}
	elsif($lcarg eq "-force_c_tdp")	{$force_tdp_lang=1;$TDP_LANGUAGE="C";}
	elsif($lcarg eq "-force_cpp_tdp"){$force_tdp_lang=2;$TDP_LANGUAGE="CPP";}
	elsif($lcarg eq "-force_c")	{force_language(1);}
	elsif($lcarg eq "-force_cpp")	{force_language(2);}
	elsif($lcarg eq "-nolist")   	{$ATTOLCC_NOLIST=1;}
	elsif($lcarg eq "-log")   	{$ATTOLCC_LOGFILE=1;}
	elsif($lcarg eq "-verbose")	{$ATTOLCC_VERBOSE=1;}
	elsif($lcarg eq "-v")		{$ATTOLCC_VERBOSE=1;}
	elsif($lcarg eq "-one_level_metrics")	{$ATMMODE=1;$MET_ONE_LEVEL=1;}
	elsif($lcarg eq "-metrics_in_source")	{$ATMMODE=1;$MET_IN_SOURCE_DIR=1;}
	elsif(/^-restrict_dir_metrics=(.+)$/i)	{$ATMMODE=1;push(@MET_RESTRICT_DIR,split(/,/,$1));}
	elsif(/^-metric=(\"?)(.+)\1$/i)		{$ATMMODE=1;$metdir=$2;}
	elsif(/^-metric/i)			{$ATMMODE=1;}
	elsif(/^-codereview=(\"?)(.+)\1$/i)	{$MISRA_MODE=1;$MISRA_CONF=$2;}
	elsif(/^-codereview$/i)			{$MISRA_MODE=1;$MISRA_CONF="$ENV{'TESTRTDIR'}/plugins/Common/lib/confrule.xml";}
	elsif(/-\#.*$/)		   	{$showCmd=1;$ENV{'ATTOLSTUDIO_VERBOSE'}=1;}
	elsif(/^-log=(\"?)(.+)\1$/i)   	{$ATTOLCC_LOGNAME=$2;$ATTOLCC_LOGFILE=1;}
	elsif(/^-ignore=(\"?)(.+)\1$/i) {
		   #ignore list: files are separated by ',' if a file has .lst ext. the file may contains one or more file list
		   #those file lists may be on one line (using ',' as separator and/or on multiple line
		   #those file lists may involve .lst files which will be read as well as file lists.
		   my @Ignore=split(/,/,$2);
		   my $f;
		   foreach (@Ignore)
		   {
			my $fl=$_;
			$fl=~ s/\\/\//g;
			if(!(grep(/^\Q$fl\E$/,@IgnoreList))) {
			   push(@IgnoreList,$fl);
			   if(/\.lst$/) { pushFromFile($fl,@IgnoreList);}
			}
		   }
	     }
	elsif(/^-instrum=(\"?)(.+)\1$/i) {
		   #instrum list: files are separated by ',' if a file has .lst ext. the file may contains one or more file list
		   #those file lists may be on one line (using ',' as separator and/or on multiple line
		   #those file lists may involve .lst files which will be read as well as file lists.
		   my @Instrum=split(/,/,$2);
		   my $f;
		   foreach (@Instrum)
		   {
			my $fl=$_;
			$fl=~ s/\\/\//g;
			if(!(grep(/^\Q$fl\E$/,@InstrumList))) {
			   push(@InstrumList,$fl);
			   if(/\.lst$/) { pushFromFile($fl,@InstrumList);}
			}
		   }
	     }
	elsif(/^-set=(.+)$/i) 	{print STDERR "SET option not allowed\n";}
	elsif(/^-otc=(\"?)(.+)\1$/i) 	{@otc=split(/,/,$2);}
	elsif($lcarg eq "-nolink")	{$link=0;}#with -nolink the link is done only if obj or lib file are on the cmd line
	elsif(/^-PAS/i)	{$ATCMODE=1;} #this option is not given to instrumentor
	else {
		#is not a launcher option give it to instrumentor
		if((/ /) && !(/\"$/)){
		    if(/^(.+)=(.+)$/) {$instrumOpt .= $sp.$1."=".$cot.$2.$cot;}
		    else {$instrumOpt .=$sp.$cot.$_.$cot;}
		}
		else {$instrumOpt .= $sp.$_;}
#		if(/^-fdcdir=(.+)$/){$fdcdir=$1.$PATH_SEPARATOR;}
#		elsif(/^-tsfdir=(.+)$/){$tsfdir=$1.$PATH_SEPARATOR;}
#		else 
		{
		  $_=uc($_);
		  #debug("instr option:$_");
		  $ATKMODE=1 if (/^-AU/); #AUTO_OTI
		  $ATPMODE=1 if (/^-MEM/);
		  $ATQMODE=1 if (/^-PERF/);
		  $ATL_CLOCK_KIND=1 if(/^-PERF.*=P/);
		  $ATTMODE=1 if (/^-TR/);#TRACE
		  $ATC_INFORMATION=1 if(/^-COMPA/);#1compact 2count
		  $ATC_INFORMATION=2 if(/^-COUN/);#1compact 2count
		  $ATCMODE=1 if ((/^-PAS/) || (/^-PRO/) || (/^-BL/) || (/^-COND/));
		}
	}
   }
   $ATCMODE=1 if ($ATC_INFORMATION ||
				!($ATKMODE|$ATPMODE|$ATQMODE|$ATTMODE|$ATMMODE|$MISRA_MODE));
   $IGNORE=",".join(',',@IgnoreList);
   $INSTRUM=",".join(',',@InstrumList) if(@InstrumList);
}
###########################################################################
# force language option found in the compiler command line
sub force_language #($)
{
my $l = shift;
$force_lang=$l;

   if(($force_lang == 2)&&($lang ne "CPP")) {
      $INIFILE="tpcpp.ini";
      DecodeIniFile();
      }
   elsif(($force_lang ==1)&&($lang ne "C")) {
      $INIFILE="tp.ini";
      DecodeIniFile();
      }
   $lang=uc($Ini{'LANGUAGE'});
   $OBJEXT=$Ini{'OBJEXT'};
   $TDP_LANGUAGE = $lang;
   trace ("force language to $lang\n");
}

###########################################################################
# read_cmd
sub read_cmd #(@)
{
require "BatchCCDefaults.pl";
   my @argv=@_;
   while((@argv) && (!$onCompiler))
   {
   	$_=shift(@argv);
	s/\"$// if(s/^\"//);#remove global cot
   	#decode instrum options
   	   if($_ eq "--"){#separator cmd
   	   	$onCompiler=1;
   	   }
    	   #debug("Launch:$_");
	   elsif(/^-opt=(\"?)(.+)\1$|\@(\"?)(.+)\3$/i){ #" accept @optFile or -opt=optFile for options
	        my $fileOpt=$2.$4;
		# read the options in the file and push into the existing @argv to be analysed as other
		open OPTIN,"<$fileOpt" || die &PerlTranslate("attolcc.pl", "Cannot open the file %1\n", "%1 is the file name", $fileOpt);
		while (<OPTIN>){
			chomp($_);
			debug("[$_]");
			my @optInFile=splitArgs($_);
			push(@launcherOptions,@optInFile);
		}
		close OPTIN;
	   }
	   elsif(/^-act=(\"?)(.+)\1$/i){
	   	$activ=$2;
	   	if(-f $activ) {
			open ACTIN,"<$activ" || die &PerlTranslate("attolcc.pl", "Cannot open the file %1\n", "%1 is the file name", $activ);
	   		while (<ACTIN>){
				chomp($_);
				$activ=$_;
	   		}
			close ACTIN;
		$activ = 0 if(lc($activ) eq "no");
	   	}
	   }
	   elsif(lc($_) eq "-help")	{usage();exit(0);}
	   elsif(lc($_) eq "--help")	{help();exit(0);}
	   elsif(/^-env_(.+)=(.+)$/i)	{$ENV{uc($1)}=$2;}
	   elsif(/^-treatmt=(.+)$/i) {
	   	my $t=$1;
		#debug("require additional treatment by $t");
		require $t;
	   }
	   elsif(/^-tmpdir=(\"?)(.+)\1/i) { 
		$attolcc_tmpdir=$2;
		$INTDIR=$attolcc_tmpdir;
		mkpath($attolcc_tmpdir,0777) unless(-d $attolcc_tmpdir);
		$attolcc_tmpdir.=$PATH_SEPARATOR unless ($attolcc_tmpdir=~/[\/\\]$/);
		$envfile=$attolcc_tmpdir.$envfile;
	   }
	   elsif(/-notdp/i)   	{$no_tdp=1;}
  	   else {
	  	   push(@launcherOptions,$_);
  	   }
   }#while @argv

   unless($activ) {
	   my $ret = system(@argv);
	   exit($ret);
   }
   
   $LOGFILENAME=$INTDIR.'/'.$launcher."files.log";

   $no_tdp=1 if($ENV{ATL_SHARED_TDP});
   $launcherStrOptions=join('',@launcherOptions);
   #debug($launcherStrOptions);
   if((!$no_tdp) && (-r $envfile)) {
		#debug("require $envfile");
		require $envfile;
		#force_tdp_cc =1 here means it was set at previous exec and so tdp generated yet
		$generateTdp=0 if($force_tdp_cc);
   }
   else
   {
   	printEnvironment();
	$ATCMODE=1; #no options=ATC
	$NAME="";
	$iniHasChanged=1;
	$firstExec=1;
   }
   #debug("launcher Options:  $launcherStrOptions env_=$launcherEnvOptions");

   DecodeIniFile();
   $lang=uc($Ini{'LANGUAGE'});
   $OBJEXT=$Ini{'OBJEXT'};
   $LIBEXT=$Ini{'LIBEXT'};
   $DLLEXT=$Ini{'DLLEXT'};
   $OUTDIR=$INTDIR;
   
   # if the cmd line is the same no need to decode it, $envfile is decoded yet
   if($launcherEnvOptions ne $launcherStrOptions) {read_Launch_cmd(@launcherOptions);}
   push(@filesToRemove,$LOGFILENAME) if($ATTOLCC_NOLIST);
   #some checks
   if(!$onCompiler) {
	#may be, we want to make the TDP only
   	if($force_tdp_cc) {
		#yes, we want to make the TDP only, Do it
		TDPcc();
		push(@filesToRemove,$envfile) unless ($KEEP); #we should be at link time so no need to keep this file
		removeFiles(0) ;
		#and do nothing else
		exit(0);
   	}
   	else {
		pError("$SMALL_PRODUCT_NAME-E-NOSEPF, command separator -- not found in command line");
		usage();
		exit(0);
	}
   }
   else #(!$onCompiler)
   {
   	#decode compilation command
   	if(ParseCompilerArgs(@argv)){
	     my $ret=stdCompil();
	     exit($ret);
	}
	$TpCflags=$CompilFlags if($TpCflags eq '');
	$APP_CFLAGS=$TpCflags if($firstExec); #memo for TP compilation
   }
   return 0;
}

###########################################################################
# TestRTcc_cmd
sub TestRTcc_cmd #(@)
{
   my @argv=@_;
   DecodeIniFile();
   $lang=uc($Ini{'LANGUAGE'});
   $OBJEXT=$Ini{'OBJEXT'};
   $LIBEXT=$Ini{'LIBEXT'};
   $DLLEXT=$Ini{'DLLEXT'};
   $attolcc_tmpdir=$OUTDIR.$PATH_SEPARATOR;
   $IGNORE=",".join(',',@IGNORE);
   $INSTRUM=",".join(',',@INSTRUM);
   $INSTRUM="" if($INSTRUM =~ /^,\s*$/);

   	#decode compilation command
   	if(ParseCompilerArgs(@argv)){
	     my $ret=stdCompil();
	     exit($ret);
	}
   #print "main::INTDIR=$main::INTDIR\n\n";
   $envfile=$INTDIR.'/TPflags.pl';
   if(-r $envfile) {
   	debug("require $envfile");
   	require $envfile;
   } else {
        $iniHasChanged=1 if($USE_CFLAGS_TP);
	$TpCflags=$CompilFlags if($TpCflags eq '');
        $APP_CFLAGS=$TpCflags;
   	#debug("TP flags will be $APP_CFLAGS");
   }
   return 0;
}
################################################################################
sub printEnvironment
{
  debug("#Perl Script Command Line (" . scalar(@ARGV) . " args):\n# $launcher [" . join ("] [", @ARGV) . "]\n");
  print STDERR "#     ATLTGT     = " . $ENV{'ATLTGT'} . "\n";
  print STDERR "#     TESTRTDIR  = " . $ENV{'TESTRTDIR'} . "\n";
}
###########################################################################
# instrumentation
sub instrumentation #($$$)
{
   my ($lang,$in,$out)=@_;
   my $co;
   my $otifiles="";
   my $set= "";
   unless($main::TestRTCC){ # compute instrum option regarding on line options  
	   my @SETS=();
	   push(@SETS,"MINMAX") if ($ATQ_COMPUTE_MINMAX);
	   push(@SETS,"CHECK_STACK") if($ATL_CHECK_STACK);
	   push(@SETS,"VOLATILDLL") if($ATL_USE_VOLATIL_DLL);
	   push(@SETS,"UNLOADDLL") if(lc($ATL_USE_VOLATIL_DLL) eq "this");
	   push(@SETS,"TPDLLIMPORT") if($ATL_RUNTIME_FORMAT eq "DLL");
	   push(@SETS,"NO_SYS_INCLUDE") if($NO_SYS_INCLUDE);
	   push(@SETS,"DYNTABLES") if($DYNTABLES);
	   push(@SETS,"MULTITHREAD") if($ATL_MULTI_THREADS);
	   push(@SETS,"LINENUMOPTIM") if($LINENUMOPTIM);
	   $set= " -SET=".join(",",@SETS) if(@SETS);
   }
   if (!($instrumOpt =~ /-comment=/i)) {
	   $co=$PreproFlags;
	   $co =~s/\\\"//g;#\ "
	   $co =~s/\"//g;
	   $co =~s/,/ /g;
	   $co="-COMMENT=\"Preprocessing Flags:$co\"";
   }
   $otifiles= '-otifile="'.join('","',@oti).'"' if (@oti);
   print STDERR ">instrumentation of $in to $out\n";
   unlink($out);
   if($lang eq "CPP") { # C++
   return SystemL("$BINDIR/attolccp $cot$in$cot $cot$out$cot atl.hpp atl.opp $instrumOpt $Ini{'INSTRUM_OPT'} $set $otifiles -studio_log=\"$LOGFILENAME\" $co");
   }
   return SystemL("$BINDIR/attolcc1 $cot$in$cot $cot$out$cot atct.def $instrumOpt $Ini{'INSTRUM_OPT'} $set -studio_log=\"$LOGFILENAME\" $co");
}

###########################################################################
# prepro contract check
sub preproOtc #($$)
{
   my ($in,$out)=@_;
   print STDERR ">preprocessing of $in\n";
   unlink($out);
   my $ret= SystemL("$BINDIR/atoprepro $cot$in$cot -G C++ -OTI $cot$out$cot -O $INTDIR/temp_cc -TDF unused_tdf -E 30 $Ini{'PREPRO_OPT'} -studio_log $LOGFILENAME");
   unlink("$INTDIR\temp_cc");
   return $ret
}

###########################################################################
# OutFileFound called when the force out file is found on the command line
#		register the requested name of the object file to generate and/or its directory
#		to register a directory the path must ends by a path separator
sub OutFileFound #($)
{
my $of=shift;
$OutFile=$of;
}

###########################################################################
# SourceFileFound called when a source file is found on the commande line
sub SourceFileFound #($)
{
my $sf=shift;
push(@srcFilesToInstrum,$sf);
}

###########################################################################
# Setting called to set a TDP setting on special compiler option
sub Setting #($$)
{
my ($set,$val)=@_;
        $settings{$set}=$val;
	eval "\$$set=\"$val\"";
}

###########################################################################
# NoLink called when the no link flag is found in the command line
sub NoLink
{
$link=0;
}

###########################################################################
# diffBetweenPreproAndCompil called when prepro use options which is not used on compil
# force to preprocess before compil even without instrum
sub diffBetweenPreproAndCompil
{
#debug("diffBetweenPreproAndCompil");
$pc_cmdDiff=1;
}

###########################################################################
# start called at first execution allow to initialize the instrumentation
sub start
{
    my $rep;
    my $firstline;
    if(@otc)
    {
    	foreach $otcfile (@otc)
    	{
    	    my ($d,$n,$e)=SplitFileName($otcfile);
    	    $d=$attolcc_tmpdir if($attolcc_tmpdir ne "");
    	    my $otifile=$d.$n.".oti";
    	    preproOtc( $otcfile , $otifile);
    	    push (@oti,$otifile);
    	    $ATKMODE=1;
    	}
	$model = "$TARGETDIR/lib/options_model.h";
	$options = "$INTDIR/options.h";

	MakeCProductsHeaderFile ($model, $options);
    }
}
###########################################################################
# TDPBatchCC
sub TDPcc
{

$generateTdp=0;
	return 0 if($ATL_RUNTIME_FORMAT eq "NONE");
	$ATL_RUNTIME_FORMAT="OBJ" if($ATL_RUNTIME_FORMAT eq "");
	$USE_UNLOAD_DLL ="VOLATILDLL" if($ATL_USE_VOLATIL_DLL);
	$USE_UNLOAD_DLL.=",UNLOADDLL" if(lc($ATL_USE_VOLATIL_DLL) eq "this");
	if($ATL_RUNTIME_FORMAT eq "OBJ") {
		$TP_CCFLAGS=$Ini{'DEFAULT_TPLIB_CCFLAGS'};
		$TP_LDFLAGS=$Ini{'DEFAULT_TPLIB_LDFLAGS'};
	}
	$MIME_NAME='ISO-8859-1' if($MIME_NAME eq "");
	# .....

	if($NAME eq '') {
		my ($d,$n,$e)=SplitFileName($objFiles[0]);
		$NAME=$n;
		($d,$NAME,$e)=SplitFileName($srcFilesToInstrum[0]) unless($NAME);
		$NAME = "root" unless($NAME);	
	}

	# Something to get the well known and unique out file
	$ATL_OUT_FILE = "atlout.spt" if($ATL_OUT_FILE eq "");
	$ATL_OUT_FILE = $ATL_TRACES_FILE if ($ATL_TRACES_FILE ne "");
	
	open( LOG, ">>$LOGFILENAME") || print STDERR "unable to open the file $LOGFILENAME\n";
   	my $name=$ATL_OUT_FILE;
	if( defined $Ini{REMOTE_SPT} ){
		$name=$Ini{REMOTE_SPT};
		if($name=~ m/[\\\/]$/){ #it is a directory not a file
			my ($d,$n,$e) = SplitFileName($ATL_OUT_FILE);
			$name.=$n.'.'.$e;
		}
	}
   	$name=~s/(.*\.)(\w{3})$/$1\*.$2/ if($ATL_MULTI_PROCESS);
	print LOG "SPT $name\n";

	my $sptOpt="A"; #describe what is involved in the result file
	$sptOpt.="T" if($ATTMODE);
	$sptOpt.="C" if($ATCMODE);
	$sptOpt.="P" if($ATPMODE);
	$sptOpt.="Q" if($ATQMODE); 
	print LOG "#OPT $sptOpt\n";
	close LOG;
	if($ENV{'ATL_NO_TDP_COMPILE'})
	   {
		print STDERR ">Products.h generation only because ATL_NO_TDP_COMPILE is set\n";
		my $model = "$TARGETDIR/lib/products_model.h";
		my $header = "$INTDIR/products.h";
		MakeCProductsHeaderFile($model,$header);
		return 0;
	   }
	if($CFLAGS == 1){
		$CFLAGS="";
		if($TP_CCFLAGS eq ""){
			$TP_CCFLAGS=$APP_CFLAGS;
			@GENERATION_CONDITION=();
			@COMPLETE_INCLUDE_DIR_LIST=();
		}
	}else{
		#-----this part comes from TDPBachCC.pl-------------------------------------

		# If no overload for them, $CPPFLAGS, $CFLAGS, @COMPLETE_INCLUDE_DIR_LIST and
		# @GENERATION_CONDITION come from ini file:
		if ($CPPFLAGS eq "") {
		  $CPPFLAGS = $Ini{'DEFAULT_CPPFLAGS'};
		}
		if ($ADDFLAGS ne "") {
		  $CPPFLAGS .= $ADDFLAGS;
		}
		if($^O =~ /Win32/) {while($CPPFLAGS=~ /\$(\w+)/){my $v=$1;$CPPFLAGS=~ s/\$$v/$ENV{$v}/g;}}
		if ($CFLAGS eq "") {
		  $CFLAGS = $Ini{'DEFAULT_CFLAGS'};
		}
		if($^O =~ /Win32/) {while($CFLAGS=~ /\$(\w+)/){my $v=$1;$CFLAGS=~ s/\$$v/$ENV{$v}/g;}}
		if ($INCLUDE_PATHS ne "") {
		  if($^O =~ /Win32/) {while($INCLUDE_PATHS=~ /\$(\w+)/){my $v=$1;$INCLUDE_PATHS=~ s/\$$v/$ENV{$v}/g;}}
		  @COMPLETE_INCLUDE_DIR_LIST = split( /,/, $INCLUDE_PATHS);
		}
		if (scalar(@COMPLETE_INCLUDE_DIR_LIST) <= 0) {
		  if ($Ini{'DEFAULT_INCLUDE_PATHS'} ne "") {
		    if($^O =~ /Win32/) {while($Ini{'DEFAULT_INCLUDE_PATHS'}=~ /\$(\w+)/){my $v=$1;$Ini{'DEFAULT_INCLUDE_PATHS'}=~ s/\$$v/$ENV{$v}/g;}}
		    @COMPLETE_INCLUDE_DIR_LIST = split( /,/, $Ini{'DEFAULT_INCLUDE_PATHS'} );
		  }
		}
		if ($DEFINES ne "") {
		  if($^O =~ /Win32/) {while($DEFINES=~ /\$(\w+)/){my $v=$1;$DEFINES=~ s/\$$v/$ENV{$v}/g;}}
		  @GENERATION_CONDITION = split( /,/, $DEFINES);
		}
		if (scalar(@GENERATION_CONDITION) <= 0) {
		  if ($Ini{'DEFAULT_DEFINES'} ne "") {
		    if($^O =~ /Win32/) {while($Ini{'DEFAULT_DEFINES'}=~ /\$(\w+)/){my $v=$1;$Ini{'DEFAULT_DEFINES'}=~ s/\$$v/$ENV{$v}/g;}}
		    @GENERATION_CONDITION = split( /,/, $Ini{'DEFAULT_DEFINES'} );
		  }
		}
	}

	#----------------------------------------------------------------------------
	print STDERR ">TDP generation...\n";
	# Let's do it
	if (MakeTargetPackageObject()) {
	  # Some errors while compiling TDP library

	  return 1;
	}
	return 0;
}

###########################################################################
# add all fileNames listed into an external .lst file to the IgnoreList array
# .lst file may include an other .lst file.
sub ignoreFromFile #($)
{
my $f =shift;
my @list=();
my $fl;
trace("#ignore list From File:$f");
open IGN, "<$f" || return &PerlTranslate("attolcc.pl", "Cannot open the file %1\n", "%1 is the file name", $f);
while(<IGN>)
   {
	chomp;
   	@files=split(/,/,$_);
	push(@list,@files);
   }
close(IGN);
foreach(@list)
   {
	$fl=$_;
	if((/\..{1,3}$/) && !(grep(/^$fl$/,@IgnoreList))) {
	   $fl=~ s/\\/\//g;
	   #debug("fromFile:$fl");
	   push(@IgnoreList,$fl);
	   if($fl =~/\.lst$/) { ignoreFromFile($fl);}
	}
   }
}

###########################################################################
# add all fileNames listed into an external .lst file to the List array
# .lst file may include an other .lst file.
sub pushFromFile #($\@)
{
my ($f,@IList) = @_;

my @list=();
my $fl;
trace("#ignore/intrum list From File:$f");
open IGN, "<$f" || return &PerlTranslate("attolcc.pl", "Cannot open the file %1\n", "%1 is the file name", $f);
while(<IGN>)
   {
	chomp;
   	@files=split(/,/,$_);
	push(@list,@files);
   }
close(IGN);
foreach(@list)
   {
	$fl=$_;
	if((/\..{1,3}$/) && !(grep(/^$fl$/,@IList))) {
	   $fl=~ s/\\/\//g;
	   #debug("fromFile:$fl");
	   push(@IList,$fl);
	   if($fl =~/\.lst$/) { pushFromFile($fl,@IList);}
	}
   }
}


###########################################################################
# record launcher and instrum options and settings into env_xxxxx.pl
# to memorize them between each instrum/compil file and reuse it at link time
sub rec_env
{
my $s;
#debug("write file:$envfile");
open EN, ">$envfile" || die &PerlTranslate("attolcclib.pl", "Cannot open the file %1\n", "%1 is the file name", $envfile);
unless($main::TestRTCC) {
	print EN "# $launcher configuration:\n";
	print EN "\$launcherEnvOptions='$launcherStrOptions';\n";
	print EN "\$INIFILE='$INIFILE';\n";
	print EN "\$INTDIR='$INTDIR';\n";
	print EN "\$NOSTOP=$NOSTOP;\n";
	print EN "\$KEEP=$KEEP;\n";
	print EN "\$showCmd=$showCmd;\n";
	print EN "\$ATTOLCC_VERBOSE=$ATTOLCC_VERBOSE;\n";
	print EN "\$force_tdp_cc=$force_tdp_cc;\n";
	print EN "\$ATTOLCC_LOGNAME='$ATTOLCC_LOGNAME';\n";
	print EN "\$ATTOLCC_LOGFILE=$ATTOLCC_LOGFILE;\n";
	print EN "\$IGNORE='$IGNORE';\n";
	print EN "\$INSTRUM='$INSTRUM';\n";
	my $attolcc_tmpdir2=$attolcc_tmpdir;
	$attolcc_tmpdir2=~ s/\\/\\\\/g;
	print EN "\$attolcc_tmpdir='$attolcc_tmpdir2';\n";
	print EN "\@oti=(\"".join('","',@oti)."\");\n" if(@oti);
	print EN "\$force_lang=$force_lang;\n";
	print EN "\$force_tdp_lang=$force_tdp_lang;\n";
	print EN "\$TDP_LANGUAGE='$TDP_LANGUAGE';\n";
	print EN "\$instrumOpt='$instrumOpt ';\n";
	print EN "# instrumentation options:\n";
	print EN "\$ATKMODE=$ATKMODE;\n" if($ATKMODE);
	print EN "\$ATPMODE=$ATPMODE;\n" if($ATPMODE);
	print EN "\$ATQMODE=$ATQMODE;\n" if($ATQMODE);
	print EN "\$ATCMODE=$ATCMODE;\n";
	print EN "\$ATTMODE=$ATTMODE;\n" if($ATTMODE);
	print EN "\$ATL_CLOCK_KIND=$ATL_CLOCK_KIND;\n" if($ATL_CLOCK_KIND);
	print EN "\$ATC_INFORMATION=$ATC_INFORMATION;\n" if($ATC_INFORMATION);
	if($ATMMODE){
	print EN "\$ATMMODE=$ATMMODE;\n";
	print EN "\$MET_ONE_LEVEL=$MET_ONE_LEVEL;\n";
	print EN "\$MET_IN_SOURCE_DIR=$MET_IN_SOURCE_DIR;\n";
	print EN "\$metdir=\"$metdir\";\n";
	print EN "\@MET_RESTRICT_DIR=(\"".join('","',@MET_RESTRICT_DIR)."\");\n" if(@MET_RESTRICT_DIR);
	#print EN "\$MET_OPTIONS=\"$MET_OPTIONS\";\n";
	}
	if($MISRA_MODE){
	$MISRA_CONF=~s/\\/\//g;
	print EN "\$MISRA_MODE=$MISRA_MODE;\n" ;
	print EN "\$MISRA_CONF=\"$MISRA_CONF\";\n";
	print EN "\@XOB=(\"".join('","',@XOB)."\");\n";
	}
	print EN "# Node settings:\n";
	print EN "\$NAME='$NAME';\n";
	print EN "\$APP_CFLAGS='$APP_CFLAGS';\n";
	foreach $key (keys %settings) {
	print EN "\$$key='$settings{$key}';\n";
	print EN "\$settings{$key}='",$settings{$key},"';\n";
	#print EN "print \"setting:$key=\$$key\\n\";\n";
	}
	#print EN "print \"loading conf.....\";\n";
   }
   print EN "#flags for TP compilation\n";
   print EN "\$APP_CFLAGS='$APP_CFLAGS';\n";
   print EN "1;\n";
   close(EN);
}

###########################################################################
# print help file
sub help
{
    open HP, "<$ENV{TESTRTDIR}/lib/locale/AttolccPlHelp.txt" || die &PerlTranslate("attolcc.pl", "Cannot open the file %1\n", "%1 is the file name", $ENV{TESTRTDIR}/lib/locale/AttolccPlHelp.txt);
    while (<HP>) {print;} close(HP);
}
###########################################################################
# print usage
sub usage
{
    pError ("$SMALL_PRODUCT_NAME-I-".uc($launcher).", Usage:  $launcher <launcher options> <instrum options> --<settings> -- <compilation command>");
    print " launcher options:\n";
    print " -help show this usage\n";
    print " -opt=<optionsFile> all options can be listed in the file instead of the command line (except -tmpdir)s\n";
    print " -nostop keep intermediate files, write a logfile, launch standard compilation and continue if instrumentation fails\n";
    print " -keep keep intermediate files\n";
    print " -# (silent) shows but does not execute the commands\n";
    print " -verbose display more about executed commands\n";
    print " -force_tdp_cc force the compilation of the TP at the first instrumentation\n";
    print " -force_c   force the instrumention as C code\n";
    print " -force_cpp force the instrumention as C++ code\n";
    print " -nolink does not interpret as a link (used when it cannot be detected on the compilation command)\n";
    print " -noTDP do not generate the TP. So env_${launcher}.pl file is no more used and so not generated\n";
    print " -noList do not generate the list of generated files ${launcher}files.log\n";
    print " -log[=<logFileName>] create a log recording all stderr and stdout\n";
    print " -ignore=<file>[,<file>....] launch standard compilation for listed files. if a file has .lst extension,\n";
    print "     all listed files in the .lst file will be ignored. The .lst file may contains one or more file list .lst as well\n";
    print " 	the file lists in the .lst file may be listed on one line using ',' as separator and/or on multiple lines\n";
    print " -instrum=<file>[,<file>....] launch standard compilation for non listed files. (same format as for ignore option)\n";
    print " -tmpdir=myPath store intermediate files in myPath instead of source directory (this option cannot be part of the optionFile)\n";
    print " -ENV_XXXX=YYYY set the environment variable XXXX to the value YYYY where XXXX and YYYY may be any name and value used by the instrumentation steps (this option cannot be part of the optionFile)\n";
    print " -treatmt=<file.pl> load intermediate treatment described in Perl to execute before, and after each instrumentation step\n";
    print "                    (this option cannot be part of the optionFile)\n";
    print " -otc=<file>[,<file>....] allows to specify the contract checking available for this application (postprocessing should be done manually)\n";
    print " -codeReview[=<file>] enable the code checking using the configuration file <file>\n";
    print " -metric[=<path>] enable the metric computation. Result files are written in <path>\n";
    #keep this line as last one (kit qualif)
    print " --help print the enhanced documentation. (More available options)\n\n";
}

###########################################################################
# remove all file from a list
sub removeFiles
{
my $kept=shift;
   foreach $fl (@filesToRemove)
   {
    if(-r $fl){
      if($kept){
	if($main::TestRTCC){
		trace("#rename file $fl");
		rename($fl,$fl.".bak");
	}
      }else{
        trace("#remove file $fl");
	unlink($fl) ;
      }
    }
   }
   @filesToRemove=();
}

sub debug #($)
{
my $s=shift;
print STDERR "#>$s\n";
}

sub pError #($)
{
my $s=shift;
print STDERR "#?$s\n";
print BLOG "#?$s\n" if($ATTOLCC_LOGFILE);
}

sub trace #($)
{
my $s=shift;
print STDERR $s."\n" if($ATTOLCC_VERBOSE || $ENV{'ATTOLSTUDIO_VERBOSE'});
print BLOG $s."\n" if($ATTOLCC_LOGFILE);
}

###########################################################################
# execute system command and get stderr and stdout to ba able to generate log
sub SystemL
{
     my @Command=@_;
     my $Ret;
     my $Err;
     my $status;
     my $Cmd=join(' ',@Command);
     trace($Cmd);
     if($showCmd){ return 0;}
     if($ATTOLCC_LOGFILE){
	open(OLDOUT,">&STDOUT");
	open(OLDERR,">&STDERR");
	open(STDOUT,">$StdOutFile");
	open(STDERR,">$StdErrfile");
	}

#     $Ret=system($Cmd);
      $Ret=system(@Command);

     $Err=$!;

     if($ATTOLCC_LOGFILE){
	close(STDOUT);open(STDOUT,">&OLDOUT");
	close(STDERR);open(STDERR,">&OLDERR");
	close(OLDOUT);close(OLDERR);
	}
	$status=ReturnAnalysis($Ret,$Err);

     if($ATTOLCC_LOGFILE){
	open(File,"<$StdOutFile"); print BLOG "stdout:\n";while(<File>) {print;print BLOG;} close(File);
	open(File,"<$StdErrFile"); print BLOG "stderr:\n";while(<File>) {print;print BLOG;} close(File);
	unlink($StdErrFile);unlink($StdOutFile);
	}
     return $status;
}

###################################### BEGIN ######################################################
sub Attolcc
{
my $status;
if($main::TestRTCC){
	$status=TestRTcc_cmd(@ARGV);
}else{
	$status=read_cmd(@ARGV);
}
my $phase;
if($ATTOLCC_LOGFILE) {open BLOG, ">>$ATTOLCC_LOGNAME";}

print STDERR "$SMALL_PRODUCT_NAME-I-STARTEXEC, Rational(R) Test RealTime instrumentation driver $VERSION\n";
print STDERR "$SMALL_PRODUCT_NAME-I-COPYRIGHT, $COPYRIGHTMSG\n";
start() if($firstExec);
foreach $s (@srcFilesToInstrum){
   if($status==0){
        @filesToRemove=();
        my $noInstrum=0;
	my $phaseCode=0;
	my $pathFile=absolutePath($s);
	$pathFile=~ s/\\/\//g;
   	my ($dir,$name,$ext) = SplitFileName($s);
	my $o=$name.".".$Ini{'OBJEXT'};
	if($OutFile) {
		$o=$OutFile;
	     if($OutFile =~/[\\\/]$/){ # it is a directory not a file
	        $o.=$name.".".$Ini{'OBJEXT'};
	        $dir=$OutFile;
	        if($attolcc_tmpdir eq "") {
	        	$INTDIR=$OutFile;
	        	$INTDIR=~s/[\\\/]+$//;
	        }
	     }
	}
	my $p=$dir.$name.$Pext;
	my $i=$dir.$name.$Iext.".".$ext;
   	if($attolcc_tmpdir ne "") {
	   	$p=$attolcc_tmpdir.$name.$Pext;
		$i=$attolcc_tmpdir.$name.$Iext.".".$ext;
	}
	push(@objFiles,$o);
	my $relFile=$s;
	$relFile =~ s/\\/\//g;
	my $fileSource=$name.'.'.$ext;
	if(($INSTRUM ne "") && !(  ($INSTRUM=~ /\Q,$fileSource\E/)
				 ||($INSTRUM=~ /\Q,$relFile\E/)
				 ||($INSTRUM=~ /\Q,$pathFile\E/) )){
		$status=1; #no instrumentation for this file
		$noInstrum=1;
		$phase="log. $s not instrumented. -instrum used (no error)";
		trace("#no instrumentation for $s -instrum=$INSTRUM");
	}
	#debug("find:($relFile|$pathFile|$fileSource) in $IGNORE");
	if(($IGNORE =~ /\Q,$fileSource\E/)
	  ||($IGNORE =~ /\Q,$relFile\E/)
	  ||($IGNORE =~ /\Q,$pathFile\E/)
	  ||(grep(/^$ext$/,@asmExtList)) ){
		$status=1; #no instrumentation for this file
		$noInstrum=1;
		$phase="log. $s not instrumented. -ignore used (no error)";
		trace("#no instrumentation for $s (ignored)");
	}
	elsif($force_lang ==0){ #lang has never ben forced
	   if(grep(/^$ext$/,@cppExtList)) { # C++
		if($INIFILE ne "tpcpp.ini") {
			$iniHasChanged=1; #env_attolcc.pl must be written
			$TpCflags=$CompilFlags if($TpCflags eq '');
			$APP_CFLAGS=$TpCflags; #memo flags used for the last c++ compil
			$INIFILE="tpcpp.ini";
			DecodeIniFile();
			$lang=uc($Ini{'LANGUAGE'});
			if($force_tdp_lang ==0){
			   #debug("TDP_LANGUAGE=$TDP_LANGUAGE");
			   $generateTdp=1 if($TDP_LANGUAGE ne $lang);
			   $TDP_LANGUAGE = $lang;
			   }
			$OBJEXT=$Ini{'OBJEXT'};
			#debug("lang=$lang, obj=$OBJEXT");
		}
	   } elsif(grep(/^$ext$/,@cExtList)) {
		if($INIFILE ne "tp.ini") {
			$iniHasChanged=1; #env_attolcc.pl must be written
			$INIFILE="tp.ini";
			#we don't save language modif if cpp has been found TDP must be cpp
			#debug("lang=C");
			DecodeIniFile();
			$lang=uc($Ini{'LANGUAGE'});
			$OBJEXT=$Ini{'OBJEXT'};
		}
	   }
	}
	if($ATTOLCC_LOGFILE) {print BLOG "cd ".$pwd."\n";}
	#debug("\$pc_cmdDiff=$pc_cmdDiff\n");
	if($ATCMODE || $ATTMODE || $ATKMODE || $ATPMODE || $ATQMODE ||$pc_cmdDiff) {

		if (($status==0)&&($TreatmentOnSource)) {
			$phase="treatment of $s";
			$s=TreatmentSource($lang,$s);
			EndStep(0);
		}
		if (($status==0)&&!($s=~/\.i$/)) {
			$phase="preprocessing of $s";
			$phaseCode=1;
			push(@filesToRemove,$p);
			$status=preprocessing($lang,$s,$p);
			#debug("status=$status\n");
			EndStep(0);
		}
		if (($status==0)&&($TreatmentOnPreprocessed)) {
			$phase="treatment of $p";
			$p=TreatmentPreprocessed($lang,$p);
			EndStep(0);
		}
		if ($status==0) {
			$phase="instrumentation of $p";
			$phaseCode=2;
			$i=~s/\.i$/\.$Ini{'SRCEXT'}/;
		    if($ATCMODE || $ATTMODE || $ATKMODE || $ATPMODE || $ATQMODE ) {
			push(@filesToRemove,$i);
			$status=instrumentation($lang,$p,$i);
			#debug("status=$status\n");
		    }else{ 
			print STDERR ">rename $p to $i\n";		    	
			rename($p,$i);
			push(@filesToRemove,$i);
		    }
		    EndStep($status);
		}
		if (($status==0)&&($TreatmentOnInstrumented)) {
			$phase="treatment of $i";
			$i=TreatmentInstrumented($lang,$i);
			EndStep(0);
		}
	}else{ $i=$s; }
	if ($status==0) {
		$phase="compilation of $i to $o";
		$phaseCode=3;
		$status=compilation($lang,$i,$o);
	   	#debug("status=$status\n");
		EndStep($status);
		removeFiles(($KEEP || $status));
	}
	if (($status==0) && $ATMMODE) {
		if($metdir eq "") {
			if($attolcc_tmpdir) {
				$metdir=$attolcc_tmpdir ;
			} else {
				$metdir=".";
			}
		}
		$metdir=~s/[\\\/]$//;
		$metdir=~s/\\/\//g;
		trace (&PerlTranslate("attolcclib.pl", "%1: Static Metrics Computing...\n", "%1 is file to be compiled", $s));
		EndStep(metricsC ($TDP_LANGUAGE, $s, $LOGFILENAME, $metdir));
	}
	if ((($status==0) && $MISRA_MODE) && (grep(/^$ext$/,@cExtList))) { 
		my $xob=codeChecker_cc($s);
		push(@XOB,$xob);
		$iniHasChanged=1;
		EndStep(0);
	}
	if (($status==0)&&($TreatmentOnObject)) {
		$phase="treatment of $o";
		$o=TreatmentObject($lang,$o);
		EndStep(0);
	}
	if ($status && ($NOSTOP || $phaseCode==0)) {
		@filesToRemove=();#keep file when error
		if(!$link && (scalar(@srcFilesToInstrum)==1)) {#general case with makefile
			pError("$SMALL_PRODUCT_NAME-W-STDCMP, Launching standard compilation");
			$status = stdCompil(); # original cmd from cmd line
		   	#debug("status=$status\n");
		   } else {#when the cmd involve more files
		   if($phaseCode==0){
		   	$phaseCode=1;# compil of the source at least
		   	if($pc_cmdDiff){#cmd may diff, so use the prepro first
			    pError("$SMALL_PRODUCT_NAME-W-PREWOI, precompilation without instrumentation");
			    $status=preprocessing($lang,$s,$p);
		   	    if($status==0){$phaseCode=2}# then compil the preprocessed file if ok
		   	    }
			}
		   if($phaseCode==2 || $phaseCode==3) { #err in phaseCode = 2 or 3, So compile the preprocessed file
			pError("$SMALL_PRODUCT_NAME-W-CMPWOI, compilation without instrumentation");
			my $iFile="attol_src.".$ext;
			trace("#copy $p to attol_src.$ext for compilation");
			copy($p,$iFile);
			$status=compilation($ext,$iFile,$o); # cmd build, without other sources lib ....
			$phaseCode=1;# to use the next compil if status bad
			unlink ($iFile);
		   	#debug("status=$status\n");
		   	}
		   if($phaseCode==1 && $status) { #last chance but not sure cmd may not be good
			pError("$SMALL_PRODUCT_NAME-W-SCPWOI, source compilation without instrumentation");
			$status=compilation($ext,$s,$o); # cmd build, without other sources lib ....
		   	#debug("status=$status\n");
			}
		   }

		if($phaseCode) {
			open  ELOG,">>$launcher.log" || die &PerlTranslate("attolcc.pl", "Cannot open the file %1\n", "%1 is the file name", "$launcher.log");
			my $date = GetDate();
			print ELOG "####$date error at $phase\n";
			print ELOG "cd ".$pwd."\n";
			print ELOG "$launcher ".join(" ",@ARGV)."\n";
			close(ELOG);
			}
		}
	#debug("generateTdp=$generateTdp force=$force_tdp_cc");
	$status=TDPcc() if($status==0 && $force_tdp_cc && $generateTdp);
        }
   }
$link=0 unless(@objFiles);

if($MISRA_MODE && $link){
	TestRTcc_MakeXOBList() if($main::TestRTCC);
	codeChecker_link() if(@XOB);
}
if($status==0 && $link) {
   my $tpObj="";
   $main::TestRTCC=2 if($main::TestRTCC); #2 means link step detected
   if($ATCMODE || $ATTMODE || $ATKMODE || $ATPMODE || $ATQMODE) {
	   $status=TDPcc() if($generateTdp && !$no_tdp);
	   $tpObj=GetTargetPackageLib($OBJEXT);
	   $tpObj=GetTargetPackageLib ($LIBEXT) if($ATL_RUNTIME_FORMAT ne "OBJ");
	   #in win32 the link use the lib file for dll
	   $tpObj=GetTargetPackageLib ($DLLEXT) if(($ATL_RUNTIME_FORMAT eq "DLL") && !($^O=~/win32/i));
	   $tpObj="" if($ATL_RUNTIME_FORMAT eq "NONE");
	   $tpObj=$ENV{ATL_SHARED_TDP} if($ENV{ATL_SHARED_TDP});
   }
   $status=Link($tpObj)if($status==0);
   #debug("status=$status\n");
   EndStep($status);
   $iniHasChanged=0;
   unlink($envfile.".log");
   rename($envfile,$envfile.".log");#finished, so no need to keep this file
   }

close(BLOG) if($ATTOLCC_LOGFILE);
rec_env() if ($iniHasChanged && $status==0 && !($no_tdp) && (@objFiles));
removeFiles(($KEEP || $status));
if ($status){
	trace("exit status $status") ;
	exit($status);
}
exit(0) unless($main::TestRTCC); #it is end for attolcc but it should continue for TestRTcc (eclipse)
}


1;


