#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*-  code ckecker Analysis  -*-                              #
#                                                                              #
#                                                                              #
################################################################################
#$Id: codeChecker.pl,v 1.28 2007/09/17 15:53:17 rfrance Exp $
################################################################################


sub codeChecker_cc #($)
{
	my $src=shift;
	print &PerlTranslate("codeChecker.pl", "%1: Code checking...\n", "%1 is the name of the file to be analized", $src);
	my ($d,$n,$e)=SplitFileName($src);
	my $command="crccc \"$src\" \"$INTDIR/$n.xob\" atus_c.def atl.opp -RULE=\"$MISRA_CONF\"";
	$command.=" -checksysinclude" if($CHECK_SYS_INC);
	my $opt;
	if(@NOCHECK_DIR_INC){
		$opt=' -std_incl="'.join(',',@NOCHECK_DIR_INC).'"' ;
		if(@COMPLETE_INCLUDE_DIR_LIST) {
			my @include_dir;
			foreach my $dir (@COMPLETE_INCLUDE_DIR_LIST) {
				push(@include_dir,$dir) unless(grep(/^\Q$dir\E$/,@NOCHECK_DIR_INC));
			}
			$opt.=" -incl=\"".join("\",\"",@include_dir)."\"" ;
		}
	} else {
		$opt.=" -incl=\"".join("\",\"",@COMPLETE_INCLUDE_DIR_LIST)."\"" if(@COMPLETE_INCLUDE_DIR_LIST);
	}
	$opt=~ s,([\\\/])",$1.",g;
	$command.=$opt;
	$command.=" -define=\"".join("\",\"",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
	my $ret = SystemP($command);
	return "" if($ret);
	open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("codeChecker.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
	print  LOG "XOB $INTDIR/$n.xob\n";
	close( LOG );
	return "$INTDIR/$n.xob";
}

sub codeChecker_link
{
        print &PerlTranslate("codeChecker.pl", "%1: Code checking report...\n", "%1 is the name of the file to be analized", $NAME);
        my $check_script;
	if($NAME_CHECK_SCRIPT){ #customer checking the naming rule
		$check_script=$NAME_CHECK_SCRIPT;
		$check_script.=".pl" unless($NAME_CHECK_SCRIPT =~ /\.pl$/);
		unless($check_script =~ m/[\\\/]/) {# if there is no path
			unless(-f $check_script){   # and the file does not exist
				$check_script=$SCRIPTDIR.$check_script; # look for it into the scripts dir
			}
		}
		if(-f $check_script){
			my $command="crcld -xref=\"$OUTDIR/$NAME.pl\" \"".join("\" \"",@XOB)."\" -RULE=\"$MISRA_CONF\"";
			$command.= " -TEST" if($ATOMODE || $ATUMODE || $ATSMODE);
			my $ret = SystemP($command);

			require $check_script;
			my $nrxob=namingRuleCheck("$OUTDIR/$NAME.pl");
			push(@XOB,$nrxob) if($nrxob);
		}else{
			print &PerlTranslate("codeChecker.pl", "%1: Name checking script not found\n", "%1 is the name of the script", $check_script);
		}
	}
	my $command="crcld -crc=\"$OUTDIR/$NAME.crc\" \"".join("\" \"",@XOB)."\" -RULE=\"$MISRA_CONF\"";
	$command.= " -TEST" if($ATOMODE || $ATUMODE || $ATSMODE);
	my $ret = SystemP($command);
	if($ret) {
	     print &PerlTranslate("codeChecker.pl", "Code checking report generation failed.($ret)\n");
	     return "";
	}
	open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("codeChecker.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
	print  LOG "CRC $OUTDIR/$NAME.crc\n";
	close( LOG );
	return "$OUTDIR/$NAME.crc";
}

1;
