
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################


use TestRTUtil;
use strict;

my $fileIn=shift;
my $fileOut=shift;
die TestRTUtil::PerlTranslate("encode64.pl", "Usage: TestRTperl encode64.pl <BinaryFile> <OutXmlFile>\n") if((! defined $fileIn) || (! defined $fileOut));
die TestRTUtil::PerlTranslate("encode64.pl", "Cannot find \"%1\"\n", "%1 is the name of the file", $fileIn) unless -f $fileIn;

open(INF,"<$fileIn") || die TestRTUtil::PerlTranslate("encode64.pl", "Cannot open %1\n", "%1 is the name of the file", $fileIn);
open(OUF,">$fileOut") || die TestRTUtil::PerlTranslate("encode64.pl", "Cannot write to %1\n", "%1 is the name of the file", $fileOut);
binmode(INF);
print OUF "<BINVALUE>";
local($/) = undef;
print OUF EncodeBase64(<INF>);
print OUF "</BINVALUE>";
close(INF);
close(OUF);

sub EncodeBase64 ($;$)
{
    my $res = "";
    my $eol = $_[1];
    $eol = "\n" unless defined $eol;
    pos($_[0]) = 0;                          # ensure start at the beginning
    while ($_[0] =~ /(.{1,45})/gs) {	
	$res .= substr(pack('u', $1), 1);
	chop($res);
    }
    $res =~ tr|` -_|AA-Za-z0-9+/|;               # `# help emacs
    # fix padding at the end
    my $padding = (3 - length($_[0]) % 3) % 3;
    $res =~ s/.{$padding}$/'=' x $padding/e if $padding;
    # break encoded string into lines of no more than 76 characters each
    if (length $eol) {
	$res =~ s/(.{1,76})/$1$eol/g;
    }
    $res;
}
