#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*-  metric Analysis for Ada & Java -*-                      #
#                                                                              #
#                                                                              #
################################################################################
#$Id: metricA.pl,v 1.7 2007/06/06 16:23:05 rfrance Exp $
################################################################################


sub metricsA
{
	my $lang   = shift;
	my $src    = shift;
	my $logfile= shift;
	my $metdir = shift;

	my $Command;
#	my ($d,$n,$e)=SplitFileName($src);
	if ($lang eq "JAVA")
	{
		$Command =  $BINDIR.$PATH_SEPARATOR."startjava \"$src\" ";
    
		# see below, but don't dream about this, because up to now studio
		# never set ATJMODE when it compute metrics .... bast....!
		$ATJMODE = 1;
		#please add to classpath to <TDP>/test and <PROJECT_PATH>
		# in order to analyze correctly test generated files.
		# this is needed only et metric time (not a test generation time).
		$Command .= BuildCompleteJavaClassPath(" -classpath ",$CLASSPATH_SEPARATOR,"$TARGETDIR/test".$CLASSPATH_SEPARATOR."$PROJECT_PATH");
		$Command.=" -restrict_dir_metrics \"".join("\" \"",@MET_RESTRICT_DIR)."\"" if(@MET_RESTRICT_DIR);
		$Command.=" -metric -odir \"$metdir\"";
		$Command .= " -studiolog \"$logfile\"";

	} else {
		$status = BuildAdaLinkFile();
		exit(1) if ( $status );

		$Command = $BINDIR.$PATH_SEPARATOR."metada \"$src\" ";
		$Command .= " -RESTRICTION=".$Ini{'RESTR'} if($Ini{'RESTR'});
		
		my $ana= "ada95.alk" ;
		$ana="ada83.alk" if ($lang =~/^ADA83/);
		
		$Command .= " -STANDARD=\"$TARGETDIR".$PATH_SEPARATOR."ana".$PATH_SEPARATOR.$ana."\"";
		if ($lang ne "ADA83_V34"){
			my $adalink="adalink.alk";
			$adalink = "\"$USER_ALK_FILE\"" if (($USER_ALK_FILE) && (-f $USER_ALK_FILE));
			$Command .= " -ADALIEN=$adalink";
		}
		$Command .= " -studio_log=\"$logfile\"";
		
		# Suppress old features
		delete $ENV{'ATTOLLAN'} ;
		delete $ENV{'ATTOLCINC'} ;
		delete $ENV{'ATTOLTMPK'} ;
		delete $ENV{'ATTOLCPPINC'} ;
		delete $ENV{'ATW_NO_USR_INCLUDE'} ;

		# Let's environment
		$ENV{'ATTOLHOME'} = $ATTOLHOME;
		$ENV{'ATUDIR'} = $ATTOLHOME . $PATH_SEPARATOR."lib";
		$ENV{'ATUTGT'} = "$TARGETDIR";
		
	}

	$Command.=" ".$OPTIONS;
	$Command.= " -one_level_metrics" if ($MET_ONE_LEVEL);

	$Command.= $MET_OPTIONS;
	$Command.= " ".$Ini{'METRIC_OPT'} if($Ini{'METRIC_OPT'});
	my $status;
	if($Ini{'ATTOLSTART'}) {
		print "ATTOLSTART specified as:$TARGETDIR/cmd/$Ini{'ATTOLSTART'}\n";
		print "sub attolStart() executed with $Command\n";
		require "$TARGETDIR/cmd/$Ini{'ATTOLSTART'}";
		$status = attolStart($Command,$lang,$src);
	}
	else
	{
		$status = SystemP($Command);
	}
	if ($status && ($status!=3))
	{ 
		print &PerlTranslate("metricC.pl", "Static Metrics Generation failed. Status $status\n"); 
	}
	
	return $status;
}

1;
