#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*-  metric Analysis for C & C++ -*-                         #
#                                                                              #
#                                                                              #
################################################################################
#$Id: metricC.pl,v 1.7 2007/09/05 17:41:43 rfrance Exp $
################################################################################
# shall not access to Tools.pl to be used in attolcc

sub metricsC
{
	my $lang   = shift;
	my $src    = shift;
	my $logfile= shift;
	my $metdir = shift;
	my $Command;
	
#	my ($d,$n,$e)=SplitFileName($src);
	if ($lang eq "C")
	{
		$Command = $BINDIR.$PATH_SEPARATOR."attolstartC \"$src\" -STD_DEFINE=\"$TARGETDIR".$PATH_SEPARATOR."ana".$PATH_SEPARATOR."atus_c.def\"";
		if(@COMPLETE_INCLUDE_DIR_LIST){
			my $opt=" -incl=\"".join("\",\"",@COMPLETE_INCLUDE_DIR_LIST)."\"" ;
			$opt=~s,\\,/,g;
			$Command.=$opt ;
		}
		$Command.=" -define=\"".join("\",\"",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
		$Command.=" -restrict_dir_metrics=\"".join("\",\"",@MET_RESTRICT_DIR)."\"" if(@MET_RESTRICT_DIR);
		$Command .= " -METRICS";
		$Command .= "=\"$metdir\"" unless ($MET_IN_SOURCE_DIR);
		$Command .= " -studio_log=\"$logfile\"";
		# Suppress old features
		delete $ENV{'ATTOLLAN'} ;
		delete $ENV{'ATTOLCINC'} ;
		delete $ENV{'ATTOLTMPK'} ;
		delete $ENV{'ATTOLCPPINC'} ;
		delete $ENV{'ATW_NO_USR_INCLUDE'} ;

		# Let's environment
		$ENV{'ATTOLHOME'} = $ATTOLHOME;
		$ENV{'ATUDIR'} = $ATTOLHOME . $PATH_SEPARATOR."lib";
		$ENV{'ATUTGT'} = "$TARGETDIR";
	} else {
		$Command =  $BINDIR.$PATH_SEPARATOR."atostart \"$src\" -opp atl.opp -hpp atl.hpp";
		if(@COMPLETE_INCLUDE_DIR_LIST){
			my $opt=" -I\"".join("\" -I\"",@COMPLETE_INCLUDE_DIR_LIST)."\"" if(@COMPLETE_INCLUDE_DIR_LIST);
			$opt=~s,\\,/,g;
			$Command.=$opt ;
		}
		$Command.=" \"-D".join("\" \"-D",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
		foreach $dir (@MET_RESTRICT_DIR) 
		{
			$Command .= " -restrict_dir_metrics \"$dir\"";
		}

		if($MET_IN_SOURCE_DIR)
		{
			$Command .= " -metrics_in_source";
		} else {
			$Command .= " -metrics \"$metdir\"";
		}
		$Command .= " -studio_log \"$logfile\"";
	}

	$Command.=" ".$OPTIONS;
	$Command .= " -one_level_metrics" if ($MET_ONE_LEVEL);

	$Command .= $MET_OPTIONS;
	$Command .= " ".$Ini{'METRIC_OPT'} if($Ini{'METRIC_OPT'});
	my $status;
	if($Ini{'ATTOLSTART'}) {
		print "ATTOLSTART specified as:$TARGETDIR/cmd/$Ini{'ATTOLSTART'}\n";
		print "sub attolStart() executed with $Command\n";
		require "$TARGETDIR/cmd/$Ini{'ATTOLSTART'}";
		$status = attolStart($Command,$lang,$src);
	}
	else
	{
		$status = SystemP($Command);
	}
	if ($status && ($status!=3))
	{ 
		print &PerlTranslate("metricC.pl", "Static Metrics Generation failed. Status $status\n"); 
	}
	
	return $status;
}

1;
