#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

################################################################################
# Copyright (c) 2003 Rational Software Corporation. All rights reserved.       #
#                                                                              #
#                Product: Rational(R) Test RealTime                            #
#      Product Component: System Testing                                       #
#               Language: PERL                                                 #
#                                                                              #
#        Product version: 2003.06.00                                           #
#                                                                              #
#                   File: parsecode.pl                                         #
#                                                                              #
# Rational, the Rational logo are registered trademarks of                     #
# Rational Software Corporation.                                               #
#                                                                              #
# The placing of the copyright notices on Rational source code is not          #
# intended to mean that they are published works, but are included in the      #
# event of inadvertent publication. The source code of Rational contains       #
# trade secrets and other valuable confidential information of Rational        #
# Software Corporation. Rational Software Corporation and its licensors        #
# retain ownership to Rational Products in both source and object code         #
# format, and related documentation and all rights therein including           #
# copyrights, patents and trade secrets.                                       #
#                                                                              #
# U.S. Government Rights                                                       #
#                                                                              #
# Use, duplication, or disclosure by the U.S. Government is subject to         #
# restrictions set forth in the applicable Rational License Agreement          #
# and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   #
# 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         #
# or FAR 52.227-14, as applicable.                                             #
#                                                                              #
# Unless otherwise agreed to in writing, use of Rational products is           #
# governed by the Rational Product License Agreement provided with             #
# the product.                                                                 #
#                                                                              #
################################################################################
$SCRIPTDIR =$ENV{'TESTRTDIR'}."/lib/scripts/";
# Target package related functions
require $SCRIPTDIR . "Translate.pl";
# Miscellaneous functions
require $SCRIPTDIR . "Fcts.pl";


###########################################################################
# Print the USAGE

sub usage
{
    print &PerlTranslate("parsecode.pl", "TestRT-%1, Usage: parsecode.pl [-preopts=<options>] [-outdir=<output directory>] [ -sepdir=/|\\ ] -mode=DEFAULT|CUSTOM <file.c|file.cpp> <file.h>\n", "%1 is the code of the message", "I-PARSECODE");
}

###########################################################################

print &PerlTranslate("parsecode.pl", "TestRT-%1, Rational(R) Test RealTime Probe Processor\n", "%1 is the code of the message", "I-STARTEXEC");
print &PerlTranslate("parsecode.pl", "TestRT-%1, Copyright(C) 1996-2004 Rational Software Corporation.\n", "%1 is the code of the message", "I-COPYRIGHT");

if ( ! @ARGV[0] )
{
    usage();
    exit(1);
}

my $atlprobeslis="atlprobe.prb";
my %messages;
my %channels;
my %ctxs;
my %sends;
my %waittils; # ajout
my %defmsgs; # ajout 
my %types;
my %rios;
my %start;
my $format;
my $message;
my $chn;
my $tdcgen;
my @hfiles;
my @incls;
my $sp=" ";
my $langC=1;
my $findstart="false";
my $findend="false";
my $stdefine="nothing";
#-----------------------------------------------------------------------------
#
# 1ere analyse, decouverte des instances(start_sonde), des message utilises et des channels
#

my $file;
my $line=0;
my $lang;
my $mode="nothing";
my $preproArg="nothing";
my $currentarg=shift(ARGV);
my $outdir="nothing";
my $PATH_SEPARATOR="/";
   $PATH_SEPARATOR="\\" if($^O=~/win32/i);

while($mode eq "nothing")
{

    if ($currentarg=~/-mode=/)
    {
	($mode) = ($currentarg=~ /-mode=(\w+)/);
    }
    else
    {    
	if ($currentarg=~/-preopts=-INCL/)
	{
	    ($preproArg) = ($currentarg=~/-preopts=(.*)/);
	} 
	elsif ($currentarg=~/-outdir=/)
	{
	    ($outdir)= ($currentarg=~/-outdir=(.*)/);
	}
	elsif ($currentarg=~/-sepdir=/)
	{
	    ($PATH_SEPARATOR)= ($currentarg=~/-sepdir=(\/|\\)/);
	}
	else
	{
	    print &PerlTranslate("parsecode.pl", "unknown option %1\n", "%1 is the option found", $currentarg);
	    usage();
	    exit(1);    
	}
	$currentarg=shift(ARGV);
    }
}

if ($outdir eq "nothing")
{
    $outdir = ".";
}

if (($mode ne "DEFAULT") && ($mode ne "CUSTOM")) 
{
    print &PerlTranslate("parsecode.pl", "bad mode selection %1\n", "%1 is the select mode", $mode);
    usage();
    exit(1);
}

my $outfilename= "$outdir" . "$PATH_SEPARATOR" . "atlprobe.lis";
open( LIS, ">$outfilename" ) or die &PerlTranslate("parsecode.pl", "Cannot open file %1\n", "%1 is the name of the file", $outfilename);
while (<>)
{
 
    if($ARGV ne $file) {
	
	$line=0;
	$file=$ARGV;
	my ($dirpath,$basename,$extension) = SplitFileName($file);
	$lang = LanguageOf ($extension, "Unknown");
	
	if($file=~/\.h(..)?$/)
	{
	    push(@hfiles,"\"$file\"");
	}
	elsif ($lang eq "CPP") {$langC=0;}	
	elsif ($lang eq "Unknown")
	{	      
	    print &PerlTranslate("parsecode.pl", "unknown extension %1\n", "%1 is the filename", $file);
	    usage();
	    exit(1);
	} 
    }
    $line++;
    if(/#define/) {}
       elsif (/atl_start_trace\s*\(\s*(\w+)\s*,\s*"(.*)"\s*,\s*(\w+)\s*,\s*(\w+)/)     
       { 
	   $findstart="true";
	   print LIS "\"$file\" $line :$_";
	   my $ctx=$1;
	   my $path=$2;
	   my $rio=$3;
	   my $p1=$4;
#		print "ctx var:$ctx file:$rio.rio\n" ;
	   if ( $ctxs{$ctx} || $rios{$rio} )
	   {
	       die &PerlTranslate("parsecode.pl", "TestRT-%1,  ctx_error : var %2 or outFile %3 already exist %4:%5\n", "%1 is the code of the message, %2 is the name of the variable and %3 is the name of outFile", "E-PARSECODE", $ctx, "$rio.rio",$file,$line);
	   }
	   else
	   {
	       $rios{$rio}=1;
	       $ctxs{$ctx}=1;
	       $start{$rio}="$ctx, \"$path\", \"$rio.rio\", \"$rio\",$p1";
	   }
       }
       elsif (/atl_start_trace/)
       {
	       die &PerlTranslate("parsecode.pl", "TestRT-%1, syntax error in atl_start_trace at %2:%3\n", "%1 is the code of the message, %2 is the filename %3 is line number", "E-PARSECODE",$file,$line);
       }
       elsif (/atl_send_trace\s*\(\s*(\w+)\s*,\s*(\w+)\s*,([^,]+),\s*(\w+)\s*,\s*(\w+)/)	
       { 
	   print LIS "\"$file\" $line :$_";
	   my $ctx=$1;
	   my $ch=$2;
	   my $idmsg=$3;
	   my $type=$4;
	   my $msg=$5;
	   $message=$type."_".$msg;
	   #construire la liste des sends
	   $send=$message.",".$ch;
	   #construire la liste des dumps pour ce type
	   if(! $sends{$send})
	   {
#			$dump{$type} .="case ATL_TDC_SEND_$message"."_$ch:\n";
	       $sends{$send} = 1;
	   }
	   #si ce message n existe pas construire la liste des message de meme type dans $types
	   if (! $messages{$message})
	   {
	       $messages{$message} = 1;
	       if ( $types{$type} )
	       {
		   $types{$type} = $types{$type}.",";
	       }
	       $types{$type} = $types{$type}.$message;
	   }
	   #construire la liste des channels ou distant utilises
	   if ( ! $channels{$ch} ) 
	   {
	       $channels{$ch} = $chn++;
	   }
       }
       elsif (/atl_send_trace/)	
       { 
	       die &PerlTranslate("parsecode.pl", "TestRT-%1, syntax error in atl_send_trace at %2:%3\n", "%1 is the code of the message, %2 is the filename %3 is line number", "E-PARSECODE",$file,$line);
       }
       elsif (/atl_recv_trace\s*\(\s*(\w+)\s*,\s*(\w+)\s*,([^,]+),\s*(\w+)\s*,\s*(\w+)/)	
       { 
	   print LIS "\"$file\" $line :$_";
	   my $ctx=$1;
	   my $ch=$2;
	   my $idmsg=$3;
	   my $type=$4;
	   my $msg=$5;
	   $message=$type."_".$msg;
	   #construire la liste des waittil 
	   $waittil=$message.",".$ch;
	   $evt=$type.",".$msg.",".$ch;
	   #construire la liste des dumps por ce type
	   if(! $waittil{$waittil})
	   {
#			$dump{$type} .="case ATL_TDC_RECV_$message"."_$ch:\n";
#			$evts{$evt} .="case ATL_TDC_RECV_$message"."_$ch:\n";
	       $waittils{$waittil} = $message;
	   }
	   if (! $messages{$message})
	   {
	       $messages{$message} = 1;
	       if ( $types{$type} )
	       {
		   $types{$type} = $types{$type}.",";
	       }
	       $types{$type} = $types{$type}.$message;
	   }
	   if ( ! $channels{$ch} ) 
	   {
	       $channels{$ch} = $chn++;
	   }
       }
       elsif (/atl_recv_trace/)	
       { 
	       die &PerlTranslate("parsecode.pl", "TestRT-%1, syntax error in atl_recv_trace at %2:%3\n", "%1 is the code of the message, %2 is the filename %3 is line number", "E-PARSECODE",$file,$line);
       }
       elsif (/atl_select_trace/)
       {        
	   print LIS "\"$file\" $line :$_";
       }	
       elsif (/atl_end_trace/)	
       { 
	   $findend="true";
	   print LIS "\"$file\" $line :$_";
       }
       elsif (/atl_format_trace/)	
       { 
	   print LIS "\"$file\" $line :$_";
	   ($format) =
	       ($_ =~ /atl_format_trace\s*\(\s*([^)]+)/ );
       push(@incls,$format);
           
       }
}

close (LIS);

if ($findstart eq "false")
{
    print &PerlTranslate("parsecode.pl", "TestRT-%1, atl_start_trace(...) not found.\n", "%1 is the code of the message", "I-PARSECODE");
}

if ($findend eq "false")
{
    print &PerlTranslate("parsecode.pl", "TestRT-%1, atl_end_trace(...) not found.\n", "%1 is the code of the message", "I-PARSECODE"); 
    
}

if (($findstart eq "false") || ($findend eq "false"))
{
    die &PerlTranslate("parsecode.pl", "TestRT-%1, Probing failed!\n", "%1 is the code of the message", "E-PARSECODE");
}


#-----------------------------------------------------------------------------
#
# Generation pts
#
my $cot="\"";
$outfilename= "$outdir" . "$PATH_SEPARATOR" . "atlprobe.pts";
$outmsgname= "$outdir" . "$PATH_SEPARATOR" . "atlprobe_msg.hts";

print &PerlTranslate("parsecode.pl", "TestRT-%1, Writing %2\n", "%1 is the code of the message and %2 is the name of the file", "I-PARSECODE", $outfilename);
open( PTS, ">$outfilename" ) or die &PerlTranslate("parsecode.pl", "Cannot create file %1\n", "%1 is the name of the file", $outfilename);
open( ATLP, ">$outmsgname" ) or die &PerlTranslate("parsecode.pl", "Cannot create file %1\n", "%1 is the name of the file", $outmsgname);
print PTS "--\n";
print PTS "-- Rational(R) Test RealTime Probe Processor\n";
print PTS "-- Copyright(C) 1996-2004 Rational Software Corporation. All rights reserved.\n";
print PTS "--\n";
print PTS "HEADER ".$cot."probe".$cot.",".$cot."1.0".$cot.",".$cot."2.0".$cot."\n";
print PTS "DECLARE_INSTANCE";
#exploitation des instances
$sp=" ";
foreach $rio ( keys %rios )
{
    print PTS $sp.$rio;
    $sp=",";
}
print PTS "\n";

print PTS "#typedef int numproc_t;\n";
print PTS "COMMTYPE way IS numproc_t\n";

#exploitation des channels
$sp="CHANNEL way :";
foreach $channel ( keys %channels )
{
    print PTS $sp.$channel;
    $sp=",";
}
print PTS "\n";

#exploitation des messages
foreach $type ( keys %types )
{
    print PTS "MESSAGE $type : $types{$type} \n";
    print ATLP "MESSAGE $type : $types{$type} \n";
}
print PTS "\n";
print ATLP "\n";
while(@incls)
{
    $format=pop(@incls);
    ($format) =~ s/\"//g;
    print PTS "INCLUDE \"$format\"";
    print PTS "\n";
}



#exploitation des types pour procsend/waittil
foreach $type ( keys %types )
{
    print PTS "PROCSEND $type : msg ON way : nWay\n";
    print PTS " -- $types{$type}\n";
    print PTS " COMMENT c\n";
    print PTS "END PROCSEND \n";
    print PTS "\n";

    print PTS "CALLBACK $type : msg ON way : nWay\n";
    print PTS " -- $types{$type}\n";
    print PTS " MESSAGE_DATE\n";
    print PTS " NO_MESSAGE\n";
    print PTS "END CALLBACK \n";
    print PTS "\n";
}
#proc de dump_all_instance
print PTS "\@void atl_dump_all_inst(){\n";
foreach $rio ( keys %start )
{
    print PTS "\@ atl_dump_inst($start{$rio});\n";
}
print PTS "\@}\n\n";
# debut SCN
print PTS "SCENARIO probes\n";

#exploitation des sends
foreach $send ( keys %sends )
{
    print PTS "   SEND( $send)\n";
}

#l instruction rendezVous doit separer les SEND des Waittil
#pour servir de code limite dans le TDC
print PTS "   RENDEZVOUS SYNCHRO\n";
#print PTS "   CALL atl_dump_all()\n";
#exploitation des waittils
foreach $waittil ( keys %waittils )
{
    if (! $defmsgs{$waittils{$waittil}})
    { 
 	$defmsgs{$waittils{$waittil}} = $waittils{$waittil};
 	print PTS "   DEF_MESSAGE $waittils{$waittil}, EV={}\n";
    } 
    print PTS "   WAITTIL( MATCHING($waittil), 0)\n";
}

print PTS "END SCENARIO\n";
# fin SCN

close( PTS );
close( ATLP );
#-----------------------------------------------------------------------------
#
# Generation atldeclar.h
#
print &PerlTranslate("parsecode.pl", "TestRT-%1, Writing %2\n", "%1 is the code of the message and %2 is the name of the file being written", "I-PARSECODE", "atldeclar.h");
$outfilename= "$outdir" . "$PATH_SEPARATOR" . "atldeclar.h";
open( DCL, ">$outfilename" ) or die &PerlTranslate("parsecode.pl", "Cannot create file %1\n", "%1 is the name of the file", $outfilename);
print DCL "#define atl_declar ATL_CTX_PRB";
#exploitation des instances
my $nbinst=0;
$sp=" ";
foreach $ctx ( keys %ctxs )
{
    print DCL $sp.$ctx;
    $sp=",";
    $nbinst++;
}

print DCL ";\n";
if (($mode ne "DEFAULT") && (!$langC))
{
print DCL "#ifdef __cplusplus\n";
print DCL "extern \"C\" atl_declar;\n";
print DCL "#else\n";
}
print DCL "extern atl_declar;\n";
if (($mode ne "DEFAULT") && (!$langC))
{
print DCL "#endif\n";
}
print DCL "#define NB_INSTANCES $nbinst\n";
close(DCL);

#-----------------------------------------------------------------------------
#
# Generation .tdc & .c & .h
#

my $Command="\"";

$ENV{ATS_DIR}=GetBinDir() unless ($ENV{ATS_DIR});
$Command .= $ENV{ATS_DIR};
$Command .= $PATH_SEPARATOR;

if ($langC==1)
{
    $Command .= "atspreproC\"" . " \"$outdir"."$PATH_SEPARATOR"."atlprobe.pts\" " ;
    if ($ENV{TARGET_DIR})
    {
	$stdefine =" -STD_DEFINE=\"$ENV{TARGET_DIR}".$PATH_SEPARATOR."ana".$PATH_SEPARATOR."atus_c.def\"";
    }
}
else
{   
    $Command .= "atspreproCPP\"" . " \"$outdir"."$PATH_SEPARATOR"."atlprobe.pts\" " ;
   if ($ENV{TARGET_DIR})
   {
       $stdefine = " -STD_DEFINE=\"$ENV{TARGET_DIR}".$PATH_SEPARATOR."ana".$PATH_SEPARATOR."atus_cpp.def\"";
   }
}

if (@hfiles)
{
    $Command .= join(",",@hfiles);
}
else
{
    print &PerlTranslate("parsecode.pl", "No .h file found for the API interface\n", "");
    usage();
    exit(1);
}
if ($langC==1)
{
    $Command .= " \"$outdir"."$PATH_SEPARATOR". "atlprobe.c\"" . " -PROBE=$mode";
} else {
    $Command .= " \"$outdir"."$PATH_SEPARATOR". "atlprobe.cpp\""  . " -PROBE=$mode";
}

if ($stdefine ne "nothing")
{
    $Command .= "$stdefine";
}
else
{
    print &PerlTranslate("parsecode.pl", "TestRT-%1 Warning : TARGET_DIR not defined!\n", "%1 is the code of the message", "I-PARSECODE");
}
if ($preproArg ne "nothing")
{
    $Command .= " \"$preproArg\"";
}
my $Status = SystemP("$Command");
if ($Status == 0)
{
    print &PerlTranslate("parsecode.pl", "TestRT-%1, End of execution without errors or warnings\n", "%1 is the code of the message", "I-PARSECODE");
} else {
    die &PerlTranslate("parsecode.pl", "TestRT-%1, End of execution with error\n", "%1 is the code of the message", "E-PARSECODE");
}
unlink($outdir."/atlprobe_dyn.tsf");
###########################################################################
# This routine will print and execute a given command, and
# implicitly return the result
sub SystemP
{
    my @Command=@_;

    print join (' ',@Command),"\n";
    system(@Command);
}
