#!perl -w

#use Win32;
use Win32::TieRegistry;


#######################################################################################################################################
#
# This script patches the example files delivered with Rational Test RealTime
# with the correct installation directory. It must be provided with the
# installation directory as the first argument.
#
# (c) Copyright 2002 Rational Software Corporation
# All Rights Rerserved
#
#######################################################################################################################################


my $BaseInstallationDirectory = join(' ', @ARGV);
#die "Missing Installation directory as first parameter\n" unless $BaseInstallationDirectory;
exit (1) unless $BaseInstallationDirectory;

# Add a separator if there isn't one already
if ($^O =~ /win/i)
  {
    $BaseInstallationDirectory .= '\\' unless ($BaseInstallationDirectory =~ m,[/\\]$,);
  }
else
  {
    $BaseInstallationDirectory .= '/' unless ($BaseInstallationDirectory =~ m,[/\\]$,);
  }
my $DoubleBaseInstallationDirectory = $BaseInstallationDirectory;
$DoubleBaseInstallationDirectory =~ s/\\/\//g;
my $ShortBaseInstallationDirectory = Win32::GetShortPathName($BaseInstallationDirectory);
my $ShortForwardBaseInstallationDirectory = $ShortBaseInstallationDirectory;
$ShortForwardBaseInstallationDirectory =~ s,\\,/,g;

open (DBG, ">c:/patch.txt") || exit (1);

#######################################################################################################################################
#
# The list of files to patch with the installation directory
#
#######################################################################################################################################

my @Files = qw( examples\\Stack\\Stack.rtp
		examples\\DataPool\\dataPool.rtp
		examples\\BaseStation_C\\BaseStation_C.rtp
		examples\\BaseStation_Java\\BaseStation_Java.rtp
		examples\\TDP\\tutorial\\add.rtp
		examples\\Task_Ada\\Task_Ada.rtp
		examples\\Enum_Ada\\Enum_Ada.rtp
		examples\\Generic_Ada\\Generic_Ada.rtp
		examples\\Philosopher\\Philosopher.rtp
		examples\\ChainedList\\ChainedList.rtp
		examples\\EuroDollarMidlet_J2ME\\EuroDollarMidlet_J2ME.rtp
		examples\\Histogram_Ada\\Histogram_Ada.rtp
		examples\\Shape\\Shape.rtp
		examples\\Shape_Ada\\Shape_Ada.rtp
		examples\\Testing_Ada\\Testing_Ada.rtp
		examples\\BroadcastServer\\BroadcastServer.rtp
		examples\\CheckFrequency\\CheckFrequency.rtp
		examples\\PhilosopherCPP\\PhilosopherCPP.rtp
		examples\\SharedLibrary\\SharedLibrary.rtp
		examples\\StubAda\\StubAda.rtp
		examples\\StubC\\StubC.rtp
		examples\\TemplateCpp\\TemplateCpp.rtp
		examples\\TestSuiteAda\\TestSuiteAda.rtp
		examples\\TestSuiteC\\TestSuiteC.rtp
		examples\\Testing_C\\Testing_C.rtp );

foreach (@Files)
  {
    my $FileToPatch = $BaseInstallationDirectory."testrealtime\\".$_;
    print DBG "SRCDIR $BaseInstallationDirectory \n";
    print DBG "Trying to Patch $FileToPatch\n";
    next unless (-f $FileToPatch); # ignore files that don't exist
    print DBG "It exists $FileToPatch\n";

    # copy the lines into a new file, patching them along the way
    next unless (open (IN, $FileToPatch));
    next unless (open (OUT, '>'.$FileToPatch.'.out'));
    print DBG "Patching $FileToPatch\n";
    while (<IN>)
	{
	print DBG "<<< ",$_;
	if ($FileToPatch =~ /examples.*/)
	  {
	    s,c:\\program files\\rational\\testrealtime\\,${BaseInstallationDirectory}testrealtime\\,ig;
	    s,c:/program files/rational/testrealtime/,${DoubleBaseInstallationDirectory}testrealtime/,ig;
 
          }

	
		print OUT;
		print DBG ">>> ",$_;
        }
    
	close (IN);
	close (OUT);

    # Remove the original file
    unlink ($FileToPatch);

    # Rename the new file as the old file
    rename ($FileToPatch.'.out', $FileToPatch);
  }


close (DBG);
