#!perl -w

#use Win32;
use Win32::TieRegistry;


#######################################################################################################################################
#
# This script patches the example files delivered with Rational Test RealTime
# with the correct installation directory. It must be provided with the
# installation directory as the first argument.
#
# (c) Copyright 2002 Rational Software Corporation
# All Rights Rerserved
#
#######################################################################################################################################


my $BaseInstallationDirectory = join(' ', @ARGV);
#die "Missing Installation directory as first parameter\n" unless $BaseInstallationDirectory;
exit (1) unless $BaseInstallationDirectory;

# Add a separator if there isn't one already
if ($^O =~ /win/i)
  {
    $BaseInstallationDirectory .= '\\' unless ($BaseInstallationDirectory =~ m,[/\\]$,);
  }
else
  {
    $BaseInstallationDirectory .= '/' unless ($BaseInstallationDirectory =~ m,[/\\]$,);
  }
my $DoubleBaseInstallationDirectory = $BaseInstallationDirectory;
$DoubleBaseInstallationDirectory =~ s,\\,\\\\,g;

my $SimpleInstallationDirectory = $BaseInstallationDirectory;
$SimpleInstallationDirectory =~ s,\\,/,g;
open (DBG, ">c:/patch_RoseRT.txt") || exit (1);

#######################################################################################################################################
#
# The list of files to patch with the installation directory
#
#######################################################################################################################################

my @Files = qw(
	       bin\\intel\\RoseRT\\TestRT-RoseRT.mnu
	       );

foreach (@Files)
  {
    my $FileToPatch = $BaseInstallationDirectory."testrealtime\\".$_;
    print DBG "Trying to Patch $FileToPatch\n";
    next unless (-f $FileToPatch); # ignore files that don't exist
    print DBG "It exists $FileToPatch\n";

    # copy the lines into a new file, patching them along the way
    next unless (open (IN, $FileToPatch));
    next unless (open (OUT, '>'.$FileToPatch.'.out'));
    print DBG "Patching $FileToPatch\n";
    while (<IN>)
	{
	print DBG "<<< ",$_;
	if ($FileToPatch =~ /bin.*/)
	  {
	    # For TestRT-RoseRT.reg	
	    s,ROSE_REG_TO_PATCH,${DoubleBaseInstallationDirectory}testrealtime\\,ig;
	    # For TestRT-RoseRT.mnu
	    s,ROSE_MNU_TO_PATCH,${SimpleInstallationDirectory}testrealtime,ig;
	   
	  }
	
	print OUT;
	print DBG ">>> ",$_;
        }
    close (IN);
    close (OUT);

    # Remove the original file
    unlink ($FileToPatch);

    # Rename the new file as the old file
    rename ($FileToPatch.'.out', $FileToPatch);
  }

close (DBG);
