
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################


my $TestRTDir=shift;

die "Usage: postInstall.pl <TestRT Dir>\n" if($TestRTDir eq ""); # NO TRANSLATION

$SCRIPTDIR="$TestRTDir/lib/scripts/";
require $SCRIPTDIR . "Translate.pl";

if($^O=~/win32/i) {
    $PATH_SEPARATOR = '\\';
  } else {
    $PATH_SEPARATOR = '/';
  }
$TARGETDIR=$TestRTDir.$PATH_SEPARATOR."targets".$PATH_SEPARATOR;
$XMLDIR=$TestRTDir.$PATH_SEPARATOR."targets".$PATH_SEPARATOR."xml".$PATH_SEPARATOR;

my @xdpFiles=qw(cvisual8.xdp cvisual6.xdp cvisual7.xdp cpcgnu.xdp cwinvxsim.xdp cwinvx386.xdp cwinvxppc.xdp cwindiabsgstep.xdp adapcgnt.xdp adawinapex.xdp j2mewtk1.03.xdp jdk1.3.1.xdp jdk1.4.0.xdp cwinmulti.xdp cwince.xdp carm.xdp cwin55xgodsp.xdp j9.xdp cwin6xgodsp.xdp j2mewtk2.x.xdp);

# No Bufferisation
$|=1;

open(OLDOUT,">&STDOUT");
open(OLDERR,">&STDERR");
open(STDOUT,">$TestRTDir/targets/TDPInstall.log");
open(STDERR,">&STDOUT");

#check the ctags installation
my $ctagsMissing=0;
my $status=system("ctags $TestRTDir\\lib\\SystemTesting\\template1.c");
if($status || !(-f "tags")) {
	print &PerlTranslate("postInstall.pl", "*** Check ctags installation\n");
	print &PerlTranslate("postInstall.pl", "*** ctags status=$status\n");
	#see if it exist into testRT installation
	$status=system("$TestRTDir/bin/intel/win32/ctags $TestRTDir\\lib\\SystemTesting\\template1.c");
	if($status || !(-f "tags")) {
		print &PerlTranslate("postInstall.pl", "*** TestRT ctags status=$status\n");
		$ctagsMissing=1;
		ctagsError();
	}
}
unlink("tags");

#generate TDPs
foreach(@xdpFiles)
{
	my $xdpName=$_;
	(my $baseName=$xdpName)=~s/\.xdp$//;
	print &PerlTranslate("postInstall.pl", "Generating TDP folder $TARGETDIR$baseName from $XMLDIR$xdpName\n", "$xdpName is the name of the xdp file and $TestRTDir is the directory of product delivery", $_, $TestRTDir);
	my $Status=system("$TestRTDir/bin/intel/win32/TestRTperl.exe -I$TestRTDir/lib/perl $TestRTDir/lib/scripts/tdpgen.pl -check $TestRTDir/targets/xml/$_ $TestRTDir/targets");
	if($Status)
	{
		print &PerlTranslate("postInstall.pl", "*** Generation of $XMLDIR$xdpName failed\n", "$xdpName is the name of the xdp file", $TestRTDir);
		print &PerlTranslate("postInstall.pl", "*** This can be due to the development environment not being installed on this machine\n");
		print &PerlTranslate("postInstall.pl", "*** This TDP may not be usable\n");
	}
}

 
close(STDOUT);open(STDOUT,">&OLDOUT");
close(STDERR);open(STDERR,">&OLDERR");

close(OLDOUT);
close(OLDERR);

if($ctagsMissing)
{ 
	ctagsError() ;
	sleep(15);
	exit(1);
}


sub ctagsError()
{
                               print "*********************************************************************************\n";
    print &PerlTranslate("postInstall.pl", "Unable to find ctags.exe please check your installation\n", "");
    print &PerlTranslate("postInstall.pl", "ctags.exe has to be downloaded from http://sourceforge.net/projects/ctags\n", "");
    print &PerlTranslate("postInstall.pl", "once downloaded copy it into $TestRTDir\\bin\\intel\\win32\n", "");
                                print "*********************************************************************************\n";

}

