#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                          -*-  Source Browsing -*-                            #
#                                                                              #
#                                                                              #
#                                                                              #
#  Perl-Script         tag_c.pl                                                #
#  Version             v1.0                                                    #
#                                                                              #
#  $Revision: 1.26 $                                                           #
#  $Date: 2007/07/23 18:41:58 $                                                #
#                                                                              #
#  Launch tags tool to determinate control structures into program files       #
#                                                                              #
#  Usage:                                                                      #
#       TestRTperl tag_c.pl <file list>                                        #
#                                                                              #
#  Problems:                                                                   #
#	Source Compilation: Spec=ads; Bdy=adb                                  #
#	RecompileAdaRuntimeLibraries: Verification NAME/LNAME only             #
#                                                                              #
################################################################################


use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

# Configuration file
require $ARGV[0];

# Miscellaneous functions
require $SCRIPTDIR . "Fcts.pl";

# Attol tools functions
require $SCRIPTDIR . "Tools.pl";

sub errorctags
{
                               print "*********************************************************************************\n";
    print &PerlTranslate("tag_c.pl", "Unable to find ctags$binext in $BINDIR please check your installation\n", "");
    print &PerlTranslate("tag_c.pl", "ctags$binext has to be downloaded from http://sourceforge.net/projects/ctags\n", "");
    print &PerlTranslate("tag_c.pl", "or http://ctags.sourceforge.net. once downloaded copy it into $BINDIR\n", "");
                                print "*********************************************************************************\n";
   exit(1);

}
################################################################################
# Here is the beginning
################################################################################
EnterInScript();
my $binext;
$binext=".exe" if($OSNAME eq "win32");


my ($dirpath,$basename,$extension) = SplitFileName($FILENAME);
my $language = LanguageOf( $extension,$TDP_LANGUAGE );

# here is the place to get the corresponding header file, TBD with dependencies
my $args     = $FILENAME;

my $prepro_file = "ctags_input.i.h";
my $tagsCPPFLAGS = "";


my $aux = 0;
foreach $cond (@GENERATION_CONDITION) 
{
      $aux = $aux +1;
      if ($aux==1) { $tagsCPPFLAGS .= " -define=\"$cond\""; }
      else { $tagsCPPFLAGS .= "\,\"$cond\""; }
}

if ( $language eq "CPP" )
{
    $tagsCPPFLAGS .= " -define=__cplusplus";
}


$aux = 0;
foreach $dir (@SOURCES_DIR_LIST) 
{
      $aux = $aux +1;
      if ($aux==1) { $tagsCPPFLAGS .= " -incl=\"$dir\""; }
      else { $tagsCPPFLAGS .= "\,\"$dir\""; }
}

my $EXPATH2 = $ENV{'PATH'};


$ENV{'ATW_NO_USR_INCLUDE'}="on";

$command = "$BINDIR" . "$PATH_SEPARATOR" . "attolstartC -PREPRO_ONLY";

$command .= $tagsCPPFLAGS;

$command .= " \"$FILENAME\" \"$prepro_file\"";

SystemP($command);

$remove_prepro_file=1;
my $st="cfnp";
$st="scfnp" if ($STRUCT_AS_CLASS);
$ENV{'PATH'}.=";".$BINDIR;
$command = "ctags --c-types=$st -u -n --fields=+afKmsS --line-directives=yes \"$prepro_file\"";
my $status = SystemP($command);

if ($status != 0)
{
    print &PerlTranslate("tag_c.pl", "Unable to complete command for %1\n", "%1 is the name of the file to be tagged", $FILENAME);
    errorctags unless(-f "$BINDIR/ctags".$binext);
}


unlink( $prepro_file ) if ( $remove_prepro_file == 1 );
$ENV{'PATH'} = $EXPATH2;

exit($status);

