#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                          -*-  Source Browsing -*-                            #
#                                                                              #
#                                                                              #
#                                                                              #
#  Perl-Script         tag_java.pl                                             #
#  Version             v1.0                                                    #
#                                                                              #
#  $Revision: 1.18 $                                                            #
#  $Date: 2007/07/23 18:41:58 $                                                #
#                                                                              #
#  Launch tags tool to determinate control structures into program files       #
#                                                                              #
#  Usage:                                                                      #
#       TestRTperl tags.pl <file list>                                         #
#                                                                              #
#  Problems:                                                                   #
#	Source Compilation: Spec=ads; Bdy=adb                                  #
#	RecompileAdaRuntimeLibraries: Verification NAME/LNAME only             #
#                                                                              #
################################################################################


use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

# Configuration file
require $ARGV[0];

# Miscellaneous functions
require $SCRIPTDIR . "Fcts.pl";

sub errorctags
{
                               print "*********************************************************************************\n";
    print &PerlTranslate("tag_java.pl", "Unable to find ctags$binext in $BINDIR please check your installation\n", "");
    print &PerlTranslate("tag_java.pl", "ctags$binext has to be downloaded from http://sourceforge.net/projects/ctags\n", "");
    print &PerlTranslate("tag_java.pl", "or http://ctags.sourceforge.net. once downloaded copy it into $BINDIR\n", "");
                                print "*********************************************************************************\n";
   exit(1);

}

################################################################################
# Here is the beginning
################################################################################
EnterInScript();
my $binext;
$binext=".exe" if($OSNAME eq "win32");
###########################################################################
# Decide what to do

my $java_file = "ctags_input.java";

open(IN_FILE, "< $FILENAME") or return;
open(OUT_FILE, "> $java_file") or return; # or die "Couldn't open log file $out_filename\n";

print OUT_FILE "#line 1 \"$FILENAME\"\n";
while( <IN_FILE> )
{
    print OUT_FILE $_;
}
close(IN_FILE);
close(OUT_FILE);

my $EXPATH2 = $ENV{'PATH'};
$ENV{'PATH'}.=$BINDIR;


$command = "ctags -h .java --java-types=cimp -u -n --fields=+afKmsS --line-directives=yes \"$java_file\"";

my $status = SystemP($command);

if ($status != 0)
{
    print &PerlTranslate("tag_java.pl", "Unable to complete command for %1\n", "%1 is the name of the file to be tagged", $FILENAME);
    errorctags unless(-f "$BINDIR/ctags".$binext);
}

$ENV{'PATH'} = $EXPATH2;

#unlink( $java_file );

exit($status);

