#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                          -*-  Source Browsing -*-                            #
#                                                                              #
#                                                                              #
#                                                                              #
#  Perl-Script         tag_ptu.pl                                              #
#  Version             v1.0                                                    #
#                                                                              #
#  $Revision: 1.12 $                                                            #
#  $Date: 2007/07/23 18:41:58 $                                                #
#                                                                              #
#  Launch tags tool to determinate control structures into program files       #
#                                                                              #
#  Usage:                                                                      #
#       TestRTperl tag_ptu.pl <file list>                                      #
#                                                                              #
#  Problems:                                                                   #
#	Source Compilation: Spec=ads; Bdy=adb                                  #
#	RecompileAdaRuntimeLibraries: Verification NAME/LNAME only             #
#                                                                              #
################################################################################

use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

# Configuration file
require $ARGV[0];

# Miscellaneous functions
require $SCRIPTDIR . "Fcts.pl";

################################################################################
# Here is the beginning
################################################################################
EnterInScript();

###########################################################################
# This routine analyze the command line of script
sub CommandLineAnalyze
{
  return (1);
}

###########################################################################
# Print the USAGE
sub AttolCommandUsage
{
   die &PerlTranslate("tag_ptu.pl", "Use command like that : TestRTperl tag_ptu.pl <environment file> <file>\nExiting\n");
}

###########################################################################
# Decide what to do

# analyze command line to get phases
CommandLineAnalyze() || AttolCommandUsage();

$command = "$BINDIR" . "$PATH_SEPARATOR" . "utags -ftags \"$FILENAME\"" ;

my $status = SystemP($command);

if ($status != 0)
{
    print &PerlTranslate("tag_ptu.pl", "Unable to complete command for %1\n", "%1 is the name of the file to be tagged", $FILENAME);
}


unlink( $prepro_file ) if ( $remove_prepro_file == 1 );

exit($status);

