#!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                          -*-  TDP print to a text file -*-                   #
#                                                                              #
#                                                                              #
################################################################################
#$Id: tdpprint.pl,v 1.17 2007/06/06 16:23:05 rfrance Exp $
################################################################################

use XML::Parser;
use strict;
use File::Basename;

## globals ############

my $bigline="\n=====================================================\n";
my $endline="\n-----------------------------------------------------\n";
my $tab    =  "                                                     ";
my $lvl0="=*>";
my $lvl1="=*->";
my $lvl2="=*--->";
my $lvl3="=*----->";
#######################
$main::TDPGEN=1;
die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
$main::SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $main::SCRIPTDIR . "Translate.pl";

my $file=shift;
my $txtFile=shift;
push(@INC,$main::SCRIPTDIR);

require "Fcts.pl";
EnterInScript();

$main::TESTRTDIR="$ENV{'TESTRTDIR'}";

die &PerlTranslate("tdpprint.pl", "Usage: TestRTperl tdpprint.pl <TdpFile> <TextFile>\n") if((! defined $file) || (! defined $txtFile));
die &PerlTranslate("tdpprint.pl", "Cannot find file \"%1\"\n", "%1 is a the missing file name", $file) unless -f $file;
my $dirName=basename($file,".xdp");

#$ENV{'ATLTGT'}="$txtFile/$dirName";

my $parser = new XML::Parser(ErrorContext => 2,
                             ParseParamEnt => 0,
                             Style=>'Subs',
                             Pkg=>'MyAnalyze'
                            );

$parser->setHandlers(Char=>\&MyAnalyze::CharHandler,Final=>\&MyAnalyze::FinalHandler);

$parser->parsefile($file);

exit(0);

package MyAnalyze;

use strict;
use File::Basename;
my @Errors;
my $flag;
my $Name;
my $binFileName;
my $condFlag;
my $MacroValue;
my $curLabel;
my $AdaMode;
my $tdpType;
my $d;
my $strget;

sub TDP
{
        my ($p,$data,%A) = @_;

        $flag=0;
        $Name=$A{'Name'};
        $tdpType=$A{'type'};
        $AdaMode="std";
        $strget="";
        $condFlag=1;
        open OU,">$txtFile" || die &PerlTranslate("tdpprint.pl", "Cannot create file %1\n", "%1 is the file name", $txtFile);
	printOU("Name=\"$Name\" ,Version=$A{'Version'} type=$tdpType $bigline");
}
sub TDP_
{
	close(OU);
}
sub IS_JAVA                     { openOU("Basic settings for \"Java $Name\"\nLANGUAGE=\"Java\""); }
sub IS_JAVA_                    { endline();}
sub IS_C                        { openOU("Basic settings for \"C $Name\"\nLANGUAGE=\"C\""); }
sub IS_C_                       { endline();}
sub IS_CPP                      { openOU("Basic settings for \"C++ $Name\"\nLANGUAGE=\"CPP\""); }
sub IS_CPP_                     { endline();}
sub IS_A                        { openOU("Basic settings for \"Ada $Name\"\nLANGUAGE=\"Ada\""); }
sub IS_A_                       { endline();}
sub IS_A83                      { openOU("Basic settings for \"Ada83 $Name\"\nLANGUAGE=\"Ada83\""); }
sub IS_A83_                     { endline();}
sub SRCEXT                      { printOU("SRCEXT=\""); }
sub SRCEXT_                     { printOU("\"\n"); }
sub OBJEXT                      { printOU("OBJEXT=\""); }
sub OBJEXT_                     { printOU("\"\n"); }
sub EXEEXT                      { printOU("EXEEXT=\""); }
sub EXEEXT_                     { printOU("\"\n"); }
sub ASMEXT                      { printOU("ASMEXT=\""); }
sub ASMEXT_                     { printOU("\"\n"); }
sub DLLEXT                      { printOU("DLLEXT=\""); }
sub DLLEXT_                     { printOU("\"\n"); }
sub LIBEXT                      { printOU("LIBEXT=\""); }
sub LIBEXT_                     { printOU("\"\n"); }
sub DEFAULT_INCLUDE_PATHS       { printOU("DEFAULT_INCLUDE_PATHS=\""); }
sub DEFAULT_INCLUDE_PATHS_      { printOU("\"\n"); }
sub DEFAULT_DEFINES             { printOU("DEFAULT_DEFINES=\""); }
sub DEFAULT_DEFINES_            { printOU("\"\n"); }
sub DEFAULT_CPPFLAGS            { printOU("DEFAULT_CPPFLAGS=\""); }
sub DEFAULT_CPPFLAGS_           { printOU("\"\n"); }
sub DEFAULT_CFLAGS              { printOU("DEFAULT_CFLAGS=\""); }
sub DEFAULT_CFLAGS_             { printOU("\"\n"); }
sub DEFAULT_LDFLAGS             { printOU("DEFAULT_LDFLAGS=\""); }
sub DEFAULT_LDFLAGS_            { printOU("\"\n"); }
sub DEFAULT_LIBRARY_PATHS       { printOU("DEFAULT_LIBRARY_PATHS=\""); }
sub DEFAULT_LIBRARY_PATHS_      { printOU("\"\n"); }
sub DEFAULT_LIBS                { printOU("DEFAULT_LIBS=\""); }
sub DEFAULT_LIBS_               { printOU("\"\n"); }
sub DEFAULT_ASMFLAGS            { printOU("DEFAULT_ASMFLAGS=\""); }
sub DEFAULT_ASMFLAGS_           { printOU("\"\n"); }
sub DEFAULT_TPLIB_CCFLAGS       { printOU("DEFAULT_TPLIB_CCFLAGS=\""); }
sub DEFAULT_TPLIB_CCFLAGS_      { printOU("\"\n"); }
sub DEFAULT_TPDLL_CCFLAGS       { printOU("DEFAULT_TPDLL_CCFLAGS=\""); }
sub DEFAULT_TPDLL_CCFLAGS_      { printOU("\"\n"); }
sub DEFAULT_TPLIB_LDFLAGS       { printOU("DEFAULT_TPLIB_LDFLAGS=\""); }
sub DEFAULT_TPLIB_LDFLAGS_      { printOU("\"\n"); }
sub DEFAULT_TPDLL_LDFLAGS       { printOU("DEFAULT_TPDLL_LDFLAGS=\""); }
sub DEFAULT_TPDLL_LDFLAGS_      { printOU("\"\n"); }
sub INIFIELD_                   { printOU("\"\n"); }

sub BUILD                       { my ($p,$data,%A)=@_; print OU "$bigline $A{'Label'} $bigline"; }
sub LIBCONF                     { my ($p,$data,%A)=@_; print OU "$bigline $A{'Label'} $bigline"; }
sub PARSERCONF                  { my ($p,$data,%A)=@_; print OU "$bigline $A{'Label'} $bigline"; }

sub ASSEMBLER                   { LABELTOP2(@_); }
sub ASSEMBLER_                  { endline(); }
sub COMPILATION                 { LABELTOP2(@_); }
sub COMPILATION_                { endline(); }
sub PREPROCESSING               { LABELTOP2(@_); }
sub PREPROCESSING_              { endline();}
sub LIBRARY                     { LABELTOP2(@_); }
sub LIBRARY_                    { endline(); }
sub LINK                        { LABELTOP2(@_); }
sub LINK_                       { endline(); }
sub EXECUTE                     { LABELTOP2(@_); }
sub EXECUTE_                    { endline();}
sub EXECUTEDBG                  { LABELTOP2(@_); }
sub EXECUTEDBG_                 { endline();}
sub NEWCMDFILE                  { my ($p,$data,%A) = @_; openOU("$A{'Name'} included as:"); }
sub NEWCMDFILE_                 { endline(); }
sub NEWBINFILE                  { my ($p,$data,%A) = @_; printOU("==>Binary file $A{'Name'} included.\n"); }


sub PCATUSCPPDEF                { LABELTOP2(@_); }
sub PCATUSCPPDEF_               { endline();}
sub PCATUSCDEF                  { LABELTOP2(@_); }
sub PCATUSCDEF_                 { endline();}
sub PCATCTDEF                   { LABELTOP2(@_); }
sub PCATCTDEF_                  { endline();}
sub PCHPP                       { LABELTOP2(@_); }
sub PCHPP_                      { endline();}
sub PCOPP                       { LABELTOP2(@_); }
sub PCOPP_                      { endline();}
sub STANDARDA83                 { LABELTOP2(@_); }
sub STANDARDA83_                { endline();}
sub STANDARDA95                 { LABELTOP2(@_); }
sub STANDARDA95_                { endline();}
sub SYSTEMADA83                 { LABELTOP2(@_); }
sub SYSTEMADA83_                { endline();}
sub SYSTEMADA95                 { LABELTOP2(@_); }
sub SYSTEMADA95_                { endline();}

#
# Lib Java
#
sub COMPONENTTESTING            { LABELTOP2(@_); }
sub COMPONENTTESTING_           { endline(1); }
sub CUSTOMJAVA 			{ LABELTOP(@_);}
sub JAVA_EARLYINIT              { LABELTOP2(@_);}
sub JAVA_IMPORTS		{ LABELTOP2(@_);}
sub JAVA_IMPORTS_		{ endline(4);}
sub JAVA_THREADS		{ LABELTOP2(@_);}
#sub JAVA_THREADS_		{ endline(5);}
sub JAVA_DATARETRIEVAL		{ LABELTOP2(@_);}
#sub JAVA_DATARETRIEVAL_		{ endline(6);}
sub JAVA_CLOCK			{ LABELTOP2(@_);}
#sub JAVA_CLOCK_			{ endline(7);}
sub CUSTOMJVMPI                 { LABELTOP(@_);}
sub BUILD_JVMPI                 { LABELTOP2(@_);}
sub BUILD_JVMPI_                { endline(9);}
sub JVMPI_HEAP                  { LABELTOP2(@_);}
sub JVMPI_IO                    { LABELTOP2(@_);}
sub JVMPI_ERROR                 { LABELTOP2(@_);}
sub JVMPI_STRING                { LABELTOP2(@_);}
sub JVMPI_DATE_IN_MILLISEC      { LABELTOP2(@_);}
sub JVMPI_SOCKET                { LABELTOP2(@_);}

# Lib C
sub COMPILER_SPECIFICS          { LABELTOP(@_); }
sub PREPROCESSING_SPECIFICS     { LABELTOP2(@_); }
sub LINKAGE                     { LABELTOP2(@_); }
sub CPP_SPECIFICS               { LABELTOP2(@_); }
sub DATA_TYPES                  { LABELTOP2(@_); }
sub APPLICATION_SPECIFICS       { LABELTOP(@_); }
sub SPRINTF                     { LABELTOP1(@_); }
sub EXIT                        { my ($p,$data,%A) = @_; $curLabel=$lvl1.$A{'Label'}; }
sub SYSTEM_TESTING              { LABELTOP1(@_); }
sub DYNTRACK                    { LABELTOP2(@_); }
sub MEMCPY                      { my ($p,$data,%A) = @_; $curLabel=$lvl2.$A{'Label'}; }
sub GETHOSTNAME                 { my ($p,$data,%A) = @_; $curLabel=$lvl2.$A{'Label'}; }
sub RDV                         { my ($p,$data,%A) = @_; $curLabel=$lvl2.$A{'Label'}; }
#sub                         { my ($p,$data,%A) = @_; $curLabel=$lvl2.$A{'Label'}; }
sub OBSERVATIONS                { LABELTOP1(@_); }
sub INITSUPPORTED               { LABELTOP2(@_); }
sub ATEXIT                      { my ($p,$data,%A) = @_; $curLabel=$lvl2.$A{'Label'}; }
sub GETENV                      { my ($p,$data,%A) = @_; $curLabel=$lvl2.$A{'Label'}; }
sub SIGNAL                      { my ($p,$data,%A) = @_; $curLabel=$lvl2.$A{'Label'}; }
sub LONGJMP                     { my ($p,$data,%A) = @_; $curLabel=$lvl2.$A{'Label'}; }



sub TESTING_SPECIFICS           { LABELTOP(@_); }
sub MAIN_RETURN                 { LABELTOP1(@_); }
sub STRING_SUPPORT              { LABELTOP1(@_); }
sub FLOAT_SUPPORT               { LABELTOP1(@_); }
sub IO                          { LABELTOP(@_); }
sub ERROR_IO                    { my ($p,$data,%A) = @_; $curLabel=$lvl1.$A{'Label'}; }
sub HEAP                        { LABELTOP(@_); }
sub CLOCK                       { LABELTOP(@_); }
sub THREADS                     { LABELTOP(@_); }

# Lib Ada
sub RESTRICTIONS                { LABELTOP2(@_); }
sub RESTRICTIONS_               { printOU("Ada Mode =$AdaMode\n");}
sub RENAMEADA                   { my ($p,$data,%A)=@_;if($A{'Value'}==1) { $AdaMode=$A{'Name'}; } }
sub TYPES                       { LABELTOP2(@_); }
sub CONSTANTS                   { LABELTOP2(@_); }
sub TYPEADA                     { my ($p,$data,%A)=@_; printOU("\tsubtype $A{'Name'} is ");}
sub TYPEADA_                    { printOU(";\n"); }
sub CONSTANTADA                 { my ($p,$data,%A)=@_; if($A{'Name'} eq "atc_nb_bit_branch") { printOU("\t$A{'Name'}:Constant Integer:=");}
                                                       else { printOU("\t$A{'Name'}:Constant:="); } }
sub CONSTANTADA_                { printOU(";\n"); }
sub CONSTANTSTRINGADA           { my ($p,$data,%A)=@_; printOU("\t$A{'Name'}:Constant String:="); }
sub CONSTANTSTRINGADA_          { printOU(";\n"); }

sub FREE_TEXT_AFTER_FOR_TDP     { LABELTOP2(@_); }
sub FREE_TEXT_AFTER_FOR_TDP_    { endline(11);}
sub FREE_TEXT_BEFORE_FOR_TDP    { LABELTOP2(@_); }
sub FREE_TEXT_BEFORE_FOR_TDP_   { endline(12);}

sub MEMLIB_EXTENSION            { LABELTOP2(@_); }
sub FREE_TEXT_BEFORE_FOR_INSTR  { LABELTOP2(@_); }
sub FREE_TEXT_BEFORE_FOR_INSTR_ { endline(14);}
sub FREE_TEXT_BEFORE_FOR_INSTR_AND_GEN  { LABELTOP2(@_); }
sub FREE_TEXT_BEFORE_FOR_INSTR_AND_GEN_ { endline();}
sub FUNCTIONS                   { LABELTOP(@_); }
sub FREE_TEXT_WITH_PRIV_IO_ADS  { LABELTOP2(@_); }
sub FREE_TEXT_WITH_PRIV_IO_ADS_ { endline(15);}
sub FREE_TEXT_ADD_PRIV_IO_ADS   { LABELTOP2(@_); }
sub FREE_TEXT_ADD_PRIV_IO_ADS_  { endline(16);}
sub FREE_TEXT_WITH_PRIV_IO_ADB  { LABELTOP2(@_); }
sub FREE_TEXT_WITH_PRIV_IO_ADB_ { endline(17);}
sub FREE_TEXT_TOP_ADD_PRIV_IO_ADB   { LABELTOP2(@_); }
sub FREE_TEXT_TOP_ADD_PRIV_IO_ADB_  { endline(18);}
sub PRIV_CLOCK                  { LABELTOP2(@_); }
sub PRIV_CLOCK_                 { endline(19);}
sub PRIV_OPEN                   { LABELTOP2(@_); }
sub PRIV_OPEN_                  { endline(20);}
sub PRIV_WRITELN                { LABELTOP2(@_); }
sub PRIV_WRITELN_               { endline(21);}
sub PRIV_CLOSE                  { LABELTOP2(@_); }
sub PRIV_CLOSE_                 { endline(22);}
sub FREE_TEXT_ADD_PRIV_IO_ADB   { LABELTOP2(@_); }
sub FREE_TEXT_ADD_PRIV_IO_ADB_  { endline(23);}

#
# general
#
sub TEXT_MACRO                  { my ($p,$data,%A)=@_;printOU("$A{'Name'} = ") if($condFlag==1); }
sub TEXT_MACRO_                 { printOU("\n") if($condFlag==1); }
sub BINARY_MACRO                { my ($p,$data,%A)=@_; if($condFlag==1){printOU("$A{'Name'} = $A{'Value'}") ;} }
sub BINARY_MACRO_               { printOU("\n") if($condFlag==1); }
sub OPTIONAL_MACRO              { my ($p,$data,%A)=@_;printOU("$A{'Name'} = $A{'Value'}\n") if($A{'Defined'} eq "1"); }
sub CHOICE                      { my ($p,$data,%A)=@_;$condFlag=0;$MacroValue=$A{'Value'};
                                  print2OU("$A{'Name'} = $MacroValue");}
sub CHOICE_                     { $condFlag=1;}
sub CHOICEDATA                  { my ($p,$data,%A)=@_; if($A{'Sensitive'}==1){$strget="";$flag=2 ;} }
sub CHOICEDATA_                 { $flag=0;$condFlag=1 if($MacroValue eq $strget); }

sub KEY    { $flag=1; }
sub KEY_   { printOU("=\""); $flag=0; }
sub VALUEFCTC  { }
sub VALUEFCTC_ { }
sub VALUE  { $flag=1 if($condFlag==1); }
sub VALUE_ { $flag=0; }
sub BINVALUE  { $flag=0; }
sub BINVALUE_ { $flag=0; }
sub PROTO  { $flag=1 if($condFlag==1); }
sub PROTO_ { if($condFlag==1) {printOU("\n"); $flag=0;} }
sub TAIL   { if($condFlag==1) {printOU("\n"); $flag=1;} }
sub TAIL_  { if($condFlag==1) {printOU("\n"); $flag=0;} }
sub ONGLET_   { endline() if($condFlag==1); }
sub LABELTOP  {my ($p,$data,%A) = @_; print OU "$tab$lvl0$A{'Label'}\n"; }
sub LABELTOP1 {my ($p,$data,%A) = @_; print OU "$tab$lvl1$A{'Label'}\n"; }
sub LABELTOP2 {my ($p,$data,%A) = @_; print OU "$tab$lvl2$A{'Label'}\n"; }
sub LABELTOP3 {my ($p,$data,%A) = @_; print OU "$tab$lvl3$A{'Label'}\n"; }
sub endline {my $x=shift;print OU "$endline";}
sub CharHandler { my ($p,$data)=@_; printOU($data) if($flag==1); $strget=$strget.$data if ($flag==2);}

sub FinalHandler        
{
    if (@Errors)
    {
        print STDERR @Errors;
        exit(1);
    }
}

sub openOU                    { my $f=shift; print OU "$tab===>".$f."\n";}
sub printOU                   { my $l=shift; print OU $l; }
sub print2OU                  { my $l=shift; print OU $l.substr($tab,length($l)).$curLabel."\n";$curLabel=""; }

package main;

