#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

# Configuration file
require $ARGV[0];

# Miscellaneous functions
require $SCRIPTDIR . "Fcts.pl";

################################################################################
# Here is the beginning
################################################################################
EnterInScript();
my $src="atltmp_inc.c";
my $prepro_file = "atltmp_inc.i";
my $typedefs = "typedeftags";

open TMP,">$src" or die "cannot write the file $src\n";
foreach(@ATS_INTERFACE_FILES){
print TMP "#include \"$_\"\n";
}
close TMP;

$ENV{'ATW_NO_USR_INCLUDE'}="on";

if ((-f "$BINDIR/gcpp") || (-f "$BINDIR/gcpp\.exe")){
$command = "$BINDIR/gcpp";
$command.=" -I\"".join("\" -I\"",@COMPLETE_INCLUDE_DIR_LIST)."\"" if(scalar(@COMPLETE_INCLUDE_DIR_LIST));
$command.=" -D\"".join("\" -D\"",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
$command.= " $src -o $prepro_file";
}else{

$command = "$BINDIR/attolstartC -PREPRO_ONLY";
  if(@COMPLETE_INCLUDE_DIR_LIST) {
	my $opt = " -incl=\"".join("\",\"",@COMPLETE_INCLUDE_DIR_LIST )."\"";
 	$opt=~ s,([\\\/])",$1.",g;
 	$command .=$opt;
     }
$command.=" -define=\"".join("\",\"",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
#$command.=" -define=__cplusplus" if ( $TDP_LANGUAGE eq "CPP" );
$command.= " $src $prepro_file";
}

my $status=SystemP($command);
unless($status)
{
my $on=0;
my $file;
my $Lnum=0;
my $Ltop;
my $Lbot;
open OUT,">$typedefs" or die "cannot write the file $typedefs\n";
print "looking for typedefs\n";
	open IN,"$prepro_file" or die "cannot open the file $prepro_file\n";
	while (<IN>) {
	    chop;
	    $Lnum++;
	    if(/#(line)? (\d+) "(.+)"/){
	    	$Lnum=$2-1;
	    	$file=$3;
	    	next;
	    }
	    if($on) {
		$line.=' '.$_;
	    }elsif(/(typedef.*)$/) { $on=1; $line=$1; $Ltop=$Lnum;}
	    
	    if($on) {
#		print $line."\n";
		while($line =~ s/\{[^{]*\}//){};
		unless($line=~ /\{/) #}
		{ 
			if($line=~ /;/) { 
				$on=0;
				#extract the typedef name
				$line=~ s/\[\d*\]//;
#				print ">$line\n";
				if($line=~ m/[\s\*](\w+)\s*;/){
					print OUT $1,",$file,$Ltop,$Lnum\n";
#					print "\t$1\n";
				}
				$line="";
			}
		}
	    }
	}
	close IN;
close OUT;
} else {print "status=$status\n" ;}
unlink( $prepro_file );

exit($status);
