

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
*        (C) 2003 Rational Software Corporation. All Rights Reserved.          # 
*                                                                              *
*                Product: Rational(R) Test RealTime                            *
*                                                                              *
*      Product Component: System Testing Agent                                 *
*                                                                              *
*               Language: C                                                    *
*                                                                              *
*        Product version: 2002.05.20                                           *
*                                                                              *
*                   File: atwstr.h                                             *
*                                                                              *
* Rational, the Rational logo are registered trademarks of                     *
* Rational Software Corporation.                                               *
*                                                                              *
* The placing of the copyright notices on Rational source code is not          *
* intended to mean that they are published works, but are included in the      *
* event of inadvertent publication. The source code of Rational contains       *
* trade secrets and other valuable confidential information of Rational        *
* Software Corporation. Rational Software Corporation and its licensors        *
* retain ownership to Rational Products in both source and object code         *
* format, and related documentation and all rights therein including           *
* copyrights, patents and trade secrets.                                       *
*                                                                              *
*                                                                              *
* U.S. Government Rights                                                       *
*                                                                              *
* Use, duplication, or disclosure by the U.S. Government is subject to         *
* restrictions set forth in the applicable Rational License Agreement          *
* and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   *
* 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         *
* or FAR 52.227-14, as applicable.                                             *
*                                                                              *
* Unless otherwise agreed to in writing, use of Rational products is           *
* governed by the Rational Product License Agreement provided with             *
* the product.                                                                 *
*******************************************************************************/
/*=====================================================
 *  MODULE :  atwstr
 *
 *  FILE :  atwstr.h
 *
 *  AUTHOR : E.M
 *
 *  CREATION DATE   : 10/07/1997
 *
 *  PUBLIC FUNCTIONS :
 *         void    atwstrStartup()
 *         void    atwstrShutdown()
 *         atwstr *atwstrCreate()
 *         atwstr *atwstrDestroy(atwstr *str)
 *         atwstr *atwstrClone(const char *s)
 *         atwstr *atwstrConcat(const char *str1, const char *str2, ...)
 *         atwstr *atwstrExtract(atwstr *str,  unsigned long b, unsigned long n)
 *         atwstr *atwstrAppend(atwstr *str, const char* s)
 *         atwstr *atwstrInsert(atwstr *str, const char *s, unsigned long b, unsigned long n)
 *         atwstr *atwstrTrunc(atwstr *str, unsigned long b, unsigned long n)
 *         unsigned long atwstrLength(const atwstr *str)
 *         int           atwstrCompare(const atwstr *str1, const atwstr *str2)
 *
 *
 *  MODIFICATION DATE :
 *
 *  SINOPSYS : Module de gestion de chaine de
 *              caracteres dynamique
 *=====================================================*/

#ifndef atwstrINCLUDED
#define atwstrINCLUDED


typedef char   atwstr;

#ifdef ANSI_C /* ANSI */
extern void atwstrStartup(void);
extern void atwstrShutdown(void);

extern atwstr *atwstrCreate(void);
extern atwstr *atwstrDestroy(atwstr *str);
extern atwstr *atwstrClone(const char *s);
extern atwstr *atwstrConcat(const char *str1, const char *str2, ...);
extern atwstr *atwstrExtract(const char *c,  unsigned b, unsigned n);

extern atwstr *atwstrAppend(atwstr *str, const char* s);
extern atwstr *atwstrInsert(atwstr *str, const char *s, unsigned b, unsigned n);
extern atwstr *atwstrTrunc(atwstr *str, unsigned b, unsigned n);

extern unsigned atwstrLength(const atwstr *str);
extern int      atwstrCompare(const atwstr *str1, const atwstr *str2);

#else          /* K&R */

extern void atwstrStartup();
extern void atwstrShutdown();

extern atwstr *atwstrCreate();
extern atwstr *atwstrDestroy();
extern atwstr *atwstrClone();
extern atwstr *atwstrConcat( );
extern atwstr *atwstrExtract();

extern atwstr *atwstrAppend();
extern atwstr *atwstrInsert();
extern atwstr *atwstrTrunc();

extern unsigned atwstrLength();
extern int      atwstrCompare();
#endif   /* ANSI_C */


#ifdef ATWSTR_DEBUG

#ifdef ANSI_C /* ANSI */
extern void atwstrStartupDebug(void);
extern void atwstrShutdownDebug(void);

extern atwstr *atwstrCreateDebug(char *file, long line);
extern atwstr *atwstrDestroyDebug(atwstr *str, char *file, long line);
extern atwstr *atwstrCloneDebug(const char *s, char *file, long line);
extern atwstr *atwstrConcatDebug(const char *str1, const char *str2, ...);
extern atwstr *atwstrExtractDebug(const char *c,  unsigned b, unsigned n, char *file, long line);

extern atwstr *atwstrAppendDebug(atwstr *str, const char* s, char *file, long line);
extern atwstr *atwstrInsertDebug(atwstr *str, const char *s, unsigned b, unsigned n, char *file, long line);
extern atwstr *atwstrTruncDebug(atwstr *str, unsigned b, unsigned n, char *file, long line);

extern unsigned atwstrLengthDebug(const atwstr *str, char *file, long line);
extern int      atwstrCompareDebug(const atwstr *str1, const atwstr *str2, char *file, long line);

#else          /* K&R */

extern void atwstrStartupDebug();
extern void atwstrShutdownDebug();

extern atwstr *atwstrCreateDebug(f,l);

extern atwstr *atwstrDestroyDebug(str, f, l);
extern atwstr *atwstrCloneDebug(c, f, l);
extern atwstr *atwstrConcatDebug(c1, c2);
extern atwstr *atwstrExtractDebug(c, b, n, f, l);

extern atwstr *atwstrAppendDebug(str, c, f, l);
extern atwstr *atwstrInsertDebug(str, c, b, n, f, l);
extern atwstr *atwstrTruncDebug(str, b, n, f, l);

extern unsigned atwstrLengthDebug(str, f, l);
extern int      atwstrCompareDebug(str1, str2, f, l);


#endif  /* ANSI_C */

#define atwstrStartup()            atwstrStartupDebug()
#define atwstrShutdown()           atwstrShutdownDebug()
#define atwstrCreate()             atwstrCreateDebug(__FILE__, __LINE__)
#define atwstrDestroy(s)           atwstrDestroyDebug(s, __FILE__, __LINE__)
#define atwstrClone(s)             atwstrCloneDebug(s, __FILE__, __LINE__)
#define atwstrConcat               atwstrConcatDebug
#define atwstrExtract(str, b, n)   atwstrExtractDebug(str, b, n, __FILE__, __LINE__)
#define atwstrAppend(str, s)       atwstrAppendDebug(str, s, __FILE__, __LINE__)
#define atwstrInsert(str, c, b, n) atwstrInsertDebug(str, c, b, n, __FILE__, __LINE__)
#define atwstrTrunc(str, b, n)     atwstrTruncDebug(str, b, n, __FILE__, __LINE__)
#define atwstrLength(str)          atwstrLengthDebug(str, __FILE__, __LINE__)
#define atwstrCompare(str1, str2)  atwstrCompareDebug(str1, str2, __FILE__, __LINE__)

#else

#define atwstrStartup()            ((void)(0))
#define atwstrShutdown()           ((void)(0))

#endif /* ATWSTR_DEBUG */


#endif  /* atwstrINCLUDED */


