

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.  *
*                                                                              *
*                Product: Rational(R) Test RealTime                            *
*                                                                              *
*      Product Component: System Testing Agent                                 *
*                                                                              *
*               Language: C                                                    *
*                                                                              *
*        Product version: 2003.06.00                                           *
*                                                                              *
*                   File: cmd_msg.h                                            *
*                                                                              *
* Rational, the Rational logo are registered trademarks of                     *
* Rational Software Corporation.                                               *
*                                                                              *
* The placing of the copyright notices on Rational source code is not          *
* intended to mean that they are published works, but are included in the      *
* event of inadvertent publication. The source code of Rational contains       *
* trade secrets and other valuable confidential information of Rational        *
* Software Corporation. Rational Software Corporation and its licensors        *
* retain ownership to Rational Products in both source and object code         *
* format, and related documentation and all rights therein including           *
* copyrights, patents and trade secrets.                                       *
*                                                                              *
*                                                                              *
* U.S. Government Rights                                                       *
*                                                                              *
* Use, duplication, or disclosure by the U.S. Government is subject to         *
* restrictions set forth in the applicable Rational License Agreement          *
* and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   *
* 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         *
* or FAR 52.227-14, as applicable.                                             *
*                                                                              *
* Unless otherwise agreed to in writing, use of Rational products is           *
* governed by the Rational Product License Agreement provided with             *
* the product.                                                                 *
*******************************************************************************/
/******************************************************************************
*
*% Module        CMDMSG
*
*                Identification
*                --------------
*
*% Version       $Revision: 1.9 $
*% Auteur        $Author: build $
*% Date          $Date: 2007/01/16 14:12:50 $
*
*% Description
*    Liste des messages 
*% Fdescription
*
*                Ressources exportees
*                --------------------
* % Exportee, TCPIPinit, T_ENTIER, Initialisation de la librairie
******************************************************************************/

#ifndef CMDMSG_INCLUDED
#define CMDMSG_INCLUDED
/*
 * Pour utiliser ce module inclure la ligne suivante dans le fichier :
 * #include "cstsyst.h" 
 */

/* Ensemble des messages retournes par les commandes */
typedef enum
{
  K_CMD_MSG_HELP = 0,
  /* Message des operations ayant reussi (debutant par 2)*/
  K_CMD_MSG_HELO,
  K_CMD_MSG_PASDAIDE,
  K_CMD_MSG_GENV_OK,
  K_CMD_MSG_SENV_OK,
  K_CMD_MSG_DENV_OK,
  K_CMD_MSG_QUIT,
  K_CMD_MSG_PORT_TRACE,
  K_CMD_MSG_TRACE_OFF,
  K_CMD_MSG_TRACE_ON,
  K_CMD_MSG_TRWA_OK,
  K_CMD_MSG_PORT_FTP,
  K_CMD_MSG_FTPA_OK,
  K_CMD_MSG_FTPB_OK,
  K_CMD_MSG_GETF_OK,
  K_CMD_MSG_PUTF_OK,
  K_CMD_MSG_DELF_OK,
  K_CMD_MSG_PORT_RDV,
  K_CMD_MSG_PORT_DYNF,
  K_CMD_MSG_CWD_OK,
  K_CMD_MSG_MKD_OK,
  K_CMD_MSG_PWD_OK,
  K_CMD_MSG_RMD_OK,
  K_CMD_MSG_EXEC_OK,
  K_CMD_MSG_STAT_END,
  K_CMD_MSG_STAT_RUN,
  K_CMD_MSG_STOP_OK,
  /* Message d'erreur de syntaxe (debutant par 3)*/
  K_CMD_MSG_ACCESS_OK,
  /* Message d'erreur de syntaxe (debutant par 4)*/
  K_CMD_MSG_AIDECMDINCONNUE,
  K_CMD_MSG_GENV_PAR,
  K_CMD_MSG_SENV_PAR,
  K_CMD_MSG_SENV_VAL,
  K_CMD_MSG_DENV_PAR,
  K_CMD_MSG_GETF_PAR,
  K_CMD_MSG_PUTF_PAR,
  K_CMD_MSG_DELF_PAR,
  K_CMD_MSG_CWD_PAR,
  K_CMD_MSG_MKD_PAR,
  K_CMD_MSG_RMD_PAR,
  K_CMD_MSG_EXEC_PAR,
  K_CMD_MSG_STAT_PAR,
  K_CMD_MSG_STOP_PAR,
  /* Message d'erreur (debutant par 5) */
  K_CMD_MSG_INCONNUE,
  K_CMD_MSG_NON_IMPL,
  K_CMD_MSG_GENV_KO,
  K_CMD_MSG_SENV_KO,
  K_CMD_MSG_DENV_KO,
  K_CMD_MSG_PORT_KO,
  K_CMD_MSG_TRWA_ERROR,
  K_CMD_MSG_PFTP_KO,
  K_CMD_MSG_GETF_KO,
  K_CMD_MSG_PUTF_KO,
  K_CMD_MSG_DELF_KO,
  K_CMD_MSG_ACCESS_KO,
  K_CMD_MSG_PRDV_KO,
  K_CMD_MSG_PDYNF_KO,
  K_CMD_MSG_CWD_KO,
  K_CMD_MSG_MKD_KO,
  K_CMD_MSG_PWD_KO,
  K_CMD_MSG_RMD_KO,
  K_CMD_MSG_EXEC_KO,
  K_CMD_MSG_STAT_KO,
  K_CMD_MSG_STOP_KO,
  K_CMD_MSG_NON_INIT,
  K_CMD_MSG_RDV_ACCEPTFAILD,
  K_CMD_MSG_RDV_RECVFAILD,
  K_CMD_MSG_RDV_MEMORYFAILD,
  K_CMD_MSG_DYNF_ACCEPTFAILD,
  K_CMD_MSG_DYNF_BOOTRECVFAILD,
  K_CMD_MSG_DYNF_LINERECVFAILD,
  K_CMD_MSG_DYNF_ENDRECVFAILD,

  /* Alerte automatique */
  K_CMD_MSG_WAITRDV,
  K_CMD_MSG_QUITRDV,
  K_CMD_MSG_RDV_CLIENTERR,
  K_CMD_MSG_PROC_END,

  /* dynfollow */
  K_CMD_MSG_RAISEDBOOTINFODYNF,
  K_CMD_MSG_RAISEDINFODYNF,
  K_CMD_MSG_RAISEDENDINFODYNF,
  K_CMD_MSG_DYNF_TSFNOTIFY,
  K_CMD_MSG_DYNF_TSFDCLNI,
  K_CMD_MSG_DYNF_TSFSYNCHRO,
  K_CMD_MSG_DYNF_TSFSENDMSG,
  K_CMD_MSG_DYNF_TSFWAITTILMSG,
  K_CMD_MSG_DYNF_TSFINTERSENDMSG,
  K_CMD_MSG_DYNF_TSFINTERRECVMSG,
  K_CMD_MSG_DECONNECTEDTESTERDYNF,
  K_CMD_MSG_DYNF_TSFBEGINWAITTIL,
  K_CMD_MSG_DYNF_TSFENDWAITTIL,
  K_CMD_MSG_DYNF_TSFINITTERMEXCEPTBLCK,

  /* cit */
  K_CMD_MSG_CIT_INTERSEND,
  K_CMD_MSG_CIT_INTERRECV,
  K_CMD_MSG_CIT_TIMEOUTRQST,

  /* studio connection */
  K_CMD_MSG_STDIOLKAVAIL,
  K_CMD_MSG_APISTUDIO_STOPCMD,

  /* Correspond au nombre de messages */
  K_CMD_NBRE_MSG
} T_INDEX_MESG_REP;

extern PT_CAR g_chaine_ret[K_CMD_NBRE_MSG];

#endif /* CMDMSG_INCLUDED */
