

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.  *
*                                                                              *
*                Product: Rational(R) Test RealTime                            *
*                                                                              *
*      Product Component: System Testing Agent                                 *
*                                                                              *
*               Language: C                                                    *
*                                                                              *
*        Product version: 2003.06.00                                           *
*                                                                              *
*                   File: cmdagtp.h                                            *
*                                                                              *
* Rational, the Rational logo are registered trademarks of                     *
* Rational Software Corporation.                                               *
*                                                                              *
* The placing of the copyright notices on Rational source code is not          *
* intended to mean that they are published works, but are included in the      *
* event of inadvertent publication. The source code of Rational contains       *
* trade secrets and other valuable confidential information of Rational        *
* Software Corporation. Rational Software Corporation and its licensors        *
* retain ownership to Rational Products in both source and object code         *
* format, and related documentation and all rights therein including           *
* copyrights, patents and trade secrets.                                       *
*                                                                              *
*                                                                              *
* U.S. Government Rights                                                       *
*                                                                              *
* Use, duplication, or disclosure by the U.S. Government is subject to         *
* restrictions set forth in the applicable Rational License Agreement          *
* and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   *
* 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         *
* or FAR 52.227-14, as applicable.                                             *
*                                                                              *
* Unless otherwise agreed to in writing, use of Rational products is           *
* governed by the Rational Product License Agreement provided with             *
* the product.                                                                 *
*******************************************************************************/
/* Definition du contexte du module */
typedef struct
{
  T_BOOLEAN notinit;
  
  /* Compte le nombre de processus lances */
  T_ENTIER  nb_proc;
  T_ENTIER  taille_tab_proc;
    T_PROC_SURV *tab_proc;
  
  /* autorisation d'acces */
    T_BOOLEAN autorise;
  PT_CAR    machine;
} T_PRIVATE_CONTEXTE_CMDAGT, *PT_PRIVATE_CONTEXTE_CMDAGT;

typedef struct {
 PT_CAR libelle;
 T_ENTIER long_lib;
 atwstr *(*cmd) PP ((PT_REF_CONTEXT, 
		     PT_PRIVATE_CONTEXTE_CMDAGT, 
		    PT_CAR));
 PT_CAR help;
} T_COMMANDE, *PT_COMMANDE;

/* Attention lien de nombre avec tableau defini dans <cmdagt.c> */
#define K_CMD_NBRE_INDEX 33 /* sly (old = 27) */

#define K_MARQUEUR_ENV '$'
#define K_CMD_NB_CMD_PAR_LIGNE_HELP 8
#define K_CMD_CARACTERE_AFFECTATION_ENV '='

static atwstr *p_CMDcwd PP (( PT_REF_CONTEXT, 
			      PT_PRIVATE_CONTEXTE_CMDAGT, 
			      PT_CAR ));
static atwstr *p_CMDdelf PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDdenv PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDexec PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDftpa PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDftpb PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDgenv PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDgetf PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDhelo PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDhelp PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDmkd PP (( PT_REF_CONTEXT, 
			      PT_PRIVATE_CONTEXTE_CMDAGT, 
			      PT_CAR ));

static atwstr *p_CMDpdynf PP (( PT_REF_CONTEXT, 
			        PT_PRIVATE_CONTEXTE_CMDAGT, 
			        PT_CAR ));
static atwstr *p_CMDpisnd PP (( PT_REF_CONTEXT,
				PT_PRIVATE_CONTEXTE_CMDAGT,
				PT_CAR ));
static atwstr *p_CMDptout PP (( PT_REF_CONTEXT,
				PT_PRIVATE_CONTEXTE_CMDAGT,
				PT_CAR ));
static atwstr *p_CMDpavai PP (( PT_REF_CONTEXT,
				PT_PRIVATE_CONTEXTE_CMDAGT,
				PT_CAR ));

static atwstr *p_CMDpftp PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDport PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDprdv PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDputf PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDpwd PP (( PT_REF_CONTEXT, 
			      PT_PRIVATE_CONTEXTE_CMDAGT, 
			      PT_CAR ));
static atwstr *p_CMDquit PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDrmd PP (( PT_REF_CONTEXT, 
			      PT_PRIVATE_CONTEXTE_CMDAGT, 
			      PT_CAR ));
static atwstr *p_CMDrvko PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDrvok PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));

static atwstr *p_CMDdfko PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDdfok PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));

static atwstr *p_CMDsenv PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDstat PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDstop PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDtron PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDtrof PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
static atwstr *p_CMDtrwa  PP (( PT_REF_CONTEXT, 
				PT_PRIVATE_CONTEXTE_CMDAGT, 
				PT_CAR ));
static atwstr *p_CMDjef  PP (( PT_REF_CONTEXT, 
			       PT_PRIVATE_CONTEXTE_CMDAGT, 
			       PT_CAR ));
