

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.  *
*                                                                              *
*                Product: Rational(R) Test RealTime                            *
*                                                                              *
*      Product Component: System Testing Agent                                 *
*                                                                              *
*               Language: C                                                    *
*                                                                              *
*        Product version: 2003.06.00                                           *
*                                                                              *
*                   File: fs_agt.h                                             *
*                                                                              *
* Rational, the Rational logo are registered trademarks of                     *
* Rational Software Corporation.                                               *
*                                                                              *
* The placing of the copyright notices on Rational source code is not          *
* intended to mean that they are published works, but are included in the      *
* event of inadvertent publication. The source code of Rational contains       *
* trade secrets and other valuable confidential information of Rational        *
* Software Corporation. Rational Software Corporation and its licensors        *
* retain ownership to Rational Products in both source and object code         *
* format, and related documentation and all rights therein including           *
* copyrights, patents and trade secrets.                                       *
*                                                                              *
*                                                                              *
* U.S. Government Rights                                                       *
*                                                                              *
* Use, duplication, or disclosure by the U.S. Government is subject to         *
* restrictions set forth in the applicable Rational License Agreement          *
* and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   *
* 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         *
* or FAR 52.227-14, as applicable.                                             *
*                                                                              *
* Unless otherwise agreed to in writing, use of Rational products is           *
* governed by the Rational Product License Agreement provided with             *
* the product.                                                                 *
*******************************************************************************/
/*******************************************************************************
*
*% Module        FS_AGT
*
*                Identification
*                --------------
*
*% Version       $Revision: 1.10 $
*% Auteur        $Author: build $
*% Date          $Date: 2007/01/16 14:12:50 $
*
*% Description
*    Gestion des repertoires
*% Fdescription
*
*                Ressources exportees
*                --------------------
* % Exportee, TCPIPinit, T_ENTIER, Initialisation de la librairie
*******************************************************************************/

#ifndef FS_AGT
#define FS_AGT

/* A DEFINIR DANS LE SOURCE L'UTILISANT
 * #include "cstsyst.h"
 * #include "atwstr.h"
 * #include "ctxagt.h"
 */


extern T_RETURN		FSinit		PP ((PT_REF_CONTEXT refContext,
					     T_BOOLEAN en_serveur));
extern T_RETURN		FSfin		PP ((PT_REF_CONTEXT refContext));

/*
 * Gestion des repertoires 
 */

#ifndef NO_FILE_SYSTEM
extern T_RETURN		FSchdir		PP ((PT_REF_CONTEXT refContext,
					     PT_CAR nom_repertoire));
extern atwstr*		FSgetcwd	PP ((PT_REF_CONTEXT refContext));
extern T_RETURN		FSunlink	PP ((PT_REF_CONTEXT refContext,
					     PT_CAR nom_fichier));

extern T_RETURN		FSmkdir		PP ((PT_REF_CONTEXT refContext,
					     PT_CAR nom_repertoire));

extern T_RETURN		FSrmdir		PP ((PT_REF_CONTEXT refContext,
					     PT_CAR nom_repertoire));
#endif /* NO_FILE_SYSTEM */

/*
 * Gestion des transferts de fichier 
 */

#ifndef NO_FTP
extern void		FSsetmodascii	PP ((PT_REF_CONTEXT refContext));
extern void		FSsetmodbin	PP ((PT_REF_CONTEXT refContext));
extern T_ENTIER		FSgetportftp	PP ((PT_REF_CONTEXT refContext));
#endif /* NO_FTP */

/* Transfert de fichiers en mode serveur */
#ifndef NO_FTP
extern T_RETURN		FSputf		PP ((PT_REF_CONTEXT refContext,
					     PT_CAR nom_fichier));
extern T_RETURN		FSgetf		PP ((PT_REF_CONTEXT refContext,
					     PT_CAR nom_fichier));
#endif /* NO_FTP */

/* Transfert de fichiers en mode client */
#ifndef NO_FTP
extern T_RETURN		FSputf_to	PP ((PT_REF_CONTEXT refContext,
					     PT_CAR	nom_fichier,
					     PT_CAR	machine,
					     PT_CAR	service,
					     T_ENTIER	port));
extern T_RETURN		FSgetf_from	PP ((PT_REF_CONTEXT refContext,
					     PT_CAR	nom_fichier, 
					     PT_CAR	machine,
					     PT_CAR	service,
					     T_ENTIER	port));
#endif /* NO_FTP */

extern T_RETURN	FSestExecutable 	PP ((PT_REF_CONTEXT refContext,
					     PT_CAR	commande,
					     PT_CAR	chemins,
					     T_CAR	separateur_repertoire,
					     T_CAR	separateur_chemin,
					     T_BOOLEAN*	est_executable,
					     T_BOOLEAN*	est_dans_lun_des_chemins));
#ifndef AGT_CUSTOM
#define CSTfopen fopen
#define CSTfclose fclose
#define CSTfeof feof
#endif
#endif /* FS_AGT */








