

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.  *
*                                                                              *
*                Product: Rational(R) Test RealTime                            *
*                                                                              *
*      Product Component: System Testing Agent                                 *
*                                                                              *
*               Language: C                                                    *
*                                                                              *
*        Product version: 2003.06.00                                           *
*                                                                              *
*                   File: proagt.h                                             *
*                                                                              *
* Rational, the Rational logo are registered trademarks of                     *
* Rational Software Corporation.                                               *
*                                                                              *
* The placing of the copyright notices on Rational source code is not          *
* intended to mean that they are published works, but are included in the      *
* event of inadvertent publication. The source code of Rational contains       *
* trade secrets and other valuable confidential information of Rational        *
* Software Corporation. Rational Software Corporation and its licensors        *
* retain ownership to Rational Products in both source and object code         *
* format, and related documentation and all rights therein including           *
* copyrights, patents and trade secrets.                                       *
*                                                                              *
*                                                                              *
* U.S. Government Rights                                                       *
*                                                                              *
* Use, duplication, or disclosure by the U.S. Government is subject to         *
* restrictions set forth in the applicable Rational License Agreement          *
* and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   *
* 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         *
* or FAR 52.227-14, as applicable.                                             *
*                                                                              *
* Unless otherwise agreed to in writing, use of Rational products is           *
* governed by the Rational Product License Agreement provided with             *
* the product.                                                                 *
*******************************************************************************/
/******************************************************************************
*
*% Module        ENVAGT
*
*                Identification
*                --------------
*
*% Version       $Revision: 1.8 $
*% Auteur        $Author: build $
*% Date          $Date: 2007/01/16 14:12:50 $
*
*% Description
*    Traitement des processus.
*% Fdescription
*
*                Ressources exportees
*                --------------------
* % Exportee, TCPIPinit, T_ENTIER, Initialisation de la librairie
******************************************************************************/

#ifndef PROAGT_INCLUDED
#define PROAGT_INCLUDED


/* A DEFINIR DANS LE SOURCE L'UTILISANT
 * #include "cstsyst.h"
 */

/* Constante du modules */
#define K_CODE_EXEC_FAILD	127	/* Pour se comporter comme system() */

/* Identifiant des processus */
typedef int T_PROCESSUS;
typedef struct {T_PROCESSUS identifiant; T_ENTIER etat;} T_PROC_SURV;
typedef T_PROC_SURV* PT_PROC_SURV;

/* Liste des differents etats d'un processus */
typedef enum { PRO_INCONNU = -1, PRO_ENCOURS = 0, PRO_TERMINE = 1} T_ETATPROC;

/* Initialisation & liberation des ressources de la librairie */
extern T_RETURN		PROinit			PP ((PT_REF_CONTEXT refContext));
extern T_RETURN		PROfin			PP ((PT_REF_CONTEXT refContext));

/* Ensemble des fonctions permettant la manipulation des processus */
extern T_PROCESSUS	PROcree_proc		PP ((PT_REF_CONTEXT refContext,
						     PT_CAR commande));
extern T_ETATPROC	PROetat			PP ((PT_REF_CONTEXT refContext,
						     T_PROCESSUS identifiant,
						     PT_ENTIER etat_proc));
extern T_RETURN		PROstop			PP ((PT_REF_CONTEXT refContext,
						     T_PROCESSUS identifiant,
						     PT_ENTIER etat_sortie));
extern T_ENTIER		PROsurveille		PP ((PT_REF_CONTEXT refContext,
						     PT_PROC_SURV procfinis));
extern void		PROactive_trace		PP ((PT_REF_CONTEXT refContext));
extern void		PROdesactive_trace	PP ((PT_REF_CONTEXT refContext));
extern T_RETURN		PROetablie_trace	PP ((PT_REF_CONTEXT refContext));
extern T_RETURN 	PROport_de_trace 	PP ((PT_REF_CONTEXT refContext));
#endif /*PROAGT_INCLUDED */ 
