

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.  *
*                                                                              *
*                Product: Rational(R) Test RealTime                            *
*                                                                              *
*      Product Component: System Testing Agent                                 *
*                                                                              *
*               Language: C                                                    *
*                                                                              *
*        Product version: 2003.06.00                                           *
*                                                                              *
*                   File: tcpip.h                                              *
*                                                                              *
* Rational, the Rational logo are registered trademarks of                     *
* Rational Software Corporation.                                               *
*                                                                              *
* The placing of the copyright notices on Rational source code is not          *
* intended to mean that they are published works, but are included in the      *
* event of inadvertent publication. The source code of Rational contains       *
* trade secrets and other valuable confidential information of Rational        *
* Software Corporation. Rational Software Corporation and its licensors        *
* retain ownership to Rational Products in both source and object code         *
* format, and related documentation and all rights therein including           *
* copyrights, patents and trade secrets.                                       *
*                                                                              *
*                                                                              *
* U.S. Government Rights                                                       *
*                                                                              *
* Use, duplication, or disclosure by the U.S. Government is subject to         *
* restrictions set forth in the applicable Rational License Agreement          *
* and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   *
* 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         *
* or FAR 52.227-14, as applicable.                                             *
*                                                                              *
* Unless otherwise agreed to in writing, use of Rational products is           *
* governed by the Rational Product License Agreement provided with             *
* the product.                                                                 *
*******************************************************************************/
/******************************************************************************
*
*% Module        TCPIP
*
*                Identification
*                --------------
*
*% Version       $Revision: 1.8 $
*% Auteur        $Author: build $
*% Date          $Date: 2007/01/16 14:12:50 $
*
*% Description
*    Encapsulation des fonctions de la couche de communication TCPIP 
*% Fdescription
*
*                Ressources exportees
*                --------------------
* % Exportee, TCPIPinit, T_ENTIER, Initialisation de la librairie
******************************************************************************/

#ifndef TCPIP_INCLUDED
#define TCPIP_INCLUDED

/* A DEFINIR DANS LE SOURCE L'UTILISANT
 * #include "cstsyst.h"
 * #include "atwstr.h"
 * #include "ctxagt.h"
 */

/* Definition des differents types de prise de communication */
/* Communication en mode connecte */
typedef int		T_SOCKET_STREAM,	* PT_SOCKET_STREAM;

/* Communication en mode non connecte */
typedef int		T_SOCKET_DGRAM,		* PT_SOCKET_DGRAM;

typedef union 
{
  T_SOCKET_STREAM	stream;
  T_SOCKET_DGRAM	dgram;
  T_ENTIER		masque;
}			T_SOCKET,		* PT_SOCKET;

/* Ensemble des fonctions communes a tous les modes de communication */
extern T_RETURN		TCPIPinit			PP ((
				PT_REF_CONTEXT		refContext)) ;
/* MODIF BCORMIER : seems not to be used */
/*
#ifdef VXWORKS
extern T_RETURN		TCPIPclone			PP ((
				PT_REF_CONTEXT		refContext)) ;
#endif 
*/
extern T_RETURN		TCPIPfin			PP ((
				PT_REF_CONTEXT		refContext)) ;
extern T_ENTIER		TCPIPsurveille_sockets		PP ((
				PT_REF_CONTEXT		refContext,
				PT_SOCKET*		sockets_a_lires,
				T_ENTIER		duree_ms)) ;

/* Ensemble des fonctions de gestion des communications TCP.
 * C'est a dire toutes celles en mode connecte.
 */
extern T_SOCKET_STREAM	TCPIPsocket_stream		PP ((
				PT_REF_CONTEXT		refContext)) ;
extern T_SOCKET_STREAM	TCPIPsocket_named_stream	PP ((
				PT_REF_CONTEXT		refContext,
				PT_CAR			machine,
				PT_CAR			service,
				PT_ENTIER		port	)) ;
extern T_ENTIER		TCPIPport_stream		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_STREAM		socket	)) ;
extern T_RETURN		TCPIPabonne_stream		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_STREAM		sock	)) ;
extern T_RETURN		TCPIPdesabonne_stream		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_STREAM		sock	)) ;
extern T_RETURN		TCPIPaccept_stream		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_STREAM		sock_serveur, 
				PT_SOCKET_STREAM	sock_client,
				PT_CAR			machine,
				PT_ENTIER		port_client)) ;
extern T_RETURN		TCPIPconnect_stream		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_STREAM		sock, 
				PT_CAR			machine,
				PT_CAR			service,
				T_ENTIER		port	)) ;
extern atwstr*		TCPIPnomMachineCliente_stream	PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_STREAM		sock	)) ;
extern T_RETURN		TCPIPsend_stream		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_STREAM		sock, 
				void*			buffer,
				PT_ENTIER		buffer_lg)) ;
extern T_ENTIER		TCPIPrecv_texte_stream		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_STREAM		sock, 
				atwstr**		buffer,
				T_BOOLEAN*		est_deconnecte)) ;
extern T_ENTIER		TCPIPrecv_buffer_stream		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_STREAM		sock, 
				void*			buffer,
				T_ENTIER		taille_buffer,
				T_BOOLEAN*		est_deconnecte)) ;
extern T_RETURN		TCPIPclose_stream		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_STREAM		sock	)) ;

/* Ensemble des fonctions de gestion des communications UDP.
 * C'est a dires toutes celle en mode non connecte (datagramme).
 */
extern T_SOCKET_DGRAM	TCPIPsocket_dgram		PP ((
				PT_REF_CONTEXT		refContext)) ;
extern T_SOCKET_DGRAM	TCPIPsocket_named_dgram		PP ((
				PT_REF_CONTEXT		refContext,
				PT_CAR			machine,
				PT_CAR			service,
				PT_ENTIER		port	)) ;
extern T_ENTIER		TCPIPport_dgram			PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_DGRAM		socket	)) ;
extern T_RETURN		TCPIPabonne_dgram		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_DGRAM		sock	)) ;
extern T_RETURN		TCPIPdesabonne_dgram		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_DGRAM		sock	)) ;
extern T_RETURN		TCPIPsendto_dgram		PP ((
				PT_REF_CONTEXT		refContext,
				T_SOCKET_DGRAM		sock, 
				void*			buffer,
				PT_ENTIER		buffer_lg,
				PT_CAR			machine_dest,
				T_ENTIER		port_dest)) ;
extern T_ENTIER		TCPIPrecvfrom_texte_dgram	PP ((	
				PT_REF_CONTEXT		refContext,
				T_SOCKET_DGRAM		sock, 
				atwstr**		buffer,
				PT_CAR			machine_orig,
				PT_ENTIER		port_orig)) ;
extern T_RETURN		TCPIPclose_dgram		PP ((	
				PT_REF_CONTEXT		refContext,
				T_SOCKET_DGRAM		sock	));

#endif /* TCPIP_INCLUDED */


