

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.  *
*                                                                              *
*                Product: Rational(R) Test RealTime                            *
*                                                                              *
*      Product Component: System Testing Agent                                 *
*                                                                              *
*               Language: C                                                    *
*                                                                              *
*        Product version: 2003.06.00                                           *
*                                                                              *
*                   File: cmd_msg.c                                            *
*                                                                              *
* Rational, the Rational logo are registered trademarks of                     *
* Rational Software Corporation.                                               *
*                                                                              *
* The placing of the copyright notices on Rational source code is not          *
* intended to mean that they are published works, but are included in the      *
* event of inadvertent publication. The source code of Rational contains       *
* trade secrets and other valuable confidential information of Rational        *
* Software Corporation. Rational Software Corporation and its licensors        *
* retain ownership to Rational Products in both source and object code         *
* format, and related documentation and all rights therein including           *
* copyrights, patents and trade secrets.                                       *
*                                                                              *
*                                                                              *
* U.S. Government Rights                                                       *
*                                                                              *
* Use, duplication, or disclosure by the U.S. Government is subject to         *
* restrictions set forth in the applicable Rational License Agreement          *
* and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   *
* 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         *
* or FAR 52.227-14, as applicable.                                             *
*                                                                              *
* Unless otherwise agreed to in writing, use of Rational products is           *
* governed by the Rational Product License Agreement provided with             *
* the product.                                                                 *
*******************************************************************************/
#ifndef AGT_CUSTOM
static char WHAT_LINE[] = "@(#)cmd_msg $Revision: 1.13 $ $Date: 2007/01/16 14:12:51 $";
#endif

/*********************************************************************
 *                                                                   *
 *% Module  CMD_MSG                                                  *
 *                                                                   *
 *                         Identification                            *
 *                         --------------                            *
 *% Version $Revision: 1.13 $                                         *
 *% Auteur  Jean-Francois Marronnier                                 *
 *% Date    $Date: 2007/01/16 14:12:51 $                             *
 *                                                                   *
 *% Description                                                      *
 *    Messages renvoyes par l'agent au superviseur                   *
 *% Fdescription                                                     *
 *                                                                   *
 *********************************************************************/

#ifndef AGT_CUSTOM
#include "cstsyst.h"
#else
#include "agtconf.h"
#endif

#include "cmd_msg.h"

/*
 * The reply of the agent  consists of three-digit number, a space, some
 * text, and an end of line. The first digit of the message indicates
 * whether the reply is good, bad, or incomplete.
 * Five values exist for the first digit.  The values and the interpretations
 * of the values are:
 *
 *         1       The requested action is being initiated; expect another
 *                 reply before proceeding with a new command.
 *
 *         2       The requested action is complete.  The server is ready
 *                 for a new request.
 *
 *         3       The command has been accepted, but the requested action
 *                 requires more information.
 *
 *         4       The command was not accepted, the requested action
 *                 failed, but the error condition is temporary and the
 *                 action can be requested again.
 *
 *         5       The command was not accepted, the requested action
 *                 failed, and the error condition would most likely occur
 *                 again if the same command sequence is repeated.
 *
 * The second digit indicates the functional area that the message
 * addresses.  The values of the second digit and the interpretations of
 * these values are:
 *
 *         0       Syntax.  A message with a 0 for the second digit
 *                 indicates that a syntax error occurred.
 *
 *         1       Information.  A message with a 1 as the second digit
 *                 indicates that the message is in reply to a request for
 *                 information.
 *
 *         2       Connections.  A message with a 2 as the second digit
 *                 indicates that the message is a reply to a request for
 *                 control and data connection information.
 *
 *         3       Authentication and accounting.  A message with a 3 as the
 *                 second digit indicates that the message is a reply to a
 *                 login or accounting procedure.
 *
 *         4       System action. A message with a 4  as the second digit
 *                 indicates that the message is a system error or information.
 *
 *         5       File system.  A message with a 5 as the second digit
 *                 indicates that the text following the number contains
 *                 information concerning the status of the server file
 *                 system.
 *
 * The third digit provides a further clarification of the information
 * supplied by the second digit.  Following are several examples of
 *
 */

/* Ensemble des messages retournes par les commandes */
PT_CAR    g_chaine_ret[K_CMD_NBRE_MSG] =
{
  "110 the known commands are :",

  "210 hello, please to meet you.",
  "210 no help.",
  "211 getenv result : ",
  "212 setenv succeeded",
  "213 unsetenv succeeded",
  "221 bye.",
  "222 TRACE port : ",
  "223 trace off",
  "224 trace on",
  "225 trace port established",
  "226 FTP port : ",
  "227 transfer mode set to ASCII",
  "228 transfer mode set to BINARY",
  "230 (end of transfered) file sent",
  "231 (end of transfered) file received",
  "232 file deleted",
  "240 RDV port : ",
  "241 DYNF port : ",
  "251 directory changed",
  "252 directory created",
  "253 the current directory is :",
  "254 directory removed",
  "261 child process launched : ",
  "263 process has ended : ",
  "264 process is running : ",
  "265 child process killed : ",

  "310 access authorized.",

  "410 I can't give you help. This command is unknown.",
  "411 GENV need a variable name as parameter",
  "412 SENV need a parameter \"variable_name=value\"",
  "413 SENV need a value for the variable",
  "414 DENV need a parameter \"variable_name\"",
  "430 GETF wait filename as parameter",
  "431 PUTF wait filename as parameter",
  "432 DELF wait filename as parameter",
  "451 CWK wait a directory name as parameter",
  "452 MDK wait a directory name as parameter",
  "454 RMD wait a directory name as parameter",
  "461 EXEC wait a command as parameter",
  "463 STAT need process number as parameter",
  "464 STOP need process number as parameter",

  "500 command unknown : ",
  "501 Not implemented.",
  "511 getenv failed",
  "512 setenv failed",
  "513 unsetenv failed",
  "522 INTERNAL ERROR: No trace port",
  "525 establish trace port failed",
  "526 INTERNAL ERROR : No ftp port",
  "530 send file failed",
  "531 receive file failed",
  "532 delete file failed",
  "533 user is not allowed to connect",
  "540 INTERNAL ERROR : No rdv port",
  "541 INTERNAL ERROR : No dynf port",
  "551 CWD failed",
  "552 MKD failed",
  "553 PWD failed",
  "554 RMD failed",
  "561 EXEC process failed",
  "563 STAT failed",
  "564 STOP process failed",
  "570 INTERNAL ERROR : CMD not initialized!",
  "580 INTERNAL ERROR : RDV accept failed!",
  "581 INTERNAL ERROR : RDV recv failed!",
  "582 INTERNAL ERROR : RDV failed on a memory allocation !!!",
  "590 INTERNAL ERROR : DYNF accept failed!",
  "591 INTERNAL ERROR : DYNF boot recv failed!",
  "592 INTERNAL ERROR : DYNF line recv failed!",
  "593 INTERNAL ERROR : DYNF end recv failed!",

  "601 wait rendezvous : ",
  "602 quit rendezvous : ",
  "603 error on rendezvous : ",
  "661 process stopped : ",

  "700 boot dynfollow : ",
  "701 line dynfollow : ",
  "702 end dynfollow : ",

  "703 tsf notify dynfollow : ",
  "704 tsf declareinstance dynfollow : ",
  "705 tsf synchro dynfollow : ",
  "706 tsf send_message dynfollow : ",
  "707 tsf waittil_message dynfollow : ",
  "708 tsf intersend_message dynfollow : ",
  "709 tsf interrecv_message dynfollow : ",

  "710 tester disconnected dynfollow : ",

  "711 tsf begin_waittil dynfollow : ",
  "712 tsf end_waittil dynfollow : ",
  "713 tsf inittermexcept_block dynfollow : ",

  "720 INTERSEND : ",
  "721 INTERRECV : ",
  "722 timeout request : ",

  "800 tester asks for studio availability : ",
  "801 studio asks for stop : "
};
