

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.  *
*                                                                              *
*                Product: Rational(R) Test RealTime                            *
*                                                                              *
*      Product Component: System Testing Agent                                 *
*                                                                              *
*               Language: C                                                    *
*                                                                              *
*        Product version: 2003.06.00                                           *
*                                                                              *
*                   File: cmdagt.c                                             *
*                                                                              *
* Rational, the Rational logo are registered trademarks of                     *
* Rational Software Corporation.                                               *
*                                                                              *
* The placing of the copyright notices on Rational source code is not          *
* intended to mean that they are published works, but are included in the      *
* event of inadvertent publication. The source code of Rational contains       *
* trade secrets and other valuable confidential information of Rational        *
* Software Corporation. Rational Software Corporation and its licensors        *
* retain ownership to Rational Products in both source and object code         *
* format, and related documentation and all rights therein including           *
* copyrights, patents and trade secrets.                                       *
*                                                                              *
*                                                                              *
* U.S. Government Rights                                                       *
*                                                                              *
* Use, duplication, or disclosure by the U.S. Government is subject to         *
* restrictions set forth in the applicable Rational License Agreement          *
* and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   *
* 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         *
* or FAR 52.227-14, as applicable.                                             *
*                                                                              *
* Unless otherwise agreed to in writing, use of Rational products is           *
* governed by the Rational Product License Agreement provided with             *
* the product.                                                                 *
*******************************************************************************/
#ifndef AGT_CUSTOM
static char WHAT_LINE[] = "@(#)cmdagt $Revision: 1.26 $ $Date: 2007/01/16 14:12:51 $";
#endif

/*********************************************************************
 *                                                                   *
 *% Module  CMDAGT                                                   *
 *                                                                   *
 *                         Identification                            *
 *                         --------------                            *
 *% Version $Revision: 1.26 $                                         *
 *% Auteur  Jean-Francois Marronnier                                 *
 *% Date    $Date: 2007/01/16 14:12:51 $                               *
 *                                                                   *
 *% Description                                                      *
 *    Execution des commandes transmises a l'agent par le superviseur*
 *% Fdescription                                                     *
 *                                                                   *
 *********************************************************************/

/* Inclusion des entetes standards SystemTest */
#include "atwstr.h"


#ifdef HP
#include <ctype.h>
#endif

#ifndef AGT_CUSTOM
#include "cstsyst.h"
#else
#include "agtconf.h"
#endif

#ifndef display
#define display(a)
#endif

#ifdef NO_ENV_VAR
#include "glob.h"
#endif

#include "ctxagt.h"
#include "tcpip.h"

/* Inclusion de l'entete du module */
#include "cmdagt.h"

/* Liste des messages utilises pour les reponses des commandes */
#include "cmd_msg.h"

/* Lien avec les sous-modules utilises */
#include "envagt.h"
#include "fs_agt.h"
#include "proagt.h"
#include "rdvagt.h"
#include "dynfagt.h"

#include "scuagt.h"

#include "cmdagtp.h"

/* Liste des commandes traitees par l'agent */
T_COMMANDE liste_commandes[K_CMD_NBRE_INDEX] =
{
  /* Rappel: Les champs composants une commande sont :
   *    libelle : libelle de l'instruction ;
   *    long_lib: longueur (en nb de caracteres) du libelle ;
   *    cmd     : fonction de traitement de la commande ;
   *    help    : message d'aide de la commande.
   */
  {"CWD", 3, p_CMDcwd, "210 change working directory : CWD directory-name"},
  {"DELF", 4, p_CMDdelf, "210 delete a file : DELF filename"},
  {"DENV", 4, p_CMDdenv, "210 delete an environement variable : DENV varname"},
  {"EXEC", 4, p_CMDexec, "210 execute command : EXEC filename"},
  {"FTPA", 4, p_CMDftpa, "210 set ASCII transfer mode"},
  {"FTPB", 4, p_CMDftpb, "210 set BINARY transfer mode"},
  {"GENV", 4, p_CMDgenv, "210 get environment variable : GENV varname"},
  {"GETF", 4, p_CMDgetf, "210 get file : GETF filename"},
  {"HELO", 4, p_CMDhelo, NULL},
  {"HELP", 4, p_CMDhelp, "210 help : HELP [command]"},
  {"MKD", 3, p_CMDmkd, "210 create a directory : MKD directory-name"},

  {"PDYN", 4, p_CMDpdynf, "210 return dynfollow port"},
  {"ISND", 4, p_CMDpisnd, "210 lower INTERSEND instruction"},
  {"TOUT", 4, p_CMDptout, "210 lower timeout value"},
  {"AVAI", 4, p_CMDpavai, "210 lower studio link availibility"},

  {"PFTP", 4, p_CMDpftp, "210 return ftp port"},
  {"PORT", 4, p_CMDport, "210 return trace port"},
  {"PRDV", 4, p_CMDprdv, "210 return rendezvous port"},
  {"PUTF", 4, p_CMDputf, "210 put a file : PUTF file-name"},
  {"PWD", 3, p_CMDpwd, "210 print working directory"},
  {"QUIT", 4, p_CMDquit, NULL},
  {"RMD", 3, p_CMDrmd, "210 remove directory : RMD directory-name"},
  {"RVKO", 4, p_CMDrvko, "210 refuse rendezvous: RVKO rendezvous-name"},
  {"RVOK", 4, p_CMDrvok, "210 accept rendezvous : RVOK rendezvous-name"},

  {"DFKO", 4, p_CMDdfko, "210 reject dynflw : DFKO tester_id"},
  {"DFOK", 4, p_CMDdfok, "210 accept dynflw : DFOK tester_id"},

  {"SENV", 4, p_CMDsenv, "210 set environment variable : SENV varname=value"},
  {"STAT", 4, p_CMDstat, "210 return process status : STAT process-id"},
  {"STOP", 4, p_CMDstop, "210 stop process : STOP process-id"},
  {"TRON", 4, p_CMDtron, "210 turn trace on"},
  {"TROF", 4, p_CMDtrof, "210 turn trace off"},
  {"TRWA", 4, p_CMDtrwa, "210 wait for connexion on PORT"},
/*
 *  ATTENTION, Jef x2, cf fonction p_CMDexecute
 */
  {"Jef", 3, p_CMDjef, "210 Jef <user>"}
};

/******************************************************************************
*  NAME
*       Verifie si la chaine de caracteres passee en parametre definit un
*       nombre
*
*  ALGORITHME
*
******************************************************************************/
static T_BOOLEAN p_CMDest_numerique DP ((argument)) BP
          PT_CAR argument EP
{

  T_BOOLEAN est_numerique = TRUE;

  /*
   * L'identifiant est-il defini ?
   */
  if (*argument == '\0')
    {
      est_numerique = FALSE;
    }

  /*
   * Est-il un nombre ?
   */
  while ((*argument != '\0') && est_numerique)
    {
      if (!(isdigit ((int)*argument)))
        {
          est_numerique = FALSE;
        }
      else
        {
          /* Caractere suivant */
          argument++;
        }
    }

  return (est_numerique);
}

/******************************************************************************
*  NAME
*       Initialise le module
*
*  ALGORITHME
*
******************************************************************************/
T_RETURN CMDinit DP ((ContexteRef, machine)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_CAR machine EP
{
  T_ENTIER  index;
  PT_PRIVATE_CONTEXTE_CMDAGT contexte;
  T_BOOLEAN init_ok;

  if (ContexteRef != NULL)
    {
      contexte = (PT_PRIVATE_CONTEXTE_CMDAGT) CSTmalloc (sizeof (T_PRIVATE_CONTEXTE_CMDAGT));
    }
  else
    {
      return (SYSTEM_ERROR);
    }

  contexte->notinit = TRUE;
  contexte->nb_proc = 0;
  contexte->taille_tab_proc = 0;
  contexte->tab_proc = NULL;
  contexte->autorise = FALSE;
  contexte->machine = NULL;

  /*
   * Initilisation de tous les sous-modules...
   * Attention lors du calcul de init_ok, le init_ok doit etre place a
   * droite du && afin de s'assurer que la fonction placer a gauche est
   * executee dans tous les cas.
   */

  init_ok = (ENVinit (ContexteRef) == SYSTEM_OK);
  init_ok = (FSinit (ContexteRef, TRUE) == SYSTEM_OK) && init_ok;
  init_ok = (PROinit (ContexteRef) == SYSTEM_OK) && init_ok;

  if (init_ok)
    {
      contexte->nb_proc = 0;

      /* Initialisation du champ long_lib de chaque commande */
      for (index = 0; index < K_CMD_NBRE_INDEX; index++)
        {
          register T_ENTIER longueur;

          longueur = CSTstrlen (liste_commandes[index].libelle);
          liste_commandes[index].long_lib = longueur;
        }
      contexte->machine = machine;
      contexte->autorise = FALSE;
      contexte->notinit = FALSE;
      contexte->nb_proc = 0;
      contexte->taille_tab_proc = 0;
      contexte->tab_proc = NULL;

      CTXset (ContexteRef, (void *) contexte, CMDAGTD_CTX);

      {
#ifndef NO_ENV_VAR
	ENVputenv (ContexteRef, "ATS_AGT_BASEPWD", (p_CMDpwd(ContexteRef,contexte,'\0')+30) );
#else
#ifndef NO_FILE_SYSTEM
	strcpy(AgtGlobals.AGTbasepwd, (p_CMDpwd(ContexteRef,contexte,'\0')+30));
#else
	AgtGlobals.AGTbasepwd[0] = 0;
#endif
#endif
      }

      return (SYSTEM_OK);
    }
  else
    {
      /* Une erreur est survenue
       *    -> desinitialisation de tous les modules
       */

      (void) ENVfin (ContexteRef);
      (void) FSfin (ContexteRef);
      (void) PROfin (ContexteRef);

      M_CSTfree (contexte);

      return (SYSTEM_ERROR);
    }
}

/******************************************************************************
*  NAME
*       Desinitialise le module
*
*  ALGORITHME
*
******************************************************************************/
T_RETURN CMDfin DP ((ContexteRef)) BP
          PT_REF_CONTEXT ContexteRef EP
{
  T_RETURN  retour_ok;
  PT_PRIVATE_CONTEXTE_CMDAGT contexte;

  /*
   * Liberation de tous les sous-modules ...
   * Attention lors du caclul de retour_ok, le retour_ok doit etre place a
   * droite du && afin de s'assurer que la fonction placer a gauche est
   * executee dans tous les cas.
   */

  contexte = (PT_PRIVATE_CONTEXTE_CMDAGT) CTXget (ContexteRef, CMDAGTD_CTX);

  CTXset (ContexteRef, (void *) NULL, CMDAGTD_CTX);

  if ((contexte == NULL) || contexte->notinit)
    {
      return (SYSTEM_ERROR);
    }

  retour_ok = (T_RETURN) (ENVfin (ContexteRef) == SYSTEM_OK);

  retour_ok = (T_RETURN) ((FSfin (ContexteRef) == SYSTEM_OK) && retour_ok);

  retour_ok = (T_RETURN) ((PROfin (ContexteRef) == SYSTEM_OK) && retour_ok);

  /* Retour_ok est vrai si tous les modules se sont termines correctement */
  if (retour_ok)
    {
      /* Libere l'espace reserve pour le tableau de processus */
      if (contexte->tab_proc)
        {
          M_CSTfree (contexte->tab_proc);
        }
      M_CSTfree (contexte);
      return (SYSTEM_OK);
    }
  else
    {
      M_CSTfree (contexte);
      return (SYSTEM_ERROR);
    }
}

/******************************************************************************
*  NAME
*       Lance la surveillance du sous module PROAGT
*
*  ALGORITHME
*
******************************************************************************/
atwstr   *CMDsurveille DP ((ContexteRef)) BP
          PT_REF_CONTEXT ContexteRef EP
{
  int       nb_proc_termines;

  PT_PRIVATE_CONTEXTE_CMDAGT contexte;

  contexte = (PT_PRIVATE_CONTEXTE_CMDAGT) CTXget (ContexteRef, CMDAGTD_CTX);

  if ((contexte == NULL) || contexte->notinit)
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_INIT]));
    }

  if (contexte->nb_proc == 0)
    {
      return (NULL);
    }

  if (contexte->nb_proc > contexte->taille_tab_proc)
    {
      contexte->tab_proc = (PT_PROC_SURV)CSTrealloc (contexte->tab_proc, contexte->nb_proc * sizeof (T_PROC_SURV));
      contexte->taille_tab_proc = contexte->nb_proc;
    }

  /* Lance la surveillance des processus */
  if ((nb_proc_termines = PROsurveille (ContexteRef, contexte->tab_proc)) < 1)
    {
      /*
       * La surveillance n'a pas detectee la fin de processus
       */
      return (NULL);
    }
  else
    {
      /* Cree le message de reponse */
      T_CAR     nb[80];
      atwstr   *res;

      debug (CSTprintf ("~~~ surveille %d\n", nb_proc_termines));

      /* Le format de la reponse est le suivant :
       *        K_CMD_MSG_END nbre => id (etat)[, id (etat)]*
       * ou             nbre    : nombre de processus dont la fin est detectees
       *                id      : identifiant d'un processus termine
       *                etat    : etat REELLE de sortie du processus
       */

      /* Creation du debut du message resultat et insertion du nombre de
       * de processus termine.
       */
      CSTsprintf (nb, "%%%d => ", nb_proc_termines);
      res = atwstrClone (g_chaine_ret[K_CMD_MSG_PROC_END]);
      res = atwstrAppend (res, nb);

      /* Decompte les processus termines du compte global */
      contexte->nb_proc -= nb_proc_termines;

      /* Insertion des etats de sorties de tous les processus detectes */
      while (nb_proc_termines-- > 0)
        {
          T_TABCAR  pid;

          CSTsprintf (pid,
                      "%%%d (%%%d)",
                      contexte->tab_proc[nb_proc_termines].identifiant,
                      contexte->tab_proc[nb_proc_termines].etat
            );
          res = atwstrAppend (res, pid);

          /* Ajoute le separateur des etats s'il reste des processus a
           * inserer.
           * nb_proc_termines = index du prochain processus. Comme le tableau
           * est parcouru de la fin vers le debut, le dernier processus est
           * celui place en position 0
           */
          if (nb_proc_termines)
            {
              res = atwstrAppend (res, ", ");
            }
        }

      /* Fin de traitement */
      return (res);
    }
}

/******************************************************************************
*  NAME
*       Traduit la commande et execute le traitement correspondant
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDexecute DP ((ContexteRef, contexte, cmd, fin)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR cmd SP
          T_BOOLEAN * fin EP
{
  int       index = 0;
  PT_CAR    parametre;
  atwstr   *commande_a_traiter;
  atwstr   *message_resultat;
  atwstr   *result = NULL;

  debug (CSTprintf ("~~~ CMDexecute %s (%d)\n", cmd, fin));

#ifndef NO_ENV_VAR
  /* Traduit les variables d'environnement */
  commande_a_traiter = ENVevalue_env (ContexteRef, cmd, K_MARQUEUR_ENV);
#else
  commande_a_traiter = atwstrClone (cmd);
#endif

  /*
   *  ATTENTION, Jef x2, cf tableau liste_commandes
   */

  /* Controle de l'autorisation */
  if ((!contexte->autorise && (CSTstrncmp (commande_a_traiter, "Jef ", 4)) != 0)
      || (commande_a_traiter == NULL))
    {
      *fin = TRUE;
      return (NULL);
    }

  /*
   * Recherche la procedure correspondant a la commande saisie et lance son
   * execution.
   */
  do
    {
      /* Parcourt la table des commandes */
      if ((!CSTstrncmp (liste_commandes[index].libelle,
                        commande_a_traiter,
                        liste_commandes[index].long_lib))
          &&
          ((commande_a_traiter[liste_commandes[index].long_lib] == '\0')
           ||
           (commande_a_traiter[liste_commandes[index].long_lib] == ' ')
           ||
           (commande_a_traiter[liste_commandes[index].long_lib] == '\t')))
        {
          /*
           * Il n'y a pas de differences entre les chaines et celle-ci est
           * terminee soit par la fin de la ligne
           * soit par un espace en separateur de parametre.
           *    -> Instruction trouvee
           */

          parametre = commande_a_traiter + liste_commandes[index].long_lib;
          if (*parametre != '\0')
            {
              /*
               * Le parametre est defini -> on saute le separateur
               */
              parametre++;
              /*
               * on saute blanc et espace
               */
              while ((*parametre != '\0') &&
                     ((*parametre == ' ') ||
                      (*parametre == '\t')))
                {
                  parametre++;
                }
            }

          /*
           * APPEL DE LA COMMANDE
           */
          result = liste_commandes[index].cmd (ContexteRef, contexte, parametre);

          *fin = (((void *) liste_commandes[index].cmd) == ((void *) p_CMDquit))
            || (!contexte->autorise);

          /* Fin de traitement de la commande */
          return (result);
        }
      /* On passe a la commande suivante */
      index++;
    }
  while (index < K_CMD_NBRE_INDEX);

  /*
   * La commande n'est pas trouvee !!! Sinon le "return" de fin de
   * traitement aurait ete atteind...
   */

  *fin = FALSE;

  message_resultat = atwstrClone (g_chaine_ret[K_CMD_MSG_INCONNUE]);
  message_resultat = atwstrAppend (message_resultat, commande_a_traiter);
  commande_a_traiter = atwstrDestroy (commande_a_traiter);

  return (message_resultat);
}

/******************************************************************************
*  NAME
*       Traduit la commande et execute le traitement correspondant
*
*  ALGORITHME
*
******************************************************************************/
atwstr   *CMDexecute DP ((ContexteRef, cmd, fin)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_CAR cmd SP
          T_BOOLEAN * fin EP
{
  PT_PRIVATE_CONTEXTE_CMDAGT contexte;

  contexte = (PT_PRIVATE_CONTEXTE_CMDAGT) CTXget (ContexteRef, CMDAGTD_CTX);

  if ((contexte == NULL) || contexte->notinit)
    {
      *fin = TRUE;
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_INIT]));
    }

  return (p_CMDexecute (ContexteRef, contexte, cmd, fin));
}

/******************************************************************************
*  NAME
*       Commande Jef
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDjef DP ((ContexteRef, contexte, user)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR user EP
{
#ifndef NO_SECURITY
  T_SECURITE securite;

  /* Lecture du fichier pour verification de l'identification */
  securite = SCUcree (ContexteRef, contexte->machine, K_NOM_FICHIER_AUTORISATION);

  contexte->autorise = SCUestAutorise (ContexteRef, &securite, user);
  SCUdetruit (ContexteRef, &securite);
  if (contexte->autorise)
    {
	  display(printf("%s %s #access granted\n",contexte->machine,user);)
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_ACCESS_OK]));
    }
  else
    {
	  display(printf("%s %s #access denied\n",contexte->machine,user);)
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_ACCESS_KO]));
    }
#else                           /* No acces control */
  contexte->autorise = TRUE;
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_ACCESS_OK]));
#endif                          /* No acces control */
}

/******************************************************************************
*  NAME
*       Commande CWD
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDcwd DP ((ContexteRef, contexte, repertoire)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR repertoire EP
{
#ifndef NO_FILE_SYSTEM
  if (*repertoire == '\0')
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_CWD_PAR]));
    }
  if (FSchdir (ContexteRef, repertoire) == SYSTEM_OK)
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_CWD_OK]));
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_CWD_KO]));
    }
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande DELF
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDdelf DP ((ContexteRef, contexte, nom_fichier)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR nom_fichier EP
{
#ifndef NO_FILE_SYSTEM
  if (*nom_fichier == '\0')
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_DELF_PAR]));
    }
  if (FSunlink (ContexteRef, nom_fichier) == SYSTEM_OK)
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_DELF_OK]));
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_DELF_KO]));
    }
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande DENV
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDdenv DP ((ContexteRef, contexte, variable)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR variable EP
{
#ifndef NO_ENV_VAR
  if (*variable == '\0')
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_DENV_PAR]));
    }
  if (ENVunsetenv (ContexteRef, variable) == SYSTEM_OK)
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_DENV_OK]));
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_DENV_KO]));
    }
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande EXEC
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDexec DP ((ContexteRef, contexte, cmd)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR cmd EP
{
  /* Lance l'execution de la commande precedant l'instruction EXEC, si
   * celle-ci est definie.
   */
  T_ENTIER  numero_proc = -1;
  PT_CAR    instruction;
  atwstr   *mesg_resultat;

  /* Cree la chaine reponse */
  mesg_resultat = atwstrCreate ();
  if (!mesg_resultat)
    {
      /* Echec lors de la creation de la chaine reponse */
      return (NULL);
    }

  /* Positionne le pointeur sur le nom de l'instruction */
  instruction = cmd;
  if (*instruction != '\0')
    {
      /* L'instruction est definie */
      if ((numero_proc = PROcree_proc (ContexteRef, instruction)) != -1)
        {
          /* L'execution de l'instruction a reussie. Creation du message
           * reponse.
           */
          T_CAR     pid[80];

          CSTsprintf (pid, "%%%d", numero_proc);

          mesg_resultat = atwstrAppend (mesg_resultat,
                                        g_chaine_ret[K_CMD_MSG_EXEC_OK]);
          mesg_resultat = atwstrAppend (mesg_resultat, pid);

          /* Comptabilise le nouveau procesus */
          contexte->nb_proc++;
        }
      else
        {
          /* Echec de creation du fils */
          mesg_resultat = atwstrAppend (mesg_resultat,
                                        g_chaine_ret[K_CMD_MSG_EXEC_KO]);
        }
    }
  else
    {
      /* La commande n'est pas definie !!! */
      mesg_resultat = atwstrAppend (mesg_resultat,
                                    g_chaine_ret[K_CMD_MSG_EXEC_PAR]);
    }
  return (mesg_resultat);
}

/******************************************************************************
*  NAME
*       Commande FTPA
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDftpa DP ((ContexteRef, contexte, leurre)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR leurre EP
{
#ifndef NO_FTP
  FSsetmodascii (ContexteRef);
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_FTPA_OK]));
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande FTPB
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDftpb DP ((ContexteRef, contexte, leurre)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR leurre EP
{
#ifndef NO_FTP
  FSsetmodbin (ContexteRef);
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_FTPB_OK]));
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande GENV
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDgenv DP ((ContexteRef, contexte, variable)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR variable EP
{
#ifndef NO_ENV_VAR
  atwstr   *val;
  atwstr   *rep;

  /* Cree la chaine reponse */
  rep = atwstrCreate ();
  if (!rep)
    {
      return (NULL);
    }

  if (*variable != '\0')
    {
      /* Recupere la valeur de la variable */
      if ((val = ENVgetenv (ContexteRef, variable)))
        {
          /* Construit le message de reponse */
          rep = atwstrAppend (rep, g_chaine_ret[K_CMD_MSG_GENV_OK]);
          rep = atwstrAppend (rep, variable);
          rep = atwstrAppend (rep, "=");
          rep = atwstrAppend (rep, val);
        }
      else
        {
          /* Construction du message d'erreur */
          rep = atwstrAppend (rep, g_chaine_ret[K_CMD_MSG_GENV_KO]);
        }
    }
  else
    {
      /* Le nom de la variable n'est pas definie !!! */
      rep = atwstrAppend (rep, g_chaine_ret[K_CMD_MSG_GENV_PAR]);
    }
  return (rep);
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande GETF
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDgetf DP ((ContexteRef, contexte, nom_fichier)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR nom_fichier EP
{
#ifndef NO_FTP
  if (*nom_fichier == '\0')
    {
      /* Le nom de fichier n'est pas defini */
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_GETF_PAR]));
    }
  else
    {
      /* Execution de la copie Superviseur -> Agent */
      if (FSgetf (ContexteRef, nom_fichier) == SYSTEM_ERROR)
        {
          return (atwstrClone (g_chaine_ret[K_CMD_MSG_GETF_KO]));
        }
      else
        {
          return (atwstrClone (g_chaine_ret[K_CMD_MSG_GETF_OK]));
        }
    }
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande HELO
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDhelo DP ((ContexteRef, contexte, cmd)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR cmd EP
{
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_HELO]));
}

/******************************************************************************
*  NAME
*       Commande HELP
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDhelp DP ((ContexteRef, contexte, cmd)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR cmd EP
{
  atwstr   *res;
  T_ENTIER  nb_cmd = 0;
  T_ENTIER  index = 0;
  T_CAR    *code_ligne_int = "110";
  T_CAR    *code_ligne_fin = "210";

  if (*cmd != '\0')
    {
      /* Demande d'une aide sur une commande particuliere */
      T_ENTIER  index = 0;

      while ((index < K_CMD_NBRE_INDEX)
             &&
             (CSTstrncmp (liste_commandes[index].libelle,
                          cmd,
                          liste_commandes[index].long_lib)))
        {
          /* La commande n'est pas trouvee */
          index++;
        }
      if (index < K_CMD_NBRE_INDEX)
        {
          /* La commande a ete trouvee */
          if (liste_commandes[index].help)
            {
              /* Elle possede un message d'aide */
              res = atwstrClone (liste_commandes[index].help);
            }
          else
            {
              /* Elle ne possede pas de message d'aide */
              res = atwstrClone (g_chaine_ret[K_CMD_MSG_PASDAIDE]);
            }
        }
      else
        {
          res = atwstrClone (g_chaine_ret[K_CMD_MSG_AIDECMDINCONNUE]);
        }
    }
  else
    {
      res = atwstrClone (g_chaine_ret[K_CMD_MSG_HELP]);
      res = atwstrAppend (res, "\r\n");
      if (K_CMD_NBRE_INDEX < K_CMD_NB_CMD_PAR_LIGNE_HELP)
        {
          /* Il n'y a qu'une ligne */
          res = atwstrAppend (res, code_ligne_fin);
        }
      else
        {
          /* Il y a plusieurs lignes --> CAS NOMINAL */
          res = atwstrAppend (res, code_ligne_int);
        }
      do
        {
          res = atwstrAppend (res, "\t");
          res = atwstrAppend (res, liste_commandes[index].libelle);
          /* Passe a la commande suivante */
          index++;
          nb_cmd++;

          /* Saute a la ligne si on a ecrit le nombre de commande
           * max / ligne
           */
          if (nb_cmd == K_CMD_NB_CMD_PAR_LIGNE_HELP)
            {
              res = atwstrAppend (res, "\r\n");
              if ((K_CMD_NBRE_INDEX - index) < K_CMD_NB_CMD_PAR_LIGNE_HELP)
                {
                  /* Il s'agit de la dernier ligne */
                  res = atwstrAppend (res, code_ligne_fin);
                }
              else
                {
                  res = atwstrAppend (res, code_ligne_int);
                }
              nb_cmd = 0;
            }
        }
      while (index < K_CMD_NBRE_INDEX);
    }
  return (res);
}

/******************************************************************************
*  NAME
*       Commande MKD
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDmkd DP ((ContexteRef, contexte, repertoire)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR repertoire EP
{
#ifndef NO_FILE_SYSTEM
  if (*repertoire == '\0')
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_MKD_PAR]));
    }
  if (FSmkdir (ContexteRef, repertoire) == SYSTEM_OK)
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_MKD_OK]));
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_MKD_KO]));
    }
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande PDYN
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDpdynf DP ((ContexteRef, contexte, leurre)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR leurre EP
{
  T_ENTIER  numero_port;
  atwstr   *rep;

  if ((numero_port = DYNFAport_dynf (ContexteRef)) != -1)
    {
      T_CAR     port[80];

      CSTsprintf (port, "%%%d", numero_port);
      rep = atwstrAppend (atwstrClone (g_chaine_ret[K_CMD_MSG_PORT_DYNF]),
                          port);
      return (rep);
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_PDYNF_KO]));
    }
}

/******************************************************************************
*  NAME
*       Commande ISND
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDpisnd DP ((ContexteRef, contexte, msg_plus_tester_id)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR msg_plus_tester_id EP
{
  T_TABCAR socknum;
  PT_CAR   p_socknum;
  T_TABCAR msg;
  PT_CAR   p_msg;
  T_ENTIER index;

  index = 0;
  p_socknum = msg_plus_tester_id;
  while (p_socknum && (p_socknum[0]>='0') && (p_socknum[0]<='9'))
    {
      socknum[index] = p_socknum[0];
      p_socknum++;
      index++;
    }

  if (p_socknum)
    {
      /* on termine la chaine de No de socket */
      socknum[index] = '\0';
      /* on passe le caractere de separation */
      p_msg = p_socknum+1;
      /* rajout de la trame de fin */
      CSTsprintf(msg,"%s\r\n",p_msg);

      DYNFAdescente_ligne(ContexteRef, CSTatoi(socknum), msg);
    }
  return (NULL);
}


/******************************************************************************
*  NAME
*       Commande TOUT
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDptout DP ((ContexteRef, contexte, tester_id_plus_timeout)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR tester_id_plus_timeout EP
{
  T_TABCAR socknum;
  PT_CAR   p_socknum;
  T_TABCAR s_timeout;
  PT_CAR   p_timeout;
  T_ENTIER index;

  index = 0;
  p_socknum = tester_id_plus_timeout;
  while (p_socknum && (p_socknum[0]>='0') && (p_socknum[0]<='9'))
    {
      socknum[index] = p_socknum[0];
      p_socknum++;
      index++;
    }

  if (p_socknum)
    {
      /* on termine la chaine de No de socket */
      socknum[index] = '\0';
      /* on passe le caractere de separation */
      p_timeout = p_socknum+1;
      /* rajout de la trame de fin */
      CSTsprintf(s_timeout,"%s\r\n",p_timeout);

      DYNFAdescente_ligne(ContexteRef, CSTatoi(socknum), s_timeout);
    }
  return (NULL);
}

/******************************************************************************
*  NAME
*       Commande AVAIL
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDpavai DP ((ContexteRef, contexte, tester_id_plus_answer)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR tester_id_plus_answer EP
{
  T_TABCAR socknum;
  PT_CAR   p_socknum;
  T_TABCAR s_answer;
  PT_CAR   p_answer;
  T_ENTIER index;

  index = 0;
  p_socknum = tester_id_plus_answer;
  while (p_socknum && (p_socknum[0]>='0') && (p_socknum[0]<='9'))
    {
      socknum[index] = p_socknum[0];
      p_socknum++;
      index++;
    }

  if (p_socknum)
    {
      /* on termine la chaine de No de socket */
      socknum[index] = '\0';
      /* on passe le caractere de separation */
      p_answer = p_socknum+1;
      /* rajout de la trame de fin */
      CSTsprintf(s_answer,"%s\r\n",p_answer);

      DYNFAdescente_ligne(ContexteRef, CSTatoi(socknum), s_answer);
    }
  return (NULL);
}


/******************************************************************************
*  NAME
*       Commande PFTP
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDpftp DP ((ContexteRef, contexte, leurre)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR leurre EP
{
  atwstr   *rep;


#ifndef NO_FTP
  T_ENTIER  numero_port;

  if ((numero_port = FSgetportftp (ContexteRef)) != SYSTEM_ERROR)
    {
      T_CAR     port[80];

      CSTsprintf (port, "%%%d", numero_port);
      rep = atwstrAppend (atwstrClone (g_chaine_ret[K_CMD_MSG_PORT_FTP]),
                          port);
      return (rep);
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_PFTP_KO]));
    }
#else
  /* return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL])); */
  rep = atwstrAppend (atwstrClone (g_chaine_ret[K_CMD_MSG_PORT_FTP]), "%0");
  return (rep);
#endif
}

/******************************************************************************
*  NAME
*       Commande PORT
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDport DP ((ContexteRef, contexte, leurre)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR leurre EP
{
  T_ENTIER  numero_port;
  atwstr   *rep;

  if ((numero_port = PROport_de_trace (ContexteRef)) != -1)
    {
      T_CAR     port[80];

      CSTsprintf (port, "%%%d", numero_port);
      rep = atwstrAppend (atwstrClone (g_chaine_ret[K_CMD_MSG_PORT_TRACE]),
                          port);
      return (rep);
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_PORT_KO]));
    }
}

/******************************************************************************
*  NAME
*       Commande PRDV
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDprdv DP ((ContexteRef, contexte, leurre)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR leurre EP
{
  T_ENTIER  numero_port;
  atwstr   *rep;

  if ((numero_port = RDVAport_rdv (ContexteRef)) != -1)
    {
      T_CAR     port[80];

      CSTsprintf (port, "%%%d", numero_port);
      rep = atwstrAppend (atwstrClone (g_chaine_ret[K_CMD_MSG_PORT_RDV]),
                          port);
      return (rep);
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_PRDV_KO]));
    }
}

/******************************************************************************
*  NAME
*       Commande PUTF
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDputf DP ((ContexteRef, contexte, nom_fichier)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR nom_fichier EP
{
#ifndef NO_FTP
  if (*nom_fichier == '\0')
    {
      /* Le nom de fichier n'est pas defini */
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_PUTF_PAR]));
    }
  else
    {
      /* Execution de la copie Superviseur -> Agent */
      if (FSputf (ContexteRef, nom_fichier) == SYSTEM_ERROR)
        {
          return (atwstrClone (g_chaine_ret[K_CMD_MSG_PUTF_KO]));
        }
      else
        {
          return (atwstrClone (g_chaine_ret[K_CMD_MSG_PUTF_OK]));
        }
    }
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande PWD
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDpwd DP ((ContexteRef, contexte, leurre)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR leurre EP
{
#ifndef NO_FILE_SYSTEM
  atwstr   *repertoire;
  atwstr   *rep;

  if ((repertoire = FSgetcwd (ContexteRef)))
    {
      rep = atwstrAppend (atwstrClone (g_chaine_ret[K_CMD_MSG_PWD_OK]),
                          repertoire);
      repertoire = atwstrDestroy (repertoire);
      return (rep);
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_PWD_KO]));
    }
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande QUIT
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDquit DP ((ContexteRef, contexte, cmd)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR cmd EP
{
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_QUIT]));
}

/******************************************************************************
*  NAME
*       Commande RMD
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDrmd DP ((ContexteRef, contexte, repertoire)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR repertoire EP
{
#ifndef NO_FILE_SYSTEM
  if (*repertoire == '\0')
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_RMD_PAR]));
    }
  if (FSrmdir (ContexteRef, repertoire) == SYSTEM_OK)
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_RMD_OK]));
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_RMD_KO]));
    }
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande RVKO
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDrvko DP ((ContexteRef, contexte, rendezvous)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR rendezvous EP
{
  debug (CSTprintf ("~~~ CMDrvko %s\n", rendezvous));
  RDVAtermine (ContexteRef, rendezvous, FALSE);
  return (NULL);
}

/******************************************************************************
*  NAME
*       Commande RVOK
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDrvok DP ((ContexteRef, contexte, rendezvous)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR rendezvous EP
{
  debug (CSTprintf ("~~~ CMDrvok %s\n", rendezvous));
  RDVAtermine (ContexteRef, rendezvous, TRUE);
  return (NULL);
}

/******************************************************************************
*  NAME
*       Commande DFKO : Notifie au testeur emetteur que sa derniere remontee
*                       bloquante vers le superviseur a ete invalidee par le
*                       superviseur.
*                       (ex. testeur destinataire d'un INTERSEND inconnu,
*                        doublon de testeur en phase de boot, fin d'un testeur
*                        non recense, etc..)
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDdfko DP ((ContexteRef, contexte, tester_id)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR tester_id EP
{
  int id;
  id = CSTatoi(tester_id);
  DYNFAdescente_ligne (ContexteRef, id, "Ko");
  return (NULL);
}

/******************************************************************************
*  NAME
*       Commande DFOK : Notifie au testeur emetteur que sa derniere remontee
*                       bloquante vers le superviseur a ete validee par le
*                       superviseur
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDdfok DP ((ContexteRef, contexte, tester_id)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR tester_id EP
{
  int id;
  id = CSTatoi(tester_id);
  DYNFAdescente_ligne (ContexteRef, id, "Ok");
  return (NULL);
}


/******************************************************************************
*  NAME
*       Commande SENV
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDsenv DP ((ContexteRef, contexte, variable)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR variable EP
{
#ifndef NO_ENV_VAR
  atwstr   *rep;
  PT_CAR    valeur;

  /* Cree la chaine reponse */
  rep = atwstrCreate ();
  if (!rep)
    {
      return (NULL);
    }
  /*
   * La chaine reponse est creee
   */

  /* Repere le nom de la variable et la valeur */
  if (*variable == '\0')
    {
      /* Usage incorrect de la commande */
      return (atwstrAppend (rep, g_chaine_ret[K_CMD_MSG_SENV_PAR]));
    }

  /*
   * La variable est bien definie
   */

  /* Recherche de la valeur (apres le '=') */
  valeur = CSTstrchr (variable, K_CMD_CARACTERE_AFFECTATION_ENV);
  if (valeur)
    {
      /* Remplace le separateur variable/valeur par le caractere de fin de
       * chaine. Ainsi la chaine pointee par variable correspond bien au nom de
       * la variable d'environnement (et se poursuit sur la valeur) */
      *valeur++ = '\0';

      /* Le pointeur valeur est positionne sur la suite de la chaine */
      if (ENVputenv (ContexteRef, variable, valeur) == SYSTEM_OK)
        {
          /*
           * Remet la chaine passee en parametre dans l'etat initial
           * a cause de atwstr
           */
          valeur--;
          *valeur = K_CMD_CARACTERE_AFFECTATION_ENV;
          return (atwstrAppend (rep, g_chaine_ret[K_CMD_MSG_SENV_OK]));
        }
      else
        {
          /*
           * Remet la chaine passee en parametre dans l'etat initial
           * a cause de atwstr
           */
          valeur--;
          *valeur = K_CMD_CARACTERE_AFFECTATION_ENV;
          return (atwstrAppend (rep, g_chaine_ret[K_CMD_MSG_SENV_KO]));
        }
    }
  else
    {
      /* La valeur n'est pas definie !!! */
      return (atwstrAppend (rep, g_chaine_ret[K_CMD_MSG_SENV_VAL]));
    }
#else
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_NON_IMPL]));
#endif
}

/******************************************************************************
*  NAME
*       Commande STAT
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDstat DP ((ContexteRef, contexte, pid)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR pid EP
{
  /* Etat de sortie d'un processus termine */
  T_ENTIER  etat;
  T_CAR     c_etat[40];

  /*
   * L'identifiant est-il defini ?
   */
  if ((*pid == '\0') || !p_CMDest_numerique (pid))
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_STAT_PAR]));
    }

  /*
   * L'identifiant est defini !
   */

  switch (PROetat (ContexteRef, CSTatoi (pid), &etat))
    {
    case PRO_ENCOURS:
      return atwstrAppend (atwstrClone (g_chaine_ret[K_CMD_MSG_STAT_RUN]),
                           pid);

    case PRO_TERMINE:
      CSTsprintf (c_etat, "%%%s (%%%d)", pid, etat);
      return (atwstrAppend (atwstrClone (g_chaine_ret[K_CMD_MSG_STAT_END]),
                            c_etat));

    case PRO_INCONNU:
    default:
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_STAT_KO]));
    }
}

/******************************************************************************
*  NAME
*       Commande STOP
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDstop DP ((ContexteRef, contexte, pid)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR pid EP
{
  T_ENTIER  etat_sortie;
  T_ENTIER  ppid;

  /*
   * L'identifiant est-il definit ?
   */
  if ((*pid == '\0') || !p_CMDest_numerique (pid))
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_STOP_PAR]));
    }

  ppid = CSTatoi (pid);
  /*
   * L'identifiant est defini !
   */

  if (PROstop (ContexteRef, ppid, &etat_sortie) == SYSTEM_OK)
    {
      /* Arret du processus reussi */
      T_TABCAR  etat;

      CSTsprintf (etat, "%%%d (%%%d)", ppid, etat_sortie);
      return (atwstrAppend (atwstrClone (g_chaine_ret[K_CMD_MSG_STOP_OK]),
                            etat));
    }
  else
    {
      /* Arret du processus echoue */
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_STOP_KO]));
    }
}

/******************************************************************************
*  NAME
*       Commande TRON
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDtron DP ((ContexteRef, contexte, leurre)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR leurre EP
{
  PROactive_trace (ContexteRef);
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_TRACE_ON]));
}

/******************************************************************************
*  NAME
*       Commande TROF
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDtrof DP ((ContexteRef, contexte, leurre)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR leurre EP
{
  PROdesactive_trace (ContexteRef);
  return (atwstrClone (g_chaine_ret[K_CMD_MSG_TRACE_OFF]));
}

/******************************************************************************
*  NAME
*       Commande TRWA
*
*  ALGORITHME
*
******************************************************************************/
static atwstr *p_CMDtrwa DP ((ContexteRef, contexte, leurre)) BP
          PT_REF_CONTEXT ContexteRef SP
          PT_PRIVATE_CONTEXTE_CMDAGT contexte SP
          PT_CAR leurre EP
{
  if (PROetablie_trace (ContexteRef) == SYSTEM_OK)
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_TRWA_OK]));
    }
  else
    {
      return (atwstrClone (g_chaine_ret[K_CMD_MSG_TRWA_ERROR]));
    }

}
