

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.  *
*                                                                              *
*                Product: Rational(R) Test RealTime                            *
*                                                                              *
*      Product Component: System Testing Agent                                 *
*                                                                              *
*               Language: C                                                    *
*                                                                              *
*        Product version: 2003.06.00                                           *
*                                                                              *
*                   File: ctxagt.c                                             *
*                                                                              *
* Rational, the Rational logo are registered trademarks of                     *
* Rational Software Corporation.                                               *
*                                                                              *
* The placing of the copyright notices on Rational source code is not          *
* intended to mean that they are published works, but are included in the      *
* event of inadvertent publication. The source code of Rational contains       *
* trade secrets and other valuable confidential information of Rational        *
* Software Corporation. Rational Software Corporation and its licensors        *
* retain ownership to Rational Products in both source and object code         *
* format, and related documentation and all rights therein including           *
* copyrights, patents and trade secrets.                                       *
*                                                                              *
*                                                                              *
* U.S. Government Rights                                                       *
*                                                                              *
* Use, duplication, or disclosure by the U.S. Government is subject to         *
* restrictions set forth in the applicable Rational License Agreement          *
* and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   *
* 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         *
* or FAR 52.227-14, as applicable.                                             *
*                                                                              *
* Unless otherwise agreed to in writing, use of Rational products is           *
* governed by the Rational Product License Agreement provided with             *
* the product.                                                                 *
*******************************************************************************/
#ifndef AGT_CUSTOM
static char WHAT_LINE[] = "@(#)ctxagt $Revision: 1.11 $ $Date: 2007/01/16 14:12:51 $";
#endif

/*********************************************************************
 *                                                                   *
 *% Module  CTXAGT                                                   *
 *                                                                   *
 *                         Identification                            *
 *                         --------------                            *
 *% Version $Revision: 1.11 $                                         *
 *% Auteur  Jean-Francois Marronnier                                 *
 *% Date    $Date: 2007/01/16 14:12:51 $                               *
 *                                                                   *
 *% Description                                                      *
 *    Gestion des contextes utilisees dans l'agent                   *
 *% Fdescription                                                     *
 *                                                                   *
 *********************************************************************/

/* Inclusion des entetes necessaires */
#ifndef AGT_CUSTOM
#include "cstsyst.h"
#else
#include "agtconf.h"
#endif


#include "ctxagt.h"
#include "ctxagtp.h"

PT_REF_CONTEXT CTXinit DP((numberOfExpectedCtx)) BP
          T_ENTIER numberOfExpectedCtx EP
{
  if ((numberOfExpectedCtx >= 1) &&
      (numberOfExpectedCtx >= LAST_CTX))
    {
      T_ENTIER  i;
      PT_REF_CONTEXT tmpCtx = (PT_REF_CONTEXT) CSTmalloc (sizeof (T_REF_CONTEXT));

      tmpCtx->ctx =
        (PT_VOID *)CSTmalloc (sizeof (PT_VOID) * numberOfExpectedCtx);
      tmpCtx->numberOfExpectedCtx = numberOfExpectedCtx;
      for (i = 0; i < numberOfExpectedCtx; i++)
        {
          tmpCtx->ctx[i] = NULL;
        }
      tmpCtx->numberOfStoredCtx = 0;
      return tmpCtx;
    }
  return NULL;
}

T_RETURN CTXfin DP ((ctxContainer)) BP
          PT_REF_CONTEXT ctxContainer EP
{
  if (ctxContainer != NULL)
    {
      M_CSTfree (ctxContainer->ctx);
      M_CSTfree (ctxContainer);
      return SYSTEM_OK;
    }
  return SYSTEM_ERROR;
}

T_RETURN CTXset DP ((ctxContainer,
                     userCtx,
                     ctxType)) BP
          PT_REF_CONTEXT ctxContainer SP
     void     *userCtx SP
               T_CTX_TYPE ctxType EP
     {
       if ((ctxContainer == NULL) ||
           (ctxType < ATSAGTD_CTX) ||
           (ctxType >= LAST_CTX))
         {
           return SYSTEM_ERROR;
         }

       ctxContainer->numberOfStoredCtx++;

       ctxContainer->ctx[ctxType] = userCtx;

       return SYSTEM_OK;
     }

PT_REF_CONTEXT CTXget DP ((ctxContainer,
                           ctxType)) BP
          PT_REF_CONTEXT ctxContainer SP
          T_CTX_TYPE ctxType EP
{
  /* ATTENTION CA VA PLANTER !! IL FAUT STOPPER PAR CSTexit car le NULL n'est pas teste */
  if ((ctxContainer == NULL) ||
      (ctxType < ATSAGTD_CTX) ||
      (ctxType >= LAST_CTX))
    {
      return NULL;
    }
  return (PT_REF_CONTEXT)ctxContainer->ctx[ctxType];
}
