
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.7.4.1 $
-- $Descr: Ada95 package: Ada.Command_Line$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 A.15 - The Package Ada.Command_Line
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

package Ada.Command_Line is

   pragma Preelaborate(Command_Line);

   function Argument_Count return Natural;

   function Argument (Number : in Positive) return String;

   function Command_Name return String;

   type Exit_Status is range
      RTRT_Imp95.t_Ada_Command_Line_Exit_Status'first ..
      RTRT_Imp95.t_Ada_Command_Line_Exit_Status'last ;

   Success : constant Exit_Status;
   Failure : constant Exit_Status;

   procedure Set_Exit_Status (Code : in Exit_Status);

private

   -- not specified by the language
   Success : constant Exit_Status
     := Exit_Status( RTRT_Imp95.c_Ada_Command_Line_Success );
   Failure : constant Exit_Status
     := Exit_Status( RTRT_Imp95.c_Ada_Command_Line_Failure );

end Ada.Command_Line;
--
--------------------------------------------------------------------------
