
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Decimal$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 F.2 - The Package Ada.Decimal
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

package Ada.Decimal is

   pragma Pure(Decimal);

   Max_Scale : constant := RTRT_Imp95.c_Ada_Decimal_Max_Scale ;
   Min_Scale : constant := RTRT_Imp95.c_Ada_Decimal_Min_Scale ;

   Min_Delta : constant := 10.0**(-Max_Scale);
   Max_Delta : constant := 10.0**(-Min_Scale);

   Max_Decimal_Digits : constant 
                      := RTRT_Imp95.c_Ada_Decimal_Max_Decimal_Digits;

   generic
          type Dividend_Type  is delta <> digits <>;
          type Divisor_Type   is delta <> digits <>;
          type Quotient_Type  is delta <> digits <>;
          type Remainder_Type is delta <> digits <>;
   procedure Divide (Dividend  : in Dividend_Type;
                     Divisor   : in Divisor_Type;
                     Quotient  : out Quotient_Type;
                     Remainder : out Remainder_Type);

   pragma Convention(Intrinsic, Divide);

end Ada.Decimal;
--
--------------------------------------------------------------------------
