
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.7.4.1 $
-- $Descr: Ada95 package: Ada.Interrupts$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 C.3.2 - The Package Ada.Interrupts
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

with System;
package Ada.Interrupts is

    type Interrupt_ID is private;

    type Parameterless_Handler is
             access protected procedure;


     function Is_Reserved (Interrupt : Interrupt_ID)
             return Boolean;

     function Is_Attached (Interrupt : Interrupt_ID)
             return Boolean;

     function Current_Handler (Interrupt : Interrupt_ID)
             return Parameterless_Handler;

     procedure Attach_Handler
             (New_Handler : in Parameterless_Handler;
              Interrupt   : in Interrupt_ID);

     procedure Exchange_Handler
             (Old_Handler : out Parameterless_Handler;
              New_Handler : in Parameterless_Handler;
              Interrupt   : in Interrupt_ID);

     procedure Detach_Handler
             (Interrupt : in Interrupt_ID);

     function Reference(Interrupt : Interrupt_ID)
             return System.Address;

private
     -- not specified by the language
    type Interrupt_ID is new RTRT_Imp95.t_Ada_Interrupts_Interrups_ID ;
end Ada.Interrupts;
--
--------------------------------------------------------------------------
