
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Numerics.Complex_Elementary_Functions$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 G.1.2
--
--------------------------------------------------------------------------
with Ada.Numerics.Complex_Types ;

package Ada.Numerics.Complex_Elementary_Functions is

  pragma Pure(Complex_Elementary_Functions);

  use Ada.Numerics.Complex_Types ;

  function Sqrt (X : Complex)   return Complex;
  function Log  (X : Complex)   return Complex;
  function Exp  (X : Complex)   return Complex;
  function Exp  (X : Imaginary) return Complex;
  function "**" (Left : Complex;   Right : Complex)   return Complex;
  function "**" (Left : Complex;   Right : Float) return Complex;
  function "**" (Left : Float; Right : Complex)   return Complex;

  function Sin (X : Complex) return Complex;
  function Cos (X : Complex) return Complex;
  function Tan (X : Complex) return Complex;
  function Cot (X : Complex) return Complex;

  function Arcsin (X : Complex) return Complex;
  function Arccos (X : Complex) return Complex;
  function Arctan (X : Complex) return Complex;
  function Arccot (X : Complex) return Complex;

  function Sinh (X : Complex) return Complex;
  function Cosh (X : Complex) return Complex;
  function Tanh (X : Complex) return Complex;
  function Coth (X : Complex) return Complex;

  function Arcsinh (X : Complex) return Complex;
  function Arccosh (X : Complex) return Complex;
  function Arctanh (X : Complex) return Complex;
  function Arccoth (X : Complex) return Complex;

end Ada.Numerics.Complex_Elementary_Functions;
--
--------------------------------------------------------------------------
