
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Numerics.Discrete_Random$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 A.5.2 - Random Number Generation
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

generic

       type Result_Subtype is (<>);

package Ada.Numerics.Discrete_Random is

    -- Basic facilities

    type Generator is limited private;

    function Random (Gen : Generator) return Result_Subtype;

    procedure Reset (Gen       : in Generator;
                     Initiator : in Integer);
    procedure Reset (Gen       : in Generator);

    -- Advanced facilities

    type State is private;

    procedure Save  (Gen        : in  Generator;
                     To_State   : out State);
    procedure Reset (Gen        : in  Generator;
                     From_State : in  State);

    Max_Image_Width : constant := RTRT_Imp95.c_Ada_Numerics_Discrete_Random_Max_Image_Width ;

    function Image (Of_State    : State)  return String;
    function Value (Coded_State : String) return State;

private

     -- not specified by the language
     Type Generator is new RTRT_Imp95.t_Ada_Numerics_Discrete_Random_Generator ;

end Ada.Numerics.Discrete_Random;
--
--------------------------------------------------------------------------
