
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Numerics.Elementary_Functions$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- Adapted From LRM Ada95 A.5.1
--
--------------------------------------------------------------------------
package Ada.Numerics.Elementary_Functions is

   pragma Pure(Elementary_Functions);

   function Sqrt    (X           : Float)        return Float;
   function Log     (X           : Float)        return Float;
   function Log     (X, Base     : Float)        return Float;
   function Exp     (X           : Float)        return Float;
   function "**"    (Left, Right : Float)        return Float;

   function Sin     (X           : Float)        return Float;
   function Sin     (X, Cycle    : Float)        return Float;
   function Cos     (X           : Float)        return Float;
   function Cos     (X, Cycle    : Float)        return Float;
   function Tan     (X           : Float)        return Float;
   function Tan     (X, Cycle    : Float)        return Float;
   function Cot     (X           : Float)        return Float;
   function Cot     (X, Cycle    : Float)        return Float;

   function Arcsin  (X           : Float)        return Float;
   function Arcsin  (X, Cycle    : Float)        return Float;
   function Arccos  (X           : Float)        return Float;
   function Arccos  (X, Cycle    : Float)        return Float;
   function Arctan  (Y           : Float;
                     X           : Float := 1.0) return Float;
   function Arctan  (Y           : Float;
                     X           : Float := 1.0;
                     Cycle       : Float)        return Float;
   function Arccot  (X           : Float;
                     Y           : Float := 1.0) return Float;
   function Arccot  (X           : Float;
                     Y           : Float := 1.0;
                     Cycle       : Float)        return Float;

   function Sinh    (X           : Float)        return Float;
   function Cosh    (X           : Float)        return Float;
   function Tanh    (X           : Float)        return Float;
   function Coth    (X           : Float)        return Float;
   function Arcsinh (X           : Float)        return Float;
   function Arccosh (X           : Float)        return Float;
   function Arctanh (X           : Float)        return Float;
   function Arccoth (X           : Float)        return Float;

end Ada.Numerics.Elementary_Functions;
--
--------------------------------------------------------------------------
