
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Storage_IO$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 A.9 - The Generic Package Storage_IO
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

with Ada.IO_Exceptions;
with System.Storage_Elements;
generic
    type Element_Type is private;
package Ada.Storage_IO is

    pragma Preelaborate(Storage_IO);

    Buffer_Size : constant System.Storage_Elements.Storage_Count 
        := RTRT_Imp95.c_Ada_Storage_IO_Buffer_Size ;

    subtype Buffer_Type is System.Storage_Elements.Storage_Array(1..Buffer_Size);

    -- Input and output operations

    procedure Read (Buffer : in  Buffer_Type; Item : out Element_Type);

    procedure Write(Buffer : out Buffer_Type; Item : in  Element_Type);

    -- Exceptions

    Data_Error   : exception renames IO_Exceptions.Data_Error;

end Ada.Storage_IO;
--
--------------------------------------------------------------------------
