
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.7.4.1 $
-- $Descr: Ada95 package: Ada.Streams$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 13.13.1 - The Package Streams
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

package Ada.Streams is

   pragma Pure(Streams);

   type Root_Stream_Type is abstract tagged limited private;

   type Stream_Element is 
           mod RTRT_Imp95.c_Ada_Streams_Stream_Element_modulus ;

   type Stream_Element_Offset is range
           RTRT_Imp95.t_Ada_Streams_Stream_Element_Offset'first ..
           RTRT_Imp95.t_Ada_Streams_Stream_Element_Offset'last;
   subtype Stream_Element_Count is
               Stream_Element_Offset range 0..Stream_Element_Offset'Last;
   type Stream_Element_Array is
               array(Stream_Element_Offset range <>) of Stream_Element;

   procedure Read(
             Stream : in out Root_Stream_Type;
             Item   : out Stream_Element_Array;
             Last   : out Stream_Element_Offset) is abstract;

   procedure Write(
             Stream : in out Root_Stream_Type;
             Item   : in Stream_Element_Array) is abstract;

private

   -- not specified by the language
   -- RT-RT: defined directly Here
   Type Root_Stream_Type is abstract tagged limited null record ;

end Ada.Streams;
--
--------------------------------------------------------------------------
