
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Strings.Maps.Constants$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 A.4.6 - String-Handling Sets and Mappings
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

package Ada.Strings.Maps.Constants is

   pragma Preelaborate(Constants);

   Control_Set           : constant Character_Set;
   Graphic_Set           : constant Character_Set;
   Letter_Set            : constant Character_Set;
   Lower_Set             : constant Character_Set;
   Upper_Set             : constant Character_Set;
   Basic_Set             : constant Character_Set;
   Decimal_Digit_Set     : constant Character_Set;
   Hexadecimal_Digit_Set : constant Character_Set;
   Alphanumeric_Set      : constant Character_Set;
   Special_Set           : constant Character_Set;
   ISO_646_Set           : constant Character_Set;

   Lower_Case_Map        : constant Character_Mapping;
   --Maps to lower case for letters, else identity
   Upper_Case_Map        : constant Character_Mapping;
   --Maps to upper case for letters, else identity
   Basic_Map             : constant Character_Mapping;
   --Maps to basic letter for letters, else identity

private

    -- not specified by the language
   Control_Set           : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Control_Set);
   Graphic_Set           : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Graphic_Set);
   Letter_Set            : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Control_Set);
   Lower_Set             : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Control_Set);
   Upper_Set             : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Upper_Set);
   Basic_Set             : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Control_Set);
   Decimal_Digit_Set     : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Control_Set);
   Hexadecimal_Digit_Set : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Control_Set);
   Alphanumeric_Set      : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Alphanumeric_Set) ;
   Special_Set           : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Special_Set);
   ISO_646_Set           : constant Character_Set
    := Character_Set(RTRT_Imp95.c_Ada_Strings_Maps_Constants_ISO_646_Set);

   Lower_Case_Map        : constant Character_Mapping
	:= Character_Mapping(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Lower_Case_Map) ;
   Upper_Case_Map        : constant Character_Mapping
	:= Character_Mapping(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Upper_Case_Map) ;
   Basic_Map             : constant Character_Mapping
	:= Character_Mapping(RTRT_Imp95.c_Ada_Strings_Maps_Constants_Basic_Map) ;


end Ada.Strings.Maps.Constants;
--
--------------------------------------------------------------------------
