
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Strings.Wide_Maps.Wide_Constants$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 A.7 - Wide String Handling
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

package Ada.Strings.Wide_Maps.Wide_Constants is

   pragma Preelaborate(Wide_Constants);

   Control_Set           : constant Wide_Character_Set;
   Graphic_Set           : constant Wide_Character_Set;
   Letter_Set            : constant Wide_Character_Set;
   Lower_Set             : constant Wide_Character_Set;
   Upper_Set             : constant Wide_Character_Set;
   Basic_Set             : constant Wide_Character_Set;
   Decimal_Digit_Set     : constant Wide_Character_Set;
   Hexadecimal_Digit_Set : constant Wide_Character_Set;
   Alphanumeric_Set      : constant Wide_Character_Set;
   Special_Set           : constant Wide_Character_Set;
   ISO_646_Set           : constant Wide_Character_Set;

   Character_Set         : constant Wide_Character_Set;

   Lower_Case_Map        : constant Wide_Character_Mapping;
   --Maps to lower case for letters, else identity
   Upper_Case_Map        : constant Wide_Character_Mapping;
   --Maps to upper case for letters, else identity
   Basic_Map             : constant Wide_Character_Mapping;
   --Maps to basic letter for letters, else identity

private

    -- not specified by the language
   Control_Set           : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Control_Set) ;
   Graphic_Set           : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Graphic_Set );
   Letter_Set            : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Letter_Set );
   Lower_Set             : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Lower_Set );
   Upper_Set             : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Upper_Set );
   Basic_Set             : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Basic_Set );
   Decimal_Digit_Set     : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Decimal_Set );
   Hexadecimal_Digit_Set : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Hexadecimal_Digit_Set );
   Alphanumeric_Set      : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Alphanumeric_Set );
   Special_Set           : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Special_Set );
   ISO_646_Set           : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_ISO_646_Set );

   Character_Set         : constant Wide_Character_Set
	                         := Wide_Character_Set(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Character_Set );

   Lower_Case_Map        : constant Wide_Character_Mapping
	                         := Wide_Character_Mapping(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Lower_Case_Map );
   Upper_Case_Map        : constant Wide_Character_Mapping
	                         := Wide_Character_Mapping(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Upper_Case_Map );
   Basic_Map             : constant Wide_Character_Mapping
	                         := Wide_Character_Mapping(
      RTRT_Imp95.c_Ada_Strings_Wide_Maps_Wide_Constants_Basic_Map );


End Ada.Strings.Maps.Constants;
--
--------------------------------------------------------------------------
