
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Synchronous_Task_Control$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 D.10 - Synchronous Task Control
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

package Ada.Synchronous_Task_Control is

  type Suspension_Object is limited private;

   procedure Set_True(S : in out Suspension_Object);
   procedure Set_False(S : in out Suspension_Object);
   function Current_State(S : Suspension_Object) return Boolean;
   procedure Suspend_Until_True(S : in out Suspension_Object);

private

    -- not specified by the language
    Type Suspension_Object is 
           new RTRT_Imp95.t_Ada_Synchronous_Task_Control_Suspension_Object ;

end Ada.Synchronous_Task_Control;
--
--------------------------------------------------------------------------
