
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Task_Attributes$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 C.7.2 - The Package Task Attributes
--
--------------------------------------------------------------------------
with Ada.Task_Identification; 
 use Ada.Task_Identification;

generic

    type Attribute is private;
    Initial_Value : in Attribute;

package Ada.Task_Attributes is

    type Attribute_Handle is access all Attribute;

    function Value(T : Task_ID := Current_Task)
            return Attribute;

    function Reference(T : Task_ID := Current_Task)
            return Attribute_Handle;

    procedure Set_Value(Val : in Attribute;
                                    T : in Task_ID := Current_Task);
    procedure Reinitialize(T : in Task_ID := Current_Task);

end Ada.Task_Attributes;
--
--------------------------------------------------------------------------
