
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Task_Identification$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 C.7.1 - The Package Task Identification
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

package Ada.Task_Identification is

   type Task_ID is private;

   Null_Task_ID : constant Task_ID;

   function  "=" (Left, Right : Task_ID) return Boolean;

   function  Image        (T : Task_ID) return String;
   function  Current_Task return Task_ID;
   procedure Abort_Task   (T : in out Task_ID);

   function  Is_Terminated(T : Task_ID) return Boolean;
   function  Is_Callable  (T : Task_ID) return Boolean;

private

   -- not specified by the language
   Type Task_ID is 
    new RTRT_Imp95.t_Ada_Task_Identification_Task_ID ;

   Null_Task_ID : constant Task_ID := Task_ID( 
      RTRT_Imp95.c_Ada_Task_Identification_Null_Task_ID );

end Ada.Task_Identification;
--
--------------------------------------------------------------------------
