
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Ada.Text_IO.Complex_IO$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 G.1.2 - Complex Input Output
--
--------------------------------------------------------------------------
with Ada.Numerics.Generic_Complex_Types;

generic

  with package Complex_Types is new Ada.Numerics.Generic_Complex_Types (<>);

package Ada.Text_IO.Complex_IO is

          use Complex_Types;

          Default_Fore : Field := 2;
          Default_Aft  : Field := Real'Digits - 1;
          Default_Exp  : Field := 3;

          procedure Get (File  : in  File_Type;
                         Item  : out Complex;
                         Width : in  Field := 0);
          procedure Get (Item  : out Complex;
                         Width : in  Field := 0);

          procedure Put (File : in File_Type;
                         Item : in Complex;
                         Fore : in Field := Default_Fore;
                         Aft  : in Field := Default_Aft;
                         Exp  : in Field := Default_Exp);
          procedure Put (Item : in Complex;
                         Fore : in Field := Default_Fore;
                         Aft  : in Field := Default_Aft;
                         Exp  : in Field := Default_Exp);

          procedure Get (From : in  String;
                         Item : out Complex;
                         Last : out Positive);
          procedure Put (To   : out String;
                         Item : in  Complex;
                         Aft  : in  Field := Default_Aft;
                         Exp  : in  Field := Default_Exp);

end Ada.Text_IO.Complex_IO;
--
--------------------------------------------------------------------------
