
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: Interfaces.C.Strings$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 B.3.1 - The Package Interfaces.C.Strings
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

package Interfaces.C.Strings is

          pragma Preelaborate(Strings);

          type char_array_access is access all char_array;

          type chars_ptr is private;

          type chars_ptr_array is array (size_t range <>) of chars_ptr;

          Null_Ptr : constant chars_ptr;

          function To_Chars_Ptr (Item      : in char_array_access;
                                 Nul_Check : in Boolean := False)
             return chars_ptr;

          function New_Char_Array (Chars   : in char_array) return chars_ptr;

          function New_String (Str : in String) return chars_ptr;

          procedure Free (Item : in out chars_ptr);

          Dereference_Error : exception;

          function Value (Item : in chars_ptr) return char_array;

          function Value (Item : in chars_ptr; Length : in size_t)
             return char_array;

          function Value (Item : in chars_ptr) return String;

          function Value (Item : in chars_ptr; Length : in size_t)
             return String;

          function Strlen (Item : in chars_ptr) return size_t;

          procedure Update (Item   : in chars_ptr;
                            Offset : in size_t;
                            Chars  : in char_array;
                            Check  : in Boolean := True);

          procedure Update (Item   : in chars_ptr;
                            Offset : in size_t;
                            Str    : in String;
                            Check  : in Boolean := True);

          Update_Error : exception;

private

    -- not specified by the language
    Type chars_ptr is  new RTRT_Imp95.t_Interfaces_C_Strings_Chars_Ptr ;

    Null_Ptr : constant chars_ptr
      := chars_ptr(RTRT_Imp95.c_Interfaces_C_Strings_Null_Ptr);

end Interfaces.C.Strings;
--
--------------------------------------------------------------------------
