
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.7.4.1 $
-- $Descr: Ada95 package: Interfaces.Fortran$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 B.5 - Interfacing With FORTRAN
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

with Ada.Numerics.Generic_Complex_Types;  -- see G.1.1
pragma Elaborate_All(Ada.Numerics.Generic_Complex_Types);

package Interfaces.Fortran is

          pragma Pure(Fortran);

          type Fortran_Integer is 
                  range  RTRT_Imp95.t_Interfaces_Fortran_Fortran_Integer 'first.. RTRT_Imp95.t_Interfaces_Fortran_Fortran_Integer 'last;

          type Real             is 
                  digits RTRT_Imp95.t_Interfaces_Fortran_Real'digits ;
          type Double_Precision is 
                  digits RTRT_Imp95.t_Interfaces_Fortran_Double_Precision'digits ;

          type Logical is new Boolean;

          package Single_Precision_Complex_Types is
             new Ada.Numerics.Generic_Complex_Types (Real);

          type Complex is new Single_Precision_Complex_Types.Complex;

          subtype Imaginary is Single_Precision_Complex_Types.Imaginary;
          i : Imaginary renames Single_Precision_Complex_Types.i;
          j : Imaginary renames Single_Precision_Complex_Types.j;

          type Character_Set is new character 
                  range  RTRT_Imp95.t_Interfaces_Fortran_Character_Set 'first.. RTRT_Imp95.t_Interfaces_Fortran_Character_Set 'last;

          type Fortran_Character is array (Positive range <>) of Character_Set;
          pragma Pack (Fortran_Character);

          function To_Fortran (Item : in Character) return Character_Set;
          function To_Ada (Item : in Character_Set) return Character;

          function To_Fortran (Item : in String) return Fortran_Character;
          function To_Ada     (Item : in Fortran_Character) return String;

          procedure To_Fortran (Item       : in String;
                                Target     : out Fortran_Character;
                                Last       : out Natural);

          procedure To_Ada (Item     : in Fortran_Character;
                            Target   : out String;
                            Last     : out Natural);

end Interfaces.Fortran;
--
--------------------------------------------------------------------------
