
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.7.4.1 $
-- $Descr: Ada95 package: System.RPC$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 E.5 - Partition Communication System.
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

with Ada.Streams; -- see 13.13.1
package System.RPC is

          type Partition_ID is range  RTRT_Imp95.t_System_RPC_Partition_ID 'first.. RTRT_Imp95.t_System_RPC_Partition_ID 'last;


          Communication_Error : exception;

          type Params_Stream_Type(
             Initial_Size : Ada.Streams.Stream_Element_Count) is new
             Ada.Streams.Root_Stream_Type with private;

          procedure Read(
             Stream : in out Params_Stream_Type;
             Item : out Ada.Streams.Stream_Element_Array;
             Last : out Ada.Streams.Stream_Element_Offset);

          procedure Write(
             Stream : in out Params_Stream_Type;
             Item : in Ada.Streams.Stream_Element_Array);

          -- Synchronous call
          procedure Do_RPC(
             Partition  : in Partition_ID;
             Params     : access Params_Stream_Type;
             Result     : access Params_Stream_Type);

          -- Asynchronous call
          procedure Do_APC(
             Partition  : in Partition_ID;
             Params     : access Params_Stream_Type);

          -- The handler for incoming RPCs
          type RPC_Receiver is access procedure(
             Params     : access Params_Stream_Type;
             Result     : access Params_Stream_Type);

          procedure Establish_RPC_Receiver(
             Partition : in Partition_ID;
             Receiver  : in RPC_Receiver);

private

     -- not specified by the language
     -- RT-RT configured Here.
     type Params_Stream_Type(
             Initial_Size : Ada.Streams.Stream_Element_Count) is new
             Ada.Streams.Root_Stream_Type
             with null record ;

end System.RPC;
--
--------------------------------------------------------------------------
