
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.7.4.1 $
-- $Descr: Ada95 package: System.Storage_Elements$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 13.7.1 - The Package System.Storage_Elements
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

package System.Storage_Elements is

          pragma Preelaborate(System.Storage_Elements);

          type Storage_Offset is 
                 range  RTRT_Imp95.t_System_Storage_Elements_Storage_Offset 'first.. RTRT_Imp95.t_System_Storage_Elements_Storage_Offset 'last;


          subtype Storage_Count is Storage_Offset range 0..Storage_Offset'Last;

          type Storage_Element is
                 mod RTRT_Imp95.t_System_Storage_Elements_Storage_Element'modulus ;

          for Storage_Element'Size use Storage_Unit;
          type Storage_Array is array
            (Storage_Offset range <>) of aliased Storage_Element;
          for Storage_Array'Component_Size use Storage_Unit;

          -- Address Arithmetic:

          function "+"(Left : Address; Right : Storage_Offset)
            return Address;
          function "+"(Left : Storage_Offset; Right : Address)
            return Address;
          function "-"(Left : Address; Right : Storage_Offset)
            return Address;
          function "-"(Left, Right : Address)
            return Storage_Offset;

          function "mod"(Left : Address; Right : Storage_Offset)
            return Storage_Offset;

          -- Conversion to/from integers:

          type Integer_Address is 
                 range  RTRT_Imp95.t_System_Storage_Elements_Integer_Address'first.. RTRT_Imp95.t_System_Storage_Elements_Integer_Address'last;

          function To_Address(Value : Integer_Address) return Address;
          function To_Integer(Value : Address) return Integer_Address;

          pragma Convention(Intrinsic, "+");
            -- ...and so on for all language-defined subprograms declared in this package.
end System.Storage_Elements;
--
--------------------------------------------------------------------------
