
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------
-- $Revision: 1.6.4.1 $
-- $Descr: Ada95 package: System.Storage_Pools$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 13.11 - Storage Management
--
--------------------------------------------------------------------------
with Ada.Finalization;
with System.Storage_Elements;

package System.Storage_Pools is

    pragma Preelaborate(System.Storage_Pools);

    type Root_Storage_Pool is
               abstract new Ada.Finalization.Limited_Controlled with private;

    procedure Allocate(
             Pool : in out Root_Storage_Pool;
             Storage_Address : out Address;
             Size_In_Storage_Elements : in Storage_Elements.Storage_Count;
             Alignment : in Storage_Elements.Storage_Count) is abstract;

    procedure Deallocate(
             Pool : in out Root_Storage_Pool;
             Storage_Address : in Address;
             Size_In_Storage_Elements : in Storage_Elements.Storage_Count;
             Alignment : in Storage_Elements.Storage_Count) is abstract;

    function Storage_Size(Pool : Root_Storage_Pool)
               return Storage_Elements.Storage_Count is abstract;

private

   -- not specified by the language
   -- RT-RT configured Here :
   type Root_Storage_Pool is
     abstract new Ada.Finalization.Limited_Controlled 
     with null record ;

end System.Storage_Pools;
--
--------------------------------------------------------------------------
