
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

-------------------------------------------------------------------------------
--  $Revision: 1.7.4.1 $ 
--  $Descr: Ada95 link between UniTesting and Coverage Ada95 TDP$
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- ATTOL_LINK Package Body     For Attol UniTest Interface
--
-- This is the ATU part of this package, replace at compilation time 
-- attol_link stub of ATU runtime.
-- This body is used for Ada95 language.
--
-------------------------------------------------------------------------------

WITH atw.coverage ;
PACKAGE BODY ATTOL_LINK IS

  -----------------------------------------------------------------------
  -- REGISTER_SERVICE
  -- This procedure Register a new service with it number and name
  --
  -----------------------------------------------------------------------
  PROCEDURE register_service(  
		s_number : IN atl_int ; 
		s_name   : IN STRING ) IS
  BEGIN
	atw.coverage.register_service( integer(s_number), s_name );	
  END register_service ;
 

  -----------------------------------------------------------------------
  -- REGISTER_TEST
  -- This procedure Register a new test with :
  --
  -----------------------------------------------------------------------
  PROCEDURE register_test(
		t_number : IN atl_int ; 
		t_name   : IN STRING ) IS
  BEGIN
	atw.coverage.register_test( integer(t_number), t_name );
  END register_test ;

  -----------------------------------------------------------------------
  -- OUT_COV
  -- This procedure Request a dump of AttolCov. traces
  --
  -----------------------------------------------------------------------
  PROCEDURE out_cov( file : in out private_io.priv_file ) IS
  BEGIN
	atw.coverage.dump( file ) ;
  END out_cov ;

  -----------------------------------------------------------------------
  -- UNREGISTER
  -- This procedure remove all registered service/test
  --
  -----------------------------------------------------------------------
  PROCEDURE unregister IS
  BEGIN
	atw.coverage.unregister ;
  END unregister ;

-------------------------------------------------------------------------
BEGIN
   -- Set ATU / ATC mode 
   attol_cov_present := TRUE ;
END attol_link ;
--
-------------------------------------------------------------------------
