
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------------
-- Copyright (c) 2003 Rational Software Corporation. All rights reserved.     --
--                                                                            --
--                Product: Rational(R) Test RealTime                          --
--                                                                            --
--      Product Component: All                                                --
--                                                                            --
--               Language: Ada                                                --
--                                                                            --
--        Product version:                                                    --
--                                                                            --
-- Target Deployment Port: adagnat                                            --
--                         Ada95 Gnat                                         --
--                                                                            --
--                   File: attol_tag.ads                                      --
--                         UniTesting part of TDP for Ada                     --
--                                                                            --
-- Rational, the Rational logo are registered trademarks of                   --
-- Rational Software Corporation.                                             --
--                                                                            --
-- The placing of the copyright notices on Rational source code is not        --
-- intended to mean that they are published works, but are included in the    --
-- event of inadvertent publication. The source code of Rational contains     --
-- trade secrets and other valuable confidential information of Rational      --
-- Software Corporation. Rational Software Corporation and its licensors      --
-- retain ownership to Rational Products in both source and object code       --
-- format, and related documentation and all rights therein including         --
-- copyrights, patents and trade secrets.                                     --
--                                                                            --
--                                                                            --
-- U.S. Government Rights                                                     --
--                                                                            --
-- Use, duplication, or disclosure by the U.S. Government is subject to       --
-- restrictions set forth in the applicable Rational License Agreement        --
-- and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                 --
-- 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,       --
-- or FAR 52.227-14, as applicable.                                           --
--                                                                            --
-- Unless otherwise agreed to in writing, use of Rational products is         --
-- governed by the Rational Product License Agreement provided with           --
-- the product.                                                               --
--------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- $Revision: 1.11.4.4 $
-- $Descr: Ada95 extension for Ada95 TDP$
-------------------------------------------------------------------------------
--
-- Ada95 Specific part for Tag support of attol package.
--
-------------------------------------------------------------------------------

with unchecked_conversion;
with system; use system;
with private_io;use private_io;
with ada.tags;
with Attol; use Attol;
with attol_serv_95;

package Attol_tag is

  subtype attol_big_mod is attol_serv_95.attol_big_mod;
  function external_tag(t:ada.tags.tag) return string renames ada.tags.external_tag;

  procedure check_tag(t1,t2:ada.tags.tag; error : in out Attol.Attol_int);
  procedure edv_ada(CheckMode   :       in      Attol.ModeCheck         ;
                    valeur      :       in      ada.tags.tag            ;
                    numero      :       in      Attol.attol_int         ;
                    ev          :       in      ada.tags.tag            ;
                    valid       :       in      Attol.ModeValid := Attol.StdValue );

  -- wide_string
  procedure edv_ada(checkmode   :       in      ModeCheck       ;
                    valeur      :       in      wide_string          ;
                    numero      :       in      attol_int       ;
                    min         :       in      wide_string          ;
                    max         :       in      wide_string         ;
                          valid     :     in    ModeValid := StdValue );

  -- wide_caractere
  procedure edv_ada(CheckMode   :       in      ModeCheck       ;
                    valeur      :       in      wide_character       ;
                    numero      :       in      attol_int       ;
                    min         :       in      wide_character       ;
                    max         :       in      wide_character      ;
                          valid     :     in    ModeValid := StdValue );

  -- modular
  procedure edv_ada(checkmode   :       in      ModeCheck       ;
                    valeur      :       in      attol_big_mod       ;
                    numero      :       in      attol_int       ;
                    min         :       in      attol_big_mod       ;
                    max         :       in      attol_big_mod       ;
                    base        :       in      attol_int:=10;
                          valid     :     in    ModeValid := StdValue   );

  -- wide_string 
  procedure ptu_ada(valeur      :       in      wide_string          ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   );


  -- wide_caractere
  procedure ptu_ada(valeur      :       in      wide_character       ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   );

  -- modular
  procedure ptu_ada(valeur      :       in      attol_big_mod       ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   );


end Attol_Tag;
