
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

-------------------------------------------------------------------------------
-- $Revision: 1.13.4.1 $
-- $Descr: UniTexting part of TDP for Ada$
-------------------------------------------------------------------------------

with unchecked_conversion;
with system; use system;
with private_io;use private_io;

package attol is

  subtype priv_attol_int        is integer_32b;
  subtype priv_attol_float      is longest_float                ;
  subtype priv_float            is longest_float                ;

  subtype attol_big_int         is longest_integer       ;
  subtype attol_int             is priv_attol_int       ;
  subtype attol_float           is priv_attol_float     ;

  type access_proautan is access attol_int;
    for access_proautan'Storage_Size use 0;



  type int_size_access  is  range private_io.access_min..private_io.access_max      ;
  for int_size_access'size use private_io.access_size;
  NilAccess : Int_Size_Access := 0;
  NoNilAccess : Int_Size_Access := private_io.Access_Max;

  mode_tab              : boolean               := false                ;
  resultat_global       : boolean               := true                 ;
  rio                   : priv_file                                     ;

  num_test, num_operation : attol_int := 0;
  mode_cst : attol_int := 0;

  function convert is new unchecked_conversion(int_size_access,access_proautan);
  nil :  access_proautan := convert(NilAccess);
  cst_nonil :  access_proautan := convert(NoNilAccess);

  num_muet : attol_int := 0;
  res_muet : attol_int := 0;
  min_muet : attol_int := 0;
  max_muet : attol_int := 0;

  procedure Put_Var_Line_Beginning(Number : in attol_int);
  procedure opf_ada(Name: in String;Key: in string);
  procedure dcl_op_ada(numero:in attol_int;Name:in string);
  procedure dcl_tst_ada(numero:in attol_int;Name:in string);
  procedure dcl_fac_rep_ada(numero:in attol_int;facteur:in attol_int);
  procedure EDV_MUET_CHECK(numero:in attol_int;indice:in attol_int);

  procedure attol_bcl(numero:in attol_int;indice:in attol_int);

  type ModeCheck is (Check,Uncheck);
  type ModeValid is (StdValue,BadValue);
  type ModeCall  is (Init,Ev);

  -- entier
  procedure edv_ada(checkmode   :       in      ModeCheck       ;
                    valeur      :       in      attol_big_int       ;
                    numero      :       in      attol_int       ;
                    min         :       in      attol_big_int       ;
                    max         :       in      attol_big_int       ;
                    base        :       in      attol_int:=10;
                          valid     :     in    ModeValid := StdValue   );

  -- string
  procedure edv_ada(checkmode   :       in      ModeCheck       ;
                    valeur      :       in      string          ;
                    numero      :       in      attol_int       ;
                    min         :       in      string          ;
                    max         :       in      string         ;
                          valid     :     in    ModeValid := StdValue );

  -- caractere
  procedure edv_ada(CheckMode   :       in      ModeCheck       ;
                    valeur      :       in      character       ;
                    numero      :       in      attol_int       ;
                    min         :       in      character       ;
                    max         :       in      character      ;
                          valid     :     in    ModeValid := StdValue );

  -- booleen
  procedure edv_ada(CheckMode   :       in      ModeCheck       ;
                    valeur      :       in      boolean         ;
                    numero      :       in      attol_int       ;
                    min         :       in      boolean         ;
                    max         :       in      boolean        ;
                          valid     :     in    ModeValid := StdValue );

  -- enumeration 1
  procedure edv_ada(CheckMode   :       in      ModeCheck       ;
                    valeur      :       in      string          ;
                    numero      :       in      attol_int       ;
                    min         :       in      string          ;
                    max         :       in      string          ;
                    ok          :       in      boolean        ;
                          valid     :     in    ModeValid := StdValue );

  -- enumeration 2
  procedure edv_ada(CheckMode   :       in      ModeCheck       ;
                    valeur      :       in      attol_big_int       ;
                    numero      :       in      attol_int       ;
                    min         :       in      attol_big_int       ;
                    max         :       in      attol_big_int       ;
                    ok          :       in      boolean        ;
                          valid     :     in    ModeValid := StdValue );

  -- float
  procedure edv_ada(CheckMode   :       in      ModeCheck       ;
                    valeur      :       in      attol_float     ;
                    numero      :       in      attol_int       ;
                    min         :       in      attol_float     ;
                    max         :       in      attol_float     ;
                    ok          :       in      boolean        ;
                          valid     :     in    ModeValid := StdValue );


  -- entier et enumeration 2
  procedure ptu_ada(valeur      :       in      attol_big_int       ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   );

  -- string et enumeration 1
  procedure ptu_ada(valeur      :       in      string          ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   );

  -- caractere
  procedure ptu_ada(valeur      :       in      character       ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   );

  -- booleen
  procedure ptu_ada(valeur      :       in      boolean         ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   );

  -- float
  procedure ptu_ada(valeur      :       in      attol_float     ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   );

  -- access
  procedure ptu_ada(valeur      :       in      access_proautan ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   );

  procedure clf_ada;

  procedure start_chrono_ada;
  procedure stop_chrono_ada;
  procedure excep_ada(num: in attol_int;param: in string:= "") ;
  procedure erv_ada(numero:in attol_int);

  procedure Set_Multi_Test(Num_Ins:in Attol_Int;Num_Loop:in Attol_Int;Idx_Loop:in Attol_Int);
  procedure set_mode_tab_ada(numero:in attol_int;Nbdim:in Attol_int);
  procedure unset_mode_tab_ada(numero:in attol_int;Nbdim:in Attol_int);
  procedure set_mode_str_ada(numero:in attol_int);
  procedure unset_mode_str_ada(numero:in attol_int);

  procedure edv_chrono_muet_ada(muet,status,num_app:attol_int);

  type slice_muet is record
    min : Attol.Attol_int;
    max : Attol.Attol_int;
  end record; -- type slice_muet

  type stub_range is array(Attol.Attol_int range <>) of slice_muet;
  Null_range: constant stub_range(1..1) :=(1=>slice_muet'(0,0));

  procedure searchpos(index : in Attol.Attol_int;
                      tabrange : in Attol.stub_range;
                      error : in out Attol.Attol_int;
                      pos : in out Attol.Attol_int);

  procedure Begin_Check_Stub(Num_Stub : in Attol_Int;
                             tabrange : in Attol.Stub_Range;
                             Index : in Attol_int);

  procedure edv_ada(CheckMode   :       in      ModeCheck         ;
                    valeur      :       in      access_proautan   ;
                    numero      :       in      attol_int         ;
                    va_val      :       in      access_proautan   ;
                          valid     :     in    ModeValid := StdValue );

  function Present(Tab : String; Maxlevel : Natural) return Integer;

end attol;
--
-------------------------------------------------------------------------------

