
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

-------------------------------------------------------------------------------
-- $Revision: 1.11.2.1 $
-- $Descr: Common Services for UniTesting TDP Ada$
-- $Id: attol_comm_smart.adb,v 1.11.2.1 2008/03/18 11:04:24 build Exp $
-------------------------------------------------------------------------------

with attol_serv;use attol_serv;

package body attol_comm is

  subtype intervale is integer range 1 .. 3000;

  local_str		: string(intervale)				;
  local_posit		: intervale		:= intervale'first	;


  procedure put(c:character)is
  begin
    local_str(local_posit):=c;
    local_posit:=local_posit+1;
  end put;

  procedure put(s:string) is
  begin
    local_str(local_posit..s'last-s'first+local_posit):=s;
    local_posit:=s'last-s'first+local_posit+1;
  end put;
  procedure put_line(fic:in out priv_file) is
  begin
    if local_posit=1
      then
        priv_writeln(fic,"");
      else
        priv_writeln(fic,local_str(1..local_posit-1));
        local_posit:=1;
      end if;
  end put_line;


  procedure put_dec_image ( VALUE : longest_integer ) is   -- Decimal image of longest_integer.
    val		: longest_integer		:= value		;
    index	: integer		:= 0			;
    long	: integer		:= 1			;
    carry	: boolean		:= false			;
    str		: string ( 1 .. longest_integer'width ) := (others => ' '); 
  begin
    if val < 0
    then
        if val < -10000
        then -- unfortunately the biggest negative value cannot be changed to positive value
            carry := true;
            val := val + 10;  -- so reduce the value before sign change 
        end if;
        val	:= 0 - val	;
        str (1)	:= '-'		;
        long	:= 2		;
    end if ;
    loop
      str (str'last - index) := character'val ( (val mod 10)  + 48 ) ;
      val := (val / 10 ) ;
      if (carry)
        then
          carry:=false;
          val := val+1;
      end if;
  
      exit when (val = 0) ;
      index := index + 1 ;
    end loop ;
    for i in reverse 0 .. index
    loop
      str ( index -i + long ) := str (str'last - i) ;
    end loop ;
    put (STR(1..index + long)) ;
  end put_dec_image ;

end attol_comm;
--
-------------------------------------------------------------------------------
