
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

--------------------------------------------------------------------------------
-- $Revision: 1.8.2.1 $
-- $Descr: Link between UniTesting and Coverage TDP Ada$
-- $Id: attol_link.ads,v 1.8.2.1 2008/03/18 11:04:24 build Exp $
--------------------------------------------------------------------------------

WITH private_io ;
PACKAGE attol_link IS

  -- This var is true when ATC works under ATU
  -- (initialized at body elaboration time)
  attol_cov_present : BOOLEAN ;

  -- Type for service/test number
  SUBTYPE atl_int IS private_io.priv_int ;

  -- This procedure Register a new service with :
  PROCEDURE register_service(  
		s_number : IN atl_int ; -- service number
		s_name   : IN STRING );  -- service name

  -- This procedure Register a new test with :
  PROCEDURE register_test(
		t_number : IN atl_int ; -- test number
		t_name   : IN STRING );  -- test name

  -- This procedure Request a dump of AttolCov. traces
  PROCEDURE out_cov( file : in out private_io.priv_file ) ;

  -- This procedure remove all registered service/test
  PROCEDURE unregister ;

END attol_link;
--
--------------------------------------------------------------------------------
