
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

-------------------------------------------------------------------------------
-- $Revision: 1.10.2.1 $
-- $Descr: Services for UniTesting TDP Ada$
-- $Id: attol_serv_dump.adb,v 1.10.2.1 2008/03/18 11:04:24 build Exp $
-------------------------------------------------------------------------------


with attol_comm;use attol_comm;
with Unchecked_Conversion;
with system; use system;

package body attol_serv is

 subtype T_STRING    is STRING (1 .. 12);
--  subtype intervale is integer range 1 .. 3000;

  procedure put_hex_image ( VALUE : longest_integer ) is -- Hexadecimal image of longest_integer.
    val		: longest_integer		:= value		;
    str		: string ( 1 .. 12 )	:= "            "	;
    index	: integer		:= 0			;
    i		: integer					;
    ilen:integer:=0;
    digit : constant array (0..15) of character :=
      ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
  begin
    loop
      i := integer'val (val mod 16) ;
      str (str'last - index) := digit(i) ;
      val := (val-(longest_integer(i))) / 16 ;
      exit when val = 0 ;
      exit when index=7;
      index := index + 1 ;
    end loop ;
    if str (str'last - index) >='A'
      then
        index:=index+1;
        str (str'last - index):='0';
    end if;
    for k in reverse 0 .. index
    loop
      str ( index -k + 1 ) := str (str'last - k) ;
    end loop ;
    str(index+2) := 'H';  -- RA/114 
    ilen := index + 2 ;
    put( STR(1..ilen)) ;
  end put_hex_image ;

  procedure put_bin_image ( VALUE : longest_integer ) is  -- Binary image of longest_integer.
    val : longest_integer := value ;
    str  : string ( 1 .. 64 ) := (others => ' ') ;
    index : integer := 0 ;
    ilen:integer:=0;
  begin
    loop
      str (str'last - index) := character'val ((val mod 2) + 48 )  ;
      val := val / 2 ;
      exit when val = 0 ;
      exit when index=63;
      index := index + 1 ;
    end loop ;
    for i in reverse 0 .. index
    loop
      str ( index -i + 1 ) := str (str'last - i) ;
    end loop ;
    str(index + 2) := 'B'; -- RA/114
    ilen := index + 2 ;
    put( STR(1..ilen)) ;
  end put_bin_image ;

procedure put_string(valeur: in string) is
  in_str : boolean := false;
begin
  if valeur'first > valeur'last then
    put ("""""");
  else
    for i in valeur'first .. valeur'last loop
--NU:
      if i>STRING_MAX_LEN then
        put("...");
        exit;
      elsif (valeur(i) < ' ') or (valeur(i) > '~') then 
        if (in_str) then 
          put ("""&\0");
        else
          if (i = valeur'first) then put ("\0");
          else                       put ("&\0");
          end if;
        end if;
        in_str := false;
      else
        if (not in_str) then
          if (i = valeur'first) then put ("""");
          else                       put ("&""");
          end if;
        end if;
        if valeur(i) ='"' then put("""""");
        else put(valeur(i));
        end if;
        in_str := true;
      end if;
    end loop;
    if (in_str) then
      put('"');
    end if;
  end if;
end put_string;

procedure put_enum(valeur: in string) is
begin
  if valeur'first >= valeur'last then
    put ("""""");
  else
    for i in valeur'first ..  valeur'last loop
--NU:
      if i>STRING_MAX_LEN then
        put("...");
        exit;
      else
        put(valeur(i));
      end if;
    end loop;
  end if;
end put_enum ;

 
  procedure put_float_image(X:longest_float) is

  type octet is range 0..255;
  for octet'size use 8;
  type tabint is array (1..(longest_float'size+octet'size-1)/octet'size) of octet;
  pragma pack(tabint);
     function conv is new Unchecked_Conversion(Source=>longest_float,Target=>tabint);
  y:tabint;
  h,l:octet;
  begin
    y:=conv(x);
    put('!');
    for i in y'range loop
      l:=y(i) mod 16;
      h:= (y(i)-l) / 16;
      if h in 0..9
        then
	  put(character'val(character'pos('0')+h));
	else
	  put(character'val((character'pos('A')-10)+h));
      end if;
      if l in 0..9
        then
	  put(character'val(character'pos('0')+l));
	else
	  put(character'val((character'pos('A')-10)+l));
      end if;
    end loop;
    put('!');
  end put_float_image ; --procedure put_float_image 

end attol_serv;

