
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------

-- Product version: 7.0.5.1

-------------------------------------------------------------------------------
-- $Revision: 1.10.2.1 $
-- $Descr: Services for UniTesting TDP Ada$
-- $Id: attol_serv_smart.adb,v 1.10.2.1 2008/03/18 11:04:24 build Exp $
-------------------------------------------------------------------------------

with attol_comm;use attol_comm;

package body attol_serv is

 subtype T_STRING    is STRING (1 .. 12);
--  subtype intervale is integer range 1 .. 3000;

  procedure put_hex_image ( VALUE : longest_integer ) is -- Hexadecimal image of longest_integer.
    val		: longest_integer		:= value		;
    str		: string ( 1 .. 12 )	:= "            "	;
    index	: integer		:= 0			;
    i		: integer					;
    digit : constant array (0..15) of character :=
      ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
  begin
    loop
      i := integer'val (val mod 16) ;
      str (str'last - index) := digit(i) ;
      val := (val-(longest_integer(i))) / 16 ;
      exit when val = 0 ;
      exit when index=7;
      index := index + 1 ;
    end loop ;
    if str (str'last - index) >='A'
      then
        index:=index+1;
        str (str'last - index):='0';
    end if;
    for k in reverse 0 .. index
    loop
      str ( index -k + 1 ) := str (str'last - k) ;
    end loop ;
    str(index+2) := 'H';  -- RA/114 
    put( STR(1..index + 2)) ;
  end put_hex_image ;

  procedure put_bin_image ( VALUE : longest_integer ) is  -- Binary image of longest_integer.
    val : longest_integer := value ;
    str  : string ( 1 .. 64 ) := (others => ' ') ;
    index : integer := 0 ;
  begin
    loop
      str (str'last - index) := character'val ((val mod 2) + 48 )  ;
      val := val / 2 ;
      exit when val = 0 ;
      exit when index=63;
      index := index + 1 ;
    end loop ;
    for i in reverse 0 .. index
    loop
      str ( index -i + 1 ) := str (str'last - i) ;
    end loop ;
    str(index + 2) := 'B'; -- RA/114
    put( STR(1..index + 2 )) ;
  end put_bin_image ;


 
  procedure put_float_image(X:longest_float) is
    un		: constant	:= 1.0e0	;
    dix		: constant	:= 10.0e0	;
    zero	: constant	:= 0.0e0	;
    un_dixieme	: constant	:= 1.0e-1	;
    epsilon	: constant	:= 1.0e-10	;
    expo	: longest_integer	:= 0		;
    signe	: longest_integer	:= 0		;
    n		: longest_integer	:= 0		;
    m		: longest_integer	:= 0		;
    ilen1	: integer	:= 0		;
    f		: longest_float	:= 0.0		;
    g		: longest_float	:= 0.0		;
    h		: longest_float	:= 0.0		;
    l		: longest_float	:= 0.0		;
    expo_str	: t_string	:= (others => ' ');
    s           : string(1..64)  := (others => ' ');
  begin --procedure put_float_image 
    ilen1:=1;
    f:=x;
    if (f=zero)
      then
          S(1..3):="0.0";
          ilen1:=3;
          put(S(1..3));
      else -- not (f=zero)
          if (f<zero)
            then
                signe:=-1;
                s(ilen1):='-';
                ilen1:=ilen1+1;
                f:=(-f);
            else -- not (f<zero)
                signe:=+1;
              end if ; -- (f<zero)
          -- calcul de l'exposant
          g:=f;
          h:=un_dixieme;
          if (g>=un)
            then
                while (g>=un) loop
                      expo:=expo+1;
                      g:=g/dix;
                      h:=h*dix;
                    end loop; -- while (g>=un)
            else -- not (g>=un)
                if (g<un_dixieme)
                  then
                      while (g<un_dixieme) loop
                            expo:=expo-1;
                            g:=dix*g;
                            h:=h/dix;
                          end loop; -- while (g<un_dixieme)
                  else -- not (g<un_dixieme)
                      null;
                  end if; -- if (g<un_dixieme)
              end if; -- if (g>=un)
          s(ilen1):='0';
          ilen1:=ilen1+1;
          s(ilen1):='.';
          ilen1:=ilen1+1;
          g:=zero;
          m:=0;
          l:=(f/h)-g;
          loop
            begin
              n:=longest_integer(l);      -- ion pour 68332 le 22 jul 1992
              l:=l-longest_float(n);  --  | correction pour 68332 le 06 aout 1992  :
              if l<0.0             --  |
                then               --  |
                  n:=n-1;          --  |  lignes a ajouter
                elsif l>=1.0       --  |
                then               --  |
                  n:=n+1;          --  |
              end if;              -----------------------------------------------
              s(ilen1):= character'val(character'pos('0')+n);
              ilen1:=ilen1+1;
              m:=m+1;
              h:=h/dix;
              g:=(g+longest_float(n))*dix;
              l:=(f/h)-g;
              exit when ((l<epsilon) OR (l>=dix) OR (m>=20));
            end;
          end loop;
          if (expo /= 0) then
            s(ilen1):= 'E';
            ilen1:=ilen1+1;
          put(s(1..ilen1-1));
            put_dec_image(longest_integer(expo));
          else
          put(s(1..ilen1-1));
            ilen1:=ilen1-1;
          end if;
        end if; -- if (f=zero)
  end put_float_image ; --procedure put_float_image 

procedure put_string(valeur: in string) is
  in_str : boolean := false;
begin
  if ( valeur'first > valeur'last ) then
    put ("""""");
  else
    for i in valeur'first .. valeur'last loop
--NU:
      if (  i > STRING_MAX_LEN ) then
        put("...");
        exit;
      elsif (valeur(i) < ' ') or (valeur(i) > '~') then 
        if (in_str) then 
          put ("""&\0");
        else
          if (i = valeur'first) then put ("\0");
          else                       put ("&\0");
          end if;
        end if;
        in_str := false;
      else
        if (not in_str) then
          if (i = valeur'first) then put ("""");
          else                       put ("&""");
          end if;
        end if;
        if valeur(i) ='"' then put("""""");
        else put(valeur(i));
        end if;
        in_str := true;
      end if;
    end loop;
    if (in_str) then
      put('"');
    end if;
  end if;
end put_string;

procedure put_enum(valeur: in string) is
begin
  if ( valeur'first >= valeur'last ) then
    put ("""""");
  else
    for i in valeur'first ..  valeur'last loop
--NU:
      if ( i > STRING_MAX_LEN ) then
        put("...");
        exit;
      else
        put(valeur(i));
      end if;
    end loop;
  end if;
end put_enum ;

end attol_serv;
--
-------------------------------------------------------------------------------
