

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* Product version: 7.0.5.1 */

/*******************************************************************************
* $Id: TP.c,v 1.38.2.1 2008/03/18 10:55:49 build Exp $
* $Descr: C Language Library Source $
*******************************************************************************/
#define RTRT_TDP_VERSION 2 /* 7.0.5 */

/* This is the Target Package compilation */
#define RTRT_TDP_COMPILATION

/* What end-user wants to do */
#include "products.h"

/* Values used by customization file */
#include "rtvalues.h"

/* What the Target Package does support */
#include "custom.h"

/* Defaults settings */
#include "defaults.h"

/* Configuration checking */
#if RTRT_PREPRO_ERROR_SUPPORTED
#include "checks.h"
#endif

/* Init/exit header */
#include "initexit.h"

/* Clock header */
#include "clock.h"

/* I/O and system routines header */
#include "priv.h"

/* Threads synchronization/protection objects management */
#include "tasking.h"

/* Presentation functions header */
#include "image.h"

/* Traces file codes */
#include "codes.c"

/* Systems and I/O functions */
#include "priv.c"

/* Time-related functions */
#include "clock.c"

/* Standard POSIX Signals */
#include "rtsignal.c"

/* Buffer functions */
#ifdef NEEDS_atl_buffer
#include "rtbuffer.c"
#endif

/* Presentation functions */
#include "image.c"

#if USE_ATT || USE_ATP || USE_ATQ
/* Threads */
#include "threads.c"
#endif

#if USE_ATT
/* TDF support */
#include "tdf.c"
#endif

#if USE_ATT || USE_ATP || USE_ATQ
/* Call stack */
#include "rtstack.h"
#endif

#if USE_ATP || USE_ATQ || USE_ATC || USE_ATT
/* Observation Tools common functions */
#include "obstools.h"
#endif

#if USE_ATT || USE_ATP || USE_ATQ
/* Call stack */
#include "rtstack.c"
#endif

#if USE_ATU
/* TestRT Unit Testing specifics */
#include "atu.h"
#include "atu.c"
#elif USE_ATS
/* TestRT System Testing specifics */
#include "ats.h"
#include "ats.c"
#endif

#if USE_ATP || USE_ATQ || USE_ATC || USE_ATT
/* Observation Tools common functions */
#include "obstools.c"
#endif

#if USE_ATC
/* TestRT Coverage specifics */
#include "atc.h"
#include "atc.c"
#endif

#if USE_ATT
/* TestRT Trace specifics */
#include "att.h"
#include "att.c"
#endif

#if USE_ATP
/* TestRT PurifyLT specifics */
#include "atp.h"
#include "atp.c"
#endif

#if USE_ATQ
/* TestRT QuantifyLT specifics */
#include "atq.h"
#include "atq.c"
#endif

/* Initialization / Exit routines */
#include "initexit.c"

/* Additional customized code */
#include "custom.c"

