

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* Product version: 7.0.5.1 */

/*******************************************************************************
* $Id: atc.h,v 1.34.2.2 2008/03/18 10:55:49 build Exp $
* $Descr: Coverage Header (included across TP.h) $
*******************************************************************************/


/* Multiple inclusions guard: */
#ifndef ATC_H_INCLUDED
#define ATC_H_INCLUDED

#ifdef ATL_T_FAMILY
#define _ATC_CONST_FAMILY   0x08
#else
#define _ATC_CONST_FAMILY   0
#endif

#if ATC_INFORMATION == 2
                              /* COUNT MODE */
#define _ATC_CONST          (0x04|_ATC_CONST_FAMILY)
#elif ATC_INFORMATION == 1
                              /* COMPACT MODE */
#define _ATC_CONST          (0x02|_ATC_CONST_FAMILY)
#else /* ATC_INFORMATION == 0 */
                              /* PASS MODE */
#define _ATC_CONST          (0x00|_ATC_CONST_FAMILY)
#endif /* ATC_INFORMATION == 0 */


/*******************************************************************************
*  C/C++ Instrumentors
*******************************************************************************/


#if ATC_INFORMATION != 2
/* Pass and compact mode C type */
typedef RTRT_U_INT8 _atc_T_count;
#else
/* Count mode C type */
typedef RTRT_U_INT32 _atc_T_count;
#define _ATC_MAX_COUNT 0x7FFFFFFFL
#endif

#if ATC_INFORMATION == 1
#define _ATC_NB_ELT(nb)              (nb/8 + ((nb%8) ? 1 : 0))
#else /* ATC_INFORMATION == 1 */
#define _ATC_NB_ELT(nb)              nb
#endif /* ATC_INFORMATION == 1 */




#if ATL_DYN_TABLE
#if RTRT_HEAP != RTRT_NONE
#ifndef _ATC_ALLOC
#define _ATC_ALLOC(n,s) priv_malloc(n*s)
#define _ATC_FREE(p) priv_free(p)
#endif /* _ATC_ALLOC */

#define _ATC_INIT_FUNC(i) RTRT_CONCAT_MACRO(_atc_init_func,i)
#define _ATC_INIT_DONE(i) RTRT_CONCAT_MACRO(_atc_init_done,i)
#define _ATC_INIT_CONST_COMPOUND_DONE _atc_init_const_compound_done

#define _ATC_INIT_CONST_COMPOUND_DECLARE static unsigned char _ATC_INIT_CONST_COMPOUND_DONE ATL_OBSTOOLS_INITIALIZE_TO_ZERO;
#define _ATC_INIT_CONST_COMPOUND_FUNCTION _atc_init_const_compound_function
#define _ATC_INIT_CONST_COMPOUND_STUFF_OK \
  if (RTRT_IS_NOT_INITIALIZED(_ATC_INIT_CONST_COMPOUND_DONE)) \
  { \
    _ATC_INIT_CONST_COMPOUND_DONE=RTRT_VARIABLE_INITIALIZED; \
    _ATC_INIT_CONST_COMPOUND_FUNCTION(); \
  }

#ifndef ATL_T_FAMILY
#define _ATC_FAMILY_INIT(i)
#else
#ifndef ATL_FAMILY_INIT_VALUE
#define ATL_FAMILY_INIT_VALUE (ATL_T_FAMILY)0
#endif /*ATL_FAMILY_INIT_VALUE */
#define _ATC_FAMILY_INIT(i)    _ATC_DATA(i)->Family=ATL_FAMILY_INIT_VALUE;
#endif /* _ATL_T_FAMILY */

#define RTRT_ATC_DECLARE_OVERLOAD(i,akey,achecksum,anb_proc,atab_proc,anb_call,atab_call,anb_bloc,atab_bloc,anb_cond,atab_cond) \
static _atc_T_cov * _ATC_DATA(i); \
static unsigned char _ATC_INIT_DONE(i) ATL_OBSTOOLS_INITIALIZE_TO_ZERO; \
static void _ATC_INIT_FUNC(i)(void)   { \
  if( RTRT_IS_NOT_INITIALIZED(_ATC_INIT_DONE(i))) \
  { \
    _ATC_INIT_CONST_COMPOUND_STUFF \
    _ATC_INIT_DONE(i)=RTRT_VARIABLE_INITIALIZED; \
    _ATC_DATA(i)=(_atc_T_cov *) _ATC_ALLOC(1,sizeof(_atc_T_cov)); \
    _ATC_DATA(i)->key=akey; \
    _ATC_DATA(i)->checksum=achecksum; \
    _ATC_DATA(i)->nb_proc=anb_proc; \
    _ATC_DATA(i)->nb_call=anb_call; \
    _ATC_DATA(i)->nb_bloc=anb_bloc; \
    _ATC_DATA(i)->nb_cond=anb_cond; \
    _ATC_DATA(i)->proc=(_atc_T_count *)(anb_proc?_ATC_ALLOC(anb_proc,sizeof(_atc_T_count)):0); \
    _ATC_DATA(i)->call=(_atc_T_count *)(anb_call?_ATC_ALLOC(anb_call,sizeof(_atc_T_count)):0); \
    _ATC_DATA(i)->bloc=(_atc_T_count *)(anb_bloc?_ATC_ALLOC(anb_bloc,sizeof(_atc_T_count)):0); \
    _ATC_DATA(i)->cond=(_atc_T_count *)(anb_cond?_ATC_ALLOC(anb_cond,sizeof(_atc_T_count)):0); \
    _ATC_DATA(i)->next=(_atc_T_cov *)0; \
    _ATC_DATA(i)->link=_ATC_CONST; \
    _ATC_FAMILY_INIT(i) \
    _atc_link((_ATC_DATA(i))); \
  } }

#define RTRT_ATC_LINK_OVERLOAD(i)    _ATC_INIT_FUNC(i)()


#define _ATC_DECLARE_PROC(i,nb_proc)
#define _ATC_DECLARE_CALL(i,nb_call)
#define _ATC_DECLARE_BLOC(i,nb_bloc)
#define _ATC_DECLARE_COND(i,nb_cond)

#ifndef _ATC_TAB_PROC
#define _ATC_TAB_PROC(i)             _ATC_DATA(i)->proc
#define _ATC_TAB_CALL(i)             _ATC_DATA(i)->call
#define _ATC_TAB_BLOC(i)             _ATC_DATA(i)->bloc
#define _ATC_TAB_COND(i)             _ATC_DATA(i)->cond
#define _ATC_TAB_COND_I(i)           _ATC_TAB_COND(i)
#endif  /* _ATC_TAB_PROC */

#else /* RTRT_HEAP != RTRT_NONE */
#error "Dynamic table useless for TDP having RTRT_HEAP to NONE"
#endif /* RTRT_HEAP != RTRT_NONE */
#else /* ATL_DYN_TABLE */


#if !RTRT_VARIABLE_INIT_SUPPORTED

#define _ATC_INIT_FUNC(i) RTRT_CONCAT_MACRO(_atc_init_func,i)
#define _ATC_INIT_DONE(i) RTRT_CONCAT_MACRO(_atc_init_done,i)
#define _ATC_INIT_CONST_COMPOUND_DONE _atc_init_const_compound_done

#define _ATC_INIT_CONST_COMPOUND_DECLARE static unsigned char _ATC_INIT_CONST_COMPOUND_DONE ATL_OBSTOOLS_INITIALIZE_TO_ZERO;
#define _ATC_INIT_CONST_COMPOUND_FUNCTION _atc_init_const_compound_function
#define _ATC_INIT_CONST_COMPOUND_STUFF_OK \
  if (RTRT_IS_NOT_INITIALIZED(_ATC_INIT_CONST_COMPOUND_DONE)) \
  { \
    _ATC_INIT_CONST_COMPOUND_DONE=RTRT_VARIABLE_INITIALIZED; \
    _ATC_INIT_CONST_COMPOUND_FUNCTION(); \
  }

#ifndef ATL_T_FAMILY
#define _ATC_FAMILY_INIT(i)
#else
#ifndef ATL_FAMILY_INIT_VALUE
#define ATL_FAMILY_INIT_VALUE (ATL_T_FAMILY)0
#endif /*ATL_FAMILY_INIT_VALUE */
#define _ATC_FAMILY_INIT(i)    _ATC_DATA(i).Family=ATL_FAMILY_INIT_VALUE;
#endif /* _ATL_T_FAMILY */

#define RTRT_ATC_DECLARE_OVERLOAD(i,akey,achecksum,anb_proc,atab_proc,anb_call,atab_call,anb_bloc,atab_bloc,anb_cond,atab_cond) \
static _atc_T_cov _ATC_DATA(i); \
static unsigned char _ATC_INIT_DONE(i) ATL_OBSTOOLS_INITIALIZE_TO_ZERO; \
static void _ATC_INIT_FUNC(i)(void)   { \
  if( RTRT_IS_NOT_INITIALIZED(_ATC_INIT_DONE(i))) \
  { \
    _ATC_INIT_CONST_COMPOUND_STUFF \
    _ATC_INIT_DONE(i)=RTRT_VARIABLE_INITIALIZED; \
    _ATC_DATA(i).key=akey; \
    _ATC_DATA(i).checksum=achecksum; \
    _ATC_DATA(i).nb_proc=anb_proc; \
    _ATC_DATA(i).nb_call=anb_call; \
    _ATC_DATA(i).nb_bloc=anb_bloc; \
    _ATC_DATA(i).nb_cond=anb_cond; \
    _ATC_DATA(i).proc=(_atc_T_count *)atab_proc; \
    _ATC_DATA(i).call=(_atc_T_count *)atab_call; \
    _ATC_DATA(i).bloc=(_atc_T_count *)atab_bloc; \
    _ATC_DATA(i).cond=(_atc_T_count *)atab_cond; \
    _ATC_DATA(i).next=(_atc_T_cov *)0; \
    _ATC_DATA(i).link=_ATC_CONST; \
    _ATC_FAMILY_INIT(i) \
    _atc_link(&(_ATC_DATA(i))); \
  } }

#define RTRT_ATC_LINK_OVERLOAD(i)    _ATC_INIT_FUNC(i)()

#else /* !RTRT_VARIABLE_INIT_SUPPORTED */

#ifndef ATL_T_FAMILY
#define _ATC_FAMILY_INIT
#else
#ifndef ATL_FAMILY_INIT_VALUE
#define ATL_FAMILY_INIT_VALUE (ATL_T_FAMILY)0
#endif /*ATL_FAMILY_INIT_VALUE */
#define _ATC_FAMILY_INIT    ATL_FAMILY_INIT_VALUE,
#endif /* _ATL_T_FAMILY */

#define _ATC_INIT_CONST_COMPOUND_DECLARE

#endif /* !RTRT_VARIABLE_INIT_SUPPORTED */
#endif /* ATL_DYN_TABLE */


typedef struct _atc_T_cov_ {
        RTRT_U_INT32                   key;
        RTRT_U_INT32                   checksum;
        RTRT_U_INT32                   nb_proc;
        RTRT_U_INT32                   nb_call;
        RTRT_U_INT32                   nb_bloc;
        RTRT_U_INT32                   nb_cond;
        _atc_T_count                  *proc;
        _atc_T_count                  *call;
        _atc_T_count                  *bloc;
        _atc_T_count                  *cond;
        struct _atc_T_cov_            *next;
#ifdef ATL_T_FAMILY
        ATL_T_FAMILY				   Family;
#endif
        unsigned char                  link;
} _atc_T_cov;


/*******************************************************************************
* Useful names
*******************************************************************************/

#define _ATC_TAB_COND_ELT(i)         RTRT_CONCAT_MACRO(_atc_cond_elt,i)
#define _ATC_TAB_COND_CONST(s)       RTRT_CONCAT_MACRO(_atc_cond_const,s)
#define _ATC_DATA(i)                 RTRT_CONCAT_MACRO(_atc_data,i)

#ifndef _ATC_TAB_PROC
#define _ATC_TAB_PROC(i)             RTRT_CONCAT_MACRO(_atc_proc,i)
#define _ATC_TAB_CALL(i)             RTRT_CONCAT_MACRO(_atc_call,i)
#define _ATC_TAB_BLOC(i)             RTRT_CONCAT_MACRO(_atc_bloc,i)
#define _ATC_TAB_COND(i)             RTRT_CONCAT_MACRO(_atc_cond,i)
#define _ATC_TAB_COND_I(i)           _ATC_TAB_COND(i)
#endif  /* _ATC_TAB_PROC */

/*******************************************************************************
* Global variables declared by instrumentation:
*******************************************************************************/

#ifndef _ATC_DECLARE_PROC
#define _ATC_DECLARE_PROC(i,nb_proc) \
static _atc_T_count _ATC_TAB_PROC(i)[_ATC_NB_ELT(nb_proc)];

#define _ATC_DECLARE_CALL(i,nb_call) \
static _atc_T_count _ATC_TAB_CALL(i)[_ATC_NB_ELT(nb_call)];

#define _ATC_DECLARE_BLOC(i,nb_bloc) \
static _atc_T_count _ATC_TAB_BLOC(i)[_ATC_NB_ELT(nb_bloc)];

#define _ATC_DECLARE_COND(i,nb_cond) \
static _atc_T_count _ATC_TAB_COND(i)[_ATC_NB_ELT(nb_cond)];
#endif /* _ATC_DECLARE_PROC */


#ifndef RTRT_ATC_DECLARE_OVERLOAD
#define _ATC_DECLARE(i,key,checksum,nb_proc,tab_proc,nb_call,tab_call,nb_bloc,tab_bloc,nb_cond,tab_cond) \
static _atc_T_cov _ATC_DATA(i) = { \
                                   key, \
                                   checksum, \
                                   nb_proc, \
                                   nb_call, \
                                   nb_bloc, \
                                   nb_cond, \
                                   tab_proc, \
                                   tab_call, \
                                   tab_bloc, \
                                   tab_cond, \
                                   0, \
                                   _ATC_FAMILY_INIT \
                                   _ATC_CONST };
#else  /* RTRT_ATC_DECLARE_OVERLOAD */
#define _ATC_DECLARE(i,key,checksum,nb_proc,tab_proc,nb_call,tab_call,nb_bloc,tab_bloc,nb_cond,tab_cond) \
        RTRT_ATC_DECLARE_OVERLOAD(i,key,checksum,nb_proc,tab_proc,nb_call,tab_call,nb_bloc,tab_bloc,nb_cond,tab_cond)
#endif /* RTRT_ATC_DECLARE_OVERLOAD */


/*******************************************************************************
* Structures link:
*******************************************************************************/

#ifndef RTRT_ATC_LINK_OVERLOAD
#define _ATC_LINK(i)                 _atc_link(&(_ATC_DATA(i)))
#else /* RTRT_ATC_LINK_OVERLOAD */
#define _ATC_LINK(i)                 RTRT_ATC_LINK_OVERLOAD(i)
#endif


/*******************************************************************************
* Branches get, set and unset:
*******************************************************************************/

#if ATC_INFORMATION == 1
#define _ATC_SET(i,t,n)              _atc_set(t,n)
#define _ATC_GET(i,t,n)              _atc_get(t,n)
#define _ATC_UNSET(t,n,b)            _atc_unset(t,n,b)
#else /* ATC_INFORMATION == 1 */
#define _ATC_ELT_TAB(t,n)            t[n]
#if ATC_INFORMATION == 2
#define _ATC_SET(i,t,n)              _atc_set(&(_ATC_ELT_TAB(t,n)))
#define _ATC_GET(i,t,n)              _ATC_ELT_TAB(t,n)
#define _ATC_UNSET(t,n,b)            _atc_unset(&_ATC_ELT_TAB(t,n),b)
#else /* ATC_INFORMATION == 2 */
#define _ATC_SET(i,t,n)              _ATC_ELT_TAB(t,n) = 1
#define _ATC_GET(i,t,n)              _ATC_ELT_TAB(t,n)
#define _ATC_UNSET(t,n,b)            _atc_unset(&_ATC_ELT_TAB(t,n),b)
#endif /* ATC_INFORMATION == 2 */
#endif /* ATC_INFORMATION != 1 */


#define _ATC_SET_exp(i,t,n)          _ATC_SET(i,t,n)


/*******************************************************************************
* Proc, returns and exits:
*******************************************************************************/

#define _ATC_PROC(i,n)               _ATC_SET(i,_ATC_TAB_PROC(i),n)

#define _ATC_PROC_exp(i,n)           _ATC_SET_exp(i,_ATC_TAB_PROC(i),n)


/*******************************************************************************
* Calls:
*******************************************************************************/

#define _ATC_CALL(i,n)               _ATC_SET_exp(i,_ATC_TAB_CALL(i),n)


/*******************************************************************************
* Statements & implicit blocks:
*******************************************************************************/

#define _ATC_BLOC(i,n)               _ATC_SET(i,_ATC_TAB_BLOC(i),n)

#define _ATC_BLOC(i,n)               _ATC_SET(i,_ATC_TAB_BLOC(i),n)

#define _ATC_BLOC_exp(i,n)           _ATC_SET_exp(i,_ATC_TAB_BLOC(i),n)

#define _ATC_BLOC_cond_START()       (int)(

#define _ATC_BLOC_cond_END_LEFT(i,n) \
  !=0)?((_ATC_BLOC_exp(i,n)),1):(0)

#define _ATC_BLOC_cond_END_RIGHT(i,n) \
  !=0)?(1):((_ATC_BLOC_exp(i,n+1)),0)

#define _ATC_BLOC_cond_END_LEFT_RIGHT(i,n) \
  !=0)?((_ATC_BLOC_exp(i,n)),1):((_ATC_BLOC_exp(i,n+1)),0)


/*******************************************************************************
* Loops:
*******************************************************************************/

/* for and while loops: */

#define _ATC_LOOP_VAR(n)    RTRT_CONCAT_MACRO(_atc_loop_var,n)
#define _ATC_LOOP_BACK(n)   RTRT_CONCAT_MACRO(_atc_loop_back,n)

#define _ATC_LOOP_bef(i,n) \
        char _ATC_LOOP_VAR(n) = (char)0x02; \
        _atc_T_count _ATC_LOOP_BACK(n) = _ATC_GET(i,_ATC_TAB_BLOC(i),n); \
        _ATC_SET(i,_ATC_TAB_BLOC(i),n);

#define _ATC_LOOP_in(i,n) \
        if ( _ATC_LOOP_VAR(n) == (char)0x02 ) \
        { \
          _ATC_UNSET(_ATC_TAB_BLOC(i),n,_ATC_LOOP_BACK(n)); \
          _ATC_LOOP_BACK(n) = _ATC_GET(i,_ATC_TAB_BLOC(i),n+1); \
          _ATC_SET(i,_ATC_TAB_BLOC(i),n+1); \
        } \
        else if ( _ATC_LOOP_VAR(n) ) \
        { \
          _ATC_UNSET(_ATC_TAB_BLOC(i),n+1,_ATC_LOOP_BACK(n)); \
          _ATC_SET(i,_ATC_TAB_BLOC(i),n+2); \
        } \
        _ATC_LOOP_VAR(n) >>= 0x01

/* do loops: */

#define _ATC_LOOP_bef1(i,n) \
        char _ATC_LOOP_VAR(n) = (char)0x02; \
        _atc_T_count _ATC_LOOP_BACK(n) = (char)0

#define _ATC_LOOP_in1(i,n) \
        if ( _ATC_LOOP_VAR(n) == (char)0x02 ) \
        { \
          _ATC_LOOP_BACK(n) = _ATC_GET(i,_ATC_TAB_BLOC(i),n); \
          _ATC_SET(i,_ATC_TAB_BLOC(i),n); \
        } \
        else if ( _ATC_LOOP_VAR(n) ) \
        { \
          _ATC_UNSET(_ATC_TAB_BLOC(i),n,_ATC_LOOP_BACK(n)); \
          _ATC_SET(i,_ATC_TAB_BLOC(i),n+1); \
        } \
        _ATC_LOOP_VAR(n) >>= 0x01


/*******************************************************************************
* Basic conditions:
*******************************************************************************/

#define _ATC_COND_ELEM_1()           (((int)(

#define _ATC_COND_ELEM_2(i,n)        !=0)) ? \
                                       (_ATC_SET(i,_ATC_TAB_COND(i),n),1) : \
                                       (_ATC_SET(i,_ATC_TAB_COND(i),n+1),0))

#define _ATC_SWITCH                  char _atc_switch = (char)0x01

#define _ATC_COND_CASE(i,n)          _atc_cond_case( \
                                         &_atc_switch,_ATC_TAB_COND_I(i),n)

/*******************************************************************************
* Modified & compound conditions:
*******************************************************************************/

#ifdef _ATC_INIT_CONST_COMPOUND_FUNCTION

#define _ATC_DECLARE_COND_CONST(s,n,l) \
static RTRT_U_INT16 _ATC_TAB_COND_CONST(s)[n+1][(l+7)/8];

#if !RTRT_KR
#define _ATC_START_COND_CONST static void _ATC_INIT_CONST_COMPOUND_FUNCTION (void) {
#else /* RTRT_KR */
#define _ATC_START_COND_CONST static void _ATC_INIT_CONST_COMPOUND_FUNCTION () {
#endif /* RTRT_KR */

#define _ATC_SET_COND_CONST_ELT(tab,index,c) tab[index] = c;

#define _ATC_SET_COND_CONST_FIRST1(s,n,l,c1) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[0],0,c1)
#define _ATC_SET_COND_CONST_MIDDLE1(s,n,l,i,c1) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],0,c1)

#define _ATC_SET_COND_CONST_FIRST2(s,n,l,c1,c2) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[0],0,c1) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[0],1,c2)
#define _ATC_SET_COND_CONST_MIDDLE2(s,n,l,i,c1,c2) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],0,c1) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],1,c2)

#define _ATC_SET_COND_CONST_FIRST3(s,n,l,c1,c2,c3) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[0],0,c1) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[0],1,c2) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[0],2,c3)
#define _ATC_SET_COND_CONST_MIDDLE3(s,n,l,i,c1,c2,c3) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],0,c1) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],1,c2) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],2,c3)

#define _ATC_SET_COND_CONST_FIRST4(s,n,l,c1,c2,c3,c4) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[0],0,c1) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[0],1,c2) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[0],2,c3) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[0],3,c4)
#define _ATC_SET_COND_CONST_MIDDLE4(s,n,l,i,c1,c2,c3,c4) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],0,c1) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],1,c2) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],2,c3) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],3,c4)

#define _ATC_SET_COND_CONST_LAST(s,i) \
  _ATC_SET_COND_CONST_ELT(_ATC_TAB_COND_CONST(s)[i],0,0xFFFF)

#define _ATC_END_COND_CONST }

#else /* _ATC_INIT_CONST_COMPOUND_FUNCTION */

#define _ATC_DECLARE_COND_CONST(s,n,l)

#define _ATC_START_COND_CONST

#define _ATC_SET_COND_CONST_FIRST1(s,n,l,c1) \
  static RTRT_U_INT16 _ATC_TAB_COND_CONST(s)[(n)+1] = \
                              { c1,
#define _ATC_SET_COND_CONST_MIDDLE1(s,n,l,i,c1) \
                                c1,

#define _ATC_SET_COND_CONST_FIRST2(s,n,l,c1,c2) \
  static RTRT_U_INT16 _ATC_TAB_COND_CONST(s)[(n)*2+1] = \
                              { c1, c2,
#define _ATC_SET_COND_CONST_MIDDLE2(s,n,l,i,c1,c2) \
                                c1, c2,

#define _ATC_SET_COND_CONST_FIRST3(s,n,l,c1,c2,c3) \
  static RTRT_U_INT16 _ATC_TAB_COND_CONST(s)[(n)*3+1] = \
                              { c1, c2, c3,
#define _ATC_SET_COND_CONST_MIDDLE3(s,n,l,i,c1,c2,c3) \
                                c1, c2, c3,

#define _ATC_SET_COND_CONST_FIRST4(s,n,l,c1,c2,c3,c4) \
  static RTRT_U_INT16 _ATC_TAB_COND_CONST(s)[(n)*4+1] = \
                              { c1, c2, c3, c4,
#define _ATC_SET_COND_CONST_MIDDLE4(s,n,l,i,c1,c2,c3,c4) \
                                c1, c2, c3, c4,

#define _ATC_SET_COND_CONST_LAST(s,i) \
                                0xFFFF };

#define _ATC_END_COND_CONST

#endif /* _ATC_INIT_CONST_COMPOUND_FUNCTION */


#ifdef _ATC_FORCEEVALUATION

#define _ATC_DECLARE_COND_ELT(i,nb_elt) \
RTRT_U_INT32 _ATC_TAB_COND_ELT(i)[nb_elt]

#define _ATC_COND_SYNC_1()        ((_atc_cond_sync_bit( \
                                      (int)(

#define _ATC_COND_SYNC_2(i,l,s)   !=0), \
                                  &(_ATC_TAB_COND_ELT(i)[l]),s))?1:0)

#define _ATC_COND_INIT(i,l)       _ATC_TAB_COND_ELT(i)[l] = (RTRT_U_INT32)0

#define _ATC_COND_END_1(i,n,l)    _ATC_COND_INIT(i,l), \
                                  _atc_cond_end_bit( \
                                    (int)(

#define _ATC_COND_END_2(i,n,l)    !=0),_ATC_TAB_COND_I(i),n, \
                                  &(_ATC_TAB_COND_ELT(i)[l]))

#else /* _ATC_FORCEEVALUATION */

#define _ATC_DECLARE_COND_ELT(i,nb_elt) \
RTRT_U_INT16 _ATC_TAB_COND_ELT(i)[((nb_elt)+7)/8]

#define _ATC_COND_SYNC_1()           (((int)(

#define _ATC_COND_SYNC_2(i,o)        !=0)) ? \
                                       (_ATC_TAB_COND_ELT(i)[(o)/8]|=0x2<<(2*((o)%8)),1) : \
                                       (_ATC_TAB_COND_ELT(i)[(o)/8]|=0x1<<(2*((o)%8)),0))

#define _ATC_COND_INIT(i,o,l)        _atc_cond_init( \
                                       &(_ATC_TAB_COND_ELT(i)[(o)/8]),l)

#define _ATC_COND_END_1(i,n,o,l,c,f) _ATC_COND_INIT(i,o,l), \
                                       _atc_cond_end( \
                                         (int)(

#ifdef _ATC_INIT_CONST_COMPOUND_FUNCTION

#define _ATC_COND_END_2(i,n,o,l,c,f) !=0),_ATC_TAB_COND_I(i),n, \
                                     &(_ATC_TAB_COND_ELT(i)[(o)/8]),l, \
                                     &(_ATC_TAB_COND_CONST(c)[0][0]),f)

#else /* _ATC_INIT_CONST_COMPOUND_FUNCTION */

#define _ATC_COND_END_2(i,n,o,l,c,f) !=0),_ATC_TAB_COND_I(i),n, \
                                     &(_ATC_TAB_COND_ELT(i)[(o)/8]),l, \
                                     &(_ATC_TAB_COND_CONST(c)[0]),f)

#endif /* _ATC_INIT_CONST_COMPOUND_FUNCTION */

#endif /* _ATC_FORCEEVALUATION */


/*******************************************************************************
* Functions prototypes:
*******************************************************************************/

#if !RTRT_KR

#if ATC_INFORMATION == 1
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_set           ( _atc_T_count *,
                                            RTRT_U_INT32 );
#elif ATC_INFORMATION == 2
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_set           ( _atc_T_count * );
#endif /* ATC_INFORMATION == 2 */
#if ATC_INFORMATION == 1
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_unset         ( _atc_T_count *,
                                            RTRT_U_INT32,
                                            _atc_T_count );
#else /* ATC_INFORMATION == 1 */
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_unset         ( _atc_T_count *,
                                            _atc_T_count );
#endif /* ATC_INFORMATION != 1 */
#if ATC_INFORMATION == 1
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    _atc_T_count _atc_get   ( _atc_T_count *,
                                            RTRT_U_INT32 );
#endif
_ATL_EXTERN_C                        void _atc_dump          ( int );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_link          ( _atc_T_cov * );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_cond_case     ( char *,
                                            _atc_T_count *,
                                            RTRT_U_INT32 );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    int _atc_cond_sync_bit  ( int,
                                            RTRT_U_INT32 *,
                                            int );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    int _atc_cond_end_bit   ( int,
                                            _atc_T_count *,
                                            RTRT_U_INT32,
                                            RTRT_U_INT32 * );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX   void _atc_cond_init     ( RTRT_U_INT16 *,
                                            int );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX   int _atc_cond_end       ( int,
                                            _atc_T_count *,
                                            RTRT_U_INT32,
                                            RTRT_U_INT16 *,
                                            int,
                                            RTRT_U_INT16 *,
                                            int );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX   void atc_early_init     ( void );
#ifdef _ATL_EXIT_PENDING
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX   void atc_exit_pending   ( void );
#else /* _ATL_EXIT_PENDING */
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX   void atc_late_exit      ( void );
#endif /* _ATL_EXIT_PENDING */

#else /* RTRT_KR */

#if ATC_INFORMATION >= 1
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_set           ( );
#endif
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_unset         ( );
#if ATC_INFORMATION == 1
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    _atc_T_count _atc_get   ( );
#endif
_ATL_EXTERN_C                        void _atc_dump          ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_link          ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_cond_case     ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    int _atc_cond_sync_bit  ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    int _atc_cond_end_bit   ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atc_cond_init     ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    int _atc_cond_end       ( );

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void atc_early_init     ( );
#ifdef _ATL_EXIT_PENDING
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void atc_exit_pending   ( );
#else /* _ATL_EXIT_PENDING */
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void atc_late_exit      ( );
#endif /* _ATL_EXIT_PENDING */

#endif /* RTRT_KR */

#endif /* ATC_H_INCLUDED */

