

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* Product version: 7.0.5.1 */

/*******************************************************************************
* $Id: ato.h,v 1.25.4.1 2008/03/18 10:55:49 build Exp $
* $Descr: Object Testing Header (included across TP.h) $
*******************************************************************************/
/* Multiple inclusions guard: */
#ifndef ATO_H_INCLUDED
#define ATO_H_INCLUDED



/*******************************************************************************
* Types
*******************************************************************************/

#define _ato_Boolean  _atl_bool
#define _ato_Id       RTRT_U_INT32
#define _ato_File     RTRT_U_INT32
#define _ato_Checksum RTRT_U_INT32
#define _ato_Car   char
#define _ato_Int   int
#define _ato_Uint  unsigned int
#define _ato_Ulong unsigned long

/*******************************************************************************
* Macros
*******************************************************************************/

#define _ATO_DECL_CM_VAR(v) extern RTRT_U_INT32 v;
#define _ATO_INC_CM_VAR(v) ::v++;

#if RTRT_EXCEPTIONS

#define _ATO_TRY_BEGIN try {
#define _ATO_TRY_END }

#else

#define _ATO_TRY_BEGIN
#define _ATO_TRY_END

#endif /* RTRT_EXCEPTIONS */

#if ! USE_ATK
#define _ATK_TEST_CLASS_DECL
#endif
/*******************************************************************************
* Global variables
*******************************************************************************/

#if USE_ATK && USE_ATT
extern ATL_TP_PROTO_PREFIX _ato_Boolean _ato_in_stub;
#endif

/*******************************************************************************
* Routines declarations
*******************************************************************************/

extern "C++" {

extern ATL_TP_PROTO_PREFIX void         _ato_enter_test_class   (_ato_Id, _ato_File,
					     _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_exit_test_class    (_ato_File,_ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_enter_test_suite   (_ato_Id, _ato_File,
					     _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_exit_test_suite    (_ato_File,_ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_enter_test_case    (_ato_Id, _ato_File,
					     _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_exit_test_case     (_ato_File,_ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_enter_proc         (_ato_Id, _ato_File,
					     _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_exit_proc          (_ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_enter_stub         (_ato_Id, _ato_File,
					     _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_exit_stub          (_ato_File);

extern ATL_TP_PROTO_PREFIX void         _ato_enter_error        (_ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_exit_error         (_ato_Id);

extern ATL_TP_PROTO_PREFIX void         _ato_prologue           (_ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_epilogue           (_ato_Id, _ato_File);

extern ATL_TP_PROTO_PREFIX _ato_Boolean _ato_check              (_ato_Boolean, _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX _ato_Boolean _ato_check_property     (_ato_Boolean, _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX _ato_Boolean _ato_check_method       (_ato_Boolean, _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX _ato_Boolean _ato_check_exception    (_ato_Boolean, _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX _ato_Boolean _ato_check_prepos       (_ato_Boolean, _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX _ato_Boolean _ato_check_stub         (_ato_Boolean, _ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_unexpected_exception
					    (_ato_Id where, _ato_File file);
extern ATL_TP_PROTO_PREFIX void         _ato_exception_in_stub  ();
extern ATL_TP_PROTO_PREFIX void         _ato_comment            (_ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_print_start        (_ato_Id, _ato_File);
extern ATL_TP_PROTO_PREFIX void         _ato_print_end          ();
extern ATL_TP_PROTO_PREFIX void         _ato_print              (char, char *);
#if RTRT_STRING
extern ATL_TP_PROTO_PREFIX void         _ato_print              (const char *, char *);
#endif /* RTRT_STRING */
extern ATL_TP_PROTO_PREFIX void         _ato_print              (const void *, char *);
extern ATL_TP_PROTO_PREFIX void         _ato_print              (signed int, char *);
extern ATL_TP_PROTO_PREFIX void         _ato_print              (unsigned int, char *);
extern ATL_TP_PROTO_PREFIX void         _ato_print              (signed long int, char *);
extern ATL_TP_PROTO_PREFIX void         _ato_print              (unsigned long int, char *);
#ifdef RTRT_INT64
extern ATL_TP_PROTO_PREFIX void         _ato_print              (RTRT_INT64, char *);
#endif
#ifdef RTRT_U_INT64
extern ATL_TP_PROTO_PREFIX void         _ato_print              (RTRT_U_INT64, char *);
#endif
#if RTRT_FLOAT
extern ATL_TP_PROTO_PREFIX void         _ato_print              (float, char *);
extern ATL_TP_PROTO_PREFIX void         _ato_print              (double, char *);
#if RTRT_LONG_DOUBLE
extern ATL_TP_PROTO_PREFIX void         _ato_print              (long double, char *);
#endif
#endif /* RTRT_FLOAT */

extern ATL_TP_PROTO_PREFIX void         _ato_init          (char *,
					     _ato_Id, _ato_Id, _ato_Id);
extern ATL_TP_PROTO_PREFIX void         _ato_term               ();

} // end of extern "C++"

extern ATL_TP_PROTO_PREFIX _ato_File    _ato_add_source_file    (_ato_Checksum checksum1,
				             _ato_Checksum checksum2);

extern ATL_TP_PROTO_PREFIX void         _ato_obstools_set_block_name (char *);
extern ATL_TP_PROTO_PREFIX void         _ato_obstools_dump           (void);
extern ATL_TP_PROTO_PREFIX void         _ato_atp_start_test_driver   (char *);

// Backward compatibility macros
#define _ATO_Id _ato_Id
#define _ATO_File _ato_File
#define _ATO_Checksum _ato_Checksum
#define _ATO_Car _ato_Car
#define _ATO_Int _ato_Int
#define _ATO_UInt _ato_Uint
#define _ATO_Ulong _ato_Ulong
#define _ATO_enter_test_class _ato_enter_test_class
#define _ATO_exit_test_class _ato_exit_test_class
#define _ATO_enter_test_suite _ato_enter_test_suite
#define _ATO_exit_test_suite _ato_exit_test_suite
#define _ATO_enter_test_case _ato_enter_test_case
#define _ATO_exit_test_case _ato_exit_test_case
#define _ATO_enter_proc _ato_enter_proc
#define _ATO_exit_proc _ato_exit_proc
#define _ATO_enter_stub _ato_enter_stub
#define _ATO_exit_stub _ato_exit_stub
#define _ATO_enter_error _ato_enter_error
#define _ATO_exit_error _ato_exit_error
#define _ATO_prologue _ato_prologue
#define _ATO_epilogue _ato_epilogue
#define _ATO_check _ato_check
#define _ATO_check_property _ato_check_property
#define _ATO_check_method _ato_check_method
#define _ATO_check_exception _ato_check_exception
#define _ATO_check_prepos _ato_check_prepos
#define _ATO_check_stub _ato_check_stub
#define _ATO_unexpected_exception _ato_unexpected_exception
#define _ATO_exception_in_stub _ato_exception_in_stub
#define _ATO_comment _ato_comment
#define _ATO_print _ato_print
#define _ATO_CAST_init _ato_init
#define _ATO_term _ato_term
#define _ATO_add_source_file _ato_add_source_file
#ifndef ATL_EXCEPTIONS
#define ATL_EXCEPTIONS RTRT_EXCEPTIONS
#endif

// Observation tools integration
#define _ATO_OBSTOOLS_SET_BLOCK_NAME(n) _ato_obstools_set_block_name(n)
#define _ATO_OBSTOOLS_DUMP _ato_obstools_dump()

#endif

