

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
 
/* Product version: 7.0.5.1 */


/*******************************************************************************
* $Id: atu.h,v 1.31.2.1 2008/03/18 10:55:50 build Exp $
* $Descr: Unit Testing Header (included across TP.h) $
*******************************************************************************/

#define PTU_LONG_DOUBLE_CPP PTU_DOUBLE_CPP
#define EDV_LONG_DOUBLE_CPP EDV_DOUBLE_CPP

#ifndef ATU_H_INCLUDED
#define ATU_H_INCLUDED

#ifdef RTRT_INT64
/*! Largest representable signed integer */
/* see "image.c" ==>  _ATL_LARGEST_INT */
#define _ATU_LARGEST_INT RTRT_INT64
#else
#define _ATU_LARGEST_INT RTRT_INT32
#endif

#ifdef RTRT_U_INT64
/*! Largest representable unsigned integer */
/* see "image.c" ==>  _ATL_LARGEST_U_INT */
#define _ATU_LARGEST_U_INT RTRT_U_INT64
#else
#define _ATU_LARGEST_U_INT RTRT_U_INT32
#endif

#define atu_integer  _ATU_LARGEST_INT
#define atu_unsigned _ATU_LARGEST_U_INT
#define atl_memcpy priv_memcpy
#define ATU_INIT_DATA atu_init_data();
#define ATU_MEMCPY priv_memcpy
#define ATU_STRCPY atl_strcpy

/* until 7.0.0 the rio filename was provided by the test driver */
/* Now, to be compliant to other tool the runtime provide the filename */
/* to come back to the previous solution define the following macro */
#ifdef PTU_PROVIDE_RIO_NAME
#define ATU_TRACES_FILE(file) char *atu_traces_file(void){return (file);}
#else
#define ATU_TRACES_FILE(file)
#endif
/* the function CONCAT_STR_C require memory.
 * some TDP can disable this functionality
 */
#if ! RTRT_STR_CONCAT_SUPPORTED
#define CONCAT_STR_C(str,n) str
#endif
/**********************************************************/
/* MEMORY_SPACE represent the space memory where are      */
/* stored the strings. Default for this macro is empty    */
/**********************************************************/
#ifndef MEMORY_SPACE
#define MEMORY_SPACE
#endif

#ifndef ATU_STRING_SIZE
#define ATU_STRING_SIZE   1024
#endif

#ifndef NULL
#define NULL ((char *)(0))
#endif

#define PRIV_ABS(x) ((x) < 0 ? -(x) : (x))


extern char * atu_traces_file(
#if !RTRT_KR
void
#endif
) MEMORY_SPACE ;

#ifndef RTRT_TDP_COMPILATION

#ifndef RTRT_LOOPVAR_T
#define RTRT_LOOPVAR_T int
#endif

#define I  I1
static RTRT_LOOPVAR_T I1;
static RTRT_LOOPVAR_T I2;
static RTRT_LOOPVAR_T I3;
static RTRT_LOOPVAR_T I4;
static RTRT_LOOPVAR_T I5;
static RTRT_LOOPVAR_T I6;
static RTRT_LOOPVAR_T I7;
#ifndef RTRT_IDXVAR_7_MAX
static RTRT_LOOPVAR_T I8;
static RTRT_LOOPVAR_T I9;
static RTRT_LOOPVAR_T I10;
static RTRT_LOOPVAR_T I11;
static RTRT_LOOPVAR_T I12;
static RTRT_LOOPVAR_T I13;
static RTRT_LOOPVAR_T I14;
static RTRT_LOOPVAR_T I15;
static RTRT_LOOPVAR_T I16;
static RTRT_LOOPVAR_T I17;
static RTRT_LOOPVAR_T I18;
static RTRT_LOOPVAR_T I19;
static RTRT_LOOPVAR_T I20;
#endif /* RTRT_IDXVAR_7_MAX */

#define J  J1
static RTRT_LOOPVAR_T J1;
static RTRT_LOOPVAR_T J2;
static RTRT_LOOPVAR_T J3;
static RTRT_LOOPVAR_T J4;
static RTRT_LOOPVAR_T J5;
static RTRT_LOOPVAR_T J6;
static RTRT_LOOPVAR_T J7;
#ifndef RTRT_IDXVAR_7_MAX
static RTRT_LOOPVAR_T J8;
static RTRT_LOOPVAR_T J9;
static RTRT_LOOPVAR_T J10;
static RTRT_LOOPVAR_T J11;
static RTRT_LOOPVAR_T J12;
static RTRT_LOOPVAR_T J13;
static RTRT_LOOPVAR_T J14;
static RTRT_LOOPVAR_T J15;
static RTRT_LOOPVAR_T J16;
static RTRT_LOOPVAR_T J17;
static RTRT_LOOPVAR_T J18;
static RTRT_LOOPVAR_T J19;
static RTRT_LOOPVAR_T J20;
#endif /* RTRT_IDXVAR_7_MAX */

static void atu_init_data(
#if !RTRT_KR
void
#endif
)
{
   I1=0;  I2=0;  I3=0;  I4=0;  I5=0;  I6=0;  I7=0;
#ifndef RTRT_IDXVAR_7_MAX
   I8=0;  I9=0; I10=0;  I11=0; I12=0; I13=0; I14=0;
   I15=0; I16=0; I17=0; I18=0; I19=0; I20=0;
#endif /* RTRT_IDXVAR_7_MAX */
   J1=0;  J2=0;  J3=0;  J4=0;  J5=0;  J6=0;  J7=0;
#ifndef RTRT_IDXVAR_7_MAX
   J8=0;  J9=0; J10=0;  J11=0; J12=0; J13=0; J14=0;
   J15=0; J16=0; J17=0; J18=0; J19=0; J20=0;
#endif /* RTRT_IDXVAR_7_MAX */
}

#if !RTRT_CPLUSPLUS_LANGUAGE
static int NUM_OPERATION, NUM_TEST;
#endif /* !RTRT_CPLUSPLUS_LANGUAGE */

#endif

#ifndef atu_pointer
#if RTRT_KR
#define atu_pointer char *
#define _ATU_POINTER_CONVERSION unsigned long
#else /* RTRT_KR */
#define atu_pointer const void *
#define _ATU_POINTER_CONVERSION unsigned long
#endif /* RTRT_KR */
#endif /* atu_pointer */

#ifndef _ATU_POINTER_CONVERSION
#error _ATU_POINTER_CONVERSION must be defined with atu_pointer
#endif /* _ATU_POINTER_CONVERSION */

#ifndef atu_charstring
#if RTRT_KR
#define atu_charstring char *
#else /* RTRT_KR */
#define atu_charstring const char *
#endif /* RTRT_KR */
#endif /* atu_string */

#ifndef NIL
extern ATL_TP_PROTO_PREFIX atu_charstring NIL;
#endif

#ifndef NONIL
extern ATL_TP_PROTO_PREFIX atu_pointer NONIL;
#endif

#if RTRT_CPLUSPLUS_LANGUAGE

#define CLF_CPP(name) STOP_CPP()
#define OPF_CPP(name) START_CPP()

class ATTOL_RUN {
public:
  int NUM_OPERATION;
  int NUM_TEST;
  char * CONCAT_STR_CPP(atu_charstring, ...);
  void DCL_FAC_REP_CPP(int, int);
  void SET_MODE_TAB_CPP(int);
  void UNSET_MODE_TAB_CPP(int);
  void ERV_CPP(int);
  void START_CPP(void);
  void STOP_CPP(void);
  void INI_STR_CPP(char *, int, long, atu_charstring);
  void EXCEP_CPP(int, const char * = 0);
  void RUPT_CPP(int);
  void ATU_OP_CPP(int, const char *);
  void ATU_TST_CPP(int, const char *);
  void START_CHRONO_CPP();
  void STOP_CHRONO_CPP();
  void EDV_STR_CPP(int, int, atu_charstring, int, atu_charstring, atu_charstring);
  void EDV_CHAR_CPP(int, int, char, int, char, char);
  void EDV_INTEGER_CPP(int, int, atu_integer, int, int, atu_integer, atu_integer);
  void EDV_UNSIGNED_CPP(int, int, atu_unsigned, int, int, atu_unsigned, atu_unsigned);
  void EDV_POINTER_CPP(int, int, atu_pointer, int, atu_pointer);
#if RTRT_FLOAT
  void EDV_FLOAT_CPP(int, int, float, int, float, float);
  void EDV_DOUBLE_CPP(int, int, double, int, double, double);
#endif /* RTRT_FLOAT */
  void PTU_CHAR_CPP(char, int);
  void PTU_INTEGER_CPP(atu_integer, int, int);
  void PTU_UNSIGNED_CPP(atu_unsigned, int, int);
#if RTRT_FLOAT
  void PTU_FLOAT_CPP(float, int);
  void PTU_DOUBLE_CPP(double, int);
#endif /* RTRT_FLOAT */
  void PTU_BOOLEAN_CPP(int, int);
  void SET_MODE_CST_CPP(int);
  void UNSET_MODE_CST_CPP(int);
  void OPEN_BRA_CPP(int);
  void CLOSE_BRA_CPP(int);
  void EDV_CHRONO_MUET_CPP(int stub, int status, int num_app);
  void EDV_LST_ITEM_NOT_FOUND_CPP(const char *, int);
  void EDV_LST_ITEM_NOT_EXPECTED_CPP(int);
  void EDV_LST_TEST_ITEM_CPP(const char *, _atl_bool, int);
};

/* CONTAINER */
#define ATW_LST_EMPTY(lst) lst.empty()

/* SEQUENCE */
#define ATW_LST_CLEAR(lst) lst.clear()
#define ATW_LST_FRONT(lst) lst.front()
#define ATW_LST_ERASE_BEGIN(lst) lst.erase(lst.begin())
#define ATW_LST_INSERT_BEGIN(lst, val) lst.insert(lst.begin(), val)

/*
 * Type requirements for lst : Equality Comparable
 * A type is EqualityComparable if objects of that type can be compared for equality using operator==,
 * and if operator== is an equivalence relation
 */
#define ATW_LST_COMPARE(v1, v2) ((v1) == (v2))

/* Exception copy */
#define ATW_EXCEP_REFCPY(e1, e2) ((*e1) = ( e2))
#define ATW_EXCEP_PTRCPY(e1, e2) ((e1) = (e2))

#ifndef RTRT_TDP_COMPILATION
static ATTOL_RUN attol_run;
#endif

#else /* RTRT_CPLUSPLUS_LANGUAGE */

#define OPF_C(name) START_C()
#define CLF_C(name) STOP_C()

#if RTRT_STRING

#if RTRT_STR_CONCAT_SUPPORTED

extern ATL_TP_PROTO_PREFIX char * CONCAT_STR_C(
#if !RTRT_KR
  atu_charstring str,
  ...
#endif
) MEMORY_SPACE ;

#endif /* RTRT_STR_CONCAT_SUPPORTED */

#endif /* RTRT_STRING */

extern ATL_TP_PROTO_PREFIX void PTU_CHAR_C(
#if !RTRT_KR
  char value,
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void PTU_INTEGER_C(
#if !RTRT_KR
  atu_integer value,
  int num,
  int base
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void PTU_UNSIGNED_C(
#if !RTRT_KR
  atu_unsigned value,
  int num,
  int base
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void PTU_BOOLEAN_C(
#if !RTRT_KR
  int value,
  int num
#endif
) MEMORY_SPACE ;

#if RTRT_FLOAT

extern ATL_TP_PROTO_PREFIX void PTU_FLOAT_C(
#if !RTRT_KR
  float value,
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void PTU_DOUBLE_C(
#if !RTRT_KR
  double value,
  int num
#endif
) MEMORY_SPACE ;

#endif /* RTRT_FLOAT */

#if RTRT_STRING

extern ATL_TP_PROTO_PREFIX void EDV_STR_C(
#if !RTRT_KR
  int aff_interv,
  int uncheck,
  atu_charstring value,
  int num,
  atu_charstring value_min,
  atu_charstring value_max
#endif
) MEMORY_SPACE ;

#endif /* RTRT_STRING */

extern ATL_TP_PROTO_PREFIX void EDV_CHAR_C(
#if !RTRT_KR
  int aff_interv,
  int uncheck,
  char value,
  int num,
  char value_min,
  char value_max
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void EDV_INTEGER_C(
#if !RTRT_KR
  int aff_interv,
  int uncheck,
  atu_integer value,
  int num,
  int base,
  atu_integer value_min,
  atu_integer value_max
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void EDV_UNSIGNED_C(
#if !RTRT_KR
  int aff_interv,
  int uncheck,
  atu_unsigned value,
  int num,
  int base,
  atu_unsigned value_min,
  atu_unsigned value_max
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void EDV_BOOLEAN_C(
#if !RTRT_KR
  int aff_interv,
  int uncheck,
  int value,
  int num,
  int value_min,
  int value_max
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void EDV_POINTER_C(
#if !RTRT_KR
  int aff_interv,
  int uncheck,
  atu_pointer value,
  int num,
  atu_pointer value_att
#endif
) MEMORY_SPACE ;

#if RTRT_FLOAT

extern ATL_TP_PROTO_PREFIX void EDV_FLOAT_C(
#if !RTRT_KR
  int aff_interv,
  int uncheck,
  float value,
  int num,
  float value_min,
  float value_max
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void EDV_DOUBLE_C(
#if !RTRT_KR
  int aff_interv,
  int uncheck,
  double value,
  int num,
  double value_min,
  double value_max
#endif
) MEMORY_SPACE ;

#endif /* RTRT_FLOAT */
#ifndef DCL_OP_C
#define DCL_OP_C ATU_OP_C
#endif
extern ATL_TP_PROTO_PREFIX void ATU_OP_C(
#if !RTRT_KR
  int num  ,
  const char *name_op
#endif
) MEMORY_SPACE ;

#ifndef DCL_TST_C
#define DCL_TST_C ATU_TST_C
#endif
extern ATL_TP_PROTO_PREFIX void ATU_TST_C(
#if !RTRT_KR
  int num  ,
  const char *name_tst
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void START_CHRONO_C(
#if !RTRT_KR
  void
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void STOP_CHRONO_C(
#if !RTRT_KR
  void
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void START_C(
#if !RTRT_KR
  void
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void STOP_C(
#if !RTRT_KR
  void
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void SET_MODE_TAB_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void UNSET_MODE_TAB_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

#if RTRT_STRING

extern ATL_TP_PROTO_PREFIX void INI_STR_C(
#if !RTRT_KR
  char * s,
  int  aff_val,
  long num,
  atu_charstring val
#endif
) MEMORY_SPACE ;

#endif /* RTRT_STRING */

extern ATL_TP_PROTO_PREFIX void RUPT (
#if !RTRT_KR
  int niveau
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void DCL_FAC_REP_C(
#if !RTRT_KR
  int num,
  int facteur
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void SET_MODE_CST_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void UNSET_MODE_CST_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void ATTOL_OPEN_BRA_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void ATTOL_CLOSE_BRA_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void EDV_CHRONO_MUET_C(
#if !RTRT_KR
  int stub,
  int a_status,
  int num_app
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void EDV_MUET_CHECK(
#if !RTRT_KR
  int stub,
  int ind
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX int COMP_STR_C(
#if !RTRT_KR
atu_charstring  atu_s1,
atu_charstring  atu_s2
#endif
) MEMORY_SPACE;

#endif /* !RTRT_CPLUSPLUS_LANGUAGE */

#endif /* ATU_H_INCLUDED */
