

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* Product version: 7.0.5.1 */

/*******************************************************************************
* $Id: clock.h,v 1.34.4.1 2008/03/18 10:55:50 build Exp $
* $Descr: Time Management header (included by TP.c[pp] and TP.h) $
*******************************************************************************/
/* Multiple inclusions guard: */
#ifndef CLOCK_H_INCLUDED
#define CLOCK_H_INCLUDED


#if ((USE_ATU || (USE_ATT && ATT_TIMESTAMP == ATL_YES) || USE_ATQ) && \
     defined(RTRT_TDP_COMPILATION)) || \
    USE_ATS
/*! Needs priv_clock() */
#define NEEDS_priv_clock
#endif

#if RTRT_CLOCK == RTRT_STD

#if _ATL_WIN32_API

#if ATL_CLOCK_KIND == ATL_OS_CLOCK

#ifdef NEEDS_priv_clock
#if defined(RTRT_TDP_COMPILATION) || !defined( NO_SYS_INCLUDE )
#include <windows.h>
#endif /* NO_SYS_INCLUDE */
#define RTRT_CLOCK_TYPE LARGE_INTEGER
#endif

#define RTRT_UNIT_TYPE RTRT_U_INT64
#define RTRT_UNIT_TYPE_SIZE 8
#define RTRT_TIME_TYPE RTRT_U_INT32
#define RTRT_TIME_TYPE_STEP 1000L
#define RTRT_CLOCK_SECONDS(c) ((c).QuadPart / atl_clock_resolution.QuadPart)
#define RTRT_CLOCK_USECONDS(c) (((c).QuadPart % atl_clock_resolution.QuadPart) \
			        * 1000000L / atl_clock_resolution.QuadPart)

#elif ATL_CLOCK_KIND == ATL_PROCESS_CLOCK

#ifdef NEEDS_priv_clock
#if defined(RTRT_TDP_COMPILATION) || !defined( NO_SYS_INCLUDE )
#include <time.h>
#endif /* NO_SYS_INCLUDE */
#define RTRT_CLOCK_TYPE clock_t
#endif

#define RTRT_UNIT_TYPE RTRT_U_INT32
#define RTRT_UNIT_TYPE_SIZE 4
#define RTRT_TIME_TYPE RTRT_U_INT32
#define RTRT_TIME_TYPE_STEP 1000L
#define RTRT_CLOCK_SECONDS(c) ((c) / CLOCKS_PER_SEC)
#define RTRT_CLOCK_USECONDS(c) (((c) % CLOCKS_PER_SEC) * 1000000L / \
			       CLOCKS_PER_SEC)

#endif

#else /* _ATL_WIN32_API */

#ifdef NEEDS_priv_clock
#if defined(RTRT_TDP_COMPILATION) || !defined( NO_SYS_INCLUDE )
#include <time.h>
#include <sys/time.h>
#endif /* NO_SYS_INCLUDE */
#define RTRT_CLOCK_TYPE struct timeval
#endif

#define RTRT_UNIT_TYPE unsigned long long
#define RTRT_UNIT_TYPE_SIZE 8
#define RTRT_TIME_TYPE RTRT_U_INT32
#define RTRT_TIME_TYPE_STEP 1000L
#define RTRT_CLOCK_SECONDS(c) ((c).tv_sec)
#define RTRT_CLOCK_USECONDS(c) ((c).tv_usec)

#endif /* _ATL_WIN32_API */

#elif RTRT_CLOCK == RTRT_NONE

#define RTRT_CLOCK_TYPE RTRT_U_INT32
#define RTRT_UNIT_TYPE RTRT_U_INT32
#define RTRT_UNIT_TYPE_SIZE 4
#define RTRT_TIME_TYPE RTRT_U_INT32
#define RTRT_TIME_TYPE_STEP 1000L
#define RTRT_CLOCK_SECONDS(c) (c)
#define RTRT_CLOCK_USECONDS(c) 0

#endif /* RTRT_CLOCK == RTRT_STD */

#if !defined(ATL_CPLUSPLUS_INSTRUMENTOR) && !defined(ATL_C_INSTRUMENTOR)

#ifdef NEEDS_priv_clock
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX void priv_clock
#if !RTRT_KR
  (RTRT_CLOCK_TYPE *ret)
#else
  ()
#endif
  ;
#endif

#endif /* !defined(ATL_CPLUSPLUS_INSTRUMENTOR) ... */

#endif
