

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* Product version: 7.0.5.1 */
 

/*******************************************************************************
* $Id: codes.c,v 1.13.2.1 2008/03/18 10:55:50 build Exp $
* $Descr: List of Opcodes Used in Traces (included by TP.c[pp]) $
*******************************************************************************/


/*******************************************************************************
* RIO: Unit Testing
*******************************************************************************/


/*******************************************************************************
* RIO: System Testing
*******************************************************************************/


#if USE_ATO || USE_ATT || USE_ATK
/*******************************************************************************
* TDF: Object Testing & Trace
*******************************************************************************/

#define ATL_TDF_SF "SF" /* Source file */
#define ATL_TDF_CF "CS" /* Change source */
#define ATL_TDF_CI "CI" /* Change instance */
#define ATL_TDF_LK "LK" /* Link */
#define ATL_TDF_ST "ST" /* Style */
#define ATL_TDF_NO "NO" /* Note */
#define ATL_TDF_NI "NI" /* New instance */
#define ATL_TDF_DI "DI" /* Delete instance */
#define ATL_TDF_ME "ME" /* Message */
#define ATL_TDF_MR "MR" /* Message return */
#define ATL_TDF_MC "MC" /* Message call */
#define ATL_TDF_TM "TM" /* Time */
#define ATL_TDF_TS "TS" /* Time synchronization */
#define ATL_TDF_TU "TU" /* Time unit */
#define ATL_TDF_OT "OT" /* Object Testing information */
#define ATL_TDF_GL "GL" /* Glyph */
#define ATL_TDF_SY "SY" /* Synchro. */
#define ATL_TDF_SA "SA" /* Synchro. */
#define ATL_TDF_AC "AC" /* Action */
#define ATL_TDF_LS "LS" /* Loop Start */
#define ATL_TDF_LE "LE" /* Loop End */
#define ATL_TDF_TI "TI" /* Thread Info */

#endif /* #if USE_ATO || USE_ATT || USE_ATK */


#if USE_ATC
/*******************************************************************************
* TIO: Coverage
*******************************************************************************/
#define ATL_TIO_NT "NT" /* New test */
#define ATL_TIO_DT "DT" /* Date of test */
#define ATL_TIO_CO "CO" /* Count mode active */
#define ATL_TIO_FT "FT" /* File Key */
#define ATL_TIO_DC "DC" /* Checksum */
#define ATL_TIO_TP "TP" /* Proc Table */
#define ATL_TIO_TA "TA" /* Call Table */
#define ATL_TIO_TB "TB" /* Bloc Table */
#define ATL_TIO_TE "TE" /* Cond Table */
#define ATL_TIO_EI "EI" /* Error during execution */

#endif /* USE_ATC */


#if USE_ATP
/*******************************************************************************
* TPF: QuantifyLT
*******************************************************************************/
#define ATL_TPF_PU "PU" /* New execution */
#define ATL_TPF_PT "PT" /* New test */
#define ATL_TPF_PS "PS" /* Memory usage summary (blocks) */
#define ATL_TPF_PY "PY" /* Memory usage summary (bytes) */
#define ATL_TPF_PE "PE" /* Event description */
#define ATL_TPF_PB "PB" /* Memory block description */
#define ATL_TPF_PF "PF" /* Function from the call stack*/
#define ATL_TPF_PO "PO" /* Opened file descriptor */
#define ATL_TPF_PH "PH" /* HASH table dump */

#endif /* USE_ATP */


#if USE_ATQ
/*******************************************************************************
* TQF: QuantifyLT
*******************************************************************************/
#define ATL_TQF_QU "QU" /* New execution */
#define ATL_TQF_QT "QT" /* New test */
#define ATL_TQF_QD "QD" /* Date of test */
#define ATL_TQF_QS "QS" /* Source */
#define ATL_TQF_QF "QF" /* Function */

#endif /* USE_ATQ */

#ifndef ATL_LINE_ADD_OPCODE
#ifdef RTRT_KR
/*! Add to _atl_line the opcode o, plus a space character */
#define ATL_LINE_ADD_OPCODE_SPACE(o) atl_line_add (o); atl_line_add_char (' ')
#else
#define ATL_LINE_ADD_OPCODE_SPACE(o) atl_line_add (o " ")
#endif
#define ATL_LINE_ADD_OPCODE(o) atl_line_add (o)
#endif

#define ATL_ATL_WA "WA" /* Warning not to be split */
