

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* Product version: 7.0.5.1 */

/*******************************************************************************
* $Id: image.h,v 1.20.2.1 2008/03/18 10:55:50 build Exp $
* $Descr: Common Presentation Functions header (included by TP.h) $
*******************************************************************************/
/* Multiple inclusions guard: */
#ifndef IMAGE_H_INCLUDED
#define IMAGE_H_INCLUDED

#if USE_ATU || USE_ATO || USE_ATK
#define NEEDS_bool_type
#endif

#ifdef NEEDS_bool_type
#if RTRT_BOOL_DEFINED
#define _atl_bool bool
#define _atl_true true
#define _atl_false false
#else
#define _atl_bool RTRT_U_INT8
#define _atl_true 1
#define _atl_false 0
#endif
#endif

/* Shared type: _atl_bool */
#if defined(RTRT_TDP_COMPILATION) || USE_ATS || USE_ATU

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX char *atl_strcpy
#if !RTRT_KR
   (char *, char *)
#else
  ()
#endif
  ;
#endif

#if defined(RTRT_TDP_COMPILATION) || USE_ATS

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX int atl_strcmp
#if !RTRT_KR
  (const char *, const char *)
#else
  ()
#endif
  ;

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX int atl_strncmp
#if !RTRT_KR
  (const char *, const char *, unsigned int)
#else
  ()
#endif
  ;

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX char *atl_strcat
#if !RTRT_KR
  (char *, const char *)
#else
  ()
#endif
  ;

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX char *atl_strstr
#if !RTRT_KR
  (char *, char *)
#else
  ()
#endif
  ;

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX int atl_strlen
#if !RTRT_KR
  (char *)
#else
  ()
#endif
  ;

#if USE_ATS
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX int atl_fltcmp
#if !RTRT_KR
  (float, float)
#else
  ()
#endif
  ;

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX int atl_dblcmp
#if !RTRT_KR
  (double, double)
#else
  ()
#endif
  ;
#endif /* USE_ATS */


_ATL_EXTERN_C ATL_TP_PROTO_PREFIX int atl_sprintf
#if !RTRT_KR
  (char *, const char *, ...)
#else
  ()
#endif
  ;

#endif /* USE_ATS */

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX void _atl_add_error
#if !RTRT_KR
( const char *errcode,const char *msg )
#else
  ()
#endif
  ;

#endif
