

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* Product version: 7.0.5.1 */

/*******************************************************************************
* $Id: options_model.h,v 1.16.4.1 2008/03/18 10:55:50 build Exp $
* $Descr: Studio-modifiable Settings (Parsed by Products.pl) $
*******************************************************************************/
/* Multiple inclusions guard: */
#ifndef OPTIONS_MODEL_H_INCLUDED
#define OPTIONS_MODEL_H_INCLUDED



#define ATL_YES      1
#define ATL_NO       0

/*******************************************************************************
* TestRT Unit Testing:
*******************************************************************************/

/*******************************************************************************
* TestRT System Testing:
*******************************************************************************/

#ifndef ATL_WITHOUT_STUDIO
@ATS@ ATS_BUFFER_SIZE <number>
#else
#ifndef ATS_BUFFER_SIZE
/*! Size in bytes of buffer (used to store string vars and lines) */
#define ATS_BUFFER_SIZE 1024
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATS@ ATS_TAGTBUF_SIZE <number>
#else
#ifndef ATS_TAGTBUF_SIZE
/*! Maximum size in bytes of lines raised by testers */
#define ATS_TAGTBUF_SIZE 4096
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATS@ ATS_RT_BUFFER ATL_YES|ATL_NO
#else
#ifndef ATS_RT_BUFFER
#define ATS_RT_BUFFER ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATS@ ATS_DYNFLW ATL_YES|ATL_NO
#else
#ifndef ATS_DYNFLW
/*! Activates dynamic tracking */
#define ATS_DYNFLW ATL_NO
#endif
#endif

/*******************************************************************************
* TestRT Object Testing:
*******************************************************************************/

/*******************************************************************************
* TestRT Contract Check:
*******************************************************************************/

#ifndef ATL_WITHOUT_STUDIO
@ATK@ ATK_REPORT_REFLEXIVE_STATES ATL_NO|ATL_YES
#else
#ifndef ATK_REPORT_REFLEXIVE_STATES
/*! Calls a breakpoint function on an error if 1 */
#define ATK_REPORT_REFLEXIVE_STATES 1
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATK@ ATK_CONST_ASSERTIONS ATL_NO|ATL_YES
#else
#ifndef ATK_CONST_ASSERTIONS
/*! Enforce state conditions and invariant conditions to be constant */
#define ATK_CONST_ASSERTIONS 0
#endif
#endif

/*******************************************************************************
* TestRT Coverage:
*******************************************************************************/

/*******************************************************************************
* TestRT Trace:
*******************************************************************************/

/*******************************************************************************
* TestRT PurifyLT:
*******************************************************************************/

/*******************************************************************************
* TestRT QuantifyLT:
*******************************************************************************/

/*******************************************************************************
* Several products settings:
*******************************************************************************/

#ifndef ATL_MULTI_THREADS
#ifndef ATL_WITHOUT_STUDIO
@ATL@ ATL_MULTI_THREADS ATL_YES|ATL_NO
#else
/*! Multi-threaded application */
#define ATL_MULTI_THREADS ATL_NO
#endif
#endif

#define ATL_OS_CLOCK 1
#define ATL_PROCESS_CLOCK 2
#ifndef ATL_WITHOUT_STUDIO
@ATL@ ATL_CLOCK_KIND ATL_OS_CLOCK|ATL_PROCESS_CLOCK
#else
#ifndef ATL_CLOCK_KIND
/*! Clock type : OS or process */
#define ATL_CLOCK_KIND ATL_OS_CLOCK
#endif
#endif

#endif
