

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* Product version: 7.0.5.1 */

/*******************************************************************************
* $Id: routinst.h,v 1.17.4.1 2008/03/18 10:55:50 build Exp $
* $Descr: Routine instrumentation macros for Object Testing & Contract Check (included across TP.h) $
*******************************************************************************/
/* Multiple inclusions guard: */
#ifndef ROUTINST_H_INCLUDED
#define ROUTINST_H_INCLUDED


#if RTRT_GENERATE_EXCEPTIONS

struct _ATO_void_ret { };

#ifdef _ATO_USE_TEMPLATE_ROUTINST_STRUCTURES

template<class T>
struct _ATO_ret_template_struct {
   T ret;
   _ATO_ret_template_struct (T _ret) : ret (_ret) {}
   T _ATO_get_result () { return ret; }
};

template<class T>
struct _ATO_ret_ref_template_struct {
   T *ret;
   _ATO_ret_ref_template_struct (T &_ret) : ret (&_ret) {}
   T &_ATO_get_result () { return *ret; }
};

#endif /* _ATO_USE_TEMPLATE_ROUTINST_STRUCTURES */

#define _ATO_NONVOID_RETTYPEDEF(m,t) \
   struct RTRT_CONCAT_MACRO(_ATO_ret_,m) { t ret; \
   RTRT_CONCAT_MACRO(_ATO_ret_,m) (t _ret) : ret(_ret) {} \
   t _ATO_get_result () { return ret; } };

#define _ATO_NONVOIDREF_RETTYPEDEF(m,t) \
   struct RTRT_CONCAT_MACRO(_ATO_ret_,m) { t *ret; \
   RTRT_CONCAT_MACRO(_ATO_ret_,m) ( t &_ret) : ret(&_ret) {} \
   t &_ATO_get_result () { return *ret; } };

#define _ATO_NONVOID_ROUTINE_START \
   try

#define _ATO_VOID_ROUTINE_START \
   try

#define _ATO_NONVOIDREF_ROUTINE_START \
   try

#if USE_ATK
#define _ATO_SET_EXCEPTION(b) _atk_Boolean _ATO_in_exception=b;
#else
#define _ATO_SET_EXCEPTION(b) _ato_Boolean _ATO_in_exception=b;
#endif

#define _ATO_VOID_ROUTINE_POST \
   catch (_ATO_void_ret &_ATO_return_exception) {

#define _ATO_EXCEPTION_POST \
   catch (...) {

#define _ATO_STUB_EXCEPTION_POST \
   catch (...) { _ATO_exception_in_stub ();

#define _ATO_ROUTINE_END \
   return _ATO_return_exception.ret;}

#define _ATO_REFROUTINE_END \
   return *_ATO_return_exception.ret;}

#define _ATO_VOID_ROUTINE_END \
   return;}

#define _ATO_EXCEPTION_END \
   throw;}

#define _ATO_VOID_RETURN \
   throw _ATO_void_ret ()

#define _ATO_result (_ATO_return_exception._ATO_get_result())

#define _ATO_exc_result (*_ATO_dummy_result)

#else /* RTRT_GENERATE_EXCEPTIONS */

#define _ATO_NONVOID_RETTYPEDEF(m)

#define _ATO_NONVOIDREF_RETTYPEDEF(m)
 
#define _ATO_NONVOID_ROUTINE_START \
   _ATO_return_type _ATO_result;

#define _ATO_VOID_ROUTINE_START

#define _ATO_NONVOIDREF_ROUTINE_START \
   _ATO_return_type *_ATO_result;

#define _ATO_ROUTINE_POST(m) \
   _ATO_end_of_routine:

#define _ATO_VOID_ROUTINE_POST \
   _ATO_end_of_void_routine:

#define _ATO_ROUTINE_END \
   return _ATO_result;

#define _ATO_REFROUTINE_END \
   return *_ATO_result;

#define _ATO_VOID_ROUTINE_END \
   return;

#define _ATO_VOID_RETURN \
   goto _ATO_end_of_void_routine

#define _ATO_SET_EXCEPTION(b)

#endif /* RTRT_GENERATE_EXCEPTIONS */

/* Temporary */
#define ATL_INT32 RTRT_INT32

#endif
