

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* Product version: 7.0.5.1 */
 
/*******************************************************************************
* $Id: rtstack.c,v 1.37.2.1 2008/03/18 10:55:50 build Exp $
* $Descr: Call Stack Management (included by TP.c[pp]) $
*******************************************************************************/
#ifndef ATL_DUMP_ON_RETURNING
#define ATL_DUMP_ON_RETURNING
#endif

/*******************************************************************************
* Global variables
*******************************************************************************/

#if USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL
RTRT_GLOBALVAR RTRT_U_INT16 _atl_stack_level_max;
#endif /* USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL */

RTRT_GLOBALVAR RTRT_U_INT8 _atl_stack_error_emitted;

#if ATL_MULTI_THREADS == ATL_NO

RTRT_GLOBALVAR _AtlStackLinkP _atl_stack_start_link;
RTRT_GLOBALVAR _AtlStackLinkP _atl_stack_current_link;
#define _atl_get_stack_current() _atl_stack_current_link
#if USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL
RTRT_GLOBALVAR RTRT_U_INT16 _atl_stack_level;
#endif /* USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL */

#else /* ATL_MULTI_THREADS */

RTRT_GLOBALVAR _AtlStackLinkP _atl_stack_table_start[ATL_THREADS_MAX+1];
RTRT_GLOBALVAR _AtlStackLinkP _atl_stack_table_current[ATL_THREADS_MAX+1];

#if !RTRT_KR
RTRT_STATICFCT int _att_check_thread (_AtlStackLinkP stack_link);
#else
RTRT_STATICFCT int _att_check_thread ( );
#endif

/*******************************************************************************
*  Service: _atl_get_stack_current
*******************************************************************************/
RTRT_STATICFCT _AtlStackLinkP _atl_get_stack_current
#if !RTRT_KR
( void )
#else
( )
#endif
{
  int thedata;
  _AtlStackLinkP current=(_AtlStackLinkP)0; /* Not observed */
  RTRT_MT_THREAD_SPECIFIC_DATA_GET ( thedata );
  if ( thedata >= 0 &&
       thedata <= ATL_THREADS_MAX &&
       _atl_threads_table_used[thedata]==RTRT_MT_THREAD_SELF )
  { /* In order to be sure this is something we are already observing */
  	current = (_AtlStackLinkP)_atl_stack_table_current[thedata];
#if ATL_CHECK_STACK
    if ( current && _ATL_STACK_CHECK_MAGIC(current) )
    {
      ATL_ERROR ('H', "_atl_get_stack_current(): runtime analysis stack data is corrupted" );
      return (_AtlStackLinkP)0;
    }
#endif /* ATL_CHECK_STACK */
  }

  return current;
}

#if USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL
RTRT_GLOBALVAR RTRT_U_INT16 _atl_stack_table_level[ATL_THREADS_MAX+1];
#endif /* USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL */

#define _atl_stack_start_link \
  _atl_stack_table_start[thread_index]
#define _atl_stack_current_link \
  _atl_stack_table_current[thread_index]

#if USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL
#define _atl_stack_level \
  _atl_stack_table_level[thread_index]
#endif /* USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL */

RTRT_MT_CRITICAL_VAR_DECL(atl_stack_critical)

#if USE_ATT
/* RTRT_MT_CRITICAL_VAR_DECL(att_producer) not used any more*/
#if !RTRT_KR
RTRT_STATICFCT    void _att_thread_fall_asleep ( );
RTRT_STATICFCT    void _att_thread_schedule    ( int );
RTRT_STATICFCT    void _att_thread_create      ( _AtlStackLinkP, int );
#else
RTRT_STATICFCT    void _att_thread_fall_asleep ( );
RTRT_STATICFCT    void _att_thread_schedule    ( );
RTRT_STATICFCT    void _att_thread_create      ( );
#endif
#endif /* USE_ATT */

/*******************************************************************************
*  Service: _atl_stack_check_thread
*******************************************************************************/
RTRT_STATICFCT int _atl_stack_check_thread
#if !RTRT_KR
( _AtlStackLinkP stack_link )
#else
( stack_link )
  _AtlStackLinkP stack_link;
#endif
{
  int thread_status;
  int thread_index=stack_link->ThreadIndex;
  thread_status = _atl_threads_get_status (&thread_index);
  if ( thread_status == _ATL_THREADS_CREATED )
  {
    _atl_stack_start_link = (_AtlStackLinkP)0;
    _atl_stack_current_link = (_AtlStackLinkP)0;
#if USE_ATT
#if ATT_COMPUTE_MAX_CALLING_LEVEL
    _atl_stack_level = 0;
#endif /* ATT_COMPUTE_MAX_CALLING_LEVEL */
  RTRT_MT_CRITICAL_VAR_LOCK(atl_tdf_mutex)
    _att_thread_fall_asleep ( );
    _att_thread_create ( stack_link, thread_index);
  RTRT_MT_CRITICAL_VAR_UNLOCK(atl_tdf_mutex)
#endif /* USE_ATT */
  }
  return thread_index;
}

#endif /* ATL_MULTI_THREADS */

#if USE_ATT
#if !RTRT_KR
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _att_method_return    ( _AtlStackLinkP );
#else
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _att_method_return    ( );
#endif
#endif /* USE_ATT */

#if USE_ATQ
#if !RTRT_KR
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    int _atq_end ( _AtlStackLinkP );
#else
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    int _atq_end ( );
#endif
#endif /* USE_ATQ */



#if RTRT_LONGJMP==RTRT_USR

/*******************************************************************************
*  Service: _atl_stack_jump
*******************************************************************************/
_ATL_C_GLOBALFCT void _atl_stack_jump
#if !RTRT_KR
( void *addr, short greater_than )
#else
( addr, greater_than )
  void *addr;
  short greater_than;
#endif
{
  _AtlStackLinkP current;
#if ATL_MULTI_THREADS
  int thread_index;
#endif /* ATL_MULTI_THREADS */

#if ATL_MULTI_THREADS
  thread_index=_atl_threads_get_index ( );
#endif /* ATL_MULTI_THREADS */
  current = _atl_stack_current_link;
  for ( ;
        current &&
#if ATL_CHECK_STACK
        ! _ATL_STACK_CHECK_MAGIC(current) &&
#endif
        ( greater_than ? ( addr > (void *)current ) :
                         ( (void *)current > addr ) );
        current = current->Up )
  {
#if USE_ATT
    _att_method_return ( current );
#endif /* USE_ATT */
#if USE_ATQ
    if(current->AtqData)
        _atq_end ( current );
#endif /* USE_ATQ */
    _atl_stack_link_pop ( current );
  }
}

#endif /* RTRT_LONGJMP==RTRT_USR */

#if ATL_MULTI_THREADS

/*******************************************************************************
*  Service: _atl_stack_finish
*******************************************************************************/
RTRT_STATICFCT void _atl_stack_finish
#if !RTRT_KR
( int index )
#else
( index )
 int index;
#endif
{
  _AtlStackLinkP current;

  current = _atl_stack_table_current[index];
  for ( ;
        current
#if ATL_CHECK_STACK
        && ! _ATL_STACK_CHECK_MAGIC(current)
#endif
                                         ;
        current = current->Up )
  {
#if USE_ATT
    _att_method_return ( current );
#endif /* USE_ATT */
#if USE_ATQ
    _atq_end ( current );
#endif /* USE_ATQ */
    _atl_stack_link_pop ( current );
  }
}

#endif /* ATL_MULTI_THREADS */

/*******************************************************************************
*  Service: _atl_stack_link_push
*******************************************************************************/
_ATL_C_GLOBALFCT void _atl_stack_link_push
#if !RTRT_KR
( _AtlStackLinkP stack_link )
#else
( stack_link )
  _AtlStackLinkP stack_link;
#endif
{

#if ATL_MULTI_THREADS
  RTRT_U_INT32	thread_index;
#endif /* ATL_MULTI_THREADS */
  if ( ! _ATL_INITIALIZED )
  {
    /* This branch is reached once in the process life */
    atl_early_init ( );
  }
#if ATL_CHECK_STACK
  _ATL_STACK_SET_MAGIC(stack_link->Magic1)
  _ATL_STACK_SET_MAGIC(stack_link->Magic2)
#endif /* ATL_CHECK_STACK */
  _ATL_STACK_INIT_ATP(stack_link)
  _ATL_STACK_INIT_ATQ(stack_link)

  if ( stack_link->Info.Source->UseCheck != _ATL_STACK_CONST &&
       ! _atl_stack_error_emitted )
  {
    ATL_ERROR ('J', "Observation Tools: Mismatch between tools selection for TDP compilation and for instrumentation; check your settings and command-line (Trace/Memory Profiling/Performance Profiling)" );
    _atl_stack_error_emitted = 1;
  }
#if ATL_MULTI_THREADS
  stack_link->ThreadIndex=0;
  thread_index=_atl_stack_check_thread ( stack_link );
  stack_link->ThreadIndex=thread_index;
#endif /* ATL_MULTI_THREADS */
  RTRT_MT_CRITICAL_VAR_LOCK(atl_stack_critical)
  if ( _atl_stack_start_link && _atl_stack_current_link
       /* Both are supposed to be null or non-null at the same time, but... */
#if ATL_CHECK_STACK
  		&& !(_ATL_STACK_CHECK_MAGIC(_atl_stack_current_link))
#endif /* ATL_CHECK_STACK */
  		)
  { /* Continue the stack */
    _atl_stack_current_link->Down = stack_link;
    stack_link->Up = _atl_stack_current_link;
  }
  else
  { /* Starting the stack */
    _atl_stack_start_link = stack_link;
    stack_link->Up = (_AtlStackLinkP)0;
  }
  stack_link->Down = (_AtlStackLinkP)0;
  _atl_stack_current_link = stack_link;
#if USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL
  _atl_stack_level++;
  if ( _atl_stack_level_max < _atl_stack_level )
  {
    _atl_stack_level_max = _atl_stack_level;
  }
#endif /* USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL */
  RTRT_MT_CRITICAL_VAR_UNLOCK(atl_stack_critical)
}

/*******************************************************************************
*  Service: _atl_stack_link_pop
*******************************************************************************/
_ATL_C_GLOBALFCT void _atl_stack_link_pop
#if !RTRT_KR
( _AtlStackLinkP stack_link )
#else
( stack_link )
  _AtlStackLinkP stack_link;
#endif
{
#if ATL_MULTI_THREADS
  RTRT_U_INT32	thread_index;
#endif /* ATL_MULTI_THREADS */
  _AtlStackLinkP current;
  ATL_DUMP_ON_RETURNING

#if ATL_CHECK_STACK
  if ( stack_link && _ATL_STACK_CHECK_MAGIC(stack_link) )
  {
    ATL_ERROR ('K', "_atl_stack_link_pop(): runtime analysis stack data is corrupted" );
    return;
  }
#endif /* ATL_CHECK_STACK */
#if ATL_MULTI_THREADS
/* no need to call _atl_stack_check_thread ( stack_link ); since att did it */
  if(stack_link) thread_index=stack_link->ThreadIndex;
  else thread_index=_atl_threads_get_index();
  RTRT_MT_CRITICAL_VAR_LOCK(atl_stack_critical)
#endif /* ATL_MULTI_THREADS */
  if ( stack_link == _atl_stack_current_link )
  {
    if ( _atl_stack_start_link != _atl_stack_current_link )
    {
      _atl_stack_current_link = _atl_stack_current_link->Up;
      _atl_stack_current_link->Down = (_AtlStackLinkP)0;
    }
    else
    { /* Reaching the top of the stack */
      _atl_stack_start_link = (_AtlStackLinkP)0;
      _atl_stack_current_link = (_AtlStackLinkP)0;
    }
#if USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL
    _atl_stack_level--;
#endif /* USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL */
  }
  else
  { /* longjmp ? */
#if USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL
    _atl_stack_level = 0;
#endif /* USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL */
    for ( current = _atl_stack_start_link;
          current && current != stack_link
#if ATL_CHECK_STACK
    && !_ATL_STACK_CHECK_MAGIC(current)
#endif
          ;
          current = current->Down )
    {
#if USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL
      _atl_stack_level++;
#endif /* USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL */
    }
    if ( current && current == stack_link)
    {
      _atl_stack_current_link = stack_link->Up;
      if ( _atl_stack_current_link )
      {
        _atl_stack_current_link->Down = (_AtlStackLinkP)0;
      }
    }
    else
    { /* We are not in the same stack !?!
       * or this is a stack flush due to an exit() */
      _atl_stack_start_link = (_AtlStackLinkP)0;
      _atl_stack_current_link = (_AtlStackLinkP)0;
    }
  }
  RTRT_MT_CRITICAL_VAR_UNLOCK(atl_stack_critical)
}

/*******************************************************************************
*  Service: _atl_stack_link_pop_return
*******************************************************************************/
_ATL_C_GLOBALFCT int _atl_stack_link_pop_return
#if !RTRT_KR
( _AtlStackLinkP stack_link,
  int result )
#else
( stack_link, result )
  _AtlStackLinkP stack_link;
  int result;
#endif
{
  _atl_stack_link_pop ( stack_link );

  /* Must return result */
  return result;
}

/*******************************************************************************
*  Service: atl_stack_early_init
*******************************************************************************/
RTRT_STATICFCT void atl_stack_early_init
#if !RTRT_KR
( void )
#else
( )
#endif
{
#if ! RTRT_RAM_CLEAN

#if ATL_MULTI_THREADS
  int thread_index;
  for ( thread_index = 0; thread_index <= ATL_THREADS_MAX; thread_index++ )
#endif /* ATL_MULTI_THREADS */
  {
	  _atl_stack_start_link = (_AtlStackLinkP)0;
	  _atl_stack_current_link = (_AtlStackLinkP)0;
#if USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL
  	  _atl_stack_level = 0;
#endif /* USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL */
  }
#if USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL
  _atl_stack_level_max = 0;
#endif /* USE_ATT && ATT_COMPUTE_MAX_CALLING_LEVEL */
  _atl_stack_error_emitted = 0;
#endif

  RTRT_MT_CRITICAL_VAR_INIT(atl_stack_critical) /* mutex protecting the call stack manipulations */
}

#ifdef _ATL_EXIT_PENDING
/*******************************************************************************
*  Service: atl_stack_exit_pending
*******************************************************************************/
_ATL_C_GLOBALFCT void atl_stack_exit_pending
#if !RTRT_KR
( void )
#else
( )
#endif
{
 /* _atl_stack_link_pop ( (_AtlStackLinkP)0 ); */
}
#else
/*******************************************************************************
*  Service: atl_stack_clean_up
*******************************************************************************/
_ATL_C_GLOBALFCT void atl_stack_clean_up
#if !RTRT_KR
( void )
#else
( )
#endif
{
  /* _atl_stack_link_pop ( (_AtlStackLinkP)0 ); */
}
/*******************************************************************************
*  Service: atl_stack_late_exit
*******************************************************************************/
_ATL_C_GLOBALFCT void atl_stack_late_exit
#if !RTRT_KR
( void )
#else
( )
#endif
{
  RTRT_MT_CRITICAL_VAR_DESTROY(atl_stack_critical)
}
#endif /* _ATL_EXIT_PENDING */

