
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

////////////////////////////////////////////////////////////////////////////////
// $Id: Buffer.java,v 1.18.4.1 2008/03/18 13:31:17 build Exp $
// $Descr: Common Buffer Library $
////////////////////////////////////////////////////////////////////////////////


package com.rational.testrealtime;
import java.lang.Thread;

public class Buffer {

    public static byte buffer[];
    private static final byte atl_hexa_digits[] =
     // '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
      { 48, 49, 50, 51, 52, 53, 54, 55, 56, 57,
     // 'a', 'b', 'c', 'd', 'e', 'f'
        97, 98, 99, 100, 101, 102 };
    private static int index = 0;

    static boolean is_open = true,
                   flush_at_each_line = false;


    public static Thread JTestThread = null;

    public static void setJtestThread(Thread Jtest)
    {
      JTestThread = Jtest;
    }

    public static boolean is_open()
    {
      if (! Products.mode_JTesting )
        return true;

      if (!is_open)
        return false;
      else
	  {
	      if ( Thread.currentThread() != JTestThread )
		  return false;
	      return true;
	  }
    }



    public static void closebufferflag(){
      is_open= false;
    }
    public static void openbufferflag() {
      is_open= true;
    }

    static { // earlyInit
      buffer = new byte[Products.buffer_size];
      Custom.outOpen ( );
      if (com.rational.testrealtime.Products.mode_JTesting)
        closebufferflag();
    }

    public static void lateExit ( ) {
      flush ( );
      if ( Products.close_io ) {
        Custom.outClose ( );
      } else {
        flush_at_each_line = true;
      }
    }

    public static void flush ( int plus ) {
      if ( index > Products.buffer_size - plus ) {
        Custom.outWrite ( buffer, index );
        index = 0;
      }
    }

    public static void flush ( ) {
      if ( index > 0 ) {
        Custom.outWrite ( buffer, index );
        index = 0;
      }
    }

    public static void pushOpCode ( byte o1, byte o2 ) {
      flush ( 3 );
      buffer[index++] = o1;
      buffer[index++] = o2;
      buffer[index++] = 32; // ' '
    }

    public static void pushOpCodeSingle ( byte o1, byte o2 ) {
      flush ( 2 );
      buffer[index++] = o1;
      buffer[index++] = o2;
    }

    public static void pushLiteral ( byte literal[] ) {
      flush ( 2 * literal.length + 2 );
      buffer[index++] = 34; // '"'
      for ( int i = 0;
            i < literal.length;
            i++ ) {
        if ( literal[i] == 34 || // '"'
             literal[i] == 92 ) { // '\\'
          buffer[index++] = 92; // '\\'
        }
        buffer[index++] = literal[i];
      }
      buffer[index++] = 34; // '"'
    }

    public static void pushSpace ( ) {
      flush ( 1 );
      buffer[index++] = 32; // ' '
    }

    public static void pushComma ( ) {
      flush ( 1 );
      buffer[index++] = 44; // ','
    }

    public static void pushUnsigned16h ( int v ) {
      flush ( 9 );
      int write = 0;
      byte p;
      for ( int i = 28; i > 0; i -= 4 ) {
        p = atl_hexa_digits[(v>>i)&0x0F];
        if ( write != 0 ) {
          buffer[index++] = p;
        } else {
          if ( p != 48 ) { // '0'
            write = 1;
            buffer[index++] = p;
          }
        }
      }
      buffer[index++] = atl_hexa_digits[(v)&0x0F];
      if ( v < 0 || v > 9 ) {
        buffer[index++] = 104; // 'h'
      }
    }

    public static void pushRUnsigned16 ( int v ) {
      flush ( 8 );
      int n = v, w = ( v < 0 ) ? -1 : 0;
      byte p;
      do {
        buffer[index++] = atl_hexa_digits[n&0x0F];
        n >>= 4;
      } while ( n != w );
    }

    public static void pushLine ( ) {
      flush ( 1 );
      buffer[index++] = 10; // '\n'
      if ( flush_at_each_line ) {
        flush ( );
      }
    }

}

