
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

////////////////////////////////////////////////////////////////////////////////
// $Id: TimeMng.java,v 1.11.4.1 2008/03/18 13:31:17 build Exp $
// $Descr: Time Library Source $
////////////////////////////////////////////////////////////////////////////////

package com.rational.testrealtime;


import com.rational.testrealtime.Buffer;
import com.rational.testrealtime.Custom;

public class TimeMng {

  public TimeMng() {
  }

  protected static long initial = 0;
  protected static boolean start = false;

  static protected void startSequence()
  {
    if (com.rational.testrealtime.Buffer.is_open())
	{
	    Buffer.pushOpCode ( (byte)'T', (byte)'U' ); // TU
	    Buffer.pushLiteral ( Custom.getClockUnit ( ) ) ;
	    Buffer.pushLine ( );
	    start = true;
	    initial = Custom.getClock ( );
	}
  }

  static protected void setTime()
  {
    long current = Custom.getClock ( );
    current = (current - initial);
    if (com.rational.testrealtime.Buffer.is_open())
	{
	    Buffer.pushOpCode ( (byte)'T', (byte)'M' ); // TM
	    if ( ( current >> 32 ) != 0 ) {
		Buffer.pushUnsigned16h ( (int)(current >> 32) );
		Buffer.pushSpace ( );
	    }
	    Buffer.pushUnsigned16h ( (int)(current&0xFFFFFFFF));
	    Buffer.pushLine ( );
	}
  }

  static public void writeTime()
  {
    if ( start == false )
    {
      startSequence();
    }
  }
}
