
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.//
//                                                                            //
//                Product: Rational(R) Test RealTime                          //
//                                                                            //
//      Product Component: All                                                //
//                                                                            //
//               Language: java                                               //
//                                                                            //
//        Product version: 2001A.04.00                                        //
//                                                                            //
// Target Deployment Port: jdk1.3.1                                           //
//                         Java - JDK 1.3.1                                   //
//                                                                            //
//                   File: TsfMng.java                                        //
//                         Tsf Library Source                                 //
//                                                                            //
// Rational, the Rational logo are registered trademarks of                   //
// Rational Software Corporation.                                             //
//                                                                            //
// The placing of the copyright notices on Rational source code is not        //
// intended to mean that they are published works, but are included in the    //
// event of inadvertent publication. The source code of Rational contains     //
// trade secrets and other valuable confidential information of Rational      //
// Software Corporation. Rational Software Corporation and its licensors      //
// retain ownership to Rational Products in both source and object code       //
// format, and related documentation and all rights therein including         //
// copyrights, patents and trade secrets.                                     //
//                                                                            //
//                                                                            //
// U.S. Government Rights                                                     //
//                                                                            //
// Use, duplication, or disclosure by the U.S. Government is subject to       //
// restrictions set forth in the applicable Rational License Agreement        //
// and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                 //
// 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,       //
// or FAR 52.227-14, as applicable.                                           //
//                                                                            //
// Unless otherwise agreed to in writing, use of Rational products is         //
// governed by the Rational Product License Agreement provided with           //
// the product.                                                               //
////////////////////////////////////////////////////////////////////////////////
package com.rational.testrealtime;

import com.rational.testrealtime.Buffer;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */

public class TsfMng {

  public TsfMng() {
  }

  public static final byte testcase[] = {(byte)'T',(byte)'e',(byte)'s',(byte)'t',(byte)'C',(byte)'a',(byte)'s',(byte)'e'};

  public static final byte testsuite[] = {(byte)'T',(byte)'e',(byte)'s',(byte)'t',(byte)'S',(byte)'u',(byte)'i',(byte)'t',(byte)'e'};

  public static final byte runtestcase[] = {(byte)'r',(byte)'u',(byte)'n',(byte)' ',(byte)'T',(byte)'e',(byte)'s',(byte)'t',(byte)'C',(byte)'a',(byte)'s',(byte)'e'};

  public static final byte runtestsuite[] = {(byte)'r',(byte)'u',(byte)'n',(byte)' ',(byte)'T',(byte)'e',(byte)'s',(byte)'t',(byte)'S',(byte)'u',(byte)'i',(byte)'t',(byte)'e'};

  public final static int id_testcase = 10;
  public final static int id_testsuite = 11;
  public final static int id_runtestcase = 12;
  public final static int id_runtestsuite = 13;





  public static void writeDB(byte[] msg)
  {
    if (com.rational.testrealtime.Buffer.is_open())
	{
	    Buffer.pushOpCode ( (byte)'D', (byte)'B' ); // DB
	    Buffer.pushLiteral ( msg );
	    Buffer.pushLine ( );
	}
  }

  public static void writeED()
  {
     if (com.rational.testrealtime.Buffer.is_open())
	{
	    Buffer.pushOpCode ( (byte)'E', (byte)'D' ); // ED
	    Buffer.pushLine ( );
	}
  }

  public static void writeMS(byte[] msg, int si)
  {
    if (com.rational.testrealtime.Buffer.is_open())
	{
	    Buffer.pushOpCode ( (byte)'M', (byte)'S' ); //MS
	    Buffer.pushUnsigned16h ( si );
	    Buffer.pushSpace ( );
	    Buffer.pushLiteral ( msg );
	    Buffer.pushLine ( );
	}
  }

  public static void writeID(int id1, int id2)
  {
    if (com.rational.testrealtime.Buffer.is_open())
	{
	    Buffer.pushOpCode ( (byte)'I' , (byte)'D' ); // ID
	    Buffer.pushUnsigned16h ( id1 );
	    Buffer.pushSpace ( );
	    Buffer.pushUnsigned16h ( id2 );
	    Buffer.pushLine ( );
	}
  }


  public static void writeSI(int si)
  {
    if (com.rational.testrealtime.Buffer.is_open())
	{
	    Buffer.pushOpCode ( (byte)'S', (byte)'I' ); // SI
	    Buffer.pushUnsigned16h ( si );
	    Buffer.pushLine ( );
	}
  }

  public static void writeIN(byte[] inclass, int id, byte[] nameclass)
  {
    if (com.rational.testrealtime.Buffer.is_open())
	{
	    Buffer.pushOpCode ( (byte)'I', (byte)'N' ); // IN
	    Buffer.pushSpace ( );
	    Buffer.pushLiteral ( inclass );
	    Buffer.pushSpace ( );
	    Buffer.pushUnsigned16h ( id );
	    Buffer.pushSpace ( );
	    Buffer.pushLiteral ( nameclass );
	    Buffer.pushLine ( );
	}
  }

}
