
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

/////////////////////////////////////////////////////////////////////// 
//JUnit is a regression testing framework written by Erich           // 
//Gamma and Kent Beck. It is used by the developer who               // 
//implements unit tests in Java.                                     // 
//JUnit is Open Source http://www.opensource.org/ Software,          // 
//released under the IBM's Common Public License Version 0.5         // 
//http://oss.software.ibm.com/developerworks/oss/license-cpl.htm     // 
//l and hosted on SourceForge http://sourceforge.net/projects/junit/.// 
/////////////////////////////////////////////////////////////////////// 
package j2meunit.framework;

import java.util.Vector;

public class InstanceStack {

  public InstanceStack() {

  }

  static protected Vector instanceSuite = new Vector();
  static protected Vector instanceTest = new Vector();
  static int suitestack = 0;
  static int teststack = 0;
  static int currenttestid=0;
  static int pushInstanceSuite(int id)
  {
    return pushTest(id);
  }
  public static void popInstanceSuite()
  {
    popTest();
  }
  public static int pushTest(int id)
  {
    ++teststack;
    if (instanceTest.size() >= teststack)
    {
      Integer returned = (Integer)(instanceTest.elementAt((teststack-1)));
      currenttestid = returned.intValue();
      return(currenttestid);
    }
    else
    {
      instanceTest.addElement(new Integer(id));
      currenttestid = id;
      return (currenttestid);
    }
  }
  public static void popTest()
  {
    --teststack;
   
    if (teststack>=1)
	{
	    Integer returned  = (Integer)instanceTest.elementAt(teststack-1);
	    currenttestid = returned.intValue();
	}
    else
	{
	    currenttestid = 0;
	}

  }

  public static int getCurrentTestId()
  {
    return (currenttestid);
  }

}
