
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

/////////////////////////////////////////////////////////////////////// 
//JUnit is a regression testing framework written by Erich           // 
//Gamma and Kent Beck. It is used by the developer who               // 
//implements unit tests in Java.                                     // 
//JUnit is Open Source http://www.opensource.org/ Software,          // 
//released under the IBM's Common Public License Version 0.5         // 
//http://oss.software.ibm.com/developerworks/oss/license-cpl.htm     // 
//l and hosted on SourceForge http://sourceforge.net/projects/junit/.// 
/////////////////////////////////////////////////////////////////////// 
package j2meunit.framework;
import j2meunit.framework.*;
import com.rational.testrealtime.*;

import java.util.Vector;
import java.util.Date;
import java.util.Enumeration;

public abstract class TestCase extends TestCasePrim implements StubListener, VerifyListener{
/****************************************************************************** *
 * STYLE TO PRODUCE SOME NOTES.
 */
public final static int style_stub_enter = 100;//Enter metod.
public final static int style_stub_exit = 101; //Exit method.
public final static int style_stub_fail = 157; //Check Stub failed.
public final static int style_glyph_stub_failed = 151;
/**
 *
 */
public final static int style_verify_passed = 150;
public final static int style_verify_failed = 151;
public final static int style_glyph_verify_failed = 151;
public final static int style_glyph_verify_passed = 150;
public final static int style_assert_passed = 150;
public final static int style_assert_failed = 151;
public final static int style_glyph_assert_failed = 151;
public final static int style_glyph_assert_passed = 150;
public final static int style_timer_create   = 150;   //Check passed style.
public final static int style_timer_id_error = 164;   //On error style.
public final static int style_verify_exception_passed = 154;
public final static int style_verify_exception_failed = 155;
public final static int style_glyph_verify_exception_failed = 151;
public final static int style_glyph_verify_exception_passed = 150;
public final static int style_unexpected_exception = 162;
public final static int style_comment = 165;
public final static int style_name_test  = 182; //Test class.
/**
 * Tsf generation part.
 */
protected int tsfid = 10;
public void settsfid(int id) { tsfid = id;}
public int gettsfid() { return tsfid;}
/**
 * TestCase can be a frame,
 * it enable this class to generate tsf blocks.
 */
protected boolean isframe = true;
public final void setAsFrame() { isframe = true;}
public final boolean isFrame() { return isframe;}
/**
 * Source id managment.
 * This source id is linked with the Tsf block generated.
 */
protected com.rational.testrealtime.SourceId __trtt_cs_id = new com.rational.testrealtime.SourceId( 1, 2, com.rational.testrealtime.Trace.listener, null );
public final void setSourceId(int id1, int id2) {__trtt_cs_id = new com.rational.testrealtime.SourceId( id1, id2, com.rational.testrealtime.Trace.listener, null );};
/*******************************************************************************
 * Class assert will presume that the member:
 * _trtt_getThis() will return the dynamical id for the class.
 *
 * Then the ouput of a note is:
 * Change to the source id.
 * Write the style.
 * Write the note.
 */
public int _trtt_getThis() { return _trtt_this; }
public void _trtt_setThis(int _this) { _trtt_this=_this; }
private int _trtt_this;
/**
 * Write the name of this instance.
 */
static private String StrUTF_8 = new String("no<UTF-8>");
protected synchronized void writeNoteName()
{
  String message = "";
  if (getTestMethodName() != null)
  {
    message = message + getTestMethodName();
  }
  else
  {
    message = message + "null";
  }
  com.rational.testrealtime.Trace.printStyle( style_name_test );
  try {
      com.rational.testrealtime.Trace.printNoteText(message.getBytes("UTF-8"), _trtt_getThis());
  }
  catch ( java.io.UnsupportedEncodingException e ) {
      com.rational.testrealtime.Trace.printNoteText(StrUTF_8.getBytes(), _trtt_getThis());
  }
}
/*******************************************************************************
 * WRITE NOTE PART.
 */
protected synchronized String clean_up_the_string(String from)
{
    /*Remove the end of line unsupported by trace*/
    if (from == null)
	return new String("");
 
    String result = from.replace('\u0085',' ');
    result = result.replace('\n',' ');
    result = result.replace('\t',' ');


    result = result.replace('\u0000',' ');
    result = result.replace('\u0001',' ');
    result = result.replace('\u0002',' ');
    result = result.replace('\u0003',' ');
    result = result.replace('\u0004',' ');
    result = result.replace('\u0005',' ');
    result = result.replace('\u0006',' ');
    result = result.replace('\u0007',' ');
    result = result.replace('\u0008',' ');
    result = result.replace('\u0009',' ');

    result = result.replace('\u001A',' ');
    result = result.replace('\u2028',' ');
    result = result.replace('\u2029',' ');
    result = result.replace('\r',' ');
    
    return result;
}
/*
 * The use.
 */
protected synchronized void writeNote(SourceId sid, int noteid,int id, String message)
{
  com.rational.testrealtime.TimeMng.writeTime();
  com.rational.testrealtime.Trace.newSource(sid);
  com.rational.testrealtime.Trace.printStyle( style_comment );
  if (message != null)
      {
	  try {
	      com.rational.testrealtime.Trace.printNoteId(sid,noteid, id,clean_up_the_string(message).getBytes("UTF-8"));
	  }
	  catch ( java.io.UnsupportedEncodingException e ) {
	      com.rational.testrealtime.Trace.printNoteId(sid,noteid, id,StrUTF_8.getBytes());
	  }
      }
  else
      com.rational.testrealtime.Trace.printNoteId(sid,noteid, id);
}
/**
 *
 */

protected synchronized boolean should_be_glyph(int style)
{
  return (
    style == style_verify_exception_failed ||
    style == style_assert_failed ||
    style == style_verify_failed ||
    style == style_stub_fail ||
    style == style_verify_exception_passed ||
    style == style_assert_passed ||
    style == style_verify_passed
  );
}
/**
 *
 */
 protected synchronized int style_glyph(int style)
 {
  if(style == style_verify_exception_failed)
    return style_glyph_verify_exception_failed;

  if(style == style_verify_exception_passed)
    return style_glyph_verify_exception_passed;

  if(style == style_assert_failed)
    return style_glyph_assert_failed;

  if(style == style_assert_passed)
    return style_glyph_assert_passed;

  if(style == style_verify_failed)
    return style_glyph_verify_failed;

  if(style == style_verify_passed)
    return style_glyph_verify_passed;

  if(style == style_stub_fail)
      return style_glyph_stub_failed;

  return style_glyph_verify_failed;
 }
 /**
 *
 */
protected synchronized void writeNote(SourceId sid, int noteid, int style,int id,String message)
{
  com.rational.testrealtime.TimeMng.writeTime();
  com.rational.testrealtime.Trace.newSource(sid);
  
  if (should_be_glyph(style))
      {
	  if (message==null)
	      com.rational.testrealtime.Trace.printGlyphId(sid,style_glyph(style),noteid, id);
	  else
	      {
		  try {
		      com.rational.testrealtime.Trace.printGlyphId(sid,style_glyph(style),noteid,id, clean_up_the_string(message).getBytes("UTF-8"));
		  }
		  catch ( java.io.UnsupportedEncodingException e ) {
		      com.rational.testrealtime.Trace.printGlyphId(sid,style_glyph(style),noteid,id, StrUTF_8.getBytes() );
		  }
	      }
      }
  else
      {
	  com.rational.testrealtime.Trace.printStyle(style);
	  if (message==null)
	      com.rational.testrealtime.Trace.printNoteId(sid,noteid, id);
	  else
	      {
		  try {
		      com.rational.testrealtime.Trace.printNoteId(sid,noteid, id, clean_up_the_string(message).getBytes("UTF-8"));
		  }
		  catch ( java.io.UnsupportedEncodingException e ) {
		      com.rational.testrealtime.Trace.printNoteId(sid,noteid, id, StrUTF_8.getBytes());
		  }
	      }

      }
}
/**
 *
 */
 protected synchronized void writeNote( String text, int style, int id)
{
  String formatted = "";
  if (text!=null) formatted = text;
  com.rational.testrealtime.TimeMng.writeTime();
  com.rational.testrealtime.Trace.printStyle(style);
  try {
      com.rational.testrealtime.Trace.printNoteText(clean_up_the_string(formatted).getBytes("UTF-8"), id);
  }
  catch ( java.io.UnsupportedEncodingException e ) {
      com.rational.testrealtime.Trace.printNoteText(StrUTF_8.getBytes(), id);
  }

}
/**
 *
 */
protected synchronized void writeNote( String text, int id)
{
  String formatted = "";
  if (text!=null) formatted = text;
  com.rational.testrealtime.TimeMng.writeTime();
  com.rational.testrealtime.Trace.printStyle( style_comment );
  try{
      com.rational.testrealtime.Trace.printNoteText(clean_up_the_string(formatted).getBytes("UTF-8"), id);
  }
  catch ( java.io.UnsupportedEncodingException e ) {
      com.rational.testrealtime.Trace.printNoteText(StrUTF_8.getBytes(), id);
  }
}
/**
 *
 */
 protected synchronized void writeNote( String text, boolean result, int id)
{
  com.rational.testrealtime.TimeMng.writeTime();
  com.rational.testrealtime.Trace.printStyle(result ? style_verify_passed : style_verify_failed);
  String formatted = "";
  if (text!=null) formatted = text;
  try{
      com.rational.testrealtime.Trace.printNoteText(clean_up_the_string(formatted).getBytes("UTF-8"), id );
  }
  catch ( java.io.UnsupportedEncodingException e ) {
      com.rational.testrealtime.Trace.printNoteText(StrUTF_8.getBytes(), id);
  }
}
/**
 *
 */
 protected synchronized void writeNote(SourceId sid, int noteid, boolean result, int id, String message)
{
  com.rational.testrealtime.Trace.newSource(sid);
  com.rational.testrealtime.TimeMng.writeTime();
  
  if (message == null)
      com.rational.testrealtime.Trace.printGlyphId(sid,
						   result?style_glyph_verify_passed:style_glyph_verify_failed,
						   noteid, id);
  else
      {
	  try{
	      com.rational.testrealtime.Trace.printGlyphId(sid,
							   result?style_glyph_verify_passed:style_glyph_verify_failed,
							   noteid, id,clean_up_the_string(message).getBytes("UTF-8"));
	  }
	  catch ( java.io.UnsupportedEncodingException e ) {
	      com.rational.testrealtime.Trace.printGlyphId(sid,
							   result?style_glyph_verify_passed:style_glyph_verify_failed,
							   noteid, id,StrUTF_8.getBytes());
	  }
      }
}
/**
 *
 */
 protected synchronized void writeNoteAssert(SourceId sid, int noteid, boolean result, int id, String message)
{
    
    com.rational.testrealtime.Trace.newSource(sid);
    com.rational.testrealtime.TimeMng.writeTime();
    if (message == null)
	com.rational.testrealtime.Trace.printGlyphId(sid,
						     result ? style_glyph_assert_passed : style_glyph_assert_failed,
						     noteid, id);
    else
	{
	    try{
		com.rational.testrealtime.Trace.printGlyphId(sid,
							     result ? style_glyph_assert_passed : style_glyph_assert_failed,
							     noteid, id,clean_up_the_string(message).getBytes("UTF-8"));
	    }
	    catch ( java.io.UnsupportedEncodingException e ) {
		com.rational.testrealtime.Trace.printGlyphId(sid,
							     result ? style_glyph_assert_passed : style_glyph_assert_failed,
							     noteid, id,StrUTF_8.getBytes());
	    }
	}
}
/**
 * The check results are a part of the assert.
 * A check is a message and a result for a Test.
 */
static protected Check fCheckdone;
private Vector fVerifyListener;

/**
 * The "timer" which can be used are contained in
 * this vector.
 */
protected Vector fDate;
/**
 *
 */
  public TestCase() {
  super("null");
  fDate = new Vector();
  fVerifyListener = new Vector();
  resetExceptionWatch();
  _trtt_setThis( com.rational.testrealtime.Trace.getInstanceId());
  }
/**
 *
 */
  public TestCase(String testMethodName) {
  super(testMethodName);
  fDate = new Vector();
  fVerifyListener = new Vector();
  resetExceptionWatch();
  _trtt_setThis( com.rational.testrealtime.Trace.getInstanceId());
  }
/**
 *
 */
public final void addVerifyListener(VerifyListener Listener)
{
    fVerifyListener.addElement(Listener);
}
 /**
  *
  */
 public final void addVerifyFailure(Test test)
 {
     for (Enumeration e= cloneListeners().elements(); e.hasMoreElements(); ) {
	 ((VerifyListener)e.nextElement()).addVerifyFailure(this);
     }
}
/**
 * Update the check done for listeners.
 *
 */
   final protected void updateVerifyListener(boolean result)
  {

    if (!result)
      addVerifyFailure(this);

  }
 /**
  *
  */
private synchronized Vector cloneListeners() {
    Vector cloneListeners = new Vector();
    Enumeration iterator = fVerifyListener.elements();
    while (iterator.hasMoreElements())
	cloneListeners.addElement(iterator.nextElement());
    return cloneListeners;
}
/**
 * Get the last check done.
 *
 */
static private Check getcheck()
{
  return fCheckdone;
}
/**
 * Name mng.
 */
static
  {
      if (com.rational.testrealtime.Buffer.JTestThread == null)
	  com.rational.testrealtime.Buffer.setJtestThread(Thread.currentThread());
  }

static boolean is_test_on = false;
private boolean should_end_test = false;
private final synchronized void setnametest()
{
    /*
     * Set the name for the others tools.
     */
    if (!is_test_on)
	{
       com.rational.testrealtime.Buffer.openbufferflag();
	    String name = getTestMethodName();
	    if (name != null) {
		com.rational.testrealtime.TestNode.setnametest( name );
	    }
	    else
		{
		    com.rational.testrealtime.TestNode.setnametest("null");
		}
	    is_test_on = true;
	    should_end_test = true;
	}
}
/**
 *
 */
public final synchronized void run(TestResult result)
{
    setnametest();
    this.result = result;
    addVerifyListener(result);
    result.run(this);
    this.result = null;
    if (should_end_test)
	{
	    com.rational.testrealtime.TestRT.dump();
       com.rational.testrealtime.Buffer.closebufferflag();
	    is_test_on =  false;
	}
}
/**
 *
 */
public final synchronized void runBare() throws Throwable {
  //In order to have a correct display.
  int iddisplay = InstanceStack.pushTest( _trtt_getThis() );
  _trtt_setThis(iddisplay);
  com.rational.testrealtime.Buffer.openbufferflag();
    if ( isFrame() == true )
	{
	    isframe = false;
	    int id_file;
	    String name2 =    "ObjecTest-Tracer";
	    String File =     "File";
	    String Filekind = "report" + new Integer(TestSuite.idtsf1).toString();


	    try{
		TsfMng.writeDB(name2.getBytes("UTF-8"));
		TsfMng.writeIN(File.getBytes("UTF-8"),++TestSuite.idin,Filekind.getBytes("UTF-8"));
		TsfMng.writeSI(TestSuite.idin);
		id_file = TestSuite.idin;
		name2 = getTestMethodName();
                String full_name = this.getClass().toString();
                int position_class = full_name.indexOf("class");
                position_class += 6;
                full_name = full_name.substring(position_class);
                full_name += "." + name2;
		TsfMng.writeIN( TsfMng.testcase ,++TestSuite.idin,full_name.getBytes("UTF-8"));
	    }
	    catch ( java.io.UnsupportedEncodingException e ) {
		TsfMng.writeDB(StrUTF_8.getBytes());
		TsfMng.writeIN(StrUTF_8.getBytes(),++TestSuite.idin,StrUTF_8.getBytes());
		TsfMng.writeSI(TestSuite.idin);
		id_file = TestSuite.idin;
		TsfMng.writeIN( TsfMng.testcase ,++TestSuite.idin,StrUTF_8.getBytes());
	    }

	    setSourceId(TestSuite.idtsf1,TestSuite.idtsf2);
	    settsfid(TestSuite.idin);
	    TsfMng.writeSI(id_file);
	    TsfMng.writeMS(TsfMng.runtestcase,TsfMng.id_runtestcase);
	    TsfMng.writeID(TestSuite.idtsf1,TestSuite.idtsf2);
	    TestSuite.idtsf1++;
	    TsfMng.writeED();

	}

  com.rational.testrealtime.TimeMng.writeTime();
  com.rational.testrealtime.StackLink __trtt_stack_link2 = new com.rational.testrealtime.StackLink( __trtt_cs_id, com.rational.testrealtime.TsfMng.id_runtestcase, gettsfid(), _trtt_getThis(), true );
  writeNoteName();
  listentoStub();
  //To enable some checks.
  try
  {
    super.runBare();
    //Check if there is no exception waited for this run.
    if ( exceptionwaited == true)
      {
        updateVerifyListener(false);
        writeNote(exceptionsourceid,noteidfortheexception,style_verify_exception_failed,_trtt_getThis(),null);
      }
  }

  catch (AssertionFailedError e)
  {
 	throw e;
  }

  catch (Throwable e)
    {
        if ( exceptionwaited == true)
        {
          //To return it as an error.
          if (! isWaitedException(e) )
	  {
	      updateVerifyListener(false);
	      if (e.getMessage()!=null)
		  {
		      writeNote( e.toString()  + " Message: " + e.getMessage() , style_unexpected_exception,_trtt_getThis());
		  }
	      else
		  {
		      writeNote( e.toString() , style_unexpected_exception,_trtt_getThis());
		  }
	      
	      writeNote(exceptionsourceid,noteidfortheexception,style_verify_exception_failed,_trtt_getThis(),null);
	      throw e;
	  }
	  else
	  {
            writeNote(exceptionsourceid,noteidfortheexception,style_verify_exception_passed,_trtt_getThis(),null);
	  }
       }
       else
       {
	   if (e.getMessage()!=null)
	       {
		   writeNote( e.toString()  + " Message: " + e.getMessage() , style_unexpected_exception,_trtt_getThis());
	       }
	   else
	       {
		   writeNote( e.toString() , style_unexpected_exception,_trtt_getThis());
	       }
	   throw e;//No exception waited, it is an error.
       }
   }

   finally
   {
	  		resetExceptionWatch();
      	InstanceStack.popTest();
			__trtt_stack_link2.pop( true ); __trtt_stack_link2=null;
        endListentoStub();
   }

 }
/**
 *
 */
protected void listentoStub()
 {
    TestSynchroStub.referenceTest(this);
    //And listen.
    TestSynchroStub.addListener(this);
 }
 /**
  *
  */
 protected synchronized void printNote(StubInfo stub,int style, int id)
{
     //Then write as a note with the information from the StubInfo.
     //If there is not id in, stay on the test.
     SourceId sid = stub.getSid();
     int noteid = stub.getMess();
     int dynamicalid = stub.getClassDynamicalId();

     if (sid==null)
	 {
	     if (dynamicalid != 0)
		 {
		     //Do not change the instance value.
		     //Write only the note.
		     writeNote(stub.getMethodName(),style,dynamicalid);
		 }
	     else
		 {
		     writeNote(stub.getMethodName(),style,id);
		 }
	     return;
	 }

     //Change id to go to the test.
     com.rational.testrealtime.Trace.changeInstance( id );
     //Write the note.
     com.rational.testrealtime.Trace.newSource(sid);
     if (should_be_glyph(style))
	 {
	     com.rational.testrealtime.Trace.printGlyphId(sid,style_glyph(style),noteid, id);
	 }
     else
	 {
	     com.rational.testrealtime.Trace.printStyle(style);
	     com.rational.testrealtime.Trace.printNoteId(sid,noteid, id );
	 }
     //And then go back to the stub.
     if (dynamicalid != 0)
	 com.rational.testrealtime.Trace.changeInstance( dynamicalid );
}
/**
 *
 */
final protected void endListentoStub()
 {
    TestSynchroStub.unloadTest(this);
    TestSynchroStub.removeListener(this);
 }
/**
 *
 */
final public void enterStub(StubInfo stub)
 {
     if (Products.mode_JTesting_DISPLAY)
	 {
	     if (stub.getAssociatedTest().equals(this))
		 printNote(stub,style_stub_enter,_trtt_getThis());
	 }
 }
/**
 *
 */
final public void exitStub(StubInfo stub)
 {
     if (Products.mode_JTesting_DISPLAY)
	 {
	     if (stub.getAssociatedTest().equals(this))
		 printNote(stub,style_stub_exit,_trtt_getThis());
	 }
 }
/**
 *
 */
final  public void failStub(StubInfo stub)
 {
  if (stub.getAssociatedTest().equals(this))
    printNote(stub,style_stub_fail,_trtt_getThis());

 }
/**
 *
 */
public void lateExit()
{
}
 /*******************************************************************************
 * CHECKS ON EXCEPTION
 *
 */
protected Throwable tocatch;
protected boolean exceptionwaited;
protected SourceId exceptionsourceid;
protected int noteidfortheexception;
/**
 *
 */
public void verify(SourceId sid, int noteid,Throwable exceptocheck)
{
  if (exceptocheck != null)
    tocatch = exceptocheck;
    exceptionwaited = true;
    exceptionsourceid = sid;
    noteidfortheexception = noteid;
}
/**
 *
 */
final protected void resetExceptionWatch()
{
  tocatch = null;
  exceptionwaited = false;
}
/**
 *
 */
final protected boolean isWaitedException(Throwable launched)
{

  boolean result = false;
  if (launched != null)
  {
    //Check that the class is the same or compatible.
    if (tocatch!= null)
    {
      Class fromlaunched = launched.getClass();
      Class fromwaited = tocatch.getClass();

      if ( fromwaited.isAssignableFrom(fromlaunched))
      {
        result = true;
      }
      else
      {
        result = false;
      }
    fromlaunched = null;
    fromwaited = null;

    }
    else
    {
      result = false;
    }



  }
  else
  {
    result = true;
  }

  return result;
}
/*******************************************************************************
 * CHECKS ON TIME
 *
 */
final public int createTimer(SourceId sid, int noteid,String logoncreation)
{
  //And log the message.
  String message = new String("");
  if (logoncreation != null) message += logoncreation + " ";
  message += "\"Timer:";
  //The date will be logged with a Command Start later.
  Long currentdate = new Long(0);
  fDate.addElement(currentdate);
  int timer_id = fDate.size();
  message += (String.valueOf(timer_id) + "\"");
  verifyLogMessage(sid,noteid,message);
  return( timer_id );//This is the index required to use this date.
}
/**
 *
 */
final protected boolean isvalidtimerid(int timerid)
{
  if ( (timerid > fDate.size()) || (timerid <= 0))
  {
    //No such a created timer.
    //Will be changed to a note in the tdp part.
    verifyLogMessage("NO TIMER ID");
    return false;
  }
  return true;
}
/**
 *
 */
final public void timerStart(SourceId sid, int noteid,int timerid, String startmessage)
{
  if (isvalidtimerid(timerid))
  {
    //Get current time, and log a message with this time.
    Long current_time = new Long(com.rational.testrealtime.Custom.getClock());
    fDate.removeElementAt((timerid-1));
    fDate.insertElementAt(current_time,(timerid-1));
    Integer value = new Integer(timerid);
    String message = new String("");
    if (startmessage != null)
    	message += "\"" + startmessage + "\"";
    message += " \"Timer:";
    message += String.valueOf(timerid);
    message += "\"";
    verifyLogMessage(sid,noteid,message);
  }
}
/**
 *
 */
final protected long timerElapsedTime(int timerid)
{
    return timerEllapsedTime(timerid);
}
final protected long timerEllapsedTime(int timerid)
{
    Long current_time = new Long(com.rational.testrealtime.Custom.getClock());
    long ellapsed_time;
    try
    {
      Long logged = ((Long)fDate.elementAt((timerid-1)));
      ellapsed_time = (current_time.longValue() - logged.longValue());
    }
    catch( Throwable e)
    {
      return(0);
    }
    return (ellapsed_time);
}
/**
 *
 */
final public void timerReportElapsedTime(SourceId sid, int noteid,int timerid, String ellapsedtimemessage)
{
    timerReportEllapsedTime(sid,noteid,timerid,ellapsedtimemessage);
}
final public void timerReportEllapsedTime(SourceId sid, int noteid,int timerid, String ellapsedtimemessage)
{
  if (isvalidtimerid(timerid))
  {
    //Get current time, and log a message with this time.
    long ellapsed_time = timerEllapsedTime(timerid);
    Integer value = new Integer(timerid);
    Long valueellapsed = new Long(ellapsed_time);
    String message = "\"" + valueellapsed.toString() +" " + new String(Custom.getClockUnit()) + "\" \"Timer:" + value.toString() + "\"";
    if (ellapsedtimemessage != null) message += (" \"" + ellapsedtimemessage + "\"");
    //And log the message.
    verifyLogMessage(sid,noteid,message);
  }
}
/**
 *
 */
final public void verifyElapsedTime(SourceId sid, int noteid,int timerid, long maxtime, String verifyellapsedmessage)
{
    verifyEllapsedTime( sid, noteid, timerid, maxtime, verifyellapsedmessage);
}
final public void verifyEllapsedTime(SourceId sid, int noteid,int timerid, long maxtime, String verifyellapsedmessage)
{
  if (isvalidtimerid(timerid))
  {
    long ellapsedtime = timerEllapsedTime(timerid);

    String message = new String("");
    if (verifyellapsedmessage != null)
    	message += verifyellapsedmessage + " ";
    message += "Timer:";
    message += String.valueOf(timerid);

    verifyLowerThanEquals(sid,noteid,message,maxtime,ellapsedtime);
  }
}
/*******************************************************************************
 * ASSERT CONDITION
 *
 */
final public void assertTrue(SourceId sid, int noteid,String message, boolean condition) {
	if (!condition) {fail(sid,noteid,message,true);return;}
        else {fail(sid,noteid,message,false);return;}
}
/**
 *
 */
final public void assertTrue(SourceId sid, int noteid,boolean condition) {
	assertTrue(sid,noteid,null, condition);
}
/*******************************************************************************
 *ASSERT EQUALS
 */
final public void assertEquals(SourceId sid, int noteid,long expected, long actual) {
   assertEquals(sid,noteid,null, expected, actual);
}
/**
 *
 */
final public void assertEquals(SourceId sid, int noteid,Object expected, Object actual) {
	assertEquals(sid,noteid,null, expected, actual);
}
/**
 *
 */
final public void assertEquals(SourceId sid, int noteid,String message, long expected, long actual) {
	assertEquals(sid,noteid,message, new Long(expected), new Long(actual));
}
/**
 *
 */
final public void assertEquals(SourceId sid, int noteid,String message, Object expected, Object actual) {
    if (expected == null && actual == null)
        {
	    failNotEquals(sid,noteid,message, expected, actual,false);
	    return;
        }
    if (expected != null && expected.equals(actual))
        {
	    failNotEquals(sid,noteid,message, expected, actual,false);
	    return;
        }
    failNotEquals(sid,noteid,message, expected, actual,true);
}
/*******************************************************************************
 * ASSERT NULL
 */
final public void assertNotNull(SourceId sid, int noteid,Object object) {
	assertNotNull(sid,noteid,null, object);
}
/**
 *
 */
final public void assertNotNull(SourceId sid, int noteid,String message, Object object) {
	assertTrue(sid,noteid,message, object != null);
}
/**
 *
 */
final public void assertNull(SourceId sid, int noteid,Object object) {
	assertNull(sid,noteid,null, object);
}
/**
 *
 */
final public void assertNull(SourceId sid, int noteid,String message, Object object) {
	assertTrue(sid,noteid,message, object == null);
}
/*******************************************************************************
 * ASSERT SAME
 */
final public void assertSame(SourceId sid, int noteid,Object expected, Object actual) {
	assertSame(sid,noteid,null, expected, actual);
}
/**
 *
 */
final public void assertSame(SourceId sid, int noteid,String message, Object expected, Object actual) {
    if (expected == actual)
        {
	    failNotSame(sid,noteid,message, expected, actual,false);
	    return;
	}
    failNotSame(sid,noteid,message, expected, actual,true);
}
/**
 * Fails a test with no message.
 */
final public void fail(SourceId sid, int noteid) {
	fail(sid,noteid,null,true);
}
/*******************************************************************************
 * CHECK LOG FAIL
 *
*/
 final public void verifyLogfail(SourceId sid, int noteid,String message)
{
 updateverifyFail(sid,noteid,message, InstanceStack.getCurrentTestId() );
 onCheck();
}
 final public void verifyLogfail(String message)
{
 updateverifyFail(message, InstanceStack.getCurrentTestId() );
 onCheck();
}
/*******************************************************************************
 * CHECK LOG MESSAGE
 */
 final public void verifyLogMessage(SourceId sid,int noteid,String message)
{
  updateverifyLog(sid,noteid,message, InstanceStack.getCurrentTestId() );
  onCheck();
}
/**
 *
 */
 final public void verifyLogMessage(String message)
{
  updateverifyLog(message, InstanceStack.getCurrentTestId() );
  onCheck();
}

/******************************************************************************
 * CHECK CONDITION
 */
 final public void verifyTrue(SourceId sid,int noteid,boolean condition)
{
  updateverify(sid,noteid,null,condition, InstanceStack.getCurrentTestId() );
  onCheck();
}
/**
 *
 */
 final public void verifyTrue(SourceId sid,int noteid,String message,boolean condition)
{
  updateverify(sid,noteid,message,condition, InstanceStack.getCurrentTestId() );
  onCheck();
}
/**
 * Fails a test with the given message.
 */
final public void fail(SourceId sid, int noteid,String message,boolean condition) {
    /**
     * Write Note as verify failed.
     * if condition, this is an failed assert
     * in the other context this is a passed assertion.
     */
    writeNoteAssert(sid, noteid,!condition, InstanceStack.getCurrentTestId(),message );
    if (condition)
      throw new AssertionFailedError(message);
}
/**
 *
 */
final public void fail(SourceId sid, int noteid,String message) {
    /**
     * Write Note as verify failed.
     * if condition, this is an failed assert
     * in the other context this is a passed assertion.
     */
    writeNoteAssert(sid, noteid,false, InstanceStack.getCurrentTestId(),message );
    throw new AssertionFailedError(message);
}
/**
 *
 */
final protected void failNotEquals(SourceId sid, int noteid,String message, Object expected, Object actual,boolean condition) {

     String full_message = new String();
     if (message != null)
	 full_message += "\"" + message.toString() + "\", ";
     full_message += expected!=null ? "\"" + expected.toString() + "\", " : " ";
     full_message += actual!=null ? "\"" + actual.toString() + "\"" : " ";
	 
     fail(sid,noteid,full_message,condition);
}
/**
 *
 */
final protected void failNotSame(SourceId sid, int noteid,String message, Object expected, Object actual,boolean condition) {
     String full_message = new String();
     if (message != null)
	 full_message += "\"" + message.toString() + "\", ";
     full_message += (expected!=null ? "\"" + expected.toString() + "\", " : " ");
     full_message += actual!=null ? "\"" + actual.toString() + "\"" : " ";
     fail(sid,noteid,full_message,condition);
}

/*******************************************************************************
 * CHECK EQUALS
 */
 final public void verifyEquals(SourceId sid, int noteid,String message,Object expected, Object actual)
{
  if ((expected==null)&&(actual==null))
  {
    updateverifyEquals(sid,noteid,message,expected,actual,true,InstanceStack.getCurrentTestId());
  }
  else
  if ((expected!=null)&&(expected.equals(actual)))
  {
    updateverifyEquals(sid,noteid,message,expected,actual,true,InstanceStack.getCurrentTestId());
  }
  else
  {
    updateverifyEquals(sid,noteid,message,expected,actual,false,InstanceStack.getCurrentTestId());
  }
  onCheck();
}
/**
 *
 */
 final public void verifyEquals(SourceId sid, int noteid,Object expected, Object actual)
{
  verifyEquals(sid,noteid,null,expected,actual);
}
/**
 *
 */
 final public void verifyEquals(SourceId sid, int noteid,long expected, long actual)
{
  verifyEquals(sid,noteid,null,new Long(expected),new Long(actual));
}
/**
 * This method will compare the length for the two vector.
 * And later compare the content.
 */
 final public void verifyEquals(SourceId sid, int noteid,String message, Vector expected, Vector actual)
 {
   if ((expected == null) || (actual==null))
   {
      updateverifyEquals(sid,noteid,message,expected,actual,false,InstanceStack.getCurrentTestId());
   }

   if ((expected != null) && (actual !=null))
   {
      if (expected.size() != actual.size())
      {
        updateverifyEquals(sid,noteid,message,expected,actual,false,InstanceStack.getCurrentTestId());
      }
      else
      {
        int result = 1;
        Enumeration enumexpected = expected.elements();
        Enumeration enumactual = actual.elements();
        for ( ; (enumexpected.hasMoreElements()&&enumactual.hasMoreElements());)
        {
          //Get the elements and compare.
          Object in_actual, in_expected;
          in_actual = enumactual.nextElement();
          in_expected = enumexpected.nextElement();

          if ((in_actual!=null)&&(in_expected!=null) )
          {
            if (!(in_actual.equals(in_expected)))
            {
              result = 0;
              break;
            }
          }
          else
          {
            if ((in_actual == null)&&(in_expected==null))
            {
              //These test is good, same objects.
            }
            else
            {
              result=0;
              break;
            }
          }
        }//end for.
        if (result == 1)
        {
          updateverifyEquals(sid,noteid,message,expected,actual,true,InstanceStack.getCurrentTestId());
        }
        else
        {
          updateverifyEquals(sid,noteid,message,expected,actual,false,InstanceStack.getCurrentTestId());
        }
      }
   }
   else
   {
    //One null vector.
    updateverifyEquals(sid,noteid,message,expected,actual,false,InstanceStack.getCurrentTestId());
   }
   onCheck();
}
/**
 *
 */
 final public void verifyEquals(SourceId sid, int noteid,Vector expected, Vector actual)
{
  verifyEquals(sid,noteid,null, expected, actual);
}
/**
 *
 */
 final public void verifyEquals(SourceId sid, int noteid,String message,long expected, long actual)
{
  verifyEquals(sid,noteid,message,new Long(expected),new Long(actual));
}
/**
 *
 */
 final public void verifyEquals(SourceId sid, int noteid,String message,boolean expected, boolean actual)
{
  verifyEquals(sid,noteid,message,new Boolean(expected),new Boolean(actual));
}
/**
 *
 */
 final public void verifyEquals(SourceId sid, int noteid,boolean expected, boolean actual)
{
  verifyEquals(sid,noteid,null,expected,actual);
}
/*******************************************************************************
 * CHECK EQUALS WITH DELTA
 */
 final public void verifyApproxEquals(SourceId sid, int noteid,String message, long expected, long actual, long delta)
{
    verifyAproxEquals( sid, noteid, message,  expected,  actual, delta);
}
 final public void verifyAproxEquals(SourceId sid, int noteid,String message, long expected, long actual, long delta)
{
   if ((Math.abs(expected-actual) <= delta))
   {
     updateverifyApproxEquals(sid,noteid,message,new Long(delta), new Long(expected), new Long(actual),true,InstanceStack.getCurrentTestId());
    }
    else
    {
     updateverifyApproxEquals(sid,noteid,message,new Long(delta), new Long(expected), new Long(actual),false,InstanceStack.getCurrentTestId());
    }
  onCheck();
}
/**
 *
 */
 final public void verifyApproxEquals(SourceId sid, int noteid,long expected, long actual, long delta)
{
    verifyAproxEquals( sid, noteid, expected, actual, delta);
}
 final public void verifyAproxEquals(SourceId sid, int noteid,long expected, long actual, long delta)
{
  verifyAproxEquals(sid,noteid,null,expected,actual,delta);
}
/*******************************************************************************
 * CHECK GREATER THAN
 */
 final public void verifyGreaterThan(SourceId sid, int noteid,String message,long expected, long actual)
{
  if (actual > expected)
  {
    updateverifyGreaterThan(sid,noteid,message,new Long(expected),new Long(actual),true,InstanceStack.getCurrentTestId());
  }
  else
  {
    updateverifyGreaterThan(sid,noteid,message,new Long(expected),new Long(actual),false,InstanceStack.getCurrentTestId());
  }
  onCheck();
}
/**
 *
 */
 final public void verifyGreaterThan(SourceId sid, int noteid,long expected, long actual)
{
  verifyGreaterThan(sid,noteid,null,expected,actual);
}
/*******************************************************************************
 * CHECK GREATER THAN EQUALS
 */
 final public void verifyGreaterThanEquals(SourceId sid, int noteid,String message,long expected, long actual)
{
  if (actual >= expected)
  {
    updateverifyGreaterThanEquals(sid,noteid,message,new Long(expected),new Long(actual),true,InstanceStack.getCurrentTestId());
  }
  else
  {
    updateverifyGreaterThanEquals(sid,noteid,message,new Long(expected),new Long(actual),false,InstanceStack.getCurrentTestId());
  }
  onCheck();
}
/**
 *
 */
 final public void verifyGreaterThanEquals(SourceId sid, int noteid,long expected, long actual)
{
  verifyGreaterThanEquals(sid,noteid,null,expected,actual);
}
/*******************************************************************************
 * CHECK LOWER THAN
 */
 final public void verifyLowerThan(SourceId sid, int noteid,String message,long expected, long actual)
{
  if (expected > actual)
  {
    updateverifyLowerThan(sid,noteid,message,new Long(expected),new Long(actual),true,InstanceStack.getCurrentTestId());
  }
  else
  {
    updateverifyLowerThan(sid,noteid,message,new Long(expected),new Long(actual),false,InstanceStack.getCurrentTestId());
  }
  onCheck();
}
/**
 *
 */
 final public void verifyLowerThan(SourceId sid, int noteid,long expected, long actual)
{
  verifyLowerThan(sid,noteid,null,expected,actual);
}
/*******************************************************************************
 * CHECK LOWER THAN EQUALS
 */
 final public void verifyLowerThanEquals(SourceId sid, int noteid,String message,long expected, long actual)
{
  if (expected >= actual)
  {
      updateverifyLowerThanEquals(sid,noteid,message,new Long(expected),new Long(actual),true,InstanceStack.getCurrentTestId());
  }
  else
  {
      updateverifyLowerThanEquals(sid,noteid,message,new Long(expected),new Long(actual),false,InstanceStack.getCurrentTestId());
  }
  onCheck();
}
/**
 *
 */
 final public void verifyLowerThanEquals(SourceId sid, int noteid,long expected, long actual)
{
  verifyLowerThanEquals(sid,noteid,null,expected,actual);
}
/*******************************************************************************
 * CHECK NOT NULL
 */
 final public void verifyNotNull(SourceId sid, int noteid,Object object)
{
  verifyTrue(sid,noteid,null, (object!=null));
}
/**
 *
 */
 final public void verifyNotNull(SourceId sid, int noteid,String message, Object object)
{
  verifyTrue(sid,noteid,message, (object != null));
}
/*******************************************************************************
 * CHECK NULL
 */
 final public void verifyNull(SourceId sid, int noteid,Object object)
{
  verifyTrue(sid,noteid,null,(object==null));
}
/**
 *
 */
 final public void verifyNull(SourceId sid, int noteid,String message,Object object)
{
  verifyTrue(sid,noteid,message,(object==null));
}
/*******************************************************************************
 * CHECK SAME
 */
 final public void verifySame(SourceId sid, int noteid,String message, Object expected, Object actual)
{
  updateverifySame(sid,noteid,message,expected,actual,(expected==actual),InstanceStack.getCurrentTestId());
  onCheck();
}
/**
 *
 */
 final public void verifySame(SourceId sid, int noteid,Object expected, Object actual)
{
  verifySame(sid,noteid,null,expected,actual);
}
/**
 * This method is called every time a verify is made.
 */
protected  synchronized void onCheck()
{
}
/**
 * Update the verify done.
 *
 */
 synchronized protected void updateverify(SourceId sid, int noteid,String message,boolean result, int id)
{
  updateVerifyListener(result);
  writeNote(sid, noteid,result, id, message);
}
/**
 *
 */
 final synchronized protected void updateverifyEquals(SourceId sid, int noteid,String message,Object expected, Object actual,boolean result, int id)
{
    String full_message = new String();
    if (message != null)
	full_message += "\"" + message.toString() + "\", ";
    full_message += expected!=null ? "\"" + expected.toString() + "\", " : " ";
    full_message += actual!=null ? "\"" + actual.toString()  + "\"" : " ";
    
    updateVerifyListener(result);
    writeNote(sid, noteid,result, id,full_message);
}
/**
 *
 */
 final synchronized protected void updateverifyGreaterThan(SourceId sid, int noteid,String message,Object expected, Object actual,boolean result, int id)
{
    String full_message = new String();
    if (message != null)
	full_message += "\"" + message.toString() + "\", ";
    full_message += expected!=null ? "\"" + expected.toString() + "\", " : " ";
    full_message += actual!=null ? "\"" + actual.toString() + "\"" : " ";

  updateVerifyListener(result);
  writeNote(sid, noteid,result, id,full_message);
}
/**
 *
 */
 final synchronized protected void updateverifyGreaterThanEquals(SourceId sid, int noteid,String message,Object expected, Object actual,boolean result, int id)
{
    String full_message = new String();
    if (message != null)
	full_message += "\"" + message.toString() + "\", ";
    full_message += expected!=null ? "\"" + expected.toString() + "\", " : " ";
    full_message += actual!=null ? "\"" + actual.toString() + "\"" : " ";

  updateVerifyListener(result);
  writeNote(sid, noteid,result, id,full_message);
}
/**
 *
 */
 final synchronized protected void updateverifyLowerThan(SourceId sid, int noteid,String message,Object expected, Object actual,boolean result, int id)
{

    String full_message = new String();
    if (message != null)
	full_message += "\"" + message.toString() + "\", ";
    full_message += expected!=null ? "\"" + expected.toString() + "\", " : " ";
    full_message += actual!=null ? "\"" + actual.toString() + "\"" : " ";

  updateVerifyListener(result);
  writeNote(sid, noteid,result, id,full_message);

}
/**
 *
 */
 final synchronized protected void updateverifyLowerThanEquals(SourceId sid, int noteid,String message,Object expected, Object actual,boolean result, int id)
{
    String full_message = new String();
    if (message != null)
	full_message += "\"" + message.toString() + "\", ";
    full_message += expected!=null ? "\"" + expected.toString() + "\", " : " ";
    full_message += actual!=null ? "\"" + actual.toString() + "\"" : " ";

  updateVerifyListener(result);
  writeNote(sid, noteid,result, id,full_message);
}
/**
 *
 */
 final synchronized protected void updateverifyGreaterLowerThanEquals(SourceId sid, int noteid,String message,Object expected, Object actual,boolean result, int id)
{
    String full_message = new String();
    if (message != null)
	full_message += "\"" + message.toString() + "\", ";
    full_message += expected!=null ? "\"" + expected.toString() + "\", " : " ";
    full_message += actual!=null ? "\"" + actual.toString() + "\"" : " ";

  updateVerifyListener(result);

  updateVerifyListener(result);
  writeNote(sid, noteid,result, id,message);
}
/**
 *
 */
 final synchronized protected void updateverifyApproxEquals(SourceId sid, int noteid,String message,Object delta,Object expected, Object actual,boolean result, int id)
{
    String full_message = new String();
    if (message != null)
	full_message += "\"" + message.toString() + "\", ";
    full_message += expected!=null ? "\"" + expected.toString() + "\", " : " ";
    full_message += actual!=null ? "\"" + actual.toString() + "\", " : " ";
    full_message += delta!=null ? "\"" + delta.toString() + "\"" : " ";
    
  updateVerifyListener(result);
  writeNote(sid, noteid,result, id,full_message);
}
/**
 *
 */
 final synchronized protected void updateverifySame(SourceId sid, int noteid,String message,Object expected, Object actual,boolean result, int id)
{
    String full_message = new String();
    if (message != null)
	full_message += "\"" + message.toString() + "\", ";
    full_message += expected!=null ? "\"" + expected.toString() + "\", " : " ";
    full_message += actual!=null ? "\"" + actual.toString() + "\"" : " ";

  updateVerifyListener(result);
  writeNote(sid, noteid,result, id,full_message);
}
/**
 *
 */
 final synchronized protected void updateverifyFail(SourceId sid, int noteid,String message, int id)
{
  updateVerifyListener(false);
  writeNote(sid, noteid,false, id, message);
}
/**
 *
 */
 final synchronized protected void updateverifyFail(String message, int id)
{
  /**
   * Write Note as verify failed.
   */
   updateVerifyListener(false);
   writeNote(message,false, id);
}
/**
 *
 */
 final synchronized protected void updateverifyLog(SourceId sid, int noteid,String message,int id)
{
  writeNote(sid, noteid, id, message );
}
/**
 *
 */
 final synchronized protected void updateverifyLog(String message, int id)
{
  /**
   * Write Note as comment.
   */
   writeNote(message, id);
}
}
