
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

/////////////////////////////////////////////////////////////////////// 
//JUnit is a regression testing framework written by Erich           // 
//Gamma and Kent Beck. It is used by the developer who               // 
//implements unit tests in Java.                                     // 
//JUnit is Open Source http://www.opensource.org/ Software,          // 
//released under the IBM's Common Public License Version 0.5         // 
//http://oss.software.ibm.com/developerworks/oss/license-cpl.htm     // 
//l and hosted on SourceForge http://sourceforge.net/projects/junit/.// 
/////////////////////////////////////////////////////////////////////// 
package j2meunit.framework;
import j2meunit.framework.*;
import java.util.*;
import com.rational.testrealtime.*;
public class TestSuite extends TestSuitePrim{
/**
 * Dynamical id for the tsf id.
 * Used during the generation of the block.
 */
static public int idin = 15;
/**
 * Tsf id of the class.
 * This members are set during the tsf generation.
 */
protected int tsfid = 11;
public void settsfid(int id) { tsfid = id;}
public int gettsfid() { return tsfid;}
/**
 * Dynamical id for the block which can
 * be generated.
 */
static public int idtsf1 = 1;
static public int idtsf2 = 2;
/**
 * TestSuiteRT can be a frame,
 * it enable this class to ssetAsgenerate tsf blocks.
 */

static
  {
    if (com.rational.testrealtime.Buffer.JTestThread == null)
      com.rational.testrealtime.Buffer.setJtestThread(Thread.currentThread());
  }

protected boolean isframe = true;
public final void setAsFrame() { isframe = true;};
public final boolean isFrame() { return isframe;};
/**
 * Source id associated with the class.
 * This source id can be changed according to
 * the generated tsf block.
 */
protected com.rational.testrealtime.SourceId __trtt_cs_id = new com.rational.testrealtime.SourceId( 1, 2, com.rational.testrealtime.Trace.listener, null );
public final void setSourceId(int id1, int id2) {__trtt_cs_id = new com.rational.testrealtime.SourceId( id1, id2, com.rational.testrealtime.Trace.listener, null );};

/**
 * Style to generate a note for the run of the suite.
 */
public final static int style_name_suite = 181; //Test suite id for the styles.
/*******************************************************************************
 * Class TestSuite will presume that the member:
 * _trtt_getThis() will return the dynamical id for the class.
 *
 * Then the ouput of a note is:
 * Change to the source id.
 * Write the style.
 * Write the note.
 */
public int _trtt_getThis() { return _trtt_this; }
public void _trtt_setThis(int _this) { _trtt_this=_this; }
private int _trtt_this;
/**
 * Write note for the name of this instance.
 */
static private String StrUTF_8 = new String("no<UTF-8>");
private synchronized void writeNoteName()
{
    String message = "";
    if (toString() != null)
	{
	    message = message + toString();
	}
    else
	{
	    message = message + "null";
	}
    com.rational.testrealtime.Trace.printStyle( style_name_suite );
    try{
	com.rational.testrealtime.Trace.printNoteText(message.getBytes( "UTF-8" ), _trtt_getThis());
    }
    catch( java.io.UnsupportedEncodingException e )
	{
	    com.rational.testrealtime.Trace.printNoteText(StrUTF_8.getBytes(), _trtt_getThis());
	}

}
/**
 * Constructors.
 * During this process the constructor ask for an instance id
 * to the Trace manager.
 */
public TestSuite()
{
    super("null");
    _trtt_setThis( com.rational.testrealtime.Trace.getInstanceId());

}
/**
 *
 */
public TestSuite(String name)
{
    super(name);
    _trtt_setThis( com.rational.testrealtime.Trace.getInstanceId());
}
/**
 *
 */
public TestSuite(Class theClass, String[] testNames) {
    this(theClass.getName());
    for (int i = 0; i < (testNames.length); i++) {
	TestCase testCase = null;
	try {
	    testCase = (TestCase)theClass.newInstance();
	} catch (Throwable e) {
	    com.rational.testrealtime.Custom.pushError("Class is not test rt compliant " + theClass.getName());
	}
	testCase.setTestMethodName(testNames[i]);
	addTest(testCase);
    }

    testNames = null;
    theClass = null;
}
/**
 *
 */
public final void addTest(Test theTest)
{
    if (theTest != null)
	{
	    Class testclass = theTest.getClass();
	    try
		{
		    Class testrtclass = Class.forName("j2meunit.framework.TestCase");
		    Class testrtsuiteclass = Class.forName("j2meunit.framework.TestSuite");

		    //The check compliance.
		    if ( testrtclass.isAssignableFrom(testclass) || testrtsuiteclass.isAssignableFrom(testclass)  )
			{
			    super.addTest(theTest);
			}
		    else
			{
			    com.rational.testrealtime.Custom.pushError("Class is not test rt compliant");
			}

                        testclass = null;
                        testrtclass = null;
                        testrtsuiteclass = null;

		}
	    catch(Throwable e)
		{
                  testclass=null;
		    com.rational.testrealtime.Custom.pushError("Cannot access the class");
		}
	}
}
/**
 *
 */
protected final synchronized int generatetsf(TestSuite ref,int current_class_id)
{
    //Generate a tsf with the following information:
    int cid = current_class_id;
    try
	{

	    Class testcaseclass = Class.forName("j2meunit.framework.TestCase");
	    Class testsuiteclass = Class.forName("j2meunit.framework.TestSuite");

	    for (Enumeration e= ref.tests(); e.hasMoreElements(); ) {
		Test test = (Test)e.nextElement();
		Class tryclass;
		tryclass = test.getClass();

		if (testcaseclass.isAssignableFrom(tryclass))
		    {
			TestCase current = (TestCase)test;
			String name2 = current.getTestMethodName();
			TsfMng.writeSI(cid);
			try {


                              String full_name = current.getClass().toString();
                              int position_class = full_name.indexOf("class");
                              position_class += 6;
                              full_name = full_name.substring(position_class);
                              full_name += "." + name2;

			    TsfMng.writeIN(TsfMng.testcase,++idin,full_name.getBytes( "UTF-8" ));
			}
			catch ( java.io.UnsupportedEncodingException exc ) {
			    TsfMng.writeIN(TsfMng.testcase,++idin,StrUTF_8.getBytes());
			    }

			current.settsfid(idin);
			current.isframe = false;
			current.setSourceId(idtsf1,idtsf2);
		    }
		else if (testsuiteclass.isAssignableFrom(tryclass))
		    {
			TestSuite current = (TestSuite)test;
			String name2 = current.toString();
			TsfMng.writeSI(cid);
			try
			    {

                              String full_name = current.getClass().toString();
                              int position_class = full_name.indexOf("class");
                              position_class += 6;
                              full_name = full_name.substring(position_class);
                              full_name += "." + name2;
				TsfMng.writeIN(TsfMng.testsuite,++idin,full_name.getBytes( "UTF-8" ));
			    }
			catch( java.io.UnsupportedEncodingException exc ) {
			    TsfMng.writeIN(TsfMng.testsuite,++idin,StrUTF_8.getBytes());
			}

			current_class_id++;
			current.settsfid(idin);
			current.setSourceId(idtsf1,idtsf2);
			current.isframe = false;
			generatetsf(current,idin);
		    }
                       tryclass = null;

	    }

                       testcaseclass = null;
                       testsuiteclass = null;

	    return (cid);
	}

    catch(Throwable e)
	{
	    String errormsg = "Can not build class object";
	    com.rational.testrealtime.Custom.pushError( errormsg );
	    return(0);
	}
}
/**
 * End of a report generation for All the test suite RT.
 */
static public final void lateExit()
  {
    com.rational.testrealtime.TestRT.lateExit();
  }
/**
 * Run of a test suite RT with the declaration of the instances.
 */
private final synchronized void CloseBuffer()
{
    if ( !TestCase.is_test_on )
    {
      com.rational.testrealtime.Buffer.closebufferflag();
    }
}

public final synchronized void run(TestResult result) {

    //In order to have a correct display:
    int iddisplay = InstanceStack.pushInstanceSuite( _trtt_getThis() );
    _trtt_setThis(iddisplay);
    com.rational.testrealtime.Buffer.openbufferflag();

    if ( isFrame() == true )
	{
	    int id_file;
	    String name2 =    "ObjecTest-Tracer";
	    String File =     "File";
	    String Filekind = "report" + new Integer(idtsf1).toString();
	    try {
		TsfMng.writeDB(name2.getBytes( "UTF-8" ));
		TsfMng.writeIN(File.getBytes( "UTF-8" ),++idin,Filekind.getBytes( "UTF-8" ));
		TsfMng.writeSI(idin);
		id_file = idin;
		name2 = toString();
                String full_name = this.getClass().toString();
                int position_class = full_name.indexOf("class");
                position_class += 6;
                full_name = full_name.substring(position_class);
                full_name += "." + name2;
		TsfMng.writeIN( TsfMng.testsuite ,++idin,full_name.getBytes( "UTF-8" ));
	    }
	    catch( java.io.UnsupportedEncodingException e )
		{
		    TsfMng.writeDB(StrUTF_8.getBytes());
		    TsfMng.writeIN(StrUTF_8.getBytes(),++idin,StrUTF_8.getBytes());
		    TsfMng.writeSI(idin);
		    id_file = idin;
		    name2 = toString();
		    TsfMng.writeIN( TsfMng.testsuite ,++idin,StrUTF_8.getBytes());
		}
	    setSourceId(idtsf1,idtsf2);
	    settsfid(idin);
	    generatetsf(this,idin);
	    TsfMng.writeSI(id_file);
	    TsfMng.writeIN(TsfMng.testcase,TsfMng.id_testcase,TsfMng.testcase);
	    TsfMng.writeSI(id_file);
	    TsfMng.writeIN(TsfMng.testsuite,TsfMng.id_testsuite,TsfMng.testsuite);
	    TsfMng.writeMS(TsfMng.runtestsuite,TsfMng.id_runtestsuite);
	    TsfMng.writeMS(TsfMng.runtestcase,TsfMng.id_runtestcase);
	    TsfMng.writeID(idtsf1,idtsf2);
	    idtsf1++;
	    TsfMng.writeED();
	}

    com.rational.testrealtime.TimeMng.writeTime();
    com.rational.testrealtime.StackLink __trtt_stack_link2 = new com.rational.testrealtime.StackLink( __trtt_cs_id,TsfMng.id_runtestsuite, gettsfid(), _trtt_getThis(), true );

    writeNoteName();
	CloseBuffer();



   try {

	while (fTests.size() > 0) {
		{if (result.shouldStop())
			break;}
       com.rational.testrealtime.Buffer.openbufferflag();
	    com.rational.testrealtime.Trace.changeInstance(_trtt_getThis());
     	CloseBuffer();
		((Test) fTests.elementAt(0)).run(result);
		fTests.removeElementAt(0);
	}


    } finally {

        com.rational.testrealtime.Buffer.openbufferflag();
	InstanceStack.popInstanceSuite();
	__trtt_stack_link2.pop( true ); __trtt_stack_link2=null;
     	CloseBuffer();

    }

}

}





