
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

/////////////////////////////////////////////////////////////////////// 
//JUnit is a regression testing framework written by Erich           // 
//Gamma and Kent Beck. It is used by the developer who               // 
//implements unit tests in Java.                                     // 
//JUnit is Open Source http://www.opensource.org/ Software,          // 
//released under the IBM's Common Public License Version 0.5         // 
//http://oss.software.ibm.com/developerworks/oss/license-cpl.htm     // 
//l and hosted on SourceForge http://sourceforge.net/projects/junit/.// 
/////////////////////////////////////////////////////////////////////// 
package j2meunit.framework;

import java.util.Vector;
import java.util.Enumeration;
import j2meunit.framework.*;
import com.rational.testrealtime.*;

public class TestSynchroStub {

protected static Vector ftest = new Vector();//All the tests referenced.
protected static Vector fStubInfo = new Vector();
protected static Vector fListeners = new Vector();

public static synchronized void addListener(StubListener listener) {
	fListeners.addElement(listener);
}

public static synchronized void removeListener(StubListener listener) {

    for ( Enumeration e = fListeners.elements(); e.hasMoreElements() ;)
    {
      if ( (e.nextElement()) == listener )
      {
	  fListeners.removeElement(listener);
     //     System.out.println("REMOVE LISTENER");
        }
    }

}


private static synchronized Vector cloneListeners() {
/*	Vector cloneListeners = new Vector();
	Enumeration iterator = fListeners.elements();
	while (iterator.hasMoreElements())
		cloneListeners.addElement(iterator.nextElement());
	return cloneListeners;
        */
        return fListeners;
}



public synchronized static void referenceTest(Test testtoreference)
  {

    if (testtoreference != null)
      ftest.addElement(testtoreference);

  }

  public synchronized static Test getCurrentTest()
  {
      if (Products.mode_JTesting_STUB)
	  {

	      if ( !ftest.isEmpty() )
		  return ((Test)ftest.lastElement());
	      else
		  return null;
	  }

      else
	  {
	      return null;
	  }
  }

  public synchronized static void setStubInfo(StubInfo infostub)
  {

    if (infostub.getAssociatedTest() != null)
	{
	    fStubInfo.addElement(infostub);
	    for (Enumeration e = cloneListeners().elements(); e.hasMoreElements();)
		{
		    if ( infostub.getTypeInfo() == StubInfo.ENTER )
			{
			    ((StubListener) e.nextElement()).enterStub(infostub);
			}
		    else if ( infostub.getTypeInfo() == StubInfo.EXIT )
			{
			    ((StubListener) e.nextElement()).exitStub(infostub);
			}
		    else if ( infostub.getTypeInfo() == StubInfo.FAIL )
			{
			    ((StubListener) e.nextElement()).failStub(infostub);
			}
		}
	}

  }

  protected synchronized static boolean isTestin(Test test)
  {

    for ( Enumeration e = ftest.elements(); e.hasMoreElements() ;)
    {
      if ( (e.nextElement()) == test )
        return true;
    }
    return false;
  }

  protected synchronized static void unloadreferencedTest(Test test)
  {

    for ( Enumeration e = ftest.elements(); e.hasMoreElements() ;)
    {
      if ( (e.nextElement()) == test )
	  {
                      ftest.removeElement(test);}
    }

  }

  protected synchronized static void unloadreferencedstubinfo(Test test)
  {
    for (int index = 0; index < fStubInfo.size(); )
    {
      StubInfo infoStub = (StubInfo)fStubInfo.elementAt(index);
      if ( infoStub.getAssociatedTest() == test )
        {
          fStubInfo.removeElement(infoStub);
          if (index>0) index--;
        }
    }
  }

  public synchronized static void unloadTest(Test testtounload)
  {

    unloadreferencedstubinfo(testtounload);
    unloadreferencedTest(testtounload);

  }

  protected synchronized static Vector extractVectorFor(Test test)
  {

    Vector extracted = new Vector();
    for ( Enumeration e = fStubInfo.elements(); e.hasMoreElements() ;)
    {
      StubInfo elt;
      elt = (StubInfo)(e.nextElement());
      if ( elt.getAssociatedTest() == test )
          extracted.addElement(elt);
    }
    return extracted;

  }

  public synchronized static boolean areStubfail(Test test)
  {

    if (test == null)
      return false;
    //Return true of a stub is declared failed.
    Vector fortest = extractVectorFor( test ) ;
    for ( Enumeration e = fortest.elements(); e.hasMoreElements() ;)
    {
      StubInfo elt;
      elt = (StubInfo)(e.nextElement());
      if ( elt.getTypeInfo() == StubInfo.FAIL )
        return true;
    }

    return false;
  }

  public synchronized static boolean isSeqRespected(StubSequence tocheck)
  {
    //Check if the Test is in.
    if (! isTestin( tocheck.getTestinvolved() ))
    {
      return false;
    }
    //The test is in, so search if the same seq or stack is in.
    //Extract the sequence concerning this test.
    return (tocheck.isCallSameAs(extractVectorFor(tocheck.getTestinvolved()))) ;
  }
}
