
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

/////////////////////////////////////////////////////////////////////// 
//JUnit is a regression testing framework written by Erich           // 
//Gamma and Kent Beck. It is used by the developer who               // 
//implements unit tests in Java.                                     // 
//JUnit is Open Source http://www.opensource.org/ Software,          // 
//released under the IBM's Common Public License Version 0.5         // 
//http://oss.software.ibm.com/developerworks/oss/license-cpl.htm     // 
//l and hosted on SourceForge http://sourceforge.net/projects/junit/.// 
/////////////////////////////////////////////////////////////////////// 
package junit.framework;


import com.rational.testrealtime.*;
import junit.framework.*;

public class TestStub {
  protected Test associated;
  public TestStub()
  {
    associated = TestSynchroStub.getCurrentTest();
  }

  public int _trtt_getThis() { return 0; }//Will be made in the real instance.

  protected void entermethod( SourceId sid, int message,String name)
  {

    StubInfo info=new StubInfo((this.getClass()).getName(),name,StubInfo.ENTER,associated,_trtt_getThis(),sid,message);
    TestSynchroStub.setStubInfo(info);
  }

  protected void exitmethod( SourceId sid, int message,String name)
  {
    StubInfo info=new StubInfo((this.getClass()).getName(),name,StubInfo.EXIT,associated,_trtt_getThis(),sid,message);
    TestSynchroStub.setStubInfo(info);
  }

  protected void fail( SourceId sid, int message,String name)
  {
    StubInfo info=new StubInfo((this.getClass()).getName(),name,StubInfo.FAIL,associated,_trtt_getThis(),sid,message );
    TestSynchroStub.setStubInfo(info);
  }

  protected void entermethod( String name)
  {
    StubInfo info=new StubInfo((this.getClass()).getName(),name,StubInfo.ENTER,associated,_trtt_getThis(),null,0);
    TestSynchroStub.setStubInfo(info);

  }

  protected void exitmethod( String name)
  {
    StubInfo info=new StubInfo((this.getClass()).getName(),name,StubInfo.EXIT,associated,_trtt_getThis(),null,0);
    TestSynchroStub.setStubInfo(info);
  }

  protected void fail( String name)
  {
    StubInfo info=new StubInfo((this.getClass()).getName(),name,StubInfo.FAIL,associated,_trtt_getThis(),null,0);
    TestSynchroStub.setStubInfo(info);
  }

}






















