

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/* Product version: 7.0.5.1 */

 

/*
//////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.//
//                                                                            //
//                Product: Rational(R) Test RealTime                          //
//                                                                            //
//      Product Component: All                                                //
//                                                                            //
//               Language: java                                               //
//                                                                            //
//        Product version: 2001A.04.00                                        //
//                                                                            //
//                                                                            //
// Rational, the Rational logo are registered trademarks of                   //
// Rational Software Corporation.                                             //
//                                                                            //
// The placing of the copyright notices on Rational source code is not        //
// intended to mean that they are published works, but are included in the    //
// event of inadvertent publication. The source code of Rational contains     //
// trade secrets and other valuable confidential information of Rational      //
// Software Corporation. Rational Software Corporation and its licensors      //
// retain ownership to Rational Products in both source and object code       //
// format, and related documentation and all rights therein including         //
// copyrights, patents and trade secrets.                                     //
//                                                                            //
//                                                                            //
// U.S. Government Rights                                                     //
//                                                                            //
// Use, duplication, or disclosure by the U.S. Government is subject to       //
// restrictions set forth in the applicable Rational License Agreement        //
// and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                 //
// 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,       //
// or FAR 52.227-14, as applicable.                                           //
//                                                                            //
// Unless otherwise agreed to in writing, use of Rational products is         //
// governed by the Rational Product License Agreement provided with           //
// the product.                                                               //
//////////////////////////////////////////////////////////////////////////////
*/

/****************************************************************************
*
*
*
*
*
****************************************************************************/

#ifdef CUSTO_STD
#include "jvmpi_std.h"
#else
#include "jvmpi_custom.h"
#endif

#ifndef __JMALLOC_H__
#define __JMALLOC_H__

#include <jni.h>

#if JVMPI_HEAP == JVMPI_USR
#define JVMPI_HEAP_JVMPI_USR 
extern void *jvmpi_usr_malloc(JVMPI_SIZE_T size);
extern void jvmpi_usr_free(void *ptr);
#endif

#if JVMPI_HEAP == JVMPI_STD
#define JVMPI_HEAP_JVMPI_STD 
#endif

#ifdef JVMPI_HEAP_JVMPI_STD
#include <stdlib.h>
#define JVMPI_SIZE_T size_t
#endif

/*
 *
 */
void *jmalloc( JVMPI_SIZE_T _size )
{
#ifdef JVMPI_HEAP_JVMPI_STD
  return malloc( _size );
#endif

#ifdef JVMPI_HEAP_JVMPI_USR
  void * ptr = jvmpi_usr_malloc(_size);
  return (ptr);
#endif
}
/*
 *
 */
void jfree( void *_ptr )
{
#ifdef JVMPI_HEAP_JVMPI_STD
  free( _ptr );
#endif

#ifdef JVMPI_HEAP_JVMPI_USR
  jvmpi_usr_free(_ptr);
#endif
}
/*
 * new <type> 
 */
#define JNEW( __type__ ) \
  ( __type__ *)jmalloc( sizeof( __type__ ) )
/*
 * new <type>[size] 
*/
#define JNEWARRAY( __type__ , __count__ ) \
  (__type__*)jmalloc( (__count__)*sizeof(__type__) )
/*
 *
 */
#define JDELETE(__ptr__) \
  jfree(__ptr__)

#ifndef NODEBUG
extern void jmallocAllowed( bool _a );
#endif

extern void debugalloc();

#endif /* __JMALLOC_H__ */
/*
  **************************************************************************/


#ifndef __JERROR_H__
#define __JERROR_H__


#if JVMPI_ERROR == JVMPI_USR
#define JVMPI_ERROR_JVMPI_USR
extern void *jvmpi_usr_error(char *message);
#endif
#if JVMPI_ERROR == JVMPI_STD
#define JVMPI_ERROR_JVMPI_STD
#endif

#ifdef JVMPI_ERROR_JVMPI_STD
#include <stdio.h>
#endif

void pushError( char* ptr )
{
#ifdef JVMPI_ERROR_JVMPI_STD
  fprintf(stderr,"%s\n",ptr);
#endif
#ifdef JVMPI_ERROR_JVMPI_USR
  jvmpi_usr_error(ptr);
#endif
}
/*
 *
 */
extern void pushError( char* ptr );
#define _JERROR(str) pushError(str)
#endif /* __JERROR_H__ */

/*
  **************************************************************************/
#ifndef __JNIWRAPPER_H__
#define __JNIWRAPPER_H__


#if JVMPI_IO == JVMPI_USR
#define JVMPI_IO_JVMPI_USR
extern JVMPI_FILE_TYPE jvmpi_usr_open(char *fileName);
extern void *jvmpi_usr_write(JVMPI_FILE_TYPE file,char *buffer,int len);
extern void *jvmpi_usr_close(JVMPI_FILE_TYPE file);
#endif
#if JVMPI_IO == JVMPI_STD
#define JVMPI_IO_JVMPI_STD
#endif

#ifdef JVMPI_IO_JVMPI_STD
#include <stdio.h>
#define JVMPI_FILE_TYPE FILE *
#endif
/*
 * Stub jwBuffer pour un dump en C / File
 */

#define JBYTEBUF_SIZE 1000
typedef jbyte JByteBufferArray[ JBYTEBUF_SIZE ];


/*----------------------------------------------------------------------------
 * Wrap  com.rational.testrealtime.Buffer class
 *
 */


static char * atlout = (char*)0;

void set_out_file( char* out )
{
  atlout = out;
}

#define ATLOUT atlout

class jwBuffer 
{
 public:
   //create a purify env; using given environment (load the class)
   jwBuffer( JNIEnv *_env );
  ~jwBuffer();

  void configure();

   bool failed() const { return file_==0; }

   void pushBytes( jbyte *, int _len );

   void lateExit();

 protected:
  JVMPI_FILE_TYPE file_;
};

static bool first_init=true;
static char c_buf[ JBYTEBUF_SIZE+1 ];

jwBuffer::jwBuffer( JNIEnv * )
{
}

void jwBuffer::configure()
{
  if ( first_init )
    {
#ifdef JVMPI_IO_JVMPI_STD
      if (ATLOUT == (char*)0)
	{
	  _JERROR((char*)"ERROR: can't open dump file ");
	  _JERROR((char*)"\n");
	  file_ = (JVMPI_FILE_TYPE) 0;
	  return;
	}
    file_ = fopen( ATLOUT, "w" );
#endif
#ifdef JVMPI_IO_JVMPI_USR
    file_ = jvmpi_usr_open( ATLOUT);
#endif
    first_init=false;
    } 
  
  if( !file_ )
    {
      _JERROR((char*)"ERROR: can't open dump file ");
      _JERROR(ATLOUT);
      _JERROR((char*)"\n");
    }
}

void jwBuffer::lateExit()
{
#ifdef JVMPI_IO_JVMPI_STD
  if(file_) fclose(file_);
#endif
#ifdef JVMPI_IO_JVMPI_USR
  if(file_) jvmpi_usr_close(file_);
#endif

  file_=0;
}


jwBuffer::~jwBuffer()
{
#ifdef JVMPI_IO_JVMPI_STD
  if(file_) fclose(file_);
#endif
#ifdef JVMPI_IO_JVMPI_USR
  if(file_) jvmpi_usr_close(file_);
#endif
  file_=0;
}

void jwBuffer::pushBytes( jbyte *_buf, int _len )
{
  if ( !file_ ) return ;

  int i;
  for( i=0; i<_len; i++ )
  {
    c_buf[i] = (char)_buf[i];
  }
  c_buf[i] = '\0'; 

#ifdef JVMPI_IO_JVMPI_STD
  fwrite( c_buf, _len, sizeof(char), file_ );
  fflush(file_);
#endif
#ifdef JVMPI_IO_JVMPI_USR
  jvmpi_usr_write(file_,c_buf,_len);
#endif

}
#endif //!__JNIWRAPPER_H__
/*
  **************************************************************************/
#ifndef __JSTRING_H__
#define __JSTRING_H__


#if JVMPI_STRING == JVMPI_USR
#define JVMPI_STRING_JVMPI_USR
extern int jvmpi_usr_strncmp(const char *s1, const char *s2,JVMPI_SIZE_T n);
extern JVMPI_SIZE_T jvmpi_usr_strlen(const char *s1);
extern int jvmpi_usr_strcmp(const char *s1, const char *s2);
extern char * jvmpi_usr_strcpy(char *dest,const char *src);
extern char *jvmpi_usr_strstr(const char *haystack, const char *needle);
#endif
#if JVMPI_STRING == JVMPI_STD
#define JVMPI_STRING_JVMPI_STD
#endif

#ifdef JVMPI_STRING_JVMPI_STD
#include <string.h>
#endif


/*
 *
 */
/*
 *
 */
/*
 *
 */
extern char* jstrdup( char * ptr );
#define _STRDUP(str) jstrdup (str)
/*
 *
 */
#ifdef JVMPI_STRING_JVMPI_STD
#define _STRCPY(src,dest) strcpy(src,dest)
#endif
#ifdef JVMPI_STRING_JVMPI_USR

#define _STRCPY(src,dest) jvmpi_usr_strcpy(src,dest)
#endif
/*
 *
 */
#ifdef JVMPI_STRING_JVMPI_STD
#define _STRLEN(src) strlen(src)
#endif
#ifdef JVMPI_STRING_JVMPI_USR
#define _STRLEN(src) jvmpi_usr_strlen(src)
#endif
/*
 *
 */
#ifdef JVMPI_STRING_JVMPI_STD
#define _STRSTR(from,what) strstr(from,what)
#endif
#ifdef JVMPI_STRING_JVMPI_USR
#define _STRSTR(from,what) jvmpi_usr_strstr(from,what)
#endif
/*
 *
 */
#ifdef JVMPI_STRING_JVMPI_STD
#define _STRNCMP(src1,src2,n) strncmp(src1,src2,n)
#endif
#ifdef JVMPI_STRING_JVMPI_USR
#define _STRNCMP(src1,src2,n) jvmpi_usr_strncmp(src1,src2,n)
#endif
/*
 *
 */
#ifdef JVMPI_STRING_JVMPI_STD
#define _STRCMP(src1,src2) strcmp(src1,src2)
#endif
#ifdef JVMPI_STRING_JVMPI_USR
#define _STRCMP(src1,src2) jvmpi_usr_strcmp(src1,src2)
#endif

char* jstrdup(char* ptr)
{ 
  if (ptr == (char*)0)
    return (char*)0;
  
  char* ret = (char*) JNEWARRAY( char , _STRLEN(ptr)+1 );
  if (ret != (char*)0)
    {
      _STRCPY(ret,ptr);
      return (ret);
   }
  else
    {
      return ((char*)0);
    }
}

/*
 *
 */
#endif /* __JSTRING_H__ */
/*
  **************************************************************************/

#ifndef _JBYTEBUFFER_H__
#define _JBYTEBUFFER_H__

typedef struct
{
  JByteBufferArray bytes;
  int   length;

  jwBuffer *jw_buffer; /*Buffer custom for the ouput*/

} JByteBuffer ;

/** create a buffer */
extern JByteBuffer* jbbufCreate();

/** reset buffer (a appeler au debut) */
extern void jbbufReset( JByteBuffer *_buf, jwBuffer *_jw_buffer );

/** force un send/reset du buffer */
extern void jbbufSend( JByteBuffer *_buf );

/** copy string at the end of buffer */
extern void jbbufString( JByteBuffer *_buf, const char *_str );

/** append given char to buffer */
extern void jbbufChar( JByteBuffer *_buf, char _c );

/** append number using reverse-hexadecimal format */
extern void jbbufRUnsigned16( JByteBuffer *_buf, jint _number );

/** append number using hexadecimal format (put a 'h' at end of number) */
extern void jbbufUnsigned16h( JByteBuffer *_buf, jint _number );

/** append number 32 */
extern void jbbufRUnsigned32( JByteBuffer *_buf, jlong _number );
static const char *jbb_hexa_digits = (char *)"0123456789abcdef";
/*---------------------------------------------------------------------------
 *
 *---------------------------------------------------------------------------
 */
static jwBuffer  _jwbuffer((JNIEnv*)0);

JByteBuffer * jbbufCreate()
{
  
  /*
    if (_jwbuffer == (jwBuffer*)0)
    {
    _jwbuffer = new jwBuffer((JNIEnv*)0);
    }
  */

  JByteBuffer * current = JNEW(JByteBuffer);
  if (current != (JByteBuffer*)0)
    {
      current->length = 0;
      _jwbuffer.configure();
      current->jw_buffer = &_jwbuffer;
    }
  return (current);
}
/*---------------------------------------------------------------------------
 *
 *---------------------------------------------------------------------------
 */
void jbbufReset( JByteBuffer *_buf, jwBuffer *_jw_buffer )
{
  _buf->length = 0;
  _buf->jw_buffer = _jw_buffer ;
}

/*---------------------------------------------------------------------------
 *
 *---------------------------------------------------------------------------
 */
void jbbufSend( JByteBuffer *_buf )
{
  _buf->jw_buffer->pushBytes( _buf->bytes, _buf->length );
  _buf->length = 0;
}

/*---------------------------------------------------------------------------
 *
 *---------------------------------------------------------------------------
 */
static void jbbufCheckSize( JByteBuffer *_buf, int _free_size )
{
  if ( (_buf->length+_free_size) >= JBYTEBUF_SIZE )
  {
    jbbufSend( _buf );
  }
}

/*---------------------------------------------------------------------------
 *
 *---------------------------------------------------------------------------
 */
void jbbufChar( JByteBuffer *_buf, char _c )
{
  jbbufCheckSize( _buf, 1 );
  _buf->bytes[_buf->length++] = _c ;
}
/*---------------------------------------------------------------------------
 *
 *---------------------------------------------------------------------------
 */
void jbbufString( JByteBuffer *_buf, const char *_str )
{
  int len = _STRLEN( _str );

  jbbufCheckSize( _buf, len );

  for( char *c=(char*)_str; *c; c++)
  {
    _buf->bytes[_buf->length++] = (jbyte)*c;
  }
}
/*---------------------------------------------------------------------------
 *
 *---------------------------------------------------------------------------
 */
void jbbufRUnsigned16( JByteBuffer *_buf, jint _v )
{
  jbbufCheckSize( _buf, 10 );

  //en 32bytes
  jint n = _v;
  jint w = ( _v < 0 ) ? -1 : 0;
  jint count = 0;

  do {
    _buf->bytes[_buf->length++] = jbb_hexa_digits[n&0x0F];
    n >>= 4;
    count++;
  } while ( n != w );
  
  if ( _v < 0 && (count<8))
    {
      n >>= 4;
      _buf->bytes[_buf->length++] = jbb_hexa_digits[n&0x0F];
    }
  
}
/*---------------------------------------------------------------------------
 *
 *---------------------------------------------------------------------------
 */
void jbbufUnsigned16h( JByteBuffer *_buf, jint my_v )
{
  jbbufCheckSize( _buf, 10 );
  bool first = true;
  char p;
  jint  digit;
  jint  n_out=0;
  jint i;
  jint _v = my_v;

  for ( i = 28; i >= 0; i -= 4 ) 
  {
    digit = ( ((_v))>>i ) & 0x0F ;

    if( (digit == 0) && first ) continue ;

    p = jbb_hexa_digits[ digit ];

    if ( first ) 
    {
      if ( digit >= 10 )
	{
	  _buf->bytes[_buf->length++] = (jbyte)'0' ; //heading '0'
	}

      first=false;
    }
    
    _buf->bytes[_buf->length++] = (jbyte)p;

    n_out++;

  }
  //if(_buf[(*_wbuf)++] = _atl_jbb_hexa_digits[(_v)&0x0F];

  if ( n_out==0 )
  {
    _buf->bytes[_buf->length++] = (jbyte)'0';
  }

  /*no more h*/
  
  //if( /*_v<0 ||*/ _v>9 )
  //{
  _buf->bytes[_buf->length++] = (jbyte)'h';
  //}
  

}
/*---------------------------------------------------------------------------
 *
 *---------------------------------------------------------------------------
 */
void jbbufRUnsigned32( JByteBuffer *_buf, jlong _v )
{
  jbbufCheckSize( _buf, 20 );

  jbbufRUnsigned16(_buf, (_v>>32));
  jbbufChar( _buf,',');
  jbbufRUnsigned16(_buf, (_v));
}
#endif //_JBYTEBUFFER_H__
/*
  **************************************************************************/
#ifndef __JTIME_H__
#define __JTIME_H__

#if JVMPI_DATE_IN_MILLISECOND == JVMPI_USR
#define JVMPI_DATE_IN_MILLISECOND_JVMPI_USR
extern unsigned long jvmpi_usr_getDateInMilliSec(void);
#endif
#if JVMPI_DATE_IN_MILLISECOND == JVMPI_STD
#define JVMPI_DATE_IN_MILLISECOND_JVMPI_STD
#endif

#ifdef JVMPI_DATE_IN_MILLISECOND_JVMPI_STD
#ifdef UNIX
#include <sys/time.h>
#endif
#ifdef WIN32
#include <sys/timeb.h>
#endif
#endif

/*
 *
 */
#define _GETTIME() gettimefromstart()
extern jlong gettimefromstart();

static bool start_done = false;

unsigned long time_start = 0;

#ifdef JVMPI_DATE_IN_MILLISECOND_JVMPI_STD
#ifdef UNIX
struct timeval tv;
#define _rec_time(val) gettimeofday(&val, 0);
#define _convert_to_ms(val) (unsigned long) ((long)(val.tv_sec * 1000) + (long)(val.tv_usec/1000));
#endif
#ifdef WIN32
struct timeb tv;
#define _rec_time(val) ftime(&val);
#define _convert_to_ms(val) (unsigned long) ((long)(val.time * 1000) + (long)(val.millitm/1000));
#endif
#endif

#ifdef JVMPI_DATE_IN_MILLISECOND_JVMPI_USR
#define _rec_time() jvmpi_usr_getDateInMilliSec();
#endif

jlong gettimefromstart()
{
  if (!start_done)
    {
#ifdef JVMPI_DATE_IN_MILLISECOND_JVMPI_STD
      _rec_time(tv);
      time_start = _convert_to_ms(tv);
#endif
#ifdef JVMPI_DATE_IN_MILLISECOND_JVMPI_USR
time_start = _rec_time()
#endif
       start_done = true;
    }

  unsigned long time;
#ifdef JVMPI_DATE_IN_MILLISECOND_JVMPI_STD
  _rec_time(tv);
  time = _convert_to_ms(tv);
#endif
#ifdef JVMPI_DATE_IN_MILLISECOND_JVMPI_USR
  time = _rec_time();
#endif
  time = ( time - time_start );
  return (time);

}


#endif /* __JTIME_H__ */



/*
  **************************************************************************/
#ifndef __JSOCK_H__
#define __JSOCK_H__


#if JVMPI_SOCKET == JVMPI_USR
#define JVMPI_SOCKET_JVMPI_USR
extern JVMPI_SOCKET_ID jvmpi_usr_connect(char * host,char* port);
extern int jvmpi_usr_recv(JVMPI_SOCKET_ID s,char *buffer,int len);
extern int jvmpi_usr_send(JVMPI_SOCKET_ID s,char *buffer,int len);
extern int jvmpi_usr_close(JVMPI_SOCKET_ID s);
#endif

#if JVMPI_SOCKET == JVMPI_STD
#define JVMPI_SOCKET_JVMPI_STD
#endif

#if JVMPI_SOCKET == JVMPI_NONE
#define JVMPI_SOCKET_JVMPI_NONE
#endif

#ifndef JVMPI_SOCKET_JVMPI_NONE
#ifdef JVMPI_SOCKET_JVMPI_STD
#define JVMPI_SOCKET_ID int
#ifdef UNIX
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <unistd.h>
#include <netdb.h>
#include <stdlib.h>
#include <string.h>
#endif/*UNIX*/
#ifdef WIN32
#include <winsock2.h>
#include <string.h>
#endif/*WIN32*/
/*
 * Return a socket descriptor if available.
 */
#define LENGTH_SOCKET_BUF 10
#define PORT_NUMBER 9542
#define _MEMCPY( out, in, length) memcpy (out,in,length)
#define _MEMSET( out, in, length) memset (out,in,length)
#define _ATOI(str) atoi(str)
#define _GETHOSTBYNAME(hst) gethostbyname(hst)
#define _GETHOSTBYADDR(hst,len) gethostbyaddr(hst,len,AF_INET)
#define _SOCKET(val1,val2,val3) socket(val1,val2,val3)
#define _CONNECT(val1,val2,val3) connect(val1,val2,val3)
#define _RECV(val1,val2,val3,val4) recv(val1,val2,val3,val4)
#define SEND(val1,val2,val3) send(val1,val2,val3,0)
#define _HTONS(prt) htons(prt)
#define CONNECT_TO_SERVER(host,port) pagent_connect(host,port)  
extern int pagent_connect(char* host, char * port);
#define RECEIVE_FROM_SERVER(id,buf,length) recv_fully(id,buf,length)
extern int recv_fully(int f, char *buf, int len);
#ifdef UNIX
#define CLOSESOCK(sock_fd) close(sock_fd) 
#define INITIALIZE_WSDATA() 
#endif/*UNIX*/
#ifdef WIN32
/*WSE Startup*/
static struct WSAData * test = (struct WSAData*)0;
#define CLOSESOCK(sock_fd) closesocket(sock_fd);\
if (test!=(struct WSAData*)0)\
JDELETE(test);
#define INITIALIZE_WSDATA() initwsadata()
extern void initwsadata();
#define _WSAStartup(ver,wsadata) WSAStartup(ver,wsadata)
#endif/*WIN32*/

/*
 * Return a socket descriptor connected to an adress.
 * 
 */
#ifdef WIN32
void initwsadata()
{
  test = (struct WSAData*) JNEW( struct WSAData );
  _WSAStartup(2,test);
}
#endif


int pagent_connect(char *host,  char * port_sock)
{
  struct sockaddr_in local_mbx;
  int fd;
  struct hostent *hptr;

  unsigned int port = 0;

  INITIALIZE_WSDATA();

  if ( port_sock==(char*)0 )
    return 0;
    
  port = _ATOI(port_sock);
    
  if (port <= 0 || port > 65535) {
    _JERROR((char*)"ERROR: bad port number\n");
    return 0;
  }

  if (host == (char*)0)
    {
      _JERROR((char*)"ERROR: bad hostname\n");
      return 0;
    }
  
  hptr = _GETHOSTBYNAME(host);

  if (hptr == NULL)
    {
      _JERROR((char*)"ERROR: gethostbyname\n");
      return 0;
    }


  _MEMSET(
	   ((void *)&local_mbx),
	   0,
	   (sizeof(struct sockaddr_in)));

  _MEMCPY(
	   ((void *) &local_mbx.sin_addr), 
	   hptr->h_addr, 
	   hptr->h_length);

  local_mbx.sin_family = hptr->h_addrtype;
  local_mbx.sin_port = _HTONS(port);
  
  /* create a socket with a SOCK_STREAM style */
  fd = _SOCKET(AF_INET, SOCK_STREAM, 0);

  /* now try connecting */
  if (-1 == _CONNECT(fd, (struct sockaddr*)&local_mbx, sizeof( local_mbx ))) 
    {
      _JERROR((char*)"ERROR cant connect\n");
      return 0;
    } 
  else 
    {
    return fd;
    }
}
/*
 *
 */
int recv_fully(int f, char *buf, int len)
{
  int nbytes = 0;
  while (nbytes < len) {
    int res = _RECV(f, buf + nbytes, len - nbytes, 0);
    if (res < 0) {
      return -1;
    }
    nbytes += res;
  }
  return nbytes;
}

#endif /*STD SOCKET*/
#endif /*NONE*/

#ifdef JVMPI_SOCKET_JVMPI_USR
#define LENGTH_SOCKET_BUF 10
#define PORT_NUMBER 9542
#define INITIALIZE_WSDATA() 
#define CONNECT_TO_SERVER(host,port) jvmpi_usr_connect(host,port)
#define RECEIVE_FROM_SERVER(id,buf,length) jvmpi_usr_recv(id,buf,length)
#define CLOSESOCK(sock_fd) jvmpi_usr_close(sock_fd) 
#define SEND(sock_fd,buff,len) jvmpi_usr_send(sock_fd,buff,len) 
#endif

#endif /* __JSOCK_H__ */


/*
  **************************************************************************/
/*
  **************************************************************************/
/*
  **************************************************************************/
/*
  **************************************************************************/
/*
  **************************************************************************/
/*
  **************************************************************************/
/*
  **************************************************************************/







