

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* Product version: 7.0.5.1 */

/*
////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2001-2003 Rational Software Corporation. All rights reserved.//
//                                                                            //
//                Product: Rational(R) Test RealTime                          //
//                                                                            //
//      Product Component: All                                                //
//                                                                            //
//               Language: java                                               //
//                                                                            //
//        Product version: 2001A.04.00                                        //
//                                                                            //
//                                                                            //
// Rational, the Rational logo are registered trademarks of                   //
// Rational Software Corporation.                                             //
//                                                                            //
// The placing of the copyright notices on Rational source code is not        //
// intended to mean that they are published works, but are included in the    //
// event of inadvertent publication. The source code of Rational contains     //
// trade secrets and other valuable confidential information of Rational      //
// Software Corporation. Rational Software Corporation and its licensors      //
// retain ownership to Rational Products in both source and object code       //
// format, and related documentation and all rights therein including         //
// copyrights, patents and trade secrets.                                     //
//                                                                            //
//                                                                            //
// U.S. Government Rights                                                     //
//                                                                            //
// Use, duplication, or disclosure by the U.S. Government is subject to       //
// restrictions set forth in the applicable Rational License Agreement        //
// and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                 //
// 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,       //
// or FAR 52.227-14, as applicable.                                           //
//                                                                            //
// Unless otherwise agreed to in writing, use of Rational products is         //
// governed by the Rational Product License Agreement provided with           //
// the product.                                                               //
////////////////////////////////////////////////////////////////////////////////
*/
/***************************************************************************
*
* Pagent structures.
*
* 
****************************************************************************/
#ifndef __PAGENT_H__
#define __PAGENT_H__


#include <jvmpi.h>

/*
#ifdef AIX
typedef int bool;
#define true 1
#define false 0
#endif
*/

/*
#ifdef SUN
typedef int bool;
#define true 1
#define false 0
#endif
*/

#include "jcmdl.h"

/***************************************************************************
*
* CMD LINE PART.
*
* 
****************************************************************************/

/*#define _WITH_MAX_OUT*/


static char * name_user = (char*)0;    /*Name of the user for the snapshot*/
void set_name_user(char * _name) { name_user = _name;}

static char * node_used = (char*)0;    /*Name of the node used*/
void set_node_used(char * _name) { node_used = _name;}

static bool with_no_obj_allocation = false;
void set_no_obj_allocation() { with_no_obj_allocation = true;}

static char * date_run = (char*)0;    /*Name of the user for the snapshot*/
void set_date_start(char * _date) { date_run = _date;}

static char * port_sock = (char*)0;    /*Name of the user for the snapshot*/
void set_port(char * _port) { port_sock = _port;}

static char * host = (char*)0;    /*Name of the hostname*/
void set_hostname(char * _host) { host = _host;}

static bool do_the_gc = true;        /*Will the gc be used for the dump*/
void set_gc() { do_the_gc = true; }

static bool dump_after_gc = false;        /*Will the gc be used for the dump*/
void set_dump_after_gc() { dump_after_gc = true; }

static bool should_snapshot_delete_objects = false;
void set_snap_delete() { should_snapshot_delete_objects = true;}

static bool should_the_objects_stay = true; /*Should the objects still referenced stay in the mid information*/
                                             /*between the entry of method or not*/
void set_objects_stay() { should_the_objects_stay = true;}
static bool env_global_datas = true;  /*Global datas means that all the information will be in the global var*/
                                       /*Without any thread env associated (all the threads datas in one)*/
void set_global_datas() { env_global_datas = true;}

static bool is_mode_unitest = false;   /*Unit testing mode                                 */
void set_unitest() { is_mode_unitest = true;}

static bool is_obs_from_begin = false;  /*Should the observation start with the first event */
                                        /*Or with the JVM INITIALIZATION                    */
void set_obs_from_begin() { is_obs_from_begin = true;}


static bool is_dump_partial_on_gc = false;  /*Should the dump be done after trigger and gc */
static bool force_dump_after_gc = false;
void set_partial_dump() { is_dump_partial_on_gc = true;}

static bool is_run_test_load = false; /*When junit runBare is loaded*/
static bool is_run_method_test_load = false; /*When junit test method is loaded*/

typedef unsigned long uint32;
/***************************************************************************
*
* Status of the VM.
*
* 
****************************************************************************/
typedef enum {
        VMStatus_BEFORE_INIT,
        VMStatus_OK,
        VMStatus_AFTER_SHUTDOWN
} VMStatusType;
/***************************************************************************
*
* Class Type.
*
* 
****************************************************************************/
typedef struct ClassIdType {
  jobjectID              class_id;	
  /*Jobject id for the class.*/
  /*Required to manage the MOVE operation*/

  jobjectID              first_id;	
  /*Jobject id for the class.*/
  /*Required to have a link with the TSF definition*/

  jint                   num_methods;
  /*Amount of methods for this class.*/

  struct MethodIdType   *methods;		
  /*Methods for this class.*/

  ClassIdType   	  *next;				
  /*Next for this class, for the hash part.*/
  
  bool                   is_tdp;		
  /*Is this class an Target Dep. P.*/

#ifdef _WITH_MAX_OUT
  char                  *class_name;	
  /*Name of the class.*/
  char                  *source_name;
  /*Source name of the class.*/
#endif

} ClassIdType, *ClassIdTypeP;
/***************************************************************************
*
* Class Type.
* Stack and Allocation information.
* 
****************************************************************************/
typedef struct StackInfo
{
  int num;
  struct MethodIdType  **methods;	
  /*Methods for this class.*/
  
} StackInfo, *StackInfoP;
/*
 *
 */
typedef struct AllocObjects
{
  /*Optionnal stack information*/
  /*Required to collect the stack of allocation*/
  StackInfo * info_stack;
  jobjectID obj_id;   
  /*Dynamical object id*/
  /*Required for the move operation, and free*/

  ClassIdType           *class_id ; 
  /*class_id associated with this object*/
  /*This link has to be done in order to maintain the consistency of      */
  /*the information with the move operation for classes                   */

  jint is_array;    
  /*Kind of objects*/
  /*Required to dump array of objects*/
  jint arena_id;    
  /*Arena id associated*/
  /*Required for the arena delete operation*/
  AllocObjects * next;
  /*Next one called in a env*/
  AllocObjects * hash_next;
  /*Next one called with the hash part*/
  bool is_deleted;    
  /*Do it later*/
  /*During the GC operation the object is deleted*/
  /*But the real delete has to be done after the */
  /*gc finish event.                             */
  jlong size;         
  /*Size of this object*/
  
  bool merged;
  /*Merge on dump*/
} AllocObjects, *AllocObjectsP;
/*
 *
 */
typedef struct AllocSum
{
  JNIEnv *env_id; 	
  /*Thread Env Id for these values.*/
  AllocObjects * start; 
  /*First object allocated*/
  AllocObjects * last;  
  /*last objects in order to add quickly*/
  
  AllocSum * next;	
  /*Other env_id after.*/
  
  uint32 calls;		
  /*calls done in the env.*/
  
  jlong  total_bytes;  	
  /*Local + inside allocated.*/
  jlong  total_objects;	
  /*Local + inside allocated.*/
  jlong  total_and_d_objects;	
  /*Local bytes allocated.*/
  jlong  total_and_d_bytes;  
  /*For a merge on the dump*/
  
  /*All the run of.*/
} AllocSum;
typedef struct MethodIdType MethodIdType;
/***************************************************************************
*
* Method information.
* 
* 
****************************************************************************/
typedef struct MethodIdType {
  jmethodID              method_id; 		
  /*Id for this method*/
  ClassIdType           *class_id ; 		
  /*class_id associated*/
  //  JNIEnv *env_id; 	
  /*Thread Env Id for these values in case of global mode*/

#ifdef _WITH_MAX_OUT
  char                  *signature; 		
  /*signatre for this method*/
  char                  *name ;     		
  /*Name of this method*/
#endif
  AllocSum              alloc ;    		
  /*Allocations done by env*/
  

  char                   dump;          
  /*Is this method designed for dumping*/
  /*Or will be used to dump objects with stack ...*/
  uint32                 number_message; 	
  /*Start in source file*/
  /*Required to do a dump quickly*/
} MethodIdType, *MethodIdTypeP;
/***************************************************************************
*
* Current Thread Stack and env.
* 
* 
****************************************************************************/
typedef struct _StackType {
  MethodIdTypeP          mid;		
  /*Method id associated with this stack call*/
  AllocSum               alloc;	
  /*Local allocation done*/

  bool                   ignore;
  /*In case of tdp*/
  struct _StackType     *up;
  /*Others part of the stack*/
  struct _StackType     *down;
  /*down part*/
} StackType, *StackTypeP;
/*
 * Thread local Env.
 */
typedef struct {
  jlong last_time_used; 
  /*To maintain a time by thread for the dumps*/
  StackTypeP   top;
  StackTypeP   current;
  jint         stack_level;
} EnvType, *EnvTypeP;
#endif// __PAGENT_H__
/*
  **************************************************************************/











