
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

/////////////////////////////////////////////////////////////////////// 
//JUnit is a regression testing framework written by Erich           // 
//Gamma and Kent Beck. It is used by the developer who               // 
//implements unit tests in Java.                                     // 
//JUnit is Open Source http://www.opensource.org/ Software,          // 
//released under the IBM's Common Public License Version 0.5         // 
//http://oss.software.ibm.com/developerworks/oss/license-cpl.htm     // 
//l and hosted on SourceForge http://sourceforge.net/projects/junit/.// 
/////////////////////////////////////////////////////////////////////// 
package j2meunit.framework;
import j2meunit.framework.*;
import java.util.*;

public class TestSuite extends TestSuitePrim{

  public TestSuite() {
  super("null");
  }

  public TestSuite(String name){
    super(name);
  }

  public final synchronized void run(TestResult result)
  {
    super.run(result);
  }

    public TestSuite(Class theClass, String[] testNames) {
	this(theClass.getName());
	for (int i = 0; i < testNames.length; i++) {
	    TestCase testCase = null;
	    try {
			testCase = (TestCase)theClass.newInstance();
	    } catch (Throwable e) {
		System.out.println("Class is not test rt compliant or need to have public default constructor in " + theClass.getName());
	    }
	    testCase.setTestMethodName(testNames[i]);
	    addTest(testCase);
	}
}

public final void addTest(Test theTest)
{
    if (theTest != null)
	{
	    Class testclass = theTest.getClass();
	    try
		{
		    Class testrtclass = Class.forName("j2meunit.framework.TestCase");
		    Class testrtsuiteclass = Class.forName("j2meunit.framework.TestSuite");

		    //The check compliance.
		    if ( testrtclass.isAssignableFrom(testclass) || testrtsuiteclass.isAssignableFrom(testclass)  )
			{
			    super.addTest(theTest);
			}
		    else
			{
			    System.out.println("AddTest:Class test is not compliant with test rt");
			}

		}
	    catch(Throwable e)
		{
		    System.out.println("Cannot access the class");
		}
	}
}

public final void setAsFrame() { }

static public final void lateExit() { }


}




