
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

/////////////////////////////////////////////////////////////////////// 
//JUnit is a regression testing framework written by Erich           // 
//Gamma and Kent Beck. It is used by the developer who               // 
//implements unit tests in Java.                                     // 
//JUnit is Open Source http://www.opensource.org/ Software,          // 
//released under the IBM's Common Public License Version 0.5         // 
//http://oss.software.ibm.com/developerworks/oss/license-cpl.htm     // 
//l and hosted on SourceForge http://sourceforge.net/projects/junit/.// 
/////////////////////////////////////////////////////////////////////// 
package junit.framework;

import junit.framework.*;
import junit.framework.TestSynchroStub;
import junit.framework.StubInfo;

public class TestStub {
  protected Test associated;

  public static boolean is_off = false;

  public TestStub()
  {
      if (!is_off)
	  {
	      associated = TestSynchroStub.getCurrentTest();
	  }
      else
	  {
	      associated = null;
	  }
  }

  protected void entermethod(String name)
  {
      if (!is_off)
	  {
	      StubInfo info=new StubInfo((this.getClass()).getName(),name,StubInfo.ENTER,associated);
	      TestSynchroStub.setStubInfo(info);
	  }
  }

  protected void exitmethod(String name)
    {
      if (!is_off)
	  {
	      StubInfo info=new StubInfo((this.getClass()).getName(),name,StubInfo.EXIT,associated);
	      TestSynchroStub.setStubInfo(info);
	  }
  }

  protected void fail(String name)
  {
      if (!is_off)
	  {
	      StubInfo info=new StubInfo((this.getClass()).getName(),name,StubInfo.FAIL,associated);
	      TestSynchroStub.setStubInfo(info);
	  }
  }
}





















