
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

/////////////////////////////////////////////////////////////////////// 
//JUnit is a regression testing framework written by Erich           // 
//Gamma and Kent Beck. It is used by the developer who               // 
//implements unit tests in Java.                                     // 
//JUnit is Open Source http://www.opensource.org/ Software,          // 
//released under the IBM's Common Public License Version 0.5         // 
//http://oss.software.ibm.com/developerworks/oss/license-cpl.htm     // 
//l and hosted on SourceForge http://sourceforge.net/projects/junit/.// 
/////////////////////////////////////////////////////////////////////// 
package j2meunit.framework;

import j2meunit.framework.*;
import java.lang.Class;

public class StubInfo {

  public static final short ENTER=1,EXIT=2,FAIL=3;

  protected Class classval;
  protected String methodname;
  protected short typeinfo;
  protected Test associated;

  public StubInfo(String classname,String _methodname,short _type, Test _associated) {

  Class givenclass;
  try
  {
    givenclass = Class.forName(classname);
    classval = givenclass;
    methodname = _methodname;
    typeinfo = _type;
    associated = _associated;

  }

  catch(Throwable e)
  {
    classval = null;
    methodname = null;
    typeinfo = -1;
    associated = null;
  }

}

  public boolean equals(Object other)
  {
    if (other==null)
      return false;

    try
    {
      StubInfo given = (StubInfo)other;
      return (given.equals(this));
    }
    catch(Throwable e)
    {
      return false;
    }
  }

  public boolean equals(StubInfo other)
  {
    boolean result;
    result = (
    (classval.equals( other.classval))&&
    (methodname.equals(other.methodname))&&
    (typeinfo == other.typeinfo)&&
    (associated.equals(other.associated)));
    return result;
  }

  public Class getValClass()      { return classval;}
  public String getMethodName()   { return methodname;}
  public short getTypeInfo()      { return typeinfo;}
  public Test getAssociatedTest() { return associated;}
}







