
/////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Licensed Materials - Property of IBM
//  Restricted Material of IBM
//  IBM Rational Test RealTime
//  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
//
//  US Governement Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//
/////////////////////////////////////////////////////////////////////////////////////////////////

// Product version: 7.0.5.1

/////////////////////////////////////////////////////////////////////// 
//JUnit is a regression testing framework written by Erich           // 
//Gamma and Kent Beck. It is used by the developer who               // 
//implements unit tests in Java.                                     // 
//JUnit is Open Source http://www.opensource.org/ Software,          // 
//released under the IBM's Common Public License Version 0.5         // 
//http://oss.software.ibm.com/developerworks/oss/license-cpl.htm     // 
//l and hosted on SourceForge http://sourceforge.net/projects/junit/.// 
/////////////////////////////////////////////////////////////////////// 
package junit.framework;
import java.lang.Class;
import java.util.Vector;
import java.util.Enumeration;

import junit.framework.*;

import junit.framework.StubInfo;

public class StubSequence {

  class StubItem {
    public Class involved;
    public String methodname;
    public short type;

    public StubItem(Class _involved, String _methodname, short _type)
    {
      involved = _involved;
      methodname = _methodname;
      type = _type;
    }

    public StubInfo StubInfoView()
    {
      return new StubInfo(involved.getName(),methodname,type,testinvolved);
    }

  }

  protected Vector items;
  protected Test testinvolved;

  public StubSequence(Test test)
  {
    testinvolved = test;
    items = new Vector();
  }

  public void addEltToSequence(Class nameclass, String methodname,short _type)
  {
    try
    {
    items.addElement(new StubItem( nameclass, methodname, _type ));
    }
    catch(Throwable e)
    {

    }
  }

  protected int getNext(int from, Vector _synchronized)
  {
    for (int index = (from+1); index < _synchronized.size(); index++)
    {
      StubInfo current = ((StubInfo)_synchronized.elementAt(index));
      String res = current.getMethodName();
      if ((current.getTypeInfo()==StubInfo.ENTER))
      {
         return index;
      }
      else
      {
        if (current.getTypeInfo()==StubInfo.EXIT)
        {
          return index;
        }
      }
    }
    return -1;
  }

  protected boolean arethesamefrom(int index, Vector _synchronized)
  {
    //Try to find in the _synchro part the first elt.
    Enumeration inside = items.elements();

    int from = index;

    //First check the 1st elt.
    StubItem item = (StubItem)inside.nextElement();
    StubInfo current = ((StubInfo)_synchronized.elementAt(index));
    StubInfo insideview = item.StubInfoView();

     if (!insideview.equals(current))
      {
        return false;
      }

    for ( ;inside.hasMoreElements(); )
    {

      item = (StubItem)inside.nextElement();
      index = getNext(index,_synchronized);

      if (index == -1)
        return false;

      if (index > _synchronized.size())
        return false;

      current = ((StubInfo)_synchronized.elementAt(index));
      insideview = item.StubInfoView();

      if (!insideview.equals(current))
      {
	  return false;
      }
    }
    return true;
  }


  public boolean isCallSameAs(Vector _synchronized)
  {
    if (_synchronized == null)
      return false;

    //Try to find in the _synchro part the first elt.
    //Except if items is empty.

    if ( items.isEmpty() )
      return false;



    StubInfo first = ((StubItem)items.firstElement()).StubInfoView();

    int position = _synchronized.indexOf(first);

    if (position == -1)
      return false;

    boolean endofloop = false;
    while (!endofloop)
    {
      if (arethesamefrom(position,_synchronized))
      {
        return true;
      }
      else
      {
        //find another position.
        position++;
        position = _synchronized.indexOf(first,position);
        if (position == -1)
          return false;
      }
    }
    return false;
  }

  Test getTestinvolved() { return testinvolved; }

}

